
#ifndef _CONF_ITEM_H_
#define _CONF_ITEM_H_

//#include <wx/wxprec.h>
#include <wx/wx.h>

#include <vector>

#define _CONF_ITEM_TEXT   0
#define _CONF_ITEM_BUTTON 1

#define _CONFARRAY_MAX 16

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class ConfItem_cls {
 public:
    ConfItem_cls();

    wxString mstrHeader;
    wxString mstrBody;

    virtual void SetItem(wxString strHeader, wxString strBody) = 0;
    virtual bool ReadStrLine(wxString strLine) = 0;
    virtual wxString Serialize() = 0;
    virtual wxString GetItemStr() = 0;
    bool ReadStrLineBase(wxString strLine);

    void ReplaceSeparator();
};

class ConfArray_cls {
 public:
    unsigned int mDimension;
    unsigned int CountDimension(wxString strBody);
};

class ConfItemSTR_cls : public ConfItem_cls {
 public:
    ConfItemSTR_cls();
    ConfItemSTR_cls(wxString strHeader, wxString strBody);

    void SetItem(wxString strHeader, wxString strBody);
    bool ReadStrLine(/*std::wstring*/wxString strLine);
    wxString Serialize();
    wxString GetItemStr();
};

class ConfItemINT_cls : public ConfItem_cls {
 public:
    ConfItemINT_cls();
    ConfItemINT_cls(wxString strHeader, wxString strBody);
    int mBody;

    void SetItem(wxString strHeader, wxString strBody);
    bool ReadStrLine(wxString strLine);
    wxString Serialize();
    wxString GetItemStr();
};

class ConfItemINTARRAY_cls : public ConfItem_cls, public ConfArray_cls {
 public:
    // $B%3%T!<%3%s%9%H%i%/%?4XO"$,Lq2p$J$N$G!"M>J,$KG[Ns$r;}$C$F$7$^$&!#(B
    int mpBody[_CONFARRAY_MAX];
    
    void SetItem(wxString strHeader, wxString strBody);
    bool ReadStrLine(wxString strLine);
    wxString Serialize();
    wxString GetItemStr();
};

class ConfItemUINT_cls : public ConfItem_cls {
 public:
    ConfItemUINT_cls();
    ConfItemUINT_cls(wxString strHeader, wxString strBody);

    unsigned int mBody;
    
    void SetItem(wxString strHeader, wxString strBody);
    bool ReadStrLine(/*std::wstring*/wxString strLine);
    wxString Serialize();
    wxString GetItemStr();
};

class ConfItemUINTARRAY_cls : public ConfItem_cls, public ConfArray_cls {
 public:
    // $B%3%T!<%3%s%9%H%i%/%?4XO"$,Lq2p$J$N$G!"M>J,$KG[Ns$r;}$C$F$7$^$&!#(B
    unsigned int mpBody[_CONFARRAY_MAX];
    
    void SetItem(wxString strHeader, wxString strBody);
    bool ReadStrLine(wxString strLine);
    wxString Serialize();
    wxString GetItemStr();
};

class ConfItemFLOAT_cls : public ConfItem_cls {
 public:
    ConfItemFLOAT_cls();
    ConfItemFLOAT_cls(wxString strHeader, wxString strBody);
    
    float mBody;
    
    void SetItem(wxString strHeader, wxString strBody);
    bool ReadStrLine(/*std::wstring*/wxString strLine);
    wxString Serialize();
    wxString GetItemStr();
};

class ConfItemFLOATARRAY_cls : public ConfItem_cls, public ConfArray_cls {
 public:
    ConfItemFLOATARRAY_cls();
    ConfItemFLOATARRAY_cls(wxString strHeader, wxString strBody);

    // $B%3%T!<%3%s%9%H%i%/%?4XO"$,Lq2p$J$N$G!"M>J,$KG[Ns$r;}$C$F$7$^$&!#(B
    float mpBody[_CONFARRAY_MAX];
        
    void SetItem(wxString strHeader, wxString strBody);
    bool ReadStrLine(wxString strLine);
    wxString Serialize();
    wxString GetItemStr();
};


class ConfItemDOUBLE_cls : public ConfItem_cls {
 public:
    double mBody;
    
    void SetItem(wxString strHeader, wxString strBody);
    bool ReadStrLine(wxString strLine);
    wxString Serialize();
    wxString GetItemStr();
};

class ConfItemDOUBLEARRAY_cls : public ConfItem_cls, public ConfArray_cls {
 public:
    ConfItemDOUBLEARRAY_cls();
    ConfItemDOUBLEARRAY_cls(wxString strHeader, wxString strBody);

    // $B%3%T!<%3%s%9%H%i%/%?4XO"$,Lq2p$J$N$G!"M>J,$KG[Ns$r;}$C$F$7$^$&!#(B
    double mpBody[_CONFARRAY_MAX];
        
    void SetItem(wxString strHeader, wxString strBody);
    bool ReadStrLine(wxString strLine);
    wxString Serialize();
    wxString GetItemStr();
};

class ConfItemBOOL_cls : public ConfItem_cls {
 public:
    ConfItemBOOL_cls();
    ConfItemBOOL_cls(wxString strHeader, wxString strBody);

    bool mbBody;

    void SetItem(wxString strHeader, wxString strBody);
    bool ReadStrLine(wxString strLine);
    wxString Serialize();
    wxString GetItemStr();
};

class ConfItemBOOLARRAY_cls : public ConfItem_cls, public ConfArray_cls {
 public:
    bool mpbBody[_CONFARRAY_MAX];

    void SetItem(wxString strHeader, wxString strBody);
    bool ReadStrLine(wxString strLine);
    wxString Serialize();
    wxString GetItemStr();
};

class ConfItemList_cls {
 public:
    ConfItemList_cls();

    std::vector < ConfItem_cls* > mVpCList;
    bool mbSetWithInitValue;

    void Clear();
    void Add(ConfItem_cls* pC, 
	     wxString strHeader, wxString strBody = wxT(""));

    wxString SerializeAll();
    bool ReadStrLineAll(wxString strLine);
};

#endif
