// "clsColorCurveGUI.h"

#include "clsColorCurveGUI.h"
#include "clsColorCurve.h"

#include "../WIDGETCTRL/clsHookCtrl.h"
#include "../WIDGETCTRL/clsMultiInputPanel.h"
#include "../WIDGETCTRL/clsBitmapPanel.h"
#include "../UNDO/clsUndoManager.h"

#include "../../clsFrameMain.h"
#include "../../wxWidgetEnumMenu.h"

extern wxFrame  *GpCMainFrameCLS;

BEGIN_EVENT_TABLE(ColorCurveTemplate_cls, wxPanel)
EVT_SIZE(ColorCurveTemplate_cls::OnSize)
//EVT_PAINT(ColorCurveTemplate_cls::OnPaint)
END_EVENT_TABLE()

ColorCurveTemplate_cls::
ColorCurveTemplate_cls(ColorCurveGUI_cls *pCParent, wxWindow *pC, wxWindowID id) :
    wxPanel(pC, id, wxDefaultPosition, wxDefaultSize){
    mpCParentGUILink = pCParent;

    if (msbInitialized == FALSE){
	LoadBitmap();
	msbInitialized = TRUE;
    }

    wxString strTitle[_MAX_TEMPLATE_NUM] = {
	wxT("Red Yellow"),  wxT("Green Red"),
	wxT("Black White"), wxT("Cold Color"), 
	wxT("Moderate Gray"), wxT("Spectrum"),
	wxT("SpectrumRGB"), wxT("Incandescent"),
	wxT("ColdSteel") };

    wxString strInit = wxT("1 0.8 0.6 1");
    double pClr0[2][5] = {{0.00, 1.00, 0.00, 0.00, 1.00},
			  {1.00, 1.00, 1.00, 0.00, 1.00}};
    mpCTemplate[0] = new ColorCurve_cls(wxT(""), strTitle[0], strInit, 2, pClr0);

    double pClr1[2][5] = {{0.00, 0.00, 1.00, 0.00, 1.00},
			  {1.00, 1.00, 0.00, 0.00, 1.00}};
    mpCTemplate[1] = new ColorCurve_cls(wxT(""), strTitle[1], strInit, 2, pClr1);

    double pClr2[2][5] = {{0.00, 0.00, 0.00, 0.00, 1.00},
			  {1.00, 1.00, 1.00, 1.00, 1.00}};
    mpCTemplate[2] = new ColorCurve_cls(wxT(""), strTitle[2], strInit, 2, pClr2);

    double pClr3[2][5] = {{0.00, 0.00, 0.00, 1.00, 1.00},
			  {1.00, 0.00, 1.00, 1.00, 1.00}};
    mpCTemplate[3] = new ColorCurve_cls(wxT(""), strTitle[3], strInit, 2, pClr3);

    double pClr4[2][5] = {{0.00, 0.50, 0.50, 0.50, 1.00},
			  {1.00, 0.75, 0.75, 0.75, 1.00}};
    mpCTemplate[4] = new ColorCurve_cls(wxT(""), strTitle[4], strInit, 2, pClr4);

    double pClr5[7][5] = {{0.000, 0.03, 0.00, 0.07, 1.00},
			  {0.167, 0.32, 0.00, 0.77, 1.00},
			  {0.333, 0.00, 0.31, 0.59, 1.00},
			  {0.500, 0.00, 0.78, 0.00, 1.00},
			  {0.666, 0.82, 0.56, 0.00, 1.00},
			  {0.833, 0.84, 0.00, 0.00, 1.00},
			  {1.000, 0.26, 0.00, 0.00, 1.00}};
    mpCTemplate[5] = new ColorCurve_cls(wxT(""), strTitle[5], strInit, 7, pClr5);

    double pClr6[5][5] = {{0.00, 1.00, 0.00, 0.00, 1.00},
			  {0.25, 0.50, 0.00, 0.50, 1.00},
			  {0.50, 0.00, 0.00, 1.00, 1.00},
			  {0.75, 0.00, 0.50, 0.50, 1.00},
			  {1.00, 0.00, 1.00, 0.00, 1.00}};
    mpCTemplate[6] = new ColorCurve_cls(wxT(""), strTitle[6], strInit, 5, pClr6);

    double pClr7[5][5] = {{0.000, 0.00, 0.00, 0.00, 1.00},
			  {0.594, 0.73, 0.00, 0.00, 1.00},
			  {0.809, 1.00, 0.55, 0.20, 1.00},
			  {0.900, 0.97, 0.94, 0.07, 1.00},
			  {1.000, 0.97, 0.97, 0.83, 1.00}};
    mpCTemplate[7] = new ColorCurve_cls(wxT(""), strTitle[7], strInit, 5, pClr7);

    double pClr8[3][5] = {{0.000, 1.00, 1.00, 1.00, 1.00},
			  {0.645, 0.05, 0.02, 0.14, 1.00},
			  {1.000, 0.36, 0.73, 0.76, 1.00}};
    mpCTemplate[8] = new ColorCurve_cls(wxT(""), strTitle[8], strInit, 3, pClr8);
    
    
    for (int i = 0; i < _MAX_TEMPLATE_NUM; i++){
	mpCTemplate[i]->mCbColorCurve.mbBody = TRUE;
	mpCBtnTemplate[i] = new ColorCurveBtn_cls(this, mpCTemplate[i],
						  FALSE, TRUE, TRUE);
	Connect(mpCBtnTemplate[i]->GetId(), wxEVT_COMMAND_BUTTON_CLICKED,
		wxCommandEventHandler(ColorCurveTemplate_cls::OnButtonTemplate));
    }
    
    wxBoxSizer *pBoxSizerSrc = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer *pBoxSizerFolder = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer *pBoxSizerHor0 = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer *pBoxSizerHor1 = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer *pBoxSizerHor2 = new wxBoxSizer(wxHORIZONTAL);

    mpCBPanelFolder = new BitmapPanel_cls(this, wxID_ANY, wxDefaultPosition, wxSize(14,16));
    mpCBPanelFolder->AddBitmapP(&msCBitmapOpen);
    mpCBPanelFolder->AddBitmapP(&msCBitmapClose);
    mpCBPanelFolder->SetBitmapPDisable(&msCBitmapClose);
    Connect(mpCBPanelFolder->GetId(), wxEVT_LEFT_UP,
	    wxMouseEventHandler(ColorCurveTemplate_cls::OnMouseL));
    wxStaticText *pFolderLabel = new wxStaticText(this, wxID_ANY, _("Color Curve Template"));
    
    pBoxSizerFolder->Add(mpCBPanelFolder, 0, wxEXPAND);
    pBoxSizerFolder->Add(pFolderLabel, 0, wxEXPAND);
    pBoxSizerSrc->Add(pBoxSizerFolder, 0, wxEXPAND);
    
    /*
    wxString strTitle[_MAX_TEMPLATE_NUM] = {
	wxT("Red Yellow"),  wxT("Green Red"),
	wxT("Black White"), wxT("Cold Color"), 
	wxT("Moderate Gray"), wxT("Spectrum"),
	wxT("SpectrumRGB"), wxT("Incandescent"),
	wxT("ColdSteel") };
    */
    
    for (int i = 0; i < _MAX_TEMPLATE_NUM; i++)
	mpClrLabel[i] = new wxStaticText(this, wxID_ANY, strTitle[i], wxDefaultPosition, wxDefaultSize, wxALIGN_CENTRE);
    
    for (int i = 0; i < 3; i++){
	pBoxSizerHor0->Add(mpClrLabel[i], 2, wxEXPAND);
	pBoxSizerHor0->Add(mpCBtnTemplate[i], 3, wxEXPAND);
    }
    
    for (int i = 3; i < 6; i++){
	pBoxSizerHor1->Add(mpClrLabel[i], 2, wxEXPAND);
	pBoxSizerHor1->Add(mpCBtnTemplate[i], 3, wxEXPAND);
    }
    
    for (int i = 6; i < 9; i++){
	pBoxSizerHor2->Add(mpClrLabel[i], 2, wxEXPAND);
	pBoxSizerHor2->Add(mpCBtnTemplate[i], 3, wxEXPAND);
    }
    
    pBoxSizerSrc->Add(pBoxSizerHor0, 0, wxEXPAND);
    pBoxSizerSrc->Add(pBoxSizerHor1, 0, wxEXPAND);
    pBoxSizerSrc->Add(pBoxSizerHor2, 0, wxEXPAND);

    SetSizer(pBoxSizerSrc);
}

ColorCurveTemplate_cls::
~ColorCurveTemplate_cls(){
    for (int i = 0; i < _MAX_TEMPLATE_NUM; i++)
	delete mpCTemplate[i];
}

void ColorCurveTemplate_cls::
LoadBitmap(){
    msCBitmapOpen  = wxBitmap(wxT("ICONS/open.png") ,wxBITMAP_TYPE_PNG);
    msCBitmapClose = wxBitmap(wxT("ICONS/close.png"),wxBITMAP_TYPE_PNG);
}

void ColorCurveTemplate_cls::
OnSize(wxSizeEvent& event){
    if (mpCBPanelFolder->mState == 0)
	for (int i = 0; i < _MAX_TEMPLATE_NUM; i++)
	    mpCBtnTemplate[i]->Refresh(FALSE);
    event.Skip();
}

void ColorCurveTemplate_cls::
OnMouseL(wxMouseEvent& event){
    if (mpCBPanelFolder->mState == 1)
	for (int i = 0; i < _MAX_TEMPLATE_NUM; i++){
	    mpCBtnTemplate[i]->Hide();
	    mpClrLabel[i]->Hide();
	}
    else
	for (int i = 0; i < _MAX_TEMPLATE_NUM; i++){
	    mpCBtnTemplate[i]->Show();
	    mpClrLabel[i]->Show();
	}
    
    mpCParentGUILink->Freeze();
    wxSize winSize = mpCParentGUILink->GetSize();
    //mpCParentGUILink->GetSizer()->Layout();
    //mpCParentGUILink->GetSizer()->SetDimension(0, 0, winSize.GetWidth(), -1);
    mpCParentGUILink->SetSizerAndFit(mpCParentGUILink->GetSizer());
    mpCParentGUILink->SetSize(wxDefaultCoord, wxDefaultCoord,
			      winSize.GetWidth(), wxDefaultCoord,
			      wxSIZE_USE_EXISTING);
    mpCParentGUILink->Thaw();
}

void ColorCurveTemplate_cls::
OnButtonTemplate(wxCommandEvent& event){
    int id = event.GetId();
    int index = -1;
    for (int i = 0;  i < _MAX_TEMPLATE_NUM; i++)
	if (mpCBtnTemplate[i]->GetId() == id)
	    index = i;
    if (index == -1) return;

    mpCParentGUILink->mpCCtrlLink->
	CopyColorFromP(mpCTemplate[index]);
}

wxBitmap ColorCurveTemplate_cls::msCBitmapOpen;
wxBitmap ColorCurveTemplate_cls::msCBitmapClose;
bool     ColorCurveTemplate_cls::msbInitialized = FALSE;

// ------

BEGIN_EVENT_TABLE(ColorCurveTics_cls, wxPanel)
EVT_PAINT(ColorCurveTics_cls::OnPaint)
END_EVENT_TABLE()

ColorCurveTics_cls::
ColorCurveTics_cls(ColorCurveGUI_cls *pCParent, wxWindow *pC, wxWindowID id) :
wxPanel(pC, id, wxDefaultPosition, wxSize(-1, 12)){
    mpCParentGUILink = pCParent;
    SetBackgroundStyle(wxBG_STYLE_CUSTOM);
}

void ColorCurveTics_cls::
OnPaint(wxPaintEvent& event){
    ColorCurve_cls *pCCurveLink = mpCParentGUILink->mpCCtrlLink->mpCCurveLinked;
    if (pCCurveLink != NULL) {

	wxAutoBufferedPaintDC dc(this);
	
	SetParameter(GetClientSize(), 
		     pCCurveLink->mCScalingMin.mBody,
		     pCCurveLink->mCScalingMax.mBody, 1);
	DrawTics(dc);
    }
    event.Skip();
}

// ----

BEGIN_EVENT_TABLE(ColorCurveGUI_cls, wxDialog)
EVT_PAINT(ColorCurveGUI_cls::OnPaint)
EVT_KEY_DOWN(ColorCurveGUI_cls::OnKeyDown)
END_EVENT_TABLE()

ColorCurveGUI_cls::
ColorCurveGUI_cls(ColorCurveCtrl_cls* pCCtrlLink,
		  wxWindow *pC, wxPoint pos, wxSize size) :
    wxDialogEXKey(pC, wxID_ANY, _("Color Curve Editor"), pos, size, NULL/*bitmap*/, wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER){
    mpCCtrlLink = pCCtrlLink;
    mDummy = 1;
    mDummy = 0;
    mDummyValueX = 0;
    mDummyValueType = 0;
    for (int i = 0; i < 4; i++) mDummyPColor[i] = 0;

    wxBoxSizer *pBoxSizerSrc = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer *pBoxSizerTop = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer *pBoxSizerLft = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer *pBoxSizerRgt = new wxBoxSizer(wxVERTICAL);
    
    mpCBtnClrCurve = new ColorCurveBtn_cls (this, NULL, FALSE);
    mpCTics      =   new ColorCurveTics_cls(this, this, wxID_ANY); 
    mpCMainGraph =   new GraphPanel_cls    (this, wxID_ANY, wxDefaultPosition,
					    wxSize(240, 180));
    
    pBoxSizerLft->Add(mpCBtnClrCurve, 0, wxEXPAND);
    pBoxSizerLft->Add(mpCTics, 0, wxEXPAND);
    pBoxSizerLft->Add(mpCMainGraph, 1, wxEXPAND);

    SetMNumScale(pBoxSizerRgt);
    SetMNumColor(pBoxSizerRgt);
    
    pBoxSizerTop->Add(pBoxSizerLft, 1, wxEXPAND);
    pBoxSizerTop->Add(pBoxSizerRgt, 0, wxEXPAND);

    mpCPanelTemplate = new ColorCurveTemplate_cls(this, this, wxID_ANY);

    pBoxSizerSrc->Add(pBoxSizerTop, 1, wxEXPAND);
    pBoxSizerSrc->Add(mpCPanelTemplate, 0, wxEXPAND);
    
    SetSizer(pBoxSizerSrc);
 
    ResizeDialog();
}

void ColorCurveGUI_cls::
SetMNumScale(wxBoxSizer *pBoxSizer){
    MultiInputPanel_cls* pCurr = 
	InitializeMNumPanel(&mpCMInputPanelScale, this);
    pCurr->mUpdateBit = 
	/*_COMMAND_UPDATE_DISPLAY_CAMCONF |*/ _COMMAND_UPDATE_DISPLAY_GL;
    
    int boxWidth = 2;
    pCurr->mTextWidth = 60;
    //pCurr->mComboWidth = 140;
    
    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, wxT("Min/Max"));
    mIndexScaleMin = pCurr->CombinePointer(_ITEM_FLOAT, &mDummy);
    mIndexScaleMax = pCurr->CombinePointer(_ITEM_FLOAT, &mDummy);

    pCurr->mTextWidth = 90;
#ifdef WIN32
    pCurr->mItemWidth = -1;
#else
    pCurr->mItemWidth = 120;
#endif
    wxString listValue[3] = {wxT("VALUE1"), _("Radius"), _("Velocity (not yet)")};
    mIndexValueType = pCurr->CombinePointerList(_ITEM_UINT_LIST, &mDummyValueType, 3, listValue, _("Depend on"));
    
    pCurr->mMinimumWidth = -1;
    pCurr->FinishSetting(pBoxSizer);

    pCurr->mpCHookCtrl->SetFuncHook(FuncHookRefresh, _HOOK_CHANGE, wxID_ANY, 
				    FALSE, this);
}

void ColorCurveGUI_cls::
SetMNumColor(wxBoxSizer *pBoxSizer){
    MultiInputPanel_cls* pCurr = 
	InitializeMNumPanel(&mpCMInputPanelColor, this);
    pCurr->mUpdateBit = 
	/*_COMMAND_UPDATE_DISPLAY_CAMCONF |*/ _COMMAND_UPDATE_DISPLAY_GL;
    
    int boxWidth = 2;
    pCurr->mTextWidth = 60;
    pCurr->mComboWidth = 140;

    mIndexValueX = pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, wxT("Index"));
    pCurr->CombinePointer(_ITEM_FLOAT, &mDummyValueX);
    pCurr->SetRange(_ITEM_LASTITEM, 0, 255, 255);
    pCurr->CombinePointer(_ITEM_FLOAT_SLIDER, &mDummyValueX);
    pCurr->SetRange(_ITEM_LASTITEM, 0, 255, 255);

    wxString strTag[4] = {wxT("R"), wxT("G"), wxT("B"), wxT("A")};
    for (int i = 0; i < 4; i++){
	mIndexColor[i] = 
	    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, strTag[i]);
	pCurr->CombinePointer(_ITEM_FLOAT, &mDummyPColor[i]);
	pCurr->CombinePointer(_ITEM_FLOAT_SLIDER, &mDummyPColor[i]);
	pCurr->SetRange(_ITEM_LASTITEM, 0, 255, 255);
    }
    
    pCurr->mMinimumWidth = -1;
    pCurr->FinishSetting(pBoxSizer);

    pCurr->mpCHookCtrl->SetFuncHook(FuncHookIndex, _HOOK_CHANGE,
				    pCurr->mVCItemList[mIndexValueX+1].mId, FALSE, this);
    pCurr->mpCHookCtrl->SetFuncHook(FuncHookIndex, _HOOK_CHANGE,
				    pCurr->mVCItemList[mIndexValueX+2].mId, FALSE, this);

    for (int i = 0; i < 4; i++){
	pCurr->mpCHookCtrl->SetFuncHook(FuncHookColor, _HOOK_CHANGE,
					pCurr->mVCItemList[mIndexColor[i]+1].mId, TRUE, this);
	pCurr->mpCHookCtrl->SetFuncHook(FuncHookColor, _HOOK_CHANGE,
					pCurr->mVCItemList[mIndexColor[i]+2].mId, TRUE, this);
    }
}


void ColorCurveGUI_cls::
RecconectColor(ColorCurve_cls *pCColorLinked){
    MultiInputPanel_cls* pCurr = mpCMInputPanelScale;
    pCurr->mVCItemList[mIndexScaleMin].CombinePointer
	(_ITEM_FLOAT, &pCColorLinked->mCScalingMin.mBody);
    pCurr->mVCItemList[mIndexScaleMax].CombinePointer
	(_ITEM_FLOAT, &pCColorLinked->mCScalingMax.mBody);
    pCurr->mVCItemList[mIndexValueType].CombinePointer
	(_ITEM_UINT_LIST, &pCColorLinked->mCDependType.mBody);
    UpdateMNumValues();
    pCurr->UpdateValues();
}

void ColorCurveGUI_cls::
SetColorComponent(int clrIndex){
    // XC_[𓮂2񗈂邱Ƃɒ
    int clr = 0;
    for (int i = 0; i < 4; i++)
	if (clrIndex == mIndexColor[i]+1 || clrIndex == mIndexColor[i]+2)
	    clr = i;
    
    mpCCtrlLink->mpCCurveLinked->mpCClrCurve->
	InsertKey(clr, mDummyValueX, mDummyPColor[clr]);
}

void ColorCurveGUI_cls::
UpdateMNumValues(){
    if (mpCCtrlLink == NULL || mpCCtrlLink->mpCCurveLinked == NULL) return;
    
    //mpCCtrlLink->mpCCurveLinked->PreCalcFactor();
    mpCCtrlLink->mpCCurveLinked->GetColor4fNormal(mDummyPColor, mDummyValueX);
    mpCMInputPanelColor->UpdateValues();
}

void ColorCurveGUI_cls::
OnPaint(wxPaintEvent& event){
    /*
    wxClientDC dc(mpCPanelClrCurve);
    mpCCtrlLink->mpCCurveLinked->DrawColorOnClientDC
	(dc, mpCPanelClrCurve, FALSE);
    */
    mpCBtnClrCurve->Refresh(FALSE);
    mpCTics->Refresh(FALSE);
    //mpCMainGraph->Refresh(FALSE);
    event.Skip();
}

void ColorCurveGUI_cls::
OnKeyDown(wxKeyEvent& event){
    if (event.GetModifiers() == wxMOD_NONE){
	if (event.GetKeyCode() == 'r')
	    mpCCtrlLink->SetControlMode(0);
	else if (event.GetKeyCode() == 'g')
	    mpCCtrlLink->SetControlMode(1);
	else if (event.GetKeyCode() == 'b')
	    mpCCtrlLink->SetControlMode(2);
	else if (event.GetKeyCode() == 'a')
	    mpCCtrlLink->SetControlMode(3);
	else mpCCtrlLink->SetControlMode(-1);
    }
    if (event.GetModifiers() == wxMOD_CONTROL)
	switch(event.GetKeyCode()){
	case 'Z': {
	    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuEditUndo);
	    GpCMainFrameCLS->AddPendingEvent(com);
	    break; }
	case 'Y': {
	    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuEditRedo);
	    GpCMainFrameCLS->AddPendingEvent(com);
	    break; }
	}
    event.Skip();
}

void ColorCurveGUI_cls::
FuncHookRefresh(void *pEvent, void *pArg){
    ((ColorCurveGUI_cls*)pEvent)->mpCTics->Refresh(FALSE);
}

void ColorCurveGUI_cls::
FuncHookIndex(void *pEvent, void *pArg){
    ColorCurveGUI_cls *pThis = ((ColorCurveGUI_cls*)pEvent);
    pThis->UpdateMNumValues();
    pThis->mpCMainGraph->SetValueX(pThis->mDummyValueX);
    pThis->mpCMainGraph->Refresh(FALSE);
}

void ColorCurveGUI_cls::
FuncHookColor(void *pEvent, void *pArg){
    ColorCurveGUI_cls *pThis = ((ColorCurveGUI_cls*)pEvent);
    pThis->SetColorComponent(*(int*)pArg);
}

// -----

ColorCurveCtrl_cls::
ColorCurveCtrl_cls(FrameMain_cls* pCParentFrame){
    mpCCurveLinked = NULL;
    mpCGUI = NULL;
    mpCParentFrame = pCParentFrame;
    InitGUI(pCParentFrame);
}

void ColorCurveCtrl_cls::
LinkColorCurve(ColorCurve_cls *pCClrCurve){
    mpCCurveLinked = pCClrCurve;
    wxString strLabel;
    strLabel << _("Color Curve Editor") << wxT(" : ") << pCClrCurve->mstrLabel;
    mpCGUI->SetLabel(strLabel);
    mpCGUI->RecconectColor(pCClrCurve);
    mpCGUI->mpCMainGraph->SetParamGroup(mpCCurveLinked->mpCClrCurve);
    mpCGUI->mpCBtnClrCurve->LinkColorCurve(pCClrCurve);
}

void ColorCurveCtrl_cls::
SetControlMode(int mode){
    if (mpCCurveLinked == NULL) return;
    mpCCurveLinked->mpCClrCurve->mControlMode = mode;
}

void ColorCurveCtrl_cls::
InitGUI(wxWindow *pC){
    mpCGUI = new ColorCurveGUI_cls(this, pC,
				   wxDefaultPosition, wxDefaultSize);
    SetPDialog(mpCGUI);
}

void ColorCurveCtrl_cls::
UpdateItems(bool bForce){
    if (mpCGUI == NULL) return;
    
    mpCGUI->Refresh(FALSE);
    mpCGUI->UpdateMNumValues();
    mpCGUI->mpCMInputPanelColor->UpdateValues();
}

void ColorCurveCtrl_cls::
CopyColorFromP(ColorCurve_cls *pCClrCurve){
    if (mpCCurveLinked != NULL)
	mpCCurveLinked->CopyColorFromP(pCClrCurve);
}
