// -*- c++ -*-
// "clsColorCurveGUI.cpp"

#ifndef _GL_COLORCURVE_GUI_H
#define _GL_COLORCURVE_GUI_H

#include "../WIDGETCTRL/clsDialogEXKey.h"
#include "../WIDGETCTRL/clsDialogController.h"
#include "../WIDGETCTRL/clsGraphPanel.h"
#include "../PARAMETER/clsTics.h"

class BitmapPanel_cls;
class ColorCurve_cls;
class ColorCurveBtn_cls;
class ColorCurveCtrl_cls;
class ColorCurveGUI_cls;
class FrameMain_cls;

#define _MAX_TEMPLATE_NUM 9

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class ColorCurveTemplate_cls : public wxPanel {
public:
    ColorCurveTemplate_cls(ColorCurveGUI_cls *pCParent, wxWindow *pC, wxWindowID id);
    ~ColorCurveTemplate_cls();

    ColorCurveGUI_cls* mpCParentGUILink;

    wxStaticText        *mpClrLabel[9];
    BitmapPanel_cls     *mpCBPanelFolder;
    ColorCurveBtn_cls   *mpCBtnTemplate[_MAX_TEMPLATE_NUM];
    ColorCurve_cls      *mpCTemplate[_MAX_TEMPLATE_NUM];

    static wxBitmap msCBitmapOpen;
    static wxBitmap msCBitmapClose;
    static bool     msbInitialized;

    void LoadBitmap();
    void OnSize(wxSizeEvent& event);
    //void OnPaint(wxPaintEvent& event);
    void OnMouseL(wxMouseEvent& event);
    void OnButtonTemplate(wxCommandEvent& event);

private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

class ColorCurveTics_cls : public wxPanel, Tics_cls {
public:
    ColorCurveTics_cls(ColorCurveGUI_cls *pCParent, wxWindow* pC, wxWindowID id);
    void OnPaint(wxPaintEvent& event);

    ColorCurveGUI_cls* mpCParentGUILink;

 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

class ColorCurveGUI_cls : public wxDialogEXKey {
 public:
    ColorCurveGUI_cls(ColorCurveCtrl_cls *pCCtrlLink, 
		      wxWindow *pCParent, wxPoint pos, wxSize size);

    ColorCurveCtrl_cls  *mpCCtrlLink;
    wxWindow            *mpCParent;
    MultiInputPanel_cls *mpCMInputPanelScale;
    MultiInputPanel_cls *mpCMInputPanelColor;

    ColorCurveBtn_cls   *mpCBtnClrCurve;
    ColorCurveTics_cls  *mpCTics;
    GraphPanel_cls      *mpCMainGraph;
    
    ColorCurveTemplate_cls *mpCPanelTemplate;

    float mDummy; // lƂăN
    int mIndexScaleMin, mIndexScaleMax;

    unsigned int mDummyValueType;
    float mDummyValueX;
    float mDummyPColor[4];
    int mIndexValueType;
    int mIndexValueX;
    int mIndexColor[4];

    void RecconectColor(ColorCurve_cls *pCCtrlLink);
    void SetMNumScale(wxBoxSizer *pBoxSizer);
    void SetMNumColor(wxBoxSizer *pBoxSizer);

    void SetColorComponent(int clrIndex);
    void UpdateMNumValues();
    void OnPaint(wxPaintEvent& event);
    void OnKeyDown(wxKeyEvent& event);
    
    static void FuncHookRefresh(void *pEvent, void *pArg);
    static void FuncHookIndex(void *pEvent, void *pArg);
    static void FuncHookColor(void *pEvent, void *pArg);
 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

class ColorCurveCtrl_cls : public DialogControl_cls{
 public:
    ColorCurveCtrl_cls(FrameMain_cls *pCParentFrame);

    FrameMain_cls *mpCParentFrame;
    wxBitmap      *mpBitmapLink;

    ColorCurveGUI_cls *mpCGUI;

    ColorCurve_cls *mpCCurveLinked;
    void LinkColorCurve(ColorCurve_cls *pCClrCurve);
    void SetControlMode(int mode);

    void InitGUI(wxWindow *pC);
    void UpdateItems(bool bForce = FALSE);
    void CopyColorFromP(ColorCurve_cls *pCClrCurve);
};

#endif
