// -*- c -*- 
// "clsGLAttribute.cpp"

#ifndef _GL_ATTRIBUTE_H_
#define _GL_ATTRIBUTE_H_

#define _GL_DRAW_POINT     0
#define _GL_DRAW_BILLBOARD 1
#define _GL_DRAW_SPHERE    2
#define _GL_DRAW_BOTH      3
#define _GL_HIDE           4

#define _GL_RADIUS_NORMAL   0
#define _GL_RADIUS_CONSTANT 1

#define _GL_ALPHA_NORMAL         0
#define _GL_ALPHA_INVERSE_SQUARE 1

#define _GL_BLEND_ONE_MINUS_SRC_ALPHA 0
#define _GL_BLEND_ONE 1

#define _GL_AMBIENT  0
#define _GL_DIFFUSE  1
#define _GL_SPECULAR 2

#ifdef WIN32
#include <windows.h>
#include <GL/glu.h>
#include <GL/glext.h>
#elif defined __WXMAC__
#define GL_GLEXT_PROTOTYPES 
#include <OpenGL/glu.h>
#else
#define GL_GLEXT_PROTOTYPES 
#include <GL/glu.h>
#endif

#include "../CONFITEM/clsConfItem.h"
#include <wx/wx.h>

class ColorCurve_cls;
class DrawOption_cls;
class PDataSequence_cls;
class ShaderCtrl_cls;
class GLAttributeGUI_cls;

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class GLAttribute_cls{
 public:
    GLAttribute_cls(PDataSequence_cls *pCParentSequence, 
		    int selfIndex, DrawOption_cls *pCDrawOptionLink);
    ~GLAttribute_cls();

    void InstantiateGUI(wxWindow *pCParent);
    void RefreshTex();
    void GenerateBufferRGBA(wxImage *pCImage);
    void DeleteBufferRGBA();
    
    PDataSequence_cls  *mpCParentSequence;
    DrawOption_cls     *mpCDrawOptionLink;
    GLAttributeGUI_cls *mpCGUI;

    ColorCurve_cls *mpCClrCurveCol;
    ColorCurve_cls *mpCClrCurveMat[3];
    
    unsigned char *mpBufferRGBA;
    int mBufferWidth, mBufferHeight;

    GLuint  mTextureBillboard;
    wxImage mCTexImgBillboard;
    
    int mSelfIndex;

    static ShaderCtrl_cls *mspCShaderCtrl;
    static void InitializeShader(wxWindow *pCParent);
    void BeginShader(bool bShadowMode, int lightNumber);
    void EndShader();

    float GetRadiusFactor();
    ConfItemList_cls mCConfList;
    ConfItemUINT_cls mCDrawType;
    ConfItemUINT_cls mCDrawQuality;
    ConfItemUINT_cls mCBlendType;
    ConfItemUINT_cls mCRadiusType;
    ConfItemFLOAT_cls mCRadiusFactor;
    ConfItemFLOAT_cls mCRadiusFactorForConst;
    ConfItemINT_cls   mCPointSize;
    ConfItemUINT_cls  mCAlphaType;
    ConfItemUINT_cls  mCShaderType;
    ConfItemFLOAT_cls mCAlphaFactor;
    ConfItemFLOAT_cls mCAlphaDenendBase;
    ConfItemFLOAT_cls mCAlphaMax;
    ConfItemSTR_cls mCTexFilePathBillboard;

    //----

    void ReadStrLine(std::wistream &istream, wxString strLine);
    wxString Serialize();
};

#endif
