// -*- c -*- 
// "clsShaderCtrl.cpp"

#ifndef _SHADER_CTRL_H_
#define _SHADER_CTRL_H_

#include "../CONFITEM/clsConfItem.h"

#ifdef WIN32
#include <windows.h>
#include <GL/glu.h>
#include <GL/glext.h>
#elif defined __WXMAC__
#define GL_GLEXT_PROTOTYPES 
#include <OpenGL/glu.h>
#else
#define GL_GLEXT_PROTOTYPES 
#include <GL/glu.h>
#endif

#include <wx/wx.h>

class ShaderCtrl_cls{
 public:
    ShaderCtrl_cls();

    ConfItemList_cls mCConfList;
    ConfItemFLOAT_cls mCCartoonBoldness;
    
    GLuint mFragShaderGouraud, mFragShaderPhong, mFragShaderCartoon;
    GLuint mVertShaderGouraud, mVertShaderPhong, mVertShaderCartoon;
    //GLuint msGeomShader;
    GLuint mGL2ProgramGouraud, mGL2ProgramPhong, mGL2ProgramCartoon;
    
    GLint mParamIDLNumGouraud, mParamIDLNumPhong, mParamIDLNumCartoon;
    GLint mParamIDShadowModeCartoon;
    GLint mParamIDBoldnessCartoon;

    void InitializeShader(wxWindow *pCParent);
    void MakeShader
	(wxWindow *pCParent,
	 GLuint &program, GLuint &vertShader, GLuint &fragShader,
	 wxString strVertShader, wxString strFragShader);
    void ShowLog(wxWindow *pCParent, GLuint shader);

    void BeginShader(int shaderType, bool bShadowMode, int lightNumber);
    void EndShader(int shaderType);

    void SetShaderParamIDs();
    void SetShaderParamGouraud(int value);
    void SetShaderParamPhong  (int value);
    void SetShaderParamCartoon(int value, float boldness);
    void SetShaderParamCartoonShadowMode(bool bShadowMode);
};

#endif
