// -*- c -*-
// "clsDolly.cpp"

#ifndef _DOLLY_H_
#define _DOLLY_H_

#define _DOLLY_TRANSLATE 0

#include "clsMouseCtrl.h"
#include "../MYGL/clsPositionAndDirection.h"

class MouseNormalized_cls;
class Preference_cls;

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

#include <wx/wx.h>

#define _DOLLY_LINKED 7

class Dolly_cls{
 public:
    Dolly_cls(Preference_cls *pCPreferenceLink);
    
    Preference_cls *mpCPreferenceLink;

    double mSensitivity;
    double mAspectRatio;
    MouseNormalized_cls *mpCMP;
    int    mDisplayMode;

    double *mpItemPosLink;
    double *mpItemPosOrgLink;
    double *mpItemScaleLink;
    double *mpItemDRotLink;

    double mMatrixModelView[16];
    double mMatrixProjection[16];
    int    mMatrixViewport[4];

    double mPosItemOnW[3];

    void SetParameter(double sensitivity, MouseNormalized_cls *pCMP, 
		      wxSize sz, int displayMode);
    bool Gyration  (PositionAndDirection_cls *pCCamPos);
    bool Zoom      (PositionAndDirection_cls *pCCamPos, float *pOrthoScale);
    bool MoveCenter(PositionAndDirection_cls *pCCamPos,
		    Position_cls *pCAncPos);
    bool MoveItem(PositionAndDirection_cls *pCCamPos,
		  bool bDragging, wxSize sz, int dragMode);
    bool ZoomWheel (PositionAndDirection_cls *pCCamPos, 
		    double wheelRotation, float *pOrthoScale);
};

#endif
