// -*- c -*-
// "clsHitTest.h"

#include "clsHitTest.h"
#include "clsMainGLCanvas.h"

void HitTest_cls::
StartHitTest(float mouseNX, float mouseNY, float aspect,
	     MainGLCanvas_cls *pCGLCanvas,
	     PositionAndDirection_cls *pCCamPos){
    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
    glLoadIdentity();
    
    GLint viewport[4];
    glGetIntegerv(GL_VIEWPORT, viewport);
    float fviewport[4];
    for (int i = 0; i < 4; i++) fviewport[i] = viewport[i];
    
    float pointX = mouseNX * fviewport[2];
    float pointY = ( (1.0f - mouseNY) - 0.5) * fviewport[3]/aspect + fviewport[3] / 2 ;
    gluPickMatrix(pointX, pointY, viewport[2]/50, viewport[3]/50*aspect, viewport);
    
    pCGLCanvas->SetPerspective(pCCamPos);
    
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    pCGLCanvas->SetModelView(pCCamPos);
    
    glSelectBuffer(100, mBuffer4Selection);
    glRenderMode(GL_SELECT);
    glInitNames();
}

std::vector < std::vector < int > > HitTest_cls::
GetVVHittedObject(){
    std::vector < std::vector <int> > VVRet;

    int hitNum = glRenderMode(GL_RENDER); // ZNg[hIGqbg𓾂
    
    GLuint *pBuf = mBuffer4Selection;
    GLuint depthMinMax = UINT_MAX;
    for (int i = 0; i < hitNum; i++){
	GLuint nameStack = pBuf[0]; //pBuf[3]ȍ~nameStackł邩
	GLuint depthMin = pBuf[1];
	GLuint depthMax = pBuf[2];
	std::vector < int > VStackedName;
	for (GLuint j = 0; j < nameStack; j++){
	    VStackedName.push_back(pBuf[3 + j]); 
	}
	VVRet.push_back(VStackedName);

	pBuf += (3 + nameStack);
    }
    
    return VVRet;
}

void HitTest_cls::
EndHitTest(){
    mVVHittedObjects = GetVVHittedObject();

    glMatrixMode(GL_PROJECTION);
    glPopMatrix();
    glMatrixMode(GL_MODELVIEW);
}

int HitTest_cls::
GetFirstObject(){
    if (mVVHittedObjects.size() == 0)
	return -1;

    if (mVVHittedObjects[0].size() == 0)
	return -1;
    
    return (mVVHittedObjects[0][0]);
}

int HitTest_cls::
GetFirstObjectSub(){
    if (mVVHittedObjects.size() == 0)
	return -1;
    if (mVVHittedObjects[0].size() < 2)
	return -1;
    return (mVVHittedObjects[0][1]);
}
