// "clsMainGLCanvas.h"
// (setq c-basic-offset 4)

#ifdef WIN32
#include <windows.h>
#include <GL/glu.h>
#include <GL/glext.h>
PFNGLTEXIMAGE3DPROC glTexImage3D;
PFNGLCOMPRESSEDTEXIMAGE3DPROC glTexCompressedImage3D;
PFNGLBLENDCOLORPROC glBlendColor;
PFNGLBLENDEQUATIONEXTPROC glBlendEquationEXT;
extern PFNGLBINDBUFFERPROC glBindBuffer; //!!
PFNGLCOLORTABLEEXTPROC glColorTableEXT;
#elif defined __WXMAC__
#define GL_GLEXT_PROTOTYPES 
#include <OpenGL/glu.h>
#else
#define GL_GLEXT_PROTOTYPES 
#include <GL/glu.h>
#endif

#ifdef __WXMAC__
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif


#include "../../GL/glsl.h"

#include "clsDolly.h"
#include "clsMainGLCanvas.h"
#include "clsMouseCtrl.h"
//#include "clsHitTest.h"

#include "../GLATTRIB/clsColorCurve.h"
#include "../GLOBJECTS/clsCamera.h"
#include "../GLOBJECTS/clsCone.h"
#include "../GLOBJECTS/clsCylinder.h"
#include "../GLOBJECTS/clsGrid.h"
#include "../GLOBJECTS/clsSphere.h"
#include "../GRAPHIC/clsStereoGram.h"
#include "../MAINCANVAS/clsOverlay.h"
#include "../MAINCANVAS/clsExposure.h"
#include "../MAINCANVAS/clsDrawOption.h"
#include "../TIMELINE/clsTimeCtrl.h"
#include "../PANELS/clsDataExporter.h"
#include "../PARTICLEDATA/clsParticleDataSequence.h"
#include "../PARTICLEDATA/clsThreadFileReader.h"
extern ThreadFileReader_cls   *GpCThreadReader;
extern bool                   GbThreadReaderFinished;
extern int                    GThreadReaderPercentage;
#include "../PARTICLEDATA/clsThreadInterpolate.h"
extern ThreadInterpolator_cls *GpCThreadInterpolate;
extern bool                   GbThreadInterpolateFinished;

extern int                    GDrawingStage;

#include "../SCENEOBJ/clsCameraPath.h"
#include "../SCENEOBJ/clsCameraPathGUI.h"
#include "../SCENEOBJ/clsLightSourceGUI.h"

// dll$B$N%X%C%@(B
//#include "../GLOBJ/GLOBJECTS.h"
// ---
#include "../../wxWidgetEnum.h"
#include "../../wxWidgetEnumMenu.h"

#include "../COMMON/MyVector.h"
/*
#include "../DF3/GL/clsPreviewProperty.h"
#include "../DRAWBOX/clsBoxCopy.h"
*/
#include "../GLCANVAS/clsGLCanvasCtrl.h"
#include "../MYAPI/MsgBox.h"
#include "../MYGL/clsFBO.h"
#include "../MYGL/clsGLString2D.h"
#include "../MYGL/clsGLGuides.h"
#include "../MYGL/clsGLInfo.h"
#include "../MYGL/clsGLPerspective.h"
/*
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"
#include "../MAINCANVAS/clsPreference.h"
#include "../MAINCANVAS/clsDrawItem.h"
#include "../POVRAY/clsLightSource.h"
*/
#include "../UNDO/clsUndoManager.h"
extern UndoManager_cls GCUndoList;

/*
#include "../../clsCameraPath.h"
#include "../../clsTimeCtrl.h"
*/
#include <wx/tglbtn.h>

//int displayListSphere;
//int displayListCylinder;
//int displayListCylinderOpen;
//int displayListCone;
//int displayListConeSimple;
//int displayListTransCube[4];
//int displayListWireBox[5];
//int displayListCamera;

bool GbGLLockPlayWait = FALSE;
bool GbGLLockDrawing = FALSE;
bool GbGLLockProjectLoading = FALSE;
bool GbGLLockForLoadingData = FALSE;
bool GbGLLockForInterplateData = FALSE;

long GTestVariableLong = 0;
int GTestVariableInt = 0;

MainGLCanvas_cls* GpCurrentGLPanel;
//extern MainGLCanvas_cls* GpGLPanelJustHandled;

/*
#include "../DF3/GL/clsColoring.h"
extern Coloring_cls GCColoring;
*/

#include "../GRAPHIC/clsImageIO.h"
#include "../GRAPHIC/clsImgSequence.h"
extern ImageIO_cls GCImgIO;

#include "../../clsFrameMain.h"
#include "../../clsMain.h"

#include <algorithm>
#include <functional>
#include <sstream>

#include <math.h>

#define LOOP_XYZ for (int xyz = 0; xyz < 3; xyz++)
#define X 0
#define Y 1
#define Z 2

#define LOOP_RGB for (int rgb = 0; rgb < 3; rgb++)
#define R 0
#define G 1
#define B 2

#define LOOP_YPRY for (int ypry = 0; ypry < 4; ypry++)

#define _STENCIL_MODE_0 0
#define _STENCIL_MODE_1 1
#define _STENCIL_MODE_2 2

#define ENDL std::endl
#define ENDLWX wxT("\n")

#define _MAINGL_NO_MIRROR -1

#ifdef WIN32
#define _FLAG_SET_CURRENT
#endif
#ifdef __WXGTK__
#define _FLAG_SET_CURRENT
#endif

#define ENDL std::endl

// -----------------------------------------

BEGIN_EVENT_TABLE(MainGLCanvas_cls, wxGLCanvas)
EVT_SIZE        (MainGLCanvas_cls::OnSize)
EVT_PAINT       (MainGLCanvas_cls::OnPaint)
EVT_MOUSE_EVENTS(MainGLCanvas_cls::OnMouse)
EVT_MOUSE_CAPTURE_LOST(MainGLCanvas_cls::OnMouseRelease)
EVT_MOTION(MainGLCanvas_cls::OnMouseMotion)
EVT_MENU (GLMenuMoveToCamPos,   MainGLCanvas_cls::OnMenuMoveToCamPos)
EVT_MENU (GLMenuSetKeyPos,      MainGLCanvas_cls::OnMenuSetKeyPos)
EVT_MENU (GLMenuSetKeyAnc,      MainGLCanvas_cls::OnMenuSetKeyAnc)
EVT_MENU (GLMenuToggleLink,     MainGLCanvas_cls::OnMenuToggleLink)
EVT_MENU (GLMenuTogglePerspective, MainGLCanvas_cls::OnMenuTogglePerspective)
/*
     EVT_MENU (menuItemAddLight,     MainGLCanvas_cls::OnMenuPassToParent)
     EVT_MENU (menuItemAddHotSpot,   MainGLCanvas_cls::OnMenuPassToParent)
     EVT_MENU (menuItemAddPrimitive, MainGLCanvas_cls::OnMenuAddPrimitive)
     EVT_MENU (GLMenuShowPanel,      MainGLCanvas_cls::OnMenuShowPanel)
*/
     EVT_KEY_DOWN  (MainGLCanvas_cls::OnKeyDown)
END_EVENT_TABLE()

MainGLCanvas_cls::
MainGLCanvas_cls(GLCanvasCtrl_cls *pCParentCtrl, FrameMain_cls *pCParentFrame,
		    wxWindowID id, int* attribList,
		    const wxPoint& pos, const wxSize& size,
		    long style, const wxString& name,
		    unsigned int selfIndex, int displayMode) : 
wxGLCanvas(pCParentCtrl, id, pos, size, style /*| wxFULL_REPAINT_ON_RESIZE*/, name, attribList)
{
    ConstructorMain(pCParentCtrl, pCParentFrame, selfIndex, displayMode);
}

MainGLCanvas_cls::
MainGLCanvas_cls(GLCanvasCtrl_cls *pCParentCtrl, FrameMain_cls *pCParentFrame,
		 wxWindowID id, int* attribList,
		 const wxPoint& pos, const wxSize& size,
		 long style, const wxString& name,
		 const wxGLContext *pContextToShare,
		 unsigned int selfIndex, int displayMode) : 
/*
wxGLCanvas(pCParentCtrl, id, attribList, pos, size, style|wxFULL_REPAINT_ON_RESIZE, name), //$BK\Ev$O$3$C$A$r;H$&5$$,$9$k$1$I$&$^$/$$$+$J$$(B
*/
#ifdef __WXGTK__
    wxGLCanvas(pCParentCtrl, id, pos, size, style | wxFULL_REPAINT_ON_RESIZE, name, attribList)
#else
    wxGLCanvas(pCParentCtrl, pContextToShare, id)
#endif
{
    ConstructorMain(pCParentCtrl, pCParentFrame, selfIndex, displayMode, pContextToShare);
}

void MainGLCanvas_cls::
ConstructorMain(GLCanvasCtrl_cls *pCParentCtrl, FrameMain_cls *pCParentFrame,
		unsigned int selfIndex, int displayMode,
		const wxGLContext *pContextToShare)
{
    mpCGLCtrl = pCParentCtrl;
    mpCParentFrameLink = pCParentFrame;
    mpCDrawOptionLink = mpCParentFrameLink->mpCParent->mpCDrawOption;
    mpCMouseCtrl  = new MouseCtrl_cls(pCParentFrame->mpCPreference);
    mpCDolly      = new Dolly_cls(pCParentFrame->mpCPreference);
    mpCGLString2D = new GLStrings2D_cls;
    
    SetBackgroundColour(*wxBLACK);
    mSelfIndex = selfIndex;
    mbInitialized    = FALSE;
    mbExportDataQueue = FALSE;
    mbForceUpdateCameraPos = FALSE;
    mbHitTestItemSelect    = FALSE; 
    mbHitTestGuideSelect   = FALSE; 
    mPrevFrame       = -1;
    mPrevStep        = -1;
    mbMouseDragging  = FALSE;
    mbItemDragging   = FALSE;
    mVHitObj.push_back(0); mVHitObj.push_back(0);
    mbSaveImageQueue = FALSE;
    mbRefreshQueue   = FALSE;

    SetCameraToDefaultPos();

    wxString ssTag;
    ssTag << wxT("Panel") << selfIndex;
    
    mCConfList.Add(&mCbShowItems , ssTag + L"ShowMessage=", L"1");
    mCConfList.Add(&mCbShowItems , ssTag + L"ShowItems=", L"1");
    mCConfList.Add(&mCbShowGrid, ssTag + L"ShowGrid=", L"1");
    mCConfList.Add(&mCbShowData, ssTag + L"ShowData=", L"1");

    /*
    mCConfList.Add(&mCbStereoFlip, ssTag + L"StereoFlip=", L"0");
    */
    
    mCConfList.Add(&mCGLPersAngle, ssTag + L"GLPersAngle=", L"35");
    mCConfList.Add(&mCGLOrthoScale, ssTag + L"GLOrthoScale=", L"1");
    mCConfList.Add(&mCbShowOtherCam, ssTag + L"ShowOtherCam=", L"0");
    mCConfList.Add(&mCbXOR, ssTag + L"DrawItemByXOR=", L"0");
    mCConfList.Add(&mCGLGeometry, ssTag + L"GLGeometry=", L"0");
    mCConfList.Add(&mCDisplayMode, ssTag + L"DisplayMode=", L"0");
    mCConfList.Add(&mCbPivotMode, ssTag + L"PivotMode=", L"0");
    mCConfList.Add(&mCPathIndex, ssTag + L"GLPathIndex=", L"0");
    mCConfList.Add(&mCGridType,  ssTag + L"GridType", L"0");
    mCConfList.Add(&mCbGridAnti, ssTag + L"GridAntialias", L"0");
    mCConfList.Add(&mCbShowGridTag, ssTag + L"GridShowTag", L"0");

    SetDisplayMode(displayMode);

    mCGLPersAngle.mBody = mCGLPerspective.mDeg;
        
#ifdef __WXGTK__
    mpCGLContext = new wxGLContext(this, pContextToShare);
#else
    mpCGLContext = GetContext();
#endif
   
    /*
    mpCGLGuide = new GLGuides_cls;
    mpCGLGuideScrew = new GLGuides_cls(1);
    mpCGLGuideYPR = new GLGuides_cls(3);
    */

    mpCCameraPathLinked   = NULL;
    mpCAnchorPathLinked = NULL;
    mpCImgSeqLinked     = NULL;
    mpCDataExporterLinked = NULL;

    //--- SetSubWindows;

    // Status bar $B$,L5$$$N$G(B helpString$B$OI=<($5$l$J$$$N$G>JN,(B
    mpPopupMenu = new wxMenu; // $B%a%$%s1&%/%j%C%/%a%K%e!<(B

    mpPopupMenu->Append(GLMenuMoveToCamPos, _("Move to Cam Pos"));
    mpPopupMenu->Append(GLMenuSetKeyPos   , _("Sey Key Cam Pos"));
    mpPopupMenu->Append(GLMenuSetKeyAnc   , _("Sey Key Anc Pos"));
    mpPopupMenu->Append(GLMenuToggleLink  , _("Link/Unlink to Cam"));
    mpPopupMenu->AppendSeparator();
    mpPopupMenu->Append(GLMenuTogglePerspective, _("Toggle Perspective"));

    /*
    mpPopupMenu->AppendSeparator();
    mpMenuAdd = new wxMenu;
    mpMenuAdd->Append(menuItemAddPrimitive, _("Add Primitive"));
    mpMenuAdd->Append(menuItemAddLight, _("Add Light"));
    mpMenuAdd->Append(menuItemAddHotSpot, _("Add HotSpot"));
    
    mpPopupMenu->Append(GLMenuAdd, _("Add Item"), mpMenuAdd);
    */
    
    
    /*
    mpMenuItemShowPanel = mpPopupMenu->Append(GLMenuShowPanel   , _("Show Control Panel"));
    */

    mpPopupMenu->UpdateUI(GetEventHandler());
}

MainGLCanvas_cls::
~MainGLCanvas_cls(){
    delete mpCMouseCtrl;
    delete mpCDolly;
    delete mpCGLString2D;
#ifndef __WXMAC__
    //delete mpCGLContext;
#endif
    /*
    delete mpCGLGuide;
    delete mpCGLGuideScrew;
    delete mpCGLGuideYPR;
    */
    delete mpPopupMenu;
}

// ----------

bool MainGLCanvas_cls::
SetGLContext(){
#ifndef __WXMOTIF__
    if (!GetContext()) return FALSE; 
#endif
    
#ifdef _FLAG_SET_CURRENT
    mpCGLContext->SetCurrent(*(wxGLCanvas*)this);
#else
#ifdef __WXMAC__
    /*
    if (mpCGLContext != NULL){
	mpCGLContext->SetCurrent();
	printf("context\n");
    }
    else 
	SetCurrent();
    */
    SetCurrent();
#else
    mpCGLContext->SetCurrent();
#endif
#endif
    return TRUE;
}

void MainGLCanvas_cls::
InitGL(){
    glClearColor( 0, 0, 0, 1.0f );
    glClearStencil(0);

    glEnable(GL_CULL_FACE);
    glCullFace(GL_BACK);
    glEnable(GL_DEPTH_TEST);
    glEnable(GL_LIGHTING);
    glDisable(GL_COLOR_MATERIAL);
    glLineStipple(2, 0xAAAA);
}

void MainGLCanvas_cls::
InitGLUT(){
    static bool msbGLUTInitialized = FALSE;
    if (msbGLUTInitialized == TRUE) return;
    int argc = 1;
    char **argv = new char* [1];
    argv[0] = new char [6];
    printf(argv[0], "dummy");
    glutInit(&argc, argv);
    delete argv[0]; 
    delete argv;
    msbGLUTInitialized = TRUE;
}

void MainGLCanvas_cls::
InitializeShader(){

    if (glslInit()) exit(1);

    //glCreateShader(GL_VERTEX_SHADER);

    mpCParentFrameLink->mpCParent->mpCExposure->Initialize(this);

    GLAttribute_cls::InitializeShader(this);
}

void MainGLCanvas_cls::
InitializeGLIfNot(){
    if (mbInitialized == TRUE) return;
    
    InitGLUT();
    InitGL();
    mpCParentFrameLink->mpCGLInfo->Initialize();
    UpdateWindowSizeInChildClass();
    
    mpCParentFrameLink->GetPCActiveFileSequence()->RefreshGLAttribTex();
    
    
    Camera_cls::InitializeIfNot();
    Cone_cls::InitializeIfNot();
    Cylinder_cls::InitializeIfNot();
    Sphere_cls::InitializeIfNot();
    
    InitializeShader();

    /*
    displayListCylinder = 
	GLOBJ::Cone::DListDraw(90, 4, 1, FALSE, GL_COMPILE);
    displayListCylinderOpen = 
	GLOBJ::Cone::DListDraw(90, 4, 1, TRUE, GL_COMPILE);
    displayListCone       = GLOBJ::Cone::DListDraw(90, 4, 0, FALSE, GL_COMPILE);
    */
    
    // !! FIX_ME !! $B%3!<%s$N%G%#%9%W%l%$%j%9%H$,5o$k(B
    //displayListConeSimple = GLOBJ::Cone::DListDraw(12, 1, 0, FALSE, GL_COMPILE);
    

    /*
    
    for (unsigned int i = 0; i < 4; i++)
	displayListTransCube[i] = 
	    GLOBJ::TransCube::DListDraw(GL_COMPILE, i);

    for (int i = 0; i < 5; i++)
	displayListWireBox[i] = 
	    GLOBJ::WireBox::DListDraw(GL_COMPILE, i);
        
    if (mpCParentFrameLink->mpCGLInfo->mMajorVersion >= 2) 
	RedrawPBO_cls::msbSupported = TRUE;
    if (mpCParentFrameLink->mpCGLInfo->mMajorVersion == 1 &&
	mpCParentFrameLink->mpCGLInfo->mMinorVersion >= 5) 
	RedrawPBO_cls::msbSupported = TRUE;
    */
    
    if (1){// $B8:;;=hM}$,2DG=$@$C$?$i(B
#ifdef WIN32
	glBlendEquationEXT = (PFNGLBLENDEQUATIONEXTPROC) wglGetProcAddress("glBlendEquationEXT");
	glBlendColor = (PFNGLBLENDCOLORPROC) wglGetProcAddress("glBlendColor");
	
	glColorTableEXT = (PFNGLCOLORTABLEEXTPROC)wglGetProcAddress("glColorTableEXT");
	//glCreateShader = (PFNGLCREATESHADERPROC)wglGetProcAddress("glCreateShader");
#endif 
    }
    
    glEnable(GL_TEXTURE_2D);
    mspCDrawTimeIndex->Initialize();
    mspCDrawClrLegend->Initialize();

    msCGLBTNRot.MakeTextureFromImage(wxT("ICONS/Rotation.png"));
    msCGLBTNTrans.MakeTextureFromImage(wxT("ICONS/Translation.png"));
    msCGLBTNScale.MakeTextureFromImage(wxT("ICONS/Scale.png"));
    
    glDisable(GL_TEXTURE_2D);
    glDepthFunc(GL_LEQUAL);
    mbInitialized = TRUE;
}

void MainGLCanvas_cls::
UpdateWindowSizeInChildClass(){
    int w, h;
    GetClientSize(&w, &h);
    mCGLPerspective.SetWindowSize(w, h);
}

// ----

void MainGLCanvas_cls::
SetCameraToDefaultPos(){
    double defaultPos[3] = {-1.12,-0.8,+0.56};
    double defaultTop[3] = { 0,  0, +1};

    LOOP_XYZ mCCameraPos.mPos[xyz] = 3.5 * defaultPos[xyz];
    LOOP_XYZ mCCameraPos.mTgt[xyz] = - defaultPos[xyz];
    LOOP_XYZ mCCameraPos.mTop[xyz] = defaultTop[xyz];
    mCCameraPos.NormalizeAndOrthogonalize();
    mCCameraPosFree   = mCCameraPos;
    mCCameraPosCamera = mCCameraPos;
}

void MainGLCanvas_cls::
UpdateDrawInfo(int width, int height){
    mCDrawInfoPrev = mCDrawInfo;
    
    mCDrawInfo.mbForceNewDraw = FALSE;
    mCDrawInfo.mCCameraPos = mCCameraPos;
}

PositionAndDirection_cls* MainGLCanvas_cls::
GetPCCameraPosition(){
    if (IsDisplayModeOrtho() == TRUE)
	return &mCCameraPosOrtho;
    if (mCDisplayMode.mBody == _GL_CANVAS_LINKED_CAM0)
	return &mCCameraPosCamera;
    return &mCCameraPosFree;
}

Position_cls* MainGLCanvas_cls::
GetPCAnchorPosition(){
    if (IsDisplayModeOrtho() == TRUE)
	return &msCAnchorPosOrtho;
    return &msCAnchorPos;
}

void MainGLCanvas_cls::
ForceUpdateCameraPos(){
    mbForceUpdateCameraPos = TRUE;
}

void MainGLCanvas_cls::
UpdateCameraPos(){
    if (mPrevFrame == -1 && mPrevStep == -1)
	mpCGLCtrl->SyncDisplayModeToCombobox();

    if (mCbPivotMode.mbBody == _PIVOT_FOLLOW_PATH){
	LOOP_XYZ msCAnchorPos.mPos[xyz] = 
	    GetPLinkedAnchorPath()->mCCurrentObj.mPos[xyz];
    }

    if (mCDisplayMode.mBody == _DIRECTION_FREE){
	mCCameraPosFree.PointAt(msCAnchorPos.mPos);
	mCCameraPos = mCCameraPosFree;
    }

    if (IsDisplayModeOrtho() == TRUE){
	ModifyOrthoCamera();
	mCCameraPos = mCCameraPosOrtho;
    }

    if (GetPLinkedCameraPath()->mCbLookAnchor.mbBody == TRUE)
	GetPLinkedCameraPath()->mCCurrentObj.
	    PointAt(GetPLinkedAnchorPath()->mCCurrentObj.mPos);
    
    if (mCDisplayMode.mBody == _GL_CANVAS_LINKED_CAM0){
	if (mPrevFrame != mpCParentFrameLink->GetPCTimeCtrl()->mFrame ||
	    mPrevStep  != mpCParentFrameLink->GetPCTimeCtrl()->mInterpStep)
	    if (mpCCameraPathLinked != NULL)
		mCCameraPosCamera = mpCCameraPathLinked->mCCurrentObj;
	
	if (!(mCCameraPosCamera == mpCCameraPathLinked->mCCurrentObj))
	    mCCameraPosCamera.PointAt(msCAnchorPos.mPos);
	
	mCCameraPos = mCCameraPosCamera;
    }

    GetPCCameraPosition()->UpdateYPR();
    mCCameraPos.UpdateYPR();
    
    /*
    if (mbForceUpdateCameraPos != TRUE)
	if (mPrevFrame == mpCParentFrameLink->GetPCTimeCtrl()->mFrame &&
	    mPrevStep  == mpCParentFrameLink->GetPCTimeCtrl()->mInterpStep){
	    if (mCDisplayMode.mBody == _DIRECTION_FREE)
		mCCameraPos.PointAt(msCAnchorPos.mPos);
	    return;
	}
    */
    mbForceUpdateCameraPos = FALSE;
}

CameraPath_cls* MainGLCanvas_cls::
GetPLinkedCameraPath(){
    if (mpCCameraPathLinked == NULL) 
	return mpCParentFrameLink->mpCParent->mpCCameraPath;
    return mpCCameraPathLinked;
}

LightSRCCtrl_cls* MainGLCanvas_cls::
GetPLinkLightSourceCtrl(){
    return mpCParentFrameLink->mpCParent->mpCLightSRCCtrl;
}

AnchorPath_cls* MainGLCanvas_cls::
GetPLinkedAnchorPath(){
    if (mpCAnchorPathLinked == NULL)
	return mpCParentFrameLink->mpCParent->mpCAnchorPath;
    return mpCAnchorPathLinked;
}

bool MainGLCanvas_cls::
IsStereo(){
    /*
    if (GetPLinkedCameraPath()->mpCStereoGramLinked->mCType.mBody != _STEREO_NONE){
	if (GetPLinkedCameraPath()->mpCStereoGramLinked->mCEye.mBody == _STEREO_NONE)
	    return FALSE;
	if (mCDisplayMode.mBody == _DIRECTION_FREE || 
	    mCDisplayMode.mBody >= _GL_CANVAS_LINKED_CAM0)
	    return TRUE;
    }
    */
    return FALSE;
}


bool MainGLCanvas_cls::
IsOrtographic(){
    return (mCGLGeometry.mBody == _GEOM_ORTHOGRAPHIC);
}

bool MainGLCanvas_cls::
IsDisplayModeOrtho(){
    return (mCDisplayMode.mBody >= _GL_CANVAS_DISPLAY_X_PLUS &&
	    mCDisplayMode.mBody <= _GL_CANVAS_DISPLAY_Z_MINUS);
}

bool MainGLCanvas_cls::
IsFishEye(){
    if (mCDisplayMode.mBody == _DIRECTION_FREE)
	return (mCGLGeometry.mBody == _GEOM_FISHEYE);

    if (mCDisplayMode.mBody >= _GL_CANVAS_LINKED_CAM0)
	return (GetPLinkedCameraPath()->mCCamGeometry.mBody == _GEOM_FISHEYE);

    return FALSE;
}

/*
bool MainGLCanvas_cls::
IsFBOUse(){
    // !!FIX_ME!! FBO$B$r;H$($J$$$H$-$N=hM}$,L5$$(B
    if (mbCFBO.mbBody == TRUE) return TRUE;
    if (IsFishEye() == TRUE) return TRUE;
    return FALSE;
    return TRUE;
}
*/

void MainGLCanvas_cls::
SetAngleIfLinked(){
    if (mCDisplayMode.mBody >= _GL_CANVAS_LINKED_CAM0){
	mCGLPerspective.mDeg = GetPLinkedCameraPath()->mCVAngle.mBody;
	if (GetPLinkedCameraPath()->mCCamGeometry.mBody != _GEOM_FISHEYE &&
	    mCGLPerspective.mDeg >= 120) {
	    mCGLPerspective.mDeg = 120;
	    mstrWarning << wxT("View angle is limited to 120 deg in perspective view.") << ENDLWX;
	}
    }
    else{
	mCGLPerspective.mDeg = mCGLPersAngle.mBody;
	if (mCGLGeometry.mBody != _GEOM_FISHEYE &&
	    mCGLPerspective.mDeg >= 120) {
	    mCGLPerspective.mDeg = 120;
	    mstrWarning << wxT("View angle is limited to 120 deg in perspective view.") << ENDLWX;
	}
    }
}

void MainGLCanvas_cls::
ModifyByStereogram(int forceType){
    /*
    int orgType = GetPLinkedCameraPath()->mpCStereoGramLinked->mCEye.mBody;
    if (forceType != -1)
	GetPLinkedCameraPath()->mpCStereoGramLinked->mCEye.mBody = forceType;
    
    GetPLinkedCameraPath()->ModifyStereogramPos(mCCameraPos);
    mCCameraPos.RotateYPR(GetPLinkedCameraPath()->GetStereogramYawAngle(), 0, 0);
    
    GetPLinkedCameraPath()->mpCStereoGramLinked->mCEye.mBody = orgType;
    */
}

void MainGLCanvas_cls::
ModifyByDomeTilt(){
    /*
      mCCameraPos.RotateYPR(0, GetPLinkedCameraPath()->GetDomePitchAngle(), 0);
    */
}

void MainGLCanvas_cls::
ModifyByDome(PositionAndDirection_cls *pCCam, int forceType){
    switch(forceType){
    case 0:
	pCCam->RotateYPR(45, 0 , 0);
	break;
    case 1:
	pCCam->RotateYPR(-45, 0, 0);
	break;
    case 2:
	pCCam->RotateYPR(45, -90, 0);
	break;
    case 3:
	pCCam->RotateYPR(-45, 90, 0);
	break;
    }
}

void MainGLCanvas_cls::
UpdateAnc(){
    Position_cls CCurrAnc = GetAncPos();

    if (mpCCameraPathLinked != NULL)
	mCCameraPos.SetAncPos(mpCAnchorPathLinked->mCCurrentObj.mPos);
    else
	mCCameraPos.SetAncPos(CCurrAnc.mPos);
}

Position_cls MainGLCanvas_cls::
GetAncPos(){
    if (mCDisplayMode.mBody == _DIRECTION_FREE ||
	mCDisplayMode.mBody >= _GL_CANVAS_LINKED_CAM0)
	return msCAnchorPos;

    // $B8GDjJ}8~$+$i8+$F$$$k>l9g$N%"%s%+!<0LCV$rJV$9(B
    return msCAnchorPosOrtho;
}

double* MainGLCanvas_cls::
GetAnchorPosForRender(){
    static double ancPosForRender[3];
    LOOP_XYZ ancPosForRender[xyz] = 
	mCCameraPos.mPos[xyz] + mCCameraPos.mTgt[xyz];
    return ancPosForRender;
}

void MainGLCanvas_cls::
SetKeyPos(){
    /*
    GLfloat mMatrix[16];
    glGetFloatv(GL_MODELVIEW_MATRIX, mMatrix);
    */

    std::vector < double > VEuler;
    std::vector < double > VPos;
    VPos.push_back(GetPCCameraPosition()->mPos[X]);
    VPos.push_back(GetPCCameraPosition()->mPos[Y]);
    VPos.push_back(GetPCCameraPosition()->mPos[Z]);
    
    VEuler.push_back(GetPCCameraPosition()->mYPR[X]);
    VEuler.push_back(GetPCCameraPosition()->mYPR[Y]);
    VEuler.push_back(GetPCCameraPosition()->mYPR[Z]);
    
    GCUndoList.OpenBlock();
    GetPLinkedCameraPath()->mpCTranslate->SetKeyFrame(&VPos[0], TRUE);
    GetPLinkedCameraPath()->mpCRotation->SetKeyFrame(&VEuler[0], TRUE);
    GCUndoList.CloseBlock();
}

void MainGLCanvas_cls::
SetKeyAnc(){
    GCUndoList.OpenBlock();
    GetPLinkedAnchorPath()->mpCTranslate->
	SetKeyFrame(msCAnchorPos.mPos, TRUE);
    GCUndoList.CloseBlock();
}

void MainGLCanvas_cls::
SetViewport(){
    mCGLPerspective.SetViewportOnGL();
}

void MainGLCanvas_cls::
SetPerspective(PositionAndDirection_cls *pCCam){
    
    if (IsOrtographic()) mCGLPerspective.mbPerspective = FALSE;
    else                 mCGLPerspective.mbPerspective = TRUE;
    
    if (mbSaveImageQueue == TRUE){
	if (mbSaveImgSeqQueue == TRUE 
	    && mpCImgSeqLinked != NULL &&
	    IsFishEye() == FALSE){

	    mCGLPerspective.mDeg = mpCImgSeqLinked->mClipAngle;
	    mCGLPerspective.SetClipSize(mpCImgSeqLinked->mClipWidth, 
					mpCImgSeqLinked->mClipHeight);
	    //return;
	}
    }

    mCGLPerspective.SetPerspectiveOnGL(pCCam);
}

void MainGLCanvas_cls::
SetModelView(PositionAndDirection_cls *pCCam){
    mCGLPerspective.SetModelOrProjectionViewOnGL(pCCam, GL_MODELVIEW);
    glGetDoublev(GL_MODELVIEW_MATRIX, mMatrixModelView);
    glGetDoublev(GL_PROJECTION_MATRIX, mMatrixProjection);
    glGetIntegerv(GL_VIEWPORT, mMatrixViewport);
}

/*
void MainGLCanvas_cls::
SetLight(double doubleIndex){
    
    // $B8w8;$O:GDc(B8$B$D$^$G$O;H$($k(B
    // $BD4@0:Q$_$N0LCV$r(BmALightPos$B$K;}$C$F$$$k$N$G$3$C$A$G4pK\=hM}(B
    int lightNum = mLightNumber;
    if (lightNum == 0) lightNum = 1; //$B8w8;(B0$B$G$b2>%i%$%H(B
    if (lightNum > 8) lightNum = 8;

    for (int i = 0; i < 8; i++)
	if (i < lightNum) glEnable(msGLLightIndex[i]);
	else glDisable(msGLLightIndex[i]);

    // 8$B$D$a$N%i%$%H$OFC<l(B
    for (int i = 0; i < 7; i++){
	glLightfv(msGLLightIndex[i], GL_POSITION, mALightPos[i]);
	glLightfv(msGLLightIndex[i], GL_DIFFUSE,  mALightColor[i]);
	glLightfv(msGLLightIndex[i], GL_AMBIENT,  mALightColor[i]);
	glLightfv(msGLLightIndex[i], GL_SPECULAR, mALightColor[i]);
	glLightfv(msGLLightIndex[i], GL_LINEAR_ATTENUATION, &mALightAttenuateL[i]);
	glLightfv(msGLLightIndex[i], GL_QUADRATIC_ATTENUATION, &mALightAttenuateQ[i]);

	// 8$B$D$a$N%i%$%H$K$b(BAttenuation
	glLightfv(msGLLightIndex[7], GL_LINEAR_ATTENUATION, &mALightAttenuateL[i]);
	glLightfv(msGLLightIndex[7], GL_QUADRATIC_ATTENUATION, &mALightAttenuateQ[i]);
	mpCParentFrameLink->mpCParent->mpCLightSRC->
	    SetGLLightOptional(msGLLightIndex[i], i, mALightPos[i],
			       mALightColor[i]);
    }
}
*/

void MainGLCanvas_cls::
ClearBuffer(){

    glClearColor( mspCClrCurveBG->mCConstantColor.mpBody[R],
		  mspCClrCurveBG->mCConstantColor.mpBody[G],
		  mspCClrCurveBG->mCConstantColor.mpBody[B],
		  1.0f);
    

    glClear( GL_COLOR_BUFFER_BIT | GL_ACCUM_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
}

/*
void MainGLCanvas_cls::
SetGLLightSource(double doubleIndex){
    
GetPLinkLightSourceCtrl()->GLSetLightSource(doubleIndex);
    
    GLfloat light0Pos[4]    = { 1.0f, 1.0f, 1.0f, 0.0f};
    GLfloat light0Color[4]  = { 1.0f, 1.0f, 1.0f, 1.0f};
    GLfloat light0ColorAmbient[4]  = { 1.0f, 1.0f, 1.0f, 1.0f};
    glLightfv(GL_LIGHT0, GL_POSITION, light0Pos);
    glLightfv(GL_LIGHT0, GL_DIFFUSE,  light0Color);
    glLightfv(GL_LIGHT0, GL_AMBIENT,  light0Color);
    glLightfv(GL_LIGHT0, GL_SPECULAR, light0Color);
    
    GLfloat light1Pos[4]    = { -1.0f, -1.0f, -1.0f, 0.0f};
    GLfloat light1Color[4]  = { 0.1f, 0.1f, 0.1f, 0.0f};
    GLfloat light1ColorAmbient[4]  = { 0.0f, 0.0f, 0.0f, 0.0f};
    glLightfv(GL_LIGHT1, GL_POSITION, light1Pos);
    glLightfv(GL_LIGHT1, GL_DIFFUSE,  light1Color);
    glLightfv(GL_LIGHT1, GL_AMBIENT,  light1ColorAmbient);
    glLightfv(GL_LIGHT1, GL_SPECULAR, light1ColorAmbient);
}
*/

void MainGLCanvas_cls::
DrawDataLitDiffuse(double doubleIndex, int fboIndex, int lightIndex){
    if (mCbShowData.mbBody == FALSE) return;

    int    currentIndex =
	mpCParentFrameLink->GetPCTimeCtrl()->GetRemappedIndex();
    double doubleInterpStep = 
	mpCParentFrameLink->GetPCTimeCtrl()->GetRemappedInterpStepDouble();
    double dT = 
	mpCParentFrameLink->GetPCActiveFileSequence()->GetDT(currentIndex, doubleInterpStep);
    
    mpCParentFrameLink->GetPCActiveFileSequence()->SetCameraInfo(mCCameraPos);

    int   lightNumber = GetPLinkLightSourceCtrl()->mCLightNum.mBody;
    float pLightPosForSV[4];
    float pLightPhiTheta[2];

    GetPLinkLightSourceCtrl()->
	GetLightInfo(doubleIndex, pLightPosForSV, pLightPhiTheta,
		     lightIndex, TRUE);
    GetPLinkLightSourceCtrl()->GLSetSingleDiffuse(lightIndex, doubleIndex);
    
    // $B$^$:DL>o$NIA2h(B
    mpCParentFrameLink->GetPCActiveFileSequence()->GLDrawData
	(fboIndex, currentIndex, dT, /*lightNumber*/1,
	 pLightPosForSV, pLightPhiTheta[0], pLightPhiTheta[1]);
    
    glClear(GL_STENCIL_BUFFER_BIT);
    glEnable(GL_STENCIL_TEST);
    glStencilMask(255);
    glDepthMask(GL_FALSE);
    
    glStencilFunc(GL_ALWAYS, 0, 255);
    if (mpCDrawOptionLink->mCShadow.mBody == 1)
	glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);
    glColor4f(1,1,1,0.2); //?

    // $B1F%]%j%4%s(B
    GDrawingStage = 1;
    lightNumber = 0;
    mpCParentFrameLink->GetPCActiveFileSequence()->GLDrawData
	(fboIndex, currentIndex, dT, lightNumber, pLightPosForSV,
	 pLightPhiTheta[0], pLightPhiTheta[1], TRUE);
    
    glColorMask(1,1,1,1);
    glDepthMask(GL_TRUE);
    glStencilMask(0);
    
    glStencilFunc(GL_LESS, 0, 255);
    glStencilOp(GL_KEEP, GL_KEEP, GL_KEEP);
    
    //glClear(GL_DEPTH_BUFFER_BIT);
    glDepthMask(GL_FALSE);
    
    if (mpCParentFrameLink->GetPCActiveFileSequence()
	->mpCGLAttribute[0]->mCShaderType.mBody != 0){
	// $B1F$rEI$k(B
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	gluOrtho2D(0, 1, 0, 1);
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();

	glUseProgram(0);
	glDisable(GL_LIGHTING);
	glColor4f(0, 0, 0, 0);
	glRectf(0,0,1,1);
	
	glPopMatrix();
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
    }
    else{
	GetPLinkLightSourceCtrl()->GLDisableAllLight();
	GDrawingStage = 2;
	mpCParentFrameLink->GetPCActiveFileSequence()->GLDrawData
	    (fboIndex, currentIndex, dT, 0, pLightPosForSV,
	     pLightPhiTheta[0], pLightPhiTheta[1], FALSE, TRUE);
	GDrawingStage = 0;
    }
}

void MainGLCanvas_cls::
DrawDataMain(double doubleIndex, int fboIndex, int shadowNumber){
    if (mCbShowData.mbBody == FALSE) return;
    
    int    currentIndex =
	mpCParentFrameLink->GetPCTimeCtrl()->GetRemappedIndex();
    double doubleInterpStep = 
	mpCParentFrameLink->GetPCTimeCtrl()->GetRemappedInterpStepDouble();
    double dT = 
	mpCParentFrameLink->GetPCActiveFileSequence()->GetDT(currentIndex, doubleInterpStep);
    
    mpCParentFrameLink->GetPCActiveFileSequence()->SetCameraInfo(mCCameraPos);

    int lightNumber =  GetPLinkLightSourceCtrl()->mCLightNum.mBody;
    int activeShadow = GetPLinkLightSourceCtrl()->GetActiveShadow();
    float pLightPosForSV[4];
    float pLightPhiTheta[2];
    GetPLinkLightSourceCtrl()->
	GetLightInfo(doubleIndex, pLightPosForSV, pLightPhiTheta,
		     activeShadow, TRUE);
    
    mpCParentFrameLink->GetPCActiveFileSequence()->GLDrawData
	(fboIndex, currentIndex, dT, lightNumber, pLightPosForSV, 
	 pLightPhiTheta[0], pLightPhiTheta[1]);

    if (shadowNumber > 0){
	glClear(GL_STENCIL_BUFFER_BIT);
	glEnable(GL_STENCIL_TEST);
	glStencilMask(255);
	glDepthMask(GL_FALSE);

	glStencilFunc(GL_ALWAYS, 0, 255);
	if (mpCDrawOptionLink->mCShadow.mBody == 1)
	    glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE);
	glColor4f(1,1,1,0.2); //?
	
	GDrawingStage = 1;
	mpCParentFrameLink->GetPCActiveFileSequence()->GLDrawData
	    (fboIndex, currentIndex, dT, lightNumber, pLightPosForSV, 
	     pLightPhiTheta[0], pLightPhiTheta[1],
	     TRUE);

	glColorMask(1,1,1,1);
	glDepthMask(GL_TRUE);
	glStencilMask(0);

	glStencilFunc(GL_LESS, 0, 255);
	glStencilOp(GL_KEEP, GL_KEEP, GL_KEEP);
	
	glClear(GL_DEPTH_BUFFER_BIT);
	
	GDrawingStage = 2;
	GetPLinkLightSourceCtrl()->SetBasicLight(doubleIndex, 1);
	mpCParentFrameLink->GetPCActiveFileSequence()->GLDrawData
	    (fboIndex, currentIndex, dT, lightNumber, pLightPosForSV, 
	     pLightPhiTheta[0], pLightPhiTheta[1], 
	     FALSE, TRUE);
	GDrawingStage = 0;
    }

}

void MainGLCanvas_cls::
DrawCameraPos(double scale, PositionAndDirection_cls CPos){
}

void MainGLCanvas_cls::  
DrawGrid(double scale, double scale10){
    if (mCbShowGrid.mbBody == FALSE) return;
    glColor4f(0.3f, 0.3f, 0.3f, 1.f);
    Grid_cls::DrawGridFlat(scale10);
}

void MainGLCanvas_cls::
DrawCameraPath(double doubleIndex, double scale){
    if (mpCCameraPathLinked != NULL && 
	mCCameraPosCamera == mpCCameraPathLinked->mCCurrentObj) return;
    // FIX_ME!! $BA*Br$5$l$F$$$?$iI=<($9$Y$7(B
    if (mCbShowItems.mbBody == FALSE) return; 

    glPushName(GetPLinkedCameraPath()->mObjIndex);
    GetPLinkedCameraPath()->GLDrawPath(doubleIndex);
    GetPLinkedCameraPath()->GLDrawCurrent(doubleIndex, scale, 
					  Camera_cls::mDListBasic);
    glPopName();
    glPushName(GetPLinkedAnchorPath()->mObjIndex);
    GetPLinkedAnchorPath()->GLDrawPath(doubleIndex);
    GetPLinkedAnchorPath()->GLDrawCurrent(doubleIndex, scale,
					  Camera_cls::mDListCrosshair);
    glPopName();
}

void MainGLCanvas_cls::
DrawLightSource(double doubleIndex, double scale, bool bHittest){
    if (mCbShowItems.mbBody == FALSE) return;
    if (bHittest == FALSE)
	GetPLinkLightSourceCtrl()->GLDrawPath(doubleIndex);
    GetPLinkLightSourceCtrl()->GLDrawCurrent(doubleIndex, scale, 
					     Camera_cls::mDListLightSRC);
}

void MainGLCanvas_cls::
DrawAnchor(double scale){
    if (mCbShowItems.mbBody == FALSE) return;

    glColor4f(0.2f, 1.0f, 1.0f, 1.f);
    glPushMatrix();
    glTranslated(msCAnchorPos.mPos[0],
		 msCAnchorPos.mPos[1],
		 msCAnchorPos.mPos[2]);
    //Camera_cls::Draw(_CAMERA_CROSSHAIR, scale*0.02);
    glScaled(scale*0.02, scale*0.02, scale*0.02);
    glCallList(Camera_cls::mDListCrosshair);
    glPopMatrix();
}

void MainGLCanvas_cls::
DrawMessage(){
    if (mCbShowMessage.mbBody == FALSE) return; 
    glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
    void* font = GLUT_BITMAP_HELVETICA_12;
    int index = mpCParentFrameLink->GetPCTimeCtrl()->mFrame;
    wxString strFilename = 
	mpCParentFrameLink->GetPCActiveFileSequence()->GetFilename(index);
    strFilename << wxT(":") << 
	mpCParentFrameLink->GetPCActiveFileSequence()->GetFilenameStatus(index);
    strFilename << wxT("--") << mCDisplayMode.mBody;
    strFilename << GetPLinkedCameraPath()->mCbLookAnchor.mbBody;

    mpCGLString2D->Draw(font, strFilename.ToAscii(), 30, 10, _STRINGS_BOTTOM_LEFT);

    wxString strTime;
    strTime << wxT("Time=");
    strTime << mpCParentFrameLink->GetPCActiveFileSequence()->GetTime(index);
    strTime << wxT(":PNum=")
	    << mpCParentFrameLink->GetPCActiveFileSequence()->GetParticleNumber(index)
	    << wxT(":MilliSec") << mCStopWatchSnap.Time()
	    << wxT(":Hitting")  << msCHittest.GetFirstObject()
	    << wxT("+")         << msCHittest.GetFirstObjectSub() 
	    << wxT(":Object")   << (long long)mspCSelectedObject;
    
    mpCGLString2D->Draw(font, strTime.ToAscii(), 5, 10, _STRINGS_TOP_LEFT);

    char pBuf[128]; sprintf(pBuf, "Thread = %p %p LockLoad = %d %d Repeat = %d",
			    GpCThreadReader, GpCThreadInterpolate,
			    GbGLLockForLoadingData, GbGLLockForInterplateData,
			    mpCParentFrameLink->GetPCTimeCtrl()->mCbRepeat.mbBody);
    mpCGLString2D->Draw(font, pBuf, 5, 28, _STRINGS_TOP_LEFT);

    glColor4f(1.0f, 0.5f, 0.5f, 1.0f);
    mpCGLString2D->Draw(font, mstrWarning.ToAscii(), 5, 28, _STRINGS_BOTTOM_LEFT);
    mstrWarning = wxT("");
    //glColor4f(1.0f, 1.0f, 1.0f, 1.0f);

    /*
    glBegin(GL_LINES);
    glVertex2d(0,0);
    glVertex2d(1000,1000);
    glVertex2d(-100,-100);
    glVertex2d(300,0);
    glEnd();
    */
}

void MainGLCanvas_cls::
DrawModeAxis(double scale){
}

void MainGLCanvas_cls::
DrawSelectedItem(double scale){
    if (mspCSelectedObject == NULL) return;
    if (mbItemDragging == FALSE) return;
    glColor4f(1.0, 1.0, 0.2, 1.0);
    bool bSelectKey = FALSE;
    double dpos[3] = {
	msSelectedItemPos[0] - msSelectedItemPosOrg[0],
	msSelectedItemPos[1] - msSelectedItemPosOrg[1],
	msSelectedItemPos[2] - msSelectedItemPosOrg[2]};
    LOOP_XYZ mspCSelectedObject->mCCurrentObj.mPos[xyz] = msSelectedItemPos[xyz];
    glDisable(GL_DEPTH_TEST);
    mspCSelectedObject->GLDrawGuide(scale);
    mspCSelectedObject->mbDragging = TRUE;
    glEnable(GL_DEPTH_TEST);
}

void MainGLCanvas_cls::
ShowArrow(){
    glBegin(GL_LINES);
    glVertex3d(0, 0, 0);
    glVertex3d(+1, 0, 0);
    glEnd();
    glTranslated(0.6, 0, 0);
    glScaled(0.4, 0.4, 0.4);
    Cone_cls::Draw();
}

void MainGLCanvas_cls::
ShowNavigator(PositionAndDirection_cls CCamPos, int width, int height){
    FBO_cls *pCNaviFBO = new FBO_cls(256,256);
    pCNaviFBO->SetGeometryBuffer(256, 256);
    pCNaviFBO->MakeFBO(_FBO_USE_RGBA);
    pCNaviFBO->Begin();
    glPushAttrib(GL_ALL_ATTRIB_BITS);
    glClearColor(1, 0, 0, 0);
    glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glEnable(GL_DEPTH_TEST);
    
    GLPerspective_cls CGLPerspective(256, 256, 15);
    CGLPerspective.SetWindowSize(256, 256);
    PositionAndDirection_cls CNaviCameraPos;
    CNaviCameraPos = CCamPos;//mCCameraPos;
    LOOP_XYZ CNaviCameraPos.mPos[xyz] = -6 * CCamPos.mTgt[xyz];

    CGLPerspective.SetViewportOnGL();
    CGLPerspective.SetPerspectiveOnGL(&CNaviCameraPos);

    CGLPerspective.SetModelOrProjectionViewOnGL
	(&CNaviCameraPos, GL_MODELVIEW);

    glLineWidth(5);
    glTranslated(-0.25, -0.25, -0.25);

    glColor4f(1.0f, 0.1f, 0.1f, 1.0f);
    glPushMatrix();
    ShowArrow();
    glPopMatrix();

    glColor4f(0.1f, 1.0f, 0.1f, 1.0f);
    glPushMatrix();
    glRotatef(90, 0, 0, 1);
    ShowArrow();
    glPopMatrix();

    glColor4f(0.1f, 0.1f, 1.0f, 1.0f);
    glPushMatrix();
    glRotatef(-90, 0, 1, 0);
    ShowArrow();
    glPopMatrix();
    
    
    glPopAttrib();
    pCNaviFBO->End();

    FBO_cls::DrawOnScreen2D(pCNaviFBO, 
			    width, height, 
			    64, 64, 32, 16);
    delete pCNaviFBO;
}

void MainGLCanvas_cls::
ShowInformation(){
}

bool MainGLCanvas_cls::
IsMouseOnClient(){
    wxRect  CScreenRect = GetScreenRect();
    wxPoint CMousePos   = wxGetMousePosition();
    return CScreenRect.Contains(CMousePos);
}

bool MainGLCanvas_cls::
CheckFocusOnTherCanvas(){
    /*
    for (unsigned int i = 0; i < mVPOtherCanvas.size(); i++){
	if (mVPOtherCanvas[i]->IsMouseOnClient() == TRUE){
	    GpCurrentGLPanel = mVPOtherCanvas[i];
	    return TRUE;
	}
    }
    */
    return FALSE;
}

bool MainGLCanvas_cls::
CheckGLButton(int canvasWidth, int canvasHeight,
	      int mouseX, int mouseY){
    if (msCGLBTNScale.IsMouseOnButton(canvasWidth, canvasHeight,
				      mouseX, mouseY) == TRUE){
	ScaleMode();
	return TRUE; }
    if (msCGLBTNRot.IsMouseOnButton(canvasWidth, canvasHeight,
				    mouseX, mouseY) == TRUE){
	RotationMode();
	return TRUE; }
    if (msCGLBTNTrans.IsMouseOnButton(canvasWidth, canvasHeight,
				      mouseX, mouseY) == TRUE){
	TranslationMode();
	return TRUE; }

    return FALSE;
}

void MainGLCanvas_cls::
ShowPreviousFramePBO(){
}

void MainGLCanvas_cls::
DrawOtherObjects(double doubleIndex, double scale, double scale10){
    glPointSize(6);
    glEnable(GL_DEPTH_TEST);
    glDisable(GL_LIGHTING);
    glDepthMask(GL_TRUE);

    DrawGrid(scale, scale10);
    DrawCameraPath(doubleIndex, scale);
    DrawLightSource(doubleIndex, scale);
    
    if (mbHitTestItemSelect == TRUE || mbHitTestGuideSelect == TRUE){
	msCHittest.StartHitTest((float)mMouseX/mPanelWidth,
				(float)mMouseY/mPanelHeight,
				(float)mPanelWidth/mPanelHeight,
				this, &mCCameraPos);
	glInitNames();
	glDisable(GL_DEPTH_TEST);
	DrawLightSource(doubleIndex, scale, TRUE);
	DrawCameraPath(doubleIndex, scale);

	msCHittest.EndHitTest();
	
	if (mbHitTestItemSelect == TRUE)
	    if (msCHittest.GetFirstObject() != -1){
		mpCParentFrameLink->mpCParent->
		    SelectObject(msCHittest.GetFirstObject());
		mbRefreshQueue = TRUE;
	    }

	if (mbHitTestGuideSelect == TRUE &&
	    mspCSelectedObject != NULL)
	    mspCSelectedObject->SetDragMode(msCHittest.GetFirstObjectSub());
	
	mbHitTestItemSelect  = FALSE;
	mbHitTestGuideSelect = FALSE;
    }
    
    glDisable(GL_DEPTH_TEST);
    DrawAnchor(scale);

    //DrawMessage();
}

void MainGLCanvas_cls::
RefreshOtherOrthoCanvas(){
    for (unsigned int i = 0; i < mVPOtherCanvas.size(); i++){
	if (mVPOtherCanvas[i]->IsDisplayModeOrtho() == TRUE)
	    mVPOtherCanvas[i]->Refresh(FALSE);
    }
}

void MainGLCanvas_cls::
CheckGLRefresh(int frame, int interpStep){
    if (IsShownOnScreen() == FALSE) return;
    if (frame != mPrevFrame || interpStep != mPrevStep)
	Refresh(FALSE);
}

void MainGLCanvas_cls::
DrawOnFBO(FBO_cls *pCFBO[4], FBO_cls *pCFBOShadow,
	  int stereo, double doubleIndex, double scale,
	  int bufferSize){

    double scale10 = 0.0001;
    while (scale10*10 < scale) scale10 *= 10;
    
    PositionAndDirection_cls StereoCamera = mCCameraPos;
    if (IsStereo() == TRUE)
	ModifyByStereogram(_STEREO_LFT + stereo);
    
    int fboMax = 1;
    if (IsFishEye() == TRUE) fboMax = 4;

    int shadowNumber = 
	GetPLinkLightSourceCtrl()->GetNumberLightWithShadow();
    if (mpCDrawOptionLink->mCShadow.mBody == FALSE)
	shadowNumber = 0;

    if (shadowNumber > 1)
	pCFBOShadow->MakeFBO();
    
    int orgDeg = mCGLPerspective.mDeg;
    for (int fboIdx = 0; fboIdx < fboMax; fboIdx++){
	mCGLPerspective.SetWindowSize(bufferSize, bufferSize);	
	if (IsFishEye() == TRUE){
	    StereoCamera = mCCameraPos;
	    if (IsStereo() == TRUE)
		ModifyByStereogram(_STEREO_LFT + stereo);
	    ModifyByDomeTilt();
	    ModifyByDome(&StereoCamera, fboIdx);
	    mCGLPerspective.mDeg = 90;
	    mCGLPerspective.SetClipSize(bufferSize, bufferSize);
	}
	else{
	    mCGLPerspective.SetClipSize(mPanelWidth, mPanelHeight);
	}
	
	SetViewport();
	SetPerspective(&StereoCamera);
	//UpdateWindowSizeInChildClass(); //w x h $B$,>e=q$-$N2DG=@-$G99?7(B
	SetModelView(&StereoCamera);

	pCFBO[fboIdx]->MakeFBO();
	pCFBO[fboIdx]->Begin();
	glPushAttrib(GL_ALL_ATTRIB_BITS);

	ClearBuffer();
	
	//GetPLinkedCameraPath()->mpCStereoGramLinked->
	//SetColorMask(stereo, mCbStereoFlip.mbBody);

	if (shadowNumber == 0 || shadowNumber == 1)
	    GetPLinkLightSourceCtrl()->SetNonShadowLight(doubleIndex);
	else
	    GetPLinkLightSourceCtrl()->SetBasicLight
		(doubleIndex, mpCDrawOptionLink->mCShadow.mBody);
	
	glClear(GL_DEPTH_BUFFER_BIT);
	glLineWidth(msLineWidth * pCFBO[fboIdx]->GetLineWidthFactor());
	DrawOtherObjects(doubleIndex, scale, scale10);
	
	if (shadowNumber == 1){
	    // $B8w8;$ND4@0$G(B1$B2s$N=hM}$G9T$1$k$O$:!#(B
	    DrawDataMain(doubleIndex, fboIdx, shadowNumber);
	}
	else
	    DrawDataMain(doubleIndex, fboIdx, shadowNumber);
	
	glPopAttrib();
	
	glLineWidth(msLineWidth * pCFBO[fboIdx]->GetLineWidthFactor());
	if (mspCSelectedObject != NULL) DrawSelectedItem(scale);
	pCFBO[fboIdx]->End();

	if (shadowNumber > 1) {
	    for (int i = 0; i < GetPLinkLightSourceCtrl()->mCLightNum.mBody; i++){
		if (GetPLinkLightSourceCtrl()->mpCLightSRC[i]->
		    mCbCastShadow.mbBody == FALSE) continue;
		
		pCFBOShadow->Begin(TRUE);
		
		glPushAttrib(GL_ALL_ATTRIB_BITS);
		DrawDataLitDiffuse(doubleIndex, fboIdx, i);
		glPopAttrib();
		glLineWidth(msLineWidth * pCFBO[fboIdx]->GetLineWidthFactor());
		if (mspCSelectedObject != NULL) DrawSelectedItem(scale);
		pCFBOShadow->End();
		
		pCFBO[fboIdx]->Begin(FALSE);
		glMatrixMode(GL_PROJECTION);
		glPushMatrix();
		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();	    
		
		glPushAttrib(GL_ALL_ATTRIB_BITS);
		//FBO_cls *pCDummy[4];
		//pCDummy[0] = pCFBOShadow;
		glUseProgram(0);
		FBO_cls::DrawOnScreen(&pCFBOShadow, 1, mCGLPerspective,
				      bufferSize, bufferSize, TRUE);
		glPopAttrib();
		
		glMatrixMode(GL_MODELVIEW);
		glPopMatrix();
		glMatrixMode(GL_PROJECTION);
		glPopMatrix();
		pCFBO[fboIdx]->End();
		
	    }
	}


    }
}

void MainGLCanvas_cls::
GatherFBOImages(FBO_cls *pCFBO[4], int width, int height, bool bOnFBO){
    
    glClearColor( mspCClrCurveOut->mCConstantColor.mpBody[0],
		  mspCClrCurveOut->mCConstantColor.mpBody[1],
		  mspCClrCurveOut->mCConstantColor.mpBody[2], 1.0f);

    if (IsFishEye() == TRUE){
	if (mbSaveImgSeqQueue == TRUE)
	    mCGLPerspective.mDeg = mpCImgSeqLinked->mClipAngle;
	FBO_cls::DrawOnScreen(pCFBO, 4, mCGLPerspective,
			      width, height, FALSE);
    }
    else{
	GLPerspective_cls CGLPerspective = mCGLPerspective;
	if (bOnFBO == TRUE)
	    CGLPerspective.mDeg = 45;
	FBO_cls::DrawOnScreen(pCFBO, 1, CGLPerspective, 
			      width, height);
    }
}

void MainGLCanvas_cls::
OnPaint(wxPaintEvent& event){
    if (IsShownOnScreen() == FALSE) return;
    if (GbGLLockForLoadingData == TRUE || 
	GbGLLockForInterplateData == TRUE ||
	GbGLLockProjectLoading == TRUE) { event.Skip(); return; }

    if (GbGLLockDrawing == TRUE) {event.Skip(); return; }
    GbGLLockDrawing = TRUE;

    if (mCbShowData.mbBody == TRUE){
	// $B$3$N%U%l!<%`$N=`Hw$O(BOK?
	// $B=`HwCf$K;~4V$,$:$l$k$3$H$b(B
	int count = 0; // $B0BA4AuCV!'L58B%k!<%W2sHr!#;DG0$J$,$i$?$^$KH/@8$9$k!#(B
	while (mpCParentFrameLink->IsTheFrameReady(_FM_FRAME_CURRENT) == FALSE && 
	       count < 10){
	    mpCParentFrameLink->PrepareTheFrame(_FM_FRAME_CURRENT);	
	    count++;
	}
	
	// $B<!$N%U%l!<%`$NFI$_9~$_3+;O(B
	mpCParentFrameLink->PrepareFramesAhead
	    (mpCParentFrameLink->GetPCTimeCtrl()->mPlayDirection);
    }
    
    mDrawingFrame = mpCParentFrameLink->GetPCTimeCtrl()->mFrame;
    mDrawingStep  = mpCParentFrameLink->GetPCTimeCtrl()->mInterpStep;
    double doubleIndex = 
	mpCParentFrameLink->GetPCTimeCtrl()->GetDoubleIndex();
    int    currentIndex =
	mpCParentFrameLink->GetPCTimeCtrl()->GetRemappedIndex();
    double doubleInterpStep = 
	mpCParentFrameLink->GetPCTimeCtrl()->GetRemappedInterpStepDouble();
    double dT =
	mpCParentFrameLink->GetPCActiveFileSequence()->GetDT(currentIndex, doubleInterpStep);
    
    PDataSequence_cls *pCPDataSeq = 
	mpCParentFrameLink->GetPCActiveFileSequence();
    if (mbExportDataQueue == TRUE){
	pCPDataSeq->ExportData
	    (mpCParentFrameLink->mpCParent->mpCDataExporter, currentIndex);
	FinishPaint(event);
	return;
    }

    wxPaintDC dc(this); // must always be here
    
    if (SetGLContext() == FALSE){ GbGLLockDrawing = FALSE; return; }
    InitializeGLIfNot();

    // $B2hLL%5%$%:4X78(B
    int width, height;
    GetClientSize(&width, &height);
    mPanelWidth = width;
    mPanelHeight = height;
    mpCGLString2D->SetWindowGeometry(width, height);
    if (mpCImgSeqLinked != NULL){
	mpCImgSeqLinked->SetGeom(width, height, mCGLPerspective.mDeg);
    }

    // $B%+%a%i$ND4@0(B
    GetPLinkedCameraPath()->UpdateCurrentObj(doubleIndex);
    GetPLinkedAnchorPath()->UpdateCurrentObj(doubleIndex);
    UpdateCameraPos();

    double scale = CalcAutoScale();

    mPrevFrame = mDrawingFrame;
    mPrevStep  = mDrawingStep;
    
    SetAngleIfLinked();

    UpdateDrawInfo(width, height);
    int InfoDiff = mCDrawInfo.GetDifference(mCDrawInfoPrev);

    FBO_cls *pCFBOTotal;
    pCFBOTotal = new FBO_cls(4096, 4096);
    int bufferSize = msAFBOSize[msCFBOSizeIndex.mBody];

    FBO_cls *pCFBO[4];
    for (int i = 0; i < 4; i++){ 
	pCFBO[i] = new FBO_cls(width, height);
	pCFBO[i]->SetGeometryBuffer(bufferSize, bufferSize);
    }

    FBO_cls *pCFBOShadow;
    pCFBOShadow = new FBO_cls(width, height);
    pCFBOShadow->SetGeometryBuffer(bufferSize, bufferSize);
    
    mCStopWatchSnap.Start();
    if (FALSE/*InfoDiff != 0*/){
	ShowPreviousFramePBO();
    }
    else{
	int stereoMax = 0;
	if (IsStereo() == TRUE) stereoMax = 1;
	for (int stereo = 0; stereo <= stereoMax; stereo++){

	    int orgDeg = mCGLPerspective.mDeg;
	    DrawOnFBO(pCFBO, pCFBOShadow, stereo, doubleIndex, scale, bufferSize);
	
	    //glColorMask(1,1,1,1);
	    
	    SetModelView(&mCCameraPos); // $B@5LL8~$-$KLa$9(B
	    mCGLPerspective.mDeg = orgDeg;

	    mpCParentFrameLink->mpCParent->mpCExposure->Begin();
	    
	    if (mbSaveImgSeqQueue == TRUE){
		int finalBufferSize = bufferSize;
		if (IsFishEye() == TRUE)
		    finalBufferSize = 4096;
		pCFBOTotal->SetGeometryBuffer(finalBufferSize, finalBufferSize);
		pCFBOTotal->SetDepth(8);
		pCFBOTotal->MakeFBO();
		pCFBOTotal->Begin();
		GatherFBOImages(pCFBO, finalBufferSize, finalBufferSize, TRUE);
		pCFBOTotal->End();
	    }
	    GatherFBOImages(pCFBO, width, height, FALSE);

	    mpCParentFrameLink->mpCParent->mpCExposure->End();
	}
    }

    for (int i = 0; i < 4; i++) delete pCFBO[i];
    delete pCFBOShadow;
    
    //--
    double time = mpCParentFrameLink->
	GetPCActiveFileSequence()->GetTime(currentIndex) + dT;
    
    ColorCurve_cls *pAClrCurve[4];
    for (int i = 0; i < 4; i++){
	if (pCPDataSeq->mpCGLAttribute[i]->mCDrawType.mBody == _GL_DRAW_SPHERE)
	    pAClrCurve[i] = pCPDataSeq->mpCGLAttribute[i]->mpCClrCurveMat[0];
	else
	    pAClrCurve[i] = pCPDataSeq->mpCGLAttribute[i]->mpCClrCurveCol;
    };

    FBO_cls *pCFBOOverlay = NULL;

    if (mbSaveImageQueue == TRUE){
	if ( mpCImgSeqLinked != NULL)
	    mCGLPerspective.SetClipSize(mpCImgSeqLinked->mClipWidth, 
					mpCImgSeqLinked->mClipHeight);

	pCFBOOverlay = new FBO_cls(mCGLPerspective.mClipWidth, 
				   mCGLPerspective.mClipHeight);
	pCFBOOverlay->SetGeometryBuffer(mCGLPerspective.mClipWidth,
					mCGLPerspective.mClipHeight);
	pCFBOOverlay->MakeFBO(_FBO_USE_RGBA);
	pCFBOOverlay->Begin();
	mspCDrawTimeIndex->DrawTimeInfo(time, 
					mCGLPerspective.mClipWidth,
					mCGLPerspective.mClipHeight);
	mspCDrawClrLegend->DrawClrLegend(pAClrCurve, 
					 mCGLPerspective.mClipWidth, 
					 mCGLPerspective.mClipHeight);
	pCFBOOverlay->End();
    }
    
    mspCDrawTimeIndex->DrawTimeInfo(time, width, height);
    mspCDrawClrLegend->DrawClrLegend(pAClrCurve, width, height);

    //--
    
    if (mbSaveImageQueue == TRUE)
	ProcReadImage(width, height, pCFBOTotal, pCFBOOverlay);
    
    if (pCFBOOverlay != NULL) delete pCFBOOverlay;
    delete pCFBOTotal;

    mCStopWatchSnap.Pause();
    
    // -- $B0J9_J8;zI=<($J$I(B --
    mCGLPerspective.SetWindowSize(width, height);
    SetViewport();

    // -- $B%J%S%2!<%?(B
    if (mCbShowItems.mbBody == TRUE)
	ShowNavigator(mCCameraPos, width, height);
    
    glDisable(GL_DEPTH_TEST);
    glDisable(GL_LIGHTING);
    glDisable(GL_BLEND);
    DrawMessage();

    if (GpCurrentGLPanel == this){
	GLPerspective_cls::Push2DMatrix(width, height);
	msCGLBTNScale.DrawButton(width, msManipulatorMode == _MANIP_SCALE);
	msCGLBTNRot  .DrawButton(width, msManipulatorMode == _MANIP_ROTATE);
	msCGLBTNTrans.DrawButton(width, msManipulatorMode == _MANIP_TRANSLATE);
	GLPerspective_cls::Pop2DMatrix();
    }

    glFlush();
    SwapBuffers();

    FinishPaint(event);

    if (GpCurrentGLPanel == this){
	wxCommandEvent com1(wxEVT_COMMAND_MENU_SELECTED, 
			    menuEditRefreshCamConf);
	mpCParentFrameLink->AddPendingEvent(com1);
	
	wxCommandEvent com2(wxEVT_COMMAND_MENU_SELECTED, 
			    menuEditRefreshLight);
	mpCParentFrameLink->AddPendingEvent(com2);
    }

    if (mbRefreshQueue == TRUE){
	wxCommandEvent com1(wxEVT_COMMAND_MENU_SELECTED, 
			    menuEditRefreshGL);
	mpCParentFrameLink->AddPendingEvent(com1);
	mbRefreshQueue = FALSE;
    }
}

void MainGLCanvas_cls::
FinishPaint(wxPaintEvent& event){
    event.Skip();
    GbGLLockDrawing = FALSE;
    GbGLLockPlayWait = FALSE;
}

void MainGLCanvas_cls::
ProcReadImage(int width, int height, FBO_cls *pCFBO, FBO_cls *pCFBOOverlay){
    glReadBuffer( GL_BACK );
    if (mbSaveImgSeqQueue == TRUE && mpCImgSeqLinked != NULL)
	ProcReadImageSequence(width, height, pCFBO, pCFBOOverlay);
    else{
	mbSaveImageQueue = FALSE;
	if (GCImgIO.SelectFile
	    (mpCParentFrameLink->mCLastOpenedFileIMG.mstrBody, 
	     mpCParentFrameLink) == TRUE){
	    mpCParentFrameLink->mCLastOpenedFileIMG.mstrBody = GCImgIO.mstrFile;
	    if (IsStereo() == TRUE)
		;
	    else
		GCImgIO.SaveImageFromGL(width, height);
	}
    }
}

void MainGLCanvas_cls::
ProcReadImageSequence(int width, int height, 
		      FBO_cls *pCFBO, FBO_cls *pCFBOOverlay){
    int currentFrame = mDrawingFrame;
    int offset = mpCParentFrameLink->GetPCTimeCtrl()->GetOffsetForImgSeq();
    
    if (IsStereo() == TRUE){
    }
    else
	mpCImgSeqLinked->SaveImageFromTexture
	    (&GCImgIO, pCFBO, pCFBOOverlay, width, height, offset, _STEREO_NONE);

    if (mpCImgSeqLinked->mbSnapMode == TRUE){
	mpCImgSeqLinked->mbSnapMode = FALSE;
	wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuItemPlayStop);
	wxGetTopLevelParent(this)->AddPendingEvent(com);
    }
    
    if (FALSE){ // $B<:GT$7$?$i$N%k!<%A%s$,2?=h$+$KMW$k(B
	mbSaveImgSeqQueue = FALSE;
	mbSaveImageQueue = FALSE;
    }

    mpCImgSeqLinked->Increment(offset);
}

void MainGLCanvas_cls::
StartSaveImgSeqProcess(ImgSequence_cls* pCImgSeq){
    mpCImgSeqLinked = pCImgSeq;
    mbSaveImageQueue = TRUE;
    mbSaveImgSeqQueue = TRUE;
    if (mpCImgSeqLinked != NULL)
	mpCImgSeqLinked->mCurrentOffset = 0;
}

void MainGLCanvas_cls::
StopSaveImgSeqProcess(){
    mbSaveImageQueue = FALSE;
    mbSaveImgSeqQueue = FALSE;
    if (mpCImgSeqLinked != NULL)
	mpCImgSeqLinked->OutputFinish();
}

void MainGLCanvas_cls::
StartExportDataProcess(DataExporter_cls* pCDataExporter){
    mpCDataExporterLinked = pCDataExporter;
    mbExportDataQueue = TRUE;
    if (mpCDataExporterLinked != NULL)
	mpCDataExporterLinked->mCurrentOffset = 0;
}

void MainGLCanvas_cls::
StopExportDataProcess(){
    mbExportDataQueue = FALSE;
    if (mpCDataExporterLinked != NULL)
	mpCDataExporterLinked->ExportFinish();
}

void MainGLCanvas_cls::OnSize(wxSizeEvent& event)
{
    UpdateWindowSizeInChildClass();
    mCGLPerspective.SetPerspectiveOnGL(&mCCameraPos);
    /*
    if (mpCImgSeqLinked != NULL){
	int width, height;
	GetClientSize(&width, &height);
	mpCImgSeqLinked->SetGeom(width, height, mCGLPerspective.mDeg);
    }
    */
    event.Skip();
}

void MainGLCanvas_cls::
ModifyOrthoCamera(){
    LOOP_XYZ
	mCCameraPosOrtho.mPos[xyz] = msCAnchorPosOrtho.mPos[xyz];
    switch (mCDisplayMode.mBody){
    case _GL_CANVAS_DISPLAY_X_PLUS:
	mCCameraPosOrtho.mPos[X] -= mCGLOrthoScale.mBody;
	break;
    case _GL_CANVAS_DISPLAY_X_MINUS:
	mCCameraPosOrtho.mPos[X] += mCGLOrthoScale.mBody;
	break;
    case _GL_CANVAS_DISPLAY_Y_PLUS:
	mCCameraPosOrtho.mPos[Y] -= mCGLOrthoScale.mBody;
	break;
    case _GL_CANVAS_DISPLAY_Y_MINUS:
	mCCameraPosOrtho.mPos[Y] += mCGLOrthoScale.mBody;
	break;
    case _GL_CANVAS_DISPLAY_Z_PLUS:
	mCCameraPosOrtho.mPos[Z] -= mCGLOrthoScale.mBody;
	break;
    case _GL_CANVAS_DISPLAY_Z_MINUS:
	mCCameraPosOrtho.mPos[Z] += mCGLOrthoScale.mBody;
	break;
    }
    mCCameraPosOrtho.SetAncPos(msCAnchorPosOrtho.mPos);
    mCCameraPosOrtho.SetDirection(mCDisplayMode.mBody);
}

double MainGLCanvas_cls::
CalcAutoScale(){
    double scale = MyVector::GetNormRelative(mCCameraPos.mPos,
					     msCAnchorPos.mPos);
    return scale;
}

void MainGLCanvas_cls::
ShowMenu(int x, int y){
    ShowMenuPanel(0, x, y);
    if (HasCapture() == TRUE) ReleaseMouse();
    return;
}

void MainGLCanvas_cls::
ShowMenuPanel(int type, int x, int y){
#ifdef WIN32
    PopupMenu(mpPopupMenu, x, y);
#else
    PopupMenu(mpPopupMenu);
#endif
}

bool MainGLCanvas_cls::
SetThisToBeActiveGL(){
    if (mpCParentFrameLink->mpCActiveGLCanvasLink != this) {
	mpCParentFrameLink->mpCActiveGLCanvasLink->Refresh(FALSE); 
	mpCParentFrameLink->mpCActiveGLCanvasLink = this;
	//mpCParentFrameLink->RecconectMNumCameraSetting();
	return TRUE;
    }
    return FALSE;
}

bool MainGLCanvas_cls::
SetOtherCanvasToBeActiveGL(){
    for (unsigned int i = 0; i < mVPOtherCanvas.size(); i++){
	if (mVPOtherCanvas[i]->IsMouseOnClient() == TRUE){
	    mVPOtherCanvas[i]->SetThisToBeActiveGL();
	    mVPOtherCanvas[i]->SetFocus();
	    mVPOtherCanvas[i]->Refresh(FALSE);
	    return TRUE;
	}
    }
    return FALSE;
}

bool MainGLCanvas_cls::
ProcViewOrItemDragging(wxSize sz, bool& trigAnchor){
    
    bool trigRefresh = FALSE;

    MouseNormalized_cls CMP(mpCMouseCtrl, sz);
    CMP.LimitMove();

    UpdateAnc();

    double sensitivity = 
	(mCDisplayMode.mBody == _GL_CANVAS_DISPLAY_FREE || 
	 mCDisplayMode.mBody >= _GL_CANVAS_LINKED_CAM0) ? 1 : 0.5;
    sensitivity = 1;

    mpCDolly->SetParameter(sensitivity, &CMP, sz, mCDisplayMode.mBody);
    if (mpCMouseCtrl->IsGyration()){
	if (IsDisplayModeOrtho() == TRUE)
	    trigRefresh |= mpCDolly->MoveCenter(GetPCCameraPosition(),
						GetPCAnchorPosition());
	else
	    trigRefresh |= mpCDolly->Gyration  (GetPCCameraPosition());
    }
    if (mpCMouseCtrl->IsZoom())
	trigRefresh |= mpCDolly->Zoom      (GetPCCameraPosition(), 
					    &mCGLOrthoScale.mBody);
    if (mpCMouseCtrl->IsMoveCenter())
	trigRefresh |= mpCDolly->MoveCenter(GetPCCameraPosition(),
					    GetPCAnchorPosition());

    if (mspCSelectedObject != NULL &&
	mpCMouseCtrl->IsMoveItem()){
	trigRefresh |= mpCDolly->MoveItem(GetPCCameraPosition(),
					  mbMouseDragging,
					  GetClientSize(),
					  mspCSelectedObject->mDragMode);
	mbItemDragging = TRUE;
    }

    mpCMouseCtrl->SetPreviousPosition();
    
    mbMouseDragging = TRUE; // $B:G=i$N#12s$O(B FALSE $B$GH=JL(B
    
    return trigRefresh;
}

void MainGLCanvas_cls::
ProcSelectItemForDragging(int mouseX, int mouseY){
}

void MainGLCanvas_cls::
ProcItemDraggingEnd(){
    LOOP_XYZ mspCSelectedObject->mpCTranslate->mVCParam[xyz].mInterpolatedValue = msSelectedItemPos[xyz];
    GCUndoList.OpenBlock();
    mspCSelectedObject->mpCTranslate->SetKeyFrameIfChanged();
    mspCSelectedObject->Targetting();
    mspCSelectedObject->mDragMode = -1;
    mspCSelectedObject->mbDragging = FALSE;
    GCUndoList.CloseBlock();
    mbItemDragging = FALSE;
    mbRefreshQueue = TRUE;
}

bool MainGLCanvas_cls::
ProcCaptureMouse(){
    bool trigRefresh = FALSE;
    
    CaptureMouse();
    
    for (unsigned int i = 0; i < mVPOtherCanvas.size(); i++)
	if (mVPOtherCanvas[i]->HasCapture() == TRUE)
	    mVPOtherCanvas[i]->ReleaseMouse();
    
    trigRefresh |= SetThisToBeActiveGL();

    return trigRefresh;
}

bool MainGLCanvas_cls::
StartHitTest(int mouseX, int mouseY){
    bool bHitting = FALSE;

    if (mpCMouseCtrl->IsMoveItem()) mbHitTestGuideSelect = TRUE;
    
    // $B%I%i%C%0MQ$N%R%C%H%F%9%H(B
    /*
    if (mpCMouseCtrl->IsMoveItem())
	;//ProcSelectItemForDragging(mouseX, mouseY);
    else
	;//if (msManipulatorMode != _MANIP_ROTATE) msMoveMode = _POS_AND_DIR_MOVE_FREE;
    */

    // $B%"%$%F%`%;%l%/%HMQ$N%R%C%H%F%9%H(B
    if (mpCMouseCtrl->IsHitTest()) mbHitTestItemSelect = TRUE;

    return bHitting;
}

void MainGLCanvas_cls::
OnMouse(wxMouseEvent& event){
    bool trigRefresh = FALSE;
    static bool trigAnchor = FALSE;
    static bool sbLockDragging = FALSE; // GL$B%\%?%s$r2!$7$?$i(BDrag$B$7$J$$(B

    // $B%^%&%9>pJs(B $B2hLL>pJs(B
    wxSize sz(GetClientSize());
    int width = sz.GetWidth(), height = sz.GetHeight();
    
    mpCMouseCtrl->SetMouseInformation(event);
    int mouseX = mpCMouseCtrl->mMouseX;
    int mouseY = mpCMouseCtrl->mMouseY;

    // $B%a%K%e!<(B
    if (mpCMouseCtrl->IsShowMenu() == TRUE){
	ShowMenu(mouseX, mouseY);
	event.Skip();
	return; }

    // $B2hLL>e$N%\%?%s(B
    if (mpCMouseCtrl->IsButton(_MOUSE_BTN_LEFT) == TRUE &&
	CheckGLButton(width, height, mouseX, mouseY) == TRUE){
	Refresh(FALSE);
	sbLockDragging = TRUE;
	event.Skip();
	return; }

    // $B%^%&%9$rN%$9(B
    if (mpCMouseCtrl->IsButtonUp() == TRUE){
	sbLockDragging = FALSE;
	if (HasCapture()) ReleaseMouse();
    }
	
    // $B%S%e!<$^$?$O%"%$%F%`$N%I%i%C%0(B
    if (mpCMouseCtrl->IsMouseDragging() == TRUE && sbLockDragging == FALSE)
	trigRefresh |= ProcViewOrItemDragging(sz, trigAnchor);
    else
	if (HasCapture() == FALSE)
	    mbMouseDragging = FALSE;
    
    // $B%R%C%H%F%9%H(B
    //bool bHitting = FALSE;
    if (mpCMouseCtrl->IsButtonDown() == TRUE){
	SetFocus();
	if (HasCapture() == FALSE){
	    trigRefresh |= ProcCaptureMouse();
	    trigRefresh = TRUE;
	    StartHitTest(mouseX, mouseY);
	    mMouseX = mouseX;
	    mMouseY = mouseY;
	    
	    mpCMouseCtrl->SetPreviousPosition();
	    mpCMouseCtrl->SetGyrationMode(sz);
	}
    }

    if (event.ButtonUp(wxMOUSE_BTN_LEFT) ||
	event.ButtonUp(wxMOUSE_BTN_MIDDLE) ||
	event.GetEventType() == wxEVT_MOUSEWHEEL) {
	if (mbItemDragging == TRUE && mspCSelectedObject != NULL)
	    ProcItemDraggingEnd();
    }

    // $B%^%&%9%[%$!<%k(B
    if (mpCMouseCtrl->IsWheel() == TRUE){
	if (IsMouseOnClient() == TRUE){
	    UpdateAnc();
	    mpCDolly->mDisplayMode = mCDisplayMode.mBody;
	    trigRefresh |= mpCDolly->ZoomWheel
		(GetPCCameraPosition(), mpCMouseCtrl->mWheelRotationNormalized,
		 &mCGLOrthoScale.mBody);
	    mpCMouseCtrl->SetPreviousPosition();
	    SetThisToBeActiveGL();
	}
	else
	    trigRefresh |= SetOtherCanvasToBeActiveGL();
    }
    
    if (trigRefresh == TRUE){
	if (GpCurrentGLPanel != this){
	    GpCurrentGLPanel = this;
	    mpCParentFrameLink->ReconnectCameraPathGUI();
	}
	wxPaintEvent com;
	OnPaint(com);
	if (mpCParentFrameLink->GetPCPathCtrl()->mpCGUI != NULL)
	    mpCParentFrameLink->GetPCPathCtrl()->mpCGUI->mpCMNumView[mSelfIndex]->UpdateValues();

	if (IsDisplayModeOrtho() == TRUE)
	    RefreshOtherOrthoCanvas();
    }

    event.Skip();
}

void MainGLCanvas_cls::
OnMouseRelease(wxMouseCaptureLostEvent& event){
    event.Skip();
}

void MainGLCanvas_cls::
OnMouseMotion(wxMouseEvent& event){
    if (GpCurrentGLPanel == this){
	int width, height;
	GetClientSize(&width, &height);
	int mouseX = event.GetX(), mouseY = event.GetY();

	if (msCGLBTNScale.mbMouseOn != 
	    msCGLBTNScale.IsMouseOnButton(width, height, mouseX, mouseY))
	    Refresh(FALSE);
	if (msCGLBTNRot.mbMouseOn != 
	    msCGLBTNRot.IsMouseOnButton(width, height, mouseX, mouseY))
	    Refresh(FALSE);
	if (msCGLBTNTrans.mbMouseOn != 
	    msCGLBTNTrans.IsMouseOnButton(width, height, mouseX, mouseY))
	    Refresh(FALSE);
    }
    
    event.Skip();
}

void MainGLCanvas_cls::
OnKeyDown(wxKeyEvent& event){
    event.SetId(wxGetTopLevelParent(this)->GetId());
    wxGetTopLevelParent(this)->AddPendingEvent(event);
    //event.Skip();
}

void MainGLCanvas_cls::
RotationMode(){
    msManipulatorMode = _MANIP_ROTATE;
    msMoveMode = _POS_AND_DIR_MOVE_X;
}

void MainGLCanvas_cls::
TranslationMode(){
    msManipulatorMode = _MANIP_TRANSLATE;
    msMoveMode = _POS_AND_DIR_MOVE_FREE;
}

void MainGLCanvas_cls::
ScaleMode(){
    msManipulatorMode = _MANIP_SCALE;
    msMoveMode = _POS_AND_DIR_MOVE_FREE;
}

void MainGLCanvas_cls::
InitializeStaticMembers(Overlay_cls *pCOverlayLink){
    mspCClrCurveBG    = new ColorCurve_cls(wxT("BGColor"), wxT(""), 
					   wxT("0 0 0 0"));
    mspCClrCurveOut   = new ColorCurve_cls(wxT("BGColor"), wxT(""), 
					   wxT("0 0 0 0"));

    msCConfListStatic.Add(&msCFBOSizeIndex, wxT("FBOBufferSize="), wxT("3"));

    mspCDrawTimeIndex = new DrawTimeIndex_cls(pCOverlayLink);
    mspCDrawClrLegend = new DrawClrLegend_cls(pCOverlayLink);

    mspCGLGuide = new GLGuides_cls;
    mspCGLGuideScrew = new GLGuides_cls(1);
    mspCGLGuideYPR = new GLGuides_cls(3);
    
    SceneObj_cls::mspCGLGuideLink = mspCGLGuide;
    SceneObj_cls::mspCGLGuideYPRLink = mspCGLGuideYPR;

    //mspCDF3SeqCtrl = pCDF3SeqCtrl;
    //mspCFilterCtrl = pCFilterCtrl;
    //mspCPreference = new Preference_cls(pCFrame);
}

void MainGLCanvas_cls::
DestructStaticMembers(){
    delete mspCClrCurveBG;
    delete mspCClrCurveOut;
    delete mspCDrawTimeIndex;
    delete mspCDrawClrLegend;
    delete mspCGLGuide;
    delete mspCGLGuideScrew;
    delete mspCGLGuideYPR;
}

bool MainGLCanvas_cls::
IsGLBlendEquationEXOK(){
    return (glBlendEquationEXT != NULL);
}

void MainGLCanvas_cls::
SetDefaultPosition(int displayMode){
}

void MainGLCanvas_cls::
TogglePerspective(){
    if (mCGLGeometry.mBody == _GEOM_PERSPECTIVE)
	mCGLGeometry.mBody = _GEOM_ORTHOGRAPHIC;
    else
	mCGLGeometry.mBody = _GEOM_PERSPECTIVE;
    Refresh(FALSE);
}

void MainGLCanvas_cls::
SetDisplayMode(int displayMode, bool bUpdateCombobox){
    mCDisplayMode.mBody = displayMode;

    if (IsDisplayModeOrtho() == TRUE)
	mCGLGeometry.mBody = _GEOM_ORTHOGRAPHIC;
    else
	mCGLGeometry.mBody = _GEOM_PERSPECTIVE;
    
    mpCCameraPathLinked = NULL;
}

void MainGLCanvas_cls::
LinkageConnect(){
    SetDisplayMode(_GL_CANVAS_LINKED_CAM0);
    mpCCameraPathLinked = mpCParentFrameLink->mpCParent->mpCCameraPath;
    mpCAnchorPathLinked = mpCParentFrameLink->mpCParent->mpCAnchorPath;

    double doubleIndex = 
	mpCParentFrameLink->GetPCTimeCtrl()->GetDoubleIndex();

    GetPLinkedCameraPath()->UpdateCurrentObj(doubleIndex);
    GetPLinkedAnchorPath()->UpdateCurrentObj(doubleIndex);

    mCCameraPosCamera = mpCCameraPathLinked->mCCurrentObj;
    mCCameraPosCamera.UpdateYPR(FALSE);
}

void MainGLCanvas_cls::
OnMenuPassToParent(wxCommandEvent& event){
}

void MainGLCanvas_cls::
OnMenuAddPrimitive(wxCommandEvent& event){
}

void MainGLCanvas_cls::
OnMenuShowPanel(wxCommandEvent& event){
    mpCGLCtrl->ShowPanel();
}

void MainGLCanvas_cls::
OnMenuMoveToCamPos(wxCommandEvent& WXUNUSED(event)){
    LinkageConnect();
    mpCGLCtrl->UpdateWindow();
    ForceUpdateCameraPos();
    Refresh(FALSE);
}

void MainGLCanvas_cls::
OnMenuSetKeyPos(wxCommandEvent& event){
    wxCommandEvent dummy(wxEVT_COMMAND_MENU_SELECTED, menuItemSetKeyPos);
    wxGetTopLevelParent(this)->AddPendingEvent(dummy);
}

void MainGLCanvas_cls::
OnMenuSetKeyAnc(wxCommandEvent& event){
    wxCommandEvent dummy(wxEVT_COMMAND_MENU_SELECTED, menuItemSetKeyAnc);
    wxGetTopLevelParent(this)->AddPendingEvent(dummy);
}

void MainGLCanvas_cls::
OnMenuToggleLink(wxCommandEvent& event){
    if (mCDisplayMode.mBody >= _GL_CANVAS_LINKED_CAM0)
	SetDisplayMode(_DIRECTION_FREE);
    else
	LinkageConnect();
    mpCGLCtrl->UpdateWindow();
    ForceUpdateCameraPos();
    Refresh(FALSE);
}

void MainGLCanvas_cls::
OnMenuTogglePerspective(wxCommandEvent& event){
    TogglePerspective();
}

void MainGLCanvas_cls::
HookGridComboBox(void *pArg, void *pEvent){
}

void MainGLCanvas_cls::
CopySettingToAll(){
}

void MainGLCanvas_cls::
SelectItem(Parameters_cls *pCParam){
}

// ----

void MainGLCanvas_cls::
ReadStrLine(wxString strLine){
    mCConfList.ReadStrLineAll(strLine);
}

wxString MainGLCanvas_cls::
Serialize(){
    return mCConfList.SerializeAll();
}

// ----------------------------------------------

ColorCurve_cls* MainGLCanvas_cls::mspCClrCurveBG = NULL;
ColorCurve_cls* MainGLCanvas_cls::mspCClrCurveOut = NULL;
DrawTimeIndex_cls* MainGLCanvas_cls::mspCDrawTimeIndex = NULL;
DrawClrLegend_cls* MainGLCanvas_cls::mspCDrawClrLegend = NULL;
Position_cls MainGLCanvas_cls::msCAnchorPos(0, 0, 0);
Position_cls MainGLCanvas_cls::msCAnchorPosOrtho(0, 0, 0);
int    MainGLCanvas_cls::msMoveMode = _POS_AND_DIR_MOVE_FREE;
int    MainGLCanvas_cls::msManipulatorMode = _MANIP_TRANSLATE;
double MainGLCanvas_cls::msSelectedItemPos[3] = {0, 0 ,0};
double MainGLCanvas_cls::msSelectedItemPosOrg[3] = {0, 0 ,0};
double MainGLCanvas_cls::msSelectedItemScale[3] = {1, 1 ,1};
double MainGLCanvas_cls::msSelectedItemDRot[3] = {0, 0, 0};
SceneObj_cls* MainGLCanvas_cls::mspCSelectedObject = NULL;
Preference_cls* MainGLCanvas_cls::mspCPreference = NULL;
FilterCtrl_cls* MainGLCanvas_cls::mspCFilterCtrl = NULL;
DF3SeqCtrl_cls* MainGLCanvas_cls::mspCDF3SeqCtrl = NULL;
int MainGLCanvas_cls::msAFBOSize[5] = {256, 512, 1024, 2048, 4096};
ConfItemList_cls MainGLCanvas_cls::msCConfListStatic;
ConfItemUINT_cls MainGLCanvas_cls::msCFBOSizeIndex;
float MainGLCanvas_cls::msLineWidth = 5;
int MainGLCanvas_cls::msGLLightIndex[8] = {
    GL_LIGHT0, GL_LIGHT1, GL_LIGHT2, GL_LIGHT3, 
    GL_LIGHT4, GL_LIGHT5, GL_LIGHT6, GL_LIGHT7
};

GLButton_cls MainGLCanvas_cls::msCGLBTNTrans(_BTM_LEFT, 4/*80*/, 52);
GLButton_cls MainGLCanvas_cls::msCGLBTNRot  (_BTM_LEFT, 4/*56*/, 28);
GLButton_cls MainGLCanvas_cls::msCGLBTNScale(_BTM_LEFT, 4/*32*/, 4);
HitTest_cls  MainGLCanvas_cls::msCHittest;

GLGuides_cls* MainGLCanvas_cls::mspCGLGuide;
GLGuides_cls* MainGLCanvas_cls::mspCGLGuideScrew;
GLGuides_cls* MainGLCanvas_cls::mspCGLGuideYPR;
