// -*- c -*-
// "clsGrid.h"
// (setq c-basic-offset 4)

#include "clsCamera.h"

#include <math.h>

#ifdef WIN32
#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>
#elif defined __WXMAC__
#include <OpenGL/glu.h>
#else
#include <GL/glu.h>
#endif

#ifndef TRUE
#define TRUE true
#define FALSE false
#endif


bool Camera_cls::mbInitialized = FALSE;
int  Camera_cls::mDListBasic = -1;
int  Camera_cls::mDListCrosshair = -1;
int  Camera_cls::mDListLightSRC = -1;

int  Camera_cls::
DListDraw(int type, int GLMode){
    int    listName = 0;

    if (GLMode == GL_COMPILE || GLMode == GL_COMPILE_AND_EXECUTE){
	listName = glGenLists(1); // VKXg̔ԍ
	glNewList (listName, GLMode); 
    }
    
    switch(type){
    case _CAMERA_BASIC:
	// LocalX
	glPushMatrix();
	glRotatef(-90, 0, 1, 0);
	glRotatef(-90, 0, 0, 1);
	glBegin(GL_LINE_LOOP);
	glVertex3d(-0.5, -1, -1);  glVertex3d( 0.5, -1, -1);
	glVertex3d( 0.5,  1, -1);  glVertex3d(-0.5,  1, -1);  
	glEnd();
	glBegin(GL_LINE_LOOP);
	glVertex3d(-0.5, -1, 1);  glVertex3d( 0.5, -1, 1);
	glVertex3d( 0.5,  1, 1);  glVertex3d(-0.5,  1, 1);  
	glEnd();
	glBegin(GL_LINE_LOOP);
	glVertex3d(-0.7, -1.2, -1.2);  glVertex3d( 0.7, -1.2, -1.2);
	glVertex3d( 0.7,  1.2, -1.2);  glVertex3d(-0.7,  1.2, -1.2);   
	glEnd();
	
	glBegin(GL_LINES);
	glVertex3d(-0.5, -1, -1); glVertex3d(-0.5, -1, 1);
	glVertex3d( 0.5, -1, -1); glVertex3d( 0.5, -1, 1);
	glVertex3d( 0.5,  1, -1); glVertex3d( 0.5,  1, 1);
	glVertex3d(-0.5,  1, -1); glVertex3d(-0.5,  1, 1);
	glEnd();
	glBegin(GL_LINE_LOOP);
	glVertex3d(-0.1,  1.1,  0.2);  glVertex3d( 0.1,  1.1, 0.2);
	glVertex3d( 0.0,  1.1, -0.2);
	glEnd();
	glPopMatrix();
	break;
    case _CAMERA_CROSSHAIR:
	glBegin(GL_LINES);
	glVertex3d(-0.5, 0, 0); glVertex3d(+0.5, 0, 0);
	glVertex3d(0, -0.5, 0); glVertex3d(0, +0.5, 0);
	glVertex3d(0, 0, -0.5); glVertex3d(0, 0, +0.5);
	glEnd();
	break;
    case _OBJECT_LIGHTSRC:
	glBegin(GL_LINES);
	for (int i = 0; i < 360; i+=10){
	    double rad = 3.14159 * i / 180;
	    glVertex3d(cos(rad), sin(rad), 0);
	}
	glEnd();
	glBegin(GL_LINE_STRIP);
	for (int i = 0; i <= 360; i+=10){
	    double rad = 3.14159 * i / 180;
	    glVertex3d(0.7 * cos(rad), 0.7 * sin(rad), 0);
	}
	glEnd();
	break;
    }
    
    if (GLMode == GL_COMPILE || GLMode == GL_COMPILE_AND_EXECUTE)
	glEndList(); 
    
    return listName;
}

void Camera_cls::
InitializeIfNot(){
    if (mbInitialized == TRUE) return;
    mDListBasic     = DListDraw(_CAMERA_BASIC, GL_COMPILE);
    mDListCrosshair = DListDraw(_CAMERA_CROSSHAIR, GL_COMPILE);
    mDListLightSRC  = DListDraw(_OBJECT_LIGHTSRC, GL_COMPILE);
    mbInitialized = TRUE;
}

/*
void Camera_cls::
Draw(int type, double scale){
    InitializeIfNot();
    glPushMatrix();
    glScaled(scale, scale, scale);
    switch(type){
    case _CAMERA_BASIC:
	glCallList(mDListBasic);
	break;
    case _CAMERA_CROSSHAIR:
	glCallList(mDListCrosshair);
	break;
    }
    glPopMatrix();
}
*/
