// -*- c -*-
// "clsGrid.h"
// (setq c-basic-offset 4)

#include "clsGrid.h"

#ifdef WIN32
#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>
#elif defined __WXMAC__
#include <OpenGL/glu.h>
#else
#include <GL/glu.h>
#endif

#ifndef TRUE
#define TRUE true
#define FALSE false
#endif

bool Grid_cls::mbInitialized = FALSE;
int  Grid_cls::mDListFlatInner = -1;
int  Grid_cls::mDListFlatOuter = -1;
int  Grid_cls::mFineness = 10;

int  Grid_cls::
DListFlatDraw(int fineness, int GLMode, int gridMode){
    int    listName = 0;

    if (GLMode == GL_COMPILE || GLMode == GL_COMPILE_AND_EXECUTE){
	listName = glGenLists(1); // VKXg̔ԍ
	glNewList (listName, GLMode); 
    }
    
    if (fineness < 3) fineness = 3;

    glBegin(GL_LINES);
    for (int i= -fineness + (gridMode == _GRID_INNER)
	     ; i <= fineness - (gridMode == _GRID_INNER) ; i++){
	
	if (i == 0) continue;
	
	float value = (float)i / fineness;
	glVertex3f(value, -1, 0); glVertex3f(value, +1, 0);
	glVertex3f(-1, value, 0); glVertex3f(+1, value, 0);
    }

    glVertex3d(1.05, 0.05, 0); glVertex3d(1.1, 0, 0);
    glVertex3d(1.05,-0.05, 0); glVertex3d(1.1, 0, 0);
    
    glVertex3d( 0.05, 1.05, 0); glVertex3d(0, 1.1, 0);
    glVertex3d(-0.05, 1.05, 0); glVertex3d(0, 1.1, 0);
    
    glEnd();
    
    if (gridMode == _GRID_OUTER){
	glBegin(GL_LINES);
	glVertex3f(-1, 0,   0); glVertex3f(+1,  0,  0);
	glVertex3f( 0,-1,   0); glVertex3f( 0, +1,  0);
	glVertex3f( 0,  0, -1); glVertex3f( 0,  0, +1);
	glEnd();
    }
    
    if (GLMode == GL_COMPILE || GLMode == GL_COMPILE_AND_EXECUTE)
	glEndList(); 
    
    return listName;
}

void Grid_cls::
InitializeIfNot(){
    if (mbInitialized == TRUE) return;
    mDListFlatInner = DListFlatDraw(mFineness, GL_COMPILE, _GRID_INNER);
    mDListFlatOuter = DListFlatDraw(mFineness, GL_COMPILE, _GRID_OUTER);
    mbInitialized = TRUE;
}

void Grid_cls::
DrawGridFlat(double scale){
    InitializeIfNot();
    glPushMatrix();
    glScaled(scale, scale, scale);
    glCallList(mDListFlatInner);
    glScaled(10, 10, 10);
    glCallList(mDListFlatInner);
    glScaled(10, 10, 10);
    glCallList(mDListFlatOuter);
    glPopMatrix();
}
