// (setq c-basic-offset 4)

#ifndef _IMAGE_IO_H_
#define _IMAGE_IO_H_

#include <string>
#include <wx/wx.h>
#include <wx/thread.h>

class ImageIO_cls;

#define _IMAGE_OUT_MAX_THREAD 4

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class ThreadSave_cls : public wxThread {
 public:
    ThreadSave_cls(wxThreadKind kind);
    void SetParameters(bool *pbFinishedFlag, 
		       ImageIO_cls *pCParent, int width, int height, 
		       wxString strFileOut,
		       bool bUseOverlay,
		       unsigned char *pBuffer = NULL,
		       bool bFreeDataAtEnd = TRUE);
    bool *mpbFinishedFlagLink;
    ImageIO_cls *mpCParent;
    unsigned char *mpBuffer;
    unsigned char *mpBufferSRC;
    unsigned char *mpOverlay;
    bool mbAllocLocal;
    bool mbAllocLocalSRC;
    bool mbUseOverlay;
    int mWidth, mHeight;
    int mBufferWidth, mBufferHeight;
    wxString mstrFileOut;

    void DeclareResizing(int bufferWidth, int bufferHeight);
    void GetAverageRGB(int indexTGT, int widthBuffer, int heightBuffer,
		       double dIndexX, double dIndexY,
		       double dIndexX2, double dIndexY2,
		       unsigned char* pBufferSRC,
		       unsigned char* pBufferTGT);
    
    virtual ExitCode Entry();
};

class ImageIO_cls {
 public:
    ImageIO_cls();
    ~ImageIO_cls();

    static int msJPEGQuality;
    int mActiveThread;
    bool mbSaveThreadFinished[_IMAGE_OUT_MAX_THREAD];
    bool mbSaveThreadActive[_IMAGE_OUT_MAX_THREAD];
    ThreadSave_cls *mpCThreadSave[_IMAGE_OUT_MAX_THREAD];
    
    wxString mstrLastSavedFile;
    wxString mstrFile;

    bool SaveImageFromData(int width, int height, wxString strFileOut,
			   unsigned char* pBuffer);
    bool SaveImageFromGL(int width, int height);
    bool SaveImageFromGL(int width, int height, wxString strFileOut,
			 int offsetX = 0, int offsetY = 0);
    void GetAverageRGB(int indexTGT, int widthBuffer, int heightBuffer,
		       double dIndexX, double dIndexY,
		       double dIndexX2, double dIndexY2,
		       unsigned char* pBufferSRC,
		       unsigned char* pBufferTGT);
    bool SaveImageFromTexture(int widthBuffer, int heightBuffer,
			      int width, int height, int texID, int texIDOverlay);
    bool SaveImageFromTexture
	(int widthBuffer, int heightBuffer, int width, int height, 
	 int texID, int texIDOverlay,
	 wxString strFileOut, int offsetX = 0, int offsetY = 0);
			  
    bool SelectFile(wxString strDefaultDir, /*wxString strDefaultFile,*/
		    wxWindow *pC);
    void SetFilenameStereo(int eyeType);
};

#endif

