
#include "../PARTICLEDATA/clsShadowVolume.h"
#include "../UNDO/clsUndoManager.h"

#include "../WIDGETCTRL/clsMultiInputPanel.h"
#include "../WIDGETCTRL/clsHookCtrl.h"
#include "clsDrawOption.h"
#include "clsDrawOptionGUI.h"

DrawOptionGUI_cls::
DrawOptionGUI_cls(DrawOption_cls *pCDrawOptionLink, wxWindow *pCParent){
    mpCDrawOptionLink = pCDrawOptionLink;
    mpCParent = pCParent;
    mpCMInputPanel = NULL;
    mspCThis = this;
}

void DrawOptionGUI_cls::
SetPanel(wxBoxSizer *pBoxSizer){
    mpCMInputPanel = new MultiInputPanel_cls
	(&mpCMInputPanel, mpCParent, wxID_ANY);

    MultiInputPanel_cls* pC = mpCMInputPanel;

    pC->mTextWidth = 80;
    pC->mItemWidth = 90;
    pC->mUpdateBit = 
	_COMMAND_UPDATE_DISPLAY_GL | _COMMAND_UPDATE_DISPLAY_DRAWOPTIONS;
    
    int boxWidth = 2;
    pC->CombinePointer
	(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Downsize"));
    pC->CombinePointer
	(_ITEM_INTEGER_SPIN, &mpCDrawOptionLink->mCDownSize.mBody);
    pC->SetRange(_ITEM_LASTITEM, 1, 100);
    pC->CombinePointer
	(_ITEM_INTEGER_SLIDER, &mpCDrawOptionLink->mCDownSize.mBody);
    pC->SetRange(_ITEM_LASTITEM, 1, 100);

    pC->mItemWidth = -1;
    wxString listZSort[3] = {_("No Sort (fast)"), _("Zsort (for transparency)"), _("Zsort (for solid object)") };
    pC->CombinePointerList
	(_ITEM_UINT_LIST, &mpCDrawOptionLink->mCSortOrder.mBody, 
	 3, listZSort, _("Zsort Type"));

    wxString listClassify[2] = {_("Use Attrib0 Only (fast)"), _("Use All Attrib") };
    pC->CombinePointerList
	(_ITEM_UINT_LIST, &mpCDrawOptionLink->mCClassify.mBody, 
	 2, listClassify, _("Classification"));

    wxString listShadowy[3] = {_("No Shadow"), _("Shadow Volume"), _("Show Shadow") };
    pC->CombinePointerList
	(_ITEM_UINT_LIST, &mpCDrawOptionLink->mCShadow.mBody, 
	 3, listShadowy, _("Shadow"));

    mIndexShadowOption = pC->CombinePointer
	(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Q./Length"));
    wxString listQuality[3] = {_("Low"), _("Middle"), _("High") };
    pC->CombinePointerList
	(_ITEM_UINT_LIST, &ShadowVolume_cls::msCShadowQuality.mBody, 
	 3, listQuality);
    pC->CombinePointer
	(_ITEM_FLOAT, &ShadowVolume_cls::msCShadowLength.mBody);
    pC->GetLastItem().mItemWidth = 70;
    
    pC->FinishSetting(pBoxSizer);

    pC->mpCHookCtrl->SetFuncHook(FuncHookHideAndShow, _HOOK_COMBOBOX);

    HideAndShow();
}

void DrawOptionGUI_cls::
HideAndShow(){
    bool bValid = TRUE;
    if (mpCDrawOptionLink->mCShadow.mBody == 0) bValid = FALSE;
    
    mpCMInputPanel->EnableItem(mIndexShadowOption, bValid);
}

void DrawOptionGUI_cls::
FuncHookHideAndShow(void *pPanel, void *pArg){
    mspCThis->HideAndShow();
}

DrawOptionGUI_cls *DrawOptionGUI_cls::mspCThis = NULL;
