// -*- c -*-
// "clsOverlay.h"

#ifndef _EXPOSURE_H_
#define _EXPOSURE_H_

#include "../CONFITEM/clsConfItem.h"

#include <wx/wx.h>

#ifdef WIN32
#include <windows.h>
#include <GL/glu.h>
#include <GL/glext.h>
#elif defined __WXMAC__
#define GL_GLEXT_PROTOTYPES 
#include <OpenGL/glu.h>
#else
#define GL_GLEXT_PROTOTYPES 
#include <GL/glu.h>
#endif

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class Exposure_cls;
class ExposureGUI_cls;

class Exposure_cls{
 public:
    Exposure_cls();
    ~Exposure_cls();

    void InstantiateGUI(wxWindow *pCParent);
    
    ExposureGUI_cls *mpCGUI;

    ConfItemList_cls mCConfList;
    //ConfItemFLOAT_cls mCExposure;
    ConfItemDOUBLEARRAY_cls mCLevel;
    ConfItemFLOAT_cls mCGamma;
    ConfItemINT_cls mCHueOffset;
    ConfItemINT_cls mCSaturation;

    GLint mParamIDTexture;
    GLint mParamIDLevelMin;
    GLint mParamIDLevelMax;
    GLint mParamIDExposure;
    GLint mParamIDGamma;
    GLint mParamIDHueOffset;
    GLint mParamIDSaturation;

    void Initialize(wxWindow *pCParent);
    GLuint mVertShader;
    GLuint mFragShader;
    GLuint mGeomShader;
    GLuint mGL2Program;
    void ShowLog(wxWindow *pCParent, GLuint shader);
    
    void Begin();
    void End();

    void SetParamIDs(GLint program);
    void SetParamTexture(int value);
    void SetParamExposure();
    
    // ----------------------------

    void ReadStrLine(wxString strLine);
    wxString Serialize();
};

#endif
