// (setq c-basic-offset 4)
// "clsFrameMain.h"
// "wxWidgetEnum.h"

#include "../../clsFrameMain.h"

#include <wx/wx.h>

#include "../../wxWidgetEnumMenu.h"

void FrameMain_cls::
AddBitmapMenu(wxMenu *pMenu, int ID, wxString strMain, wxString strSub, 
	      wxBitmap *pBitmap){
    wxMenuItem *pItem = new wxMenuItem(pMenu, ID, strMain, strSub);
    pItem->SetBitmap(*pBitmap);
    pMenu->Append(pItem);
}

void FrameMain_cls::
InitMenu(){
    mpCMenuBar = new wxMenuBar;

    // ----- FILE(&F) -----
    mpCMenuFile = new wxMenu;
    mpCMenuFile->Append(menuFileOpenProject,
			wxString::Format(_T("%s(&O)\tCtrl-O"), _("Open Project"),
					 _("Open Project")));
    mpCMenuFile->Append(menuFileSaveProject,
			wxString::Format(_T("%s(&S)\tCtrl-S"), _("Save Project"),
					 _("Save Project")));
    mpCMenuFile->Append(menuFileSaveProjectAs,
			wxString::Format(_T("%s(&S)\tCtrl-Shift-S"), _("Save Project As"),
					 _("Save Project As")));

    mpCMenuFile->AppendSeparator();
    mpCMenuFile->Append(menuFileOpenData,
			wxString::Format(_T("%s(&L)\tCtrl-Alt-O"), _("Load Particle Data"),
					 _("Load Particle Data")));
    mpCMenuFile->AppendSeparator();
    mpCMenuFile->Append(menuFileSaveImageSnap,
			wxString::Format(_T("%s(&I)\tF7"), _("Save Snapshot"),
					 _("Save Snapshot")));
    mpCMenuFile->Append(menuFileSaveImageSeq,
			wxString::Format(_T("%s(&A)\tF8"), _("Save Image Sequence"),
					 _("Save Image Sequence")));
    wxMenu *pCMenuExport = new wxMenu;
    mpCMenuFile->Append(menuFileExport, 
			wxString::Format(_T("%s(&E)"), _("Export")),
			pCMenuExport, _("Export"));
    pCMenuExport->Append(menuFileExportData,
			 wxString::Format(_T("%s(&P)"), _("Export Particle Data"),
					  _("Export Particle Data")));
    
    mpCMenuFile->AppendSeparator();
    mpCMenuFile->Append(menuFileCloseData,
			wxString::Format(_T("%s(&W)\tCtrl-W"), _("Close Particle Data"),
					 _("Close Particle Data")));

    mpCMenuFile->AppendSeparator();
    mpCMenuFile->Append(Minimal_Quit, 
			wxString::Format(_T("%s(&Q)\tQ"), _("Quit")),
			_("Quit this application"));
    
    // ----- EDIT(&E) -----
    mpCMenuEdit = new wxMenu;
    mpCMenuEdit->Append(menuEditUndo, wxString::Format(_T("%s(&U)\tCtrl-Z"), _("Undo")),
			_("Undo"));
    mpCMenuEdit->Append(menuEditRedo, wxString::Format(_T("%s(&R)\tCtrl-Y"), _("Redo")),
			_("Redo"));

    mpCMenuEdit->AppendSeparator();
    mpCMenuEdit->Append(menuEditGo, wxString::Format(_T("%s(&G)\tCtrl-G"),
						     _("Move Frame")),
			_("Move Frame"));

    mpCMenuEdit->AppendSeparator();
    wxMenu *pCMenuRemoveCache = new wxMenu;
    mpCMenuEdit->Append(menuEditRemoveCache, 
			wxString::Format(_T("%s(&D)"),_("Remove Cache")),
			pCMenuRemoveCache, _("Remove Cache"));
    pCMenuRemoveCache->Append(menuEditRemoveCacheSnap,
			      wxString::Format(_T("%s\tF5"),
					       _("Snapshot")));
    pCMenuRemoveCache->Append(menuEditRemoveCacheAll,
			      wxString::Format(_T("%s\tCtrl-Alt-F5"),
					       _("All Cache")));
    
    mpCMenuEdit->AppendSeparator();
    AddBitmapMenu
	(mpCMenuEdit, menuEditScene,
	 wxString::Format(_T("%s(&S)\tCtrl-K"), _("Scene Config")),
	 _("Scene Config"), mpBitmapScene);
    AddBitmapMenu
	(mpCMenuEdit, menuEditPreference,
	 wxString::Format(_T("%s(&P)\tCtrl-Alt-P"), _("Preference")),
	 _("Preference"), mpBitmapPreference);

    wxString strViewType[5] = {
	_("1 panel"), 
	_("2 panels (vertical)"),
	_("2 panels (horizontal)"),
	_("4 panelsA"),           
	_("4 panelsB")
    };
    wxString strViewTypeKey[5] = {
	wxT("\tAlt-1"), wxT("\tAlt-2"), wxT("\tAlt-3"), 
	wxT("\tAlt-4"), wxT("\tAlt-5") 
    };
    
    // ----- VIEW(&V) -----
    mpCMenuView = new wxMenu;
    for (int i = 0; i < 5; i++)
	mpCMenuView->Append
	    (menuViewMainPanelType0 + i, strViewType[i]+strViewTypeKey[i], strViewType[i]);

    // ----- Dialog(&D) -----
    mpCMenuDialog = new wxMenu;
    AddBitmapMenu
	(mpCMenuDialog, menuDialogCameraPath,
	 wxString::Format(_T("%s(&U)\tCtrl-U"), _("View and Camera Config")),
	 _("View and Camera Config"), mpBitmapCamera);
    AddBitmapMenu
	(mpCMenuDialog, menuDialogLightSRC,
	 wxString::Format(_T("%s(&L)\tCtrl-L"), _("Light Source Editor")),
	 _("Light Source Editor"), mpBitmapLight0);
    AddBitmapMenu
	(mpCMenuDialog, menuDialogColorCurve,
	 wxString::Format(_T("%s(&J)\tCtrl-J"), _("Color Curve Editor")),
	 _("Color Curve Editor"), mpBitmapColor);
    
    
    // ----- HELP(&H) -----
    mpCMenuHelp = new wxMenu;
    mpCMenuHelp->Append(Minimal_About, 
			wxString::Format(_T("%s(&A)"), _("About")),
			_("About"));
    
    mpCMenuBar->Append(mpCMenuFile, _("File(&F)"));
    mpCMenuBar->Append(mpCMenuEdit, _("Edit(&E)"));
    mpCMenuBar->Append(mpCMenuView, _("View(&V)"));
    mpCMenuBar->Append(mpCMenuDialog, _("Dialog(&D)"));
    mpCMenuBar->Append(mpCMenuHelp, _("Help(&H)"));

    SetMenuBar(mpCMenuBar);
}

