// -*- c -*-
// "clsOverlayGUI.h"

#include "../UNDO/clsUndoManager.h"

#include "../WIDGETCTRL/clsMultiInputPanel.h"
#include "clsOverlay.h"
#include "clsOverlayGUI.h"

OverlayGUI_cls::
OverlayGUI_cls(Overlay_cls *pCOverLayLink, wxWindow *pCParent){
    mpCOverlayLink = pCOverLayLink;
    mpCParent = pCParent;
    mpCMInputPanel = NULL;
}

void OverlayGUI_cls::
SetPanel(wxBoxSizer *pBoxSizer){
    mpCMInputPanel = new MultiInputPanel_cls
	(&mpCMInputPanel, mpCParent, wxID_ANY);

    MultiInputPanel_cls* pC = mpCMInputPanel;

    pC->mTextWidth = 70;
    pC->mItemWidth = 90;
    pC->mUpdateBit = 
	_COMMAND_UPDATE_DISPLAY_GL | _COMMAND_UPDATE_DISPLAY_DRAWOPTIONS ; 

    wxString listPos[4] = {wxT("Top Left"), wxT("Top Right"), wxT("Btm Left"), wxT("Btm Right") };

    int boxWidth = 2;
    pC->CombinePointer
	(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Time"));
    pC->CombinePointerList
	(_ITEM_UINT_LIST, &mpCOverlayLink->mCTimePosition.mBody, 4, listPos);
    pC->CombinePointer
	(_ITEM_BOOL, &mpCOverlayLink->mCbShowTime.mbBody);

    boxWidth = 5;
    pC->CombinePointer
	(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Legend"));
    pC->CombinePointerList
	(_ITEM_UINT_LIST, &mpCOverlayLink->mCLegendPosition.mBody, 4, listPos);
    pC->CombinePointer
	(_ITEM_BOOL, &mpCOverlayLink->mCbShowLegend.mpbBody[0]);
    pC->GetLastItem().mItemWidth = 16;
    pC->CombinePointer
	(_ITEM_BOOL, &mpCOverlayLink->mCbShowLegend.mpbBody[1]);
    pC->GetLastItem().mItemWidth = 16;
        pC->CombinePointer
	(_ITEM_BOOL, &mpCOverlayLink->mCbShowLegend.mpbBody[2]);
    pC->GetLastItem().mItemWidth = 16;
    pC->CombinePointer
	(_ITEM_BOOL, &mpCOverlayLink->mCbShowLegend.mpbBody[3]);
    pC->GetLastItem().mItemWidth = 16;

    /*
    boxWidth = 2;
    pC->CombinePointer
	(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, wxT(" "));
    */
    
    wxString listAlpha[4] = {
	_("Show Alpha"), _("Hide Alpha") };
    pC->CombinePointerList
	(_ITEM_UINT_LIST, &mpCOverlayLink->mCLegendIgnoreAlpha.mBody, 
	 2, listAlpha, _("Alpha"));
    pC->GetLastItem().mItemWidth = -1;
    wxString listTics[4] = {
	_("Show Tics"), _("Hide Tics") };
    pC->CombinePointerList
	(_ITEM_UINT_LIST, &mpCOverlayLink->mCLegendIgnoreTics.mBody, 
	 2, listTics, _("Tics"));
    pC->GetLastItem().mItemWidth = -1;
    
    pC->FinishSetting(pBoxSizer);
}
