// -*- c -*-
// "clsParamGUICtrl.cpp"
// (setq c-basic-offset 4)

#include "../PARAMETER/clsParamGroup.h"
#include "../PARAMETER/clsParamGroupGUI.h"
#include "../PARAMETER/clsParametersPanel.h"
#include "../SCENEOBJ/clsSceneObj.h"
#include "../WIDGETCTRL/clsBitmapPanel.h"
#include "clsParamGUICtrl.h"

#include "../../clsMain.h"

#include "../../wxWidgetEnumMenu.h"

BEGIN_EVENT_TABLE(ParamGUICtrl_cls, wxPanel)
EVT_PAINT       (ParamGUICtrl_cls::OnPaint)
END_EVENT_TABLE()

ParamGUICtrl_cls::
ParamGUICtrl_cls(Main_cls *pCMain,
		 wxWindow *pCParent, wxWindowID Id, 
		 wxPoint pos, wxSize size) :
wxPanel(pCParent, Id, pos, size)
{
    SetBackgroundColour(wxColour(255, 255, 128));
    
    mpCSizer = new wxBoxSizer(wxVERTICAL);

    mpCParent = pCParent;
    mpCMainLink = pCMain;
    SetSizer(mpCSizer);
}

void ParamGUICtrl_cls::
AddParamGroup(ParamGroup_cls* pCParamGroup){
    pCParamGroup->MakeParamGUI(this, mpCSizer);
    mVpCParamGroup.push_back(pCParamGroup);

    if (pCParamGroup->mbShownOnTL == FALSE)
	pCParamGroup->mpCGUI->Hide();

    for (unsigned int i = 0; i < pCParamGroup->mVpCParamGroup.size(); i++){
	pCParamGroup->mVpCParamGroup[i]->MakeParamGUI(this, mpCSizer, 1);
	mVpCParamGroup.push_back(pCParamGroup);

	if (pCParamGroup->mbShownOnTL == FALSE){
	    pCParamGroup->mVpCParamGroup[i]->mpCGUI->Hide();
	    for (unsigned int j = 0; j < pCParamGroup->mVpCParamGroup[i]->mCDimension.mBody; j++)
		pCParamGroup->mVpCParamGroup[i]->mVpCParamGUI[j]->Hide();
	}
    }
}

void ParamGUICtrl_cls::
RefreshPanels(){
    for (unsigned int i = 0; i < mVpCParamGroup.size(); i++)
	mVpCParamGroup[i]->RefreshPanels();
}

void ParamGUICtrl_cls::
ChangeOtherSelector(int objIndex){
    mpCMainLink->ThisObjectIsSelected(objIndex);
}

SceneObj_cls* ParamGUICtrl_cls::
SelectObject(SceneObj_cls* pCSceneObj){
    bool bRefesh = FALSE;
    SceneObj_cls *pCSelectedObject = NULL;
    for (unsigned int i = 0; i < mVpCParamGroup.size(); i++){
	bool bSelected = mVpCParamGroup[i]->SelectObject(pCSceneObj);
	if (bSelected == TRUE &&
	    pCSceneObj->mbSelected == TRUE)
	    pCSelectedObject = pCSceneObj;
	bRefesh |= bSelected;
    }

    if (bRefesh == TRUE){
	wxCommandEvent com1(wxEVT_COMMAND_MENU_SELECTED, menuEditRefreshGL);
	wxGetTopLevelParent(this)->AddPendingEvent(com1);
	wxCommandEvent com2(wxEVT_COMMAND_MENU_SELECTED, menuEditRefreshTL);
	wxGetTopLevelParent(this)->AddPendingEvent(com1);
    }

    if (pCSelectedObject != NULL)
	ChangeOtherSelector(pCSelectedObject->mObjIndex);
    return pCSelectedObject;
}

SceneObj_cls* ParamGUICtrl_cls::
SelectObject(int objectIndex, int guideIndex){
    bool bRefesh = FALSE;
    SceneObj_cls *pCSelectedObject = NULL;
    for (unsigned int i = 0; i < mVpCParamGroup.size(); i++){
	bool bSelected = mVpCParamGroup[i]->SelectObject(objectIndex, guideIndex);
	if (bSelected == TRUE &&
	    mVpCParamGroup[i]->GetPCObject(objectIndex) != NULL &&
	    mVpCParamGroup[i]->GetPCObject(objectIndex)->mbSelected)
	    pCSelectedObject = mVpCParamGroup[i]->GetPCObject(objectIndex);
	
	bRefesh |= bSelected;
    }

    if (bRefesh == TRUE){
	wxCommandEvent com1(wxEVT_COMMAND_MENU_SELECTED, menuEditRefreshGL);
	wxGetTopLevelParent(this)->AddPendingEvent(com1);
	wxCommandEvent com2(wxEVT_COMMAND_MENU_SELECTED, menuEditRefreshTL);
	wxGetTopLevelParent(this)->AddPendingEvent(com1);
    }
    
    if (pCSelectedObject != NULL)
	ChangeOtherSelector(pCSelectedObject->mObjIndex);
    return pCSelectedObject;
}

void ParamGUICtrl_cls::
HideAndShow(){
    for (int i = 0; i < mVpCParamGroup.size(); i++){
	if (mVpCParamGroup[i]->mbShownOnTL == TRUE){
	    mVpCParamGroup[i]->mpCGUI->Show();
	    for (int j = 0; j < mVpCParamGroup[i]->mVpCParamGroup.size(); j++){
		if (mVpCParamGroup[i]->mpCGUI->mpCBPanelFolder->mState == 0)
		    mVpCParamGroup[i]->mVpCParamGroup[j]->ShowItems();
		else
		    mVpCParamGroup[i]->mVpCParamGroup[j]->HideItems();
	    }
	}
	else{
	    mVpCParamGroup[i]->mpCGUI->Hide();
	    for (int j = 0; j < mVpCParamGroup[i]->mVpCParamGroup.size(); j++){
		mVpCParamGroup[i]->mVpCParamGroup[j]->HideItems();
	    }
	}
    }
}

void ParamGUICtrl_cls::
ResizeTL(){
    int x, y;
    mpCScrollLink->GetViewStart(&x, &y);
    mpCScrollLink->Scroll(0,0);
    Layout();
    int height =  GetBestSize().GetHeight();
    mpCScrollLink->SetScrollbars(0, 1, 0, height);
    mpCScrollLink->Scroll(x,y);

    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuEditResizedTL);
    wxGetTopLevelParent(this)->AddPendingEvent(com);
}

void ParamGUICtrl_cls::
UpdateSnippingTag(std::vector < bool > *pVbSnipTag){
    for (unsigned int i = 0; i < mVpCParamGroup.size(); i++)
	mVpCParamGroup[i]->CheckSnippingTag(pVbSnipTag);
}

void ParamGUICtrl_cls::
OnPaint(wxPaintEvent& event){
    RefreshPanels();
    event.Skip();
}
