// (setq c-basic-offset 4)
// "clsPreviewPanel.h"

#include "clsTopHalfPanel.h"

#include "../../clsFrameMain.h"
#include "../../clsMain.h"
#include "../../wxWidgetEnum.h"
#include "../GLATTRIB/clsGLAttributeGUI.h"
#include "../GLCANVAS/clsGLCanvasCtrl.h"
#include "../GLCANVAS/clsMainGLCanvas.h"
#include "../MAINCANVAS/clsDrawOption.h"
#include "../MAINCANVAS/clsDrawOptionGUI.h"
#include "../MAINCANVAS/clsExposure.h"
#include "../MAINCANVAS/clsExposureGUI.h"
#include "../MAINCANVAS/clsOverlay.h"
#include "../MAINCANVAS/clsOverlayGUI.h"
#include "../MYAPI/MsgBox.h"
#include "../PARTICLEDATA/clsParticleDataSequence.h"
#include "../WIDGETCTRL/clsMultiInputPanel.h"

#include <wx/notebook.h>
#include <wx/sizer.h>

//#include "clsFilterPanelPain.h"

// ÓIɃCxgт
BEGIN_EVENT_TABLE(TopHalfPanel_cls, wxPanel)
//       EVT_MOUSE_EVENTS(TopHalfPanel_cls::OnMouse)
//     EVT_KEY_DOWN(TopHalfPanel_cls::OnKeyDown)
END_EVENT_TABLE()

TopHalfPanel_cls::
TopHalfPanel_cls(wxWindow *pC, FrameMain_cls *pCFrame) : 
wxPanel(pC, wxID_ANY, wxDefaultPosition, wxDefaultSize)
{
    mspCThis = this;
    mpCParentFrame = pCFrame;

    wxBoxSizer  *mpBoxSizerTop = new wxBoxSizer(wxHORIZONTAL);

    mpCSplitterMain = new
	wxSplitterWindow(this, wxID_ANY, 
			 wxDefaultPosition, wxDefaultSize, wxSP_BORDER | wxSP_3DSASH );
    mpCSplitterChildA = new
	wxSplitterWindow(mpCSplitterMain, wxID_ANY, 
			 wxDefaultPosition, wxDefaultSize, wxSP_NOBORDER | wxSP_3DSASH );
    mpCSplitterChildB = new
	wxSplitterWindow(mpCSplitterMain, wxID_ANY, 
			 wxDefaultPosition, wxDefaultSize, wxSP_NOBORDER | wxSP_3DSASH );
    mpCSplitterChildA->SetSashGravity(0.5);
    mpCSplitterChildB->SetSashGravity(0.5);
    mpCSplitterMain->SetSashGravity(0.5);

    // ̃TCU[
    wxBoxSizer  *pBoxSizerLFT = new wxBoxSizer(wxVERTICAL);

    int attribList[5] = {WX_GL_DOUBLEBUFFER, 1, WX_GL_STENCIL_SIZE, 1, 0};
    mpCGLCtrl[0] = new GLCanvasCtrl_cls
	(mpCSplitterChildA, mpCParentFrame,
	 wxID_ANY, attribList, wxDefaultPosition, wxDefaultSize,
	 wxWANTS_CHARS,
	 wxT("MainGLCanvas 0"), NULL, 0, 
	 _GL_CANVAS_DISPLAY_FREE);
    mpCGLCtrl[1] = new GLCanvasCtrl_cls
	(mpCSplitterChildA, mpCParentFrame,
	 wxID_ANY, attribList, wxDefaultPosition, wxDefaultSize,
	 wxWANTS_CHARS,
	 wxT("MainGLCanvas 1"), mpCGLCtrl[0]->mpCGLCanvas->mpCGLContext, 1,
	 _GL_CANVAS_DISPLAY_Z_MINUS);
    mpCGLCtrl[2] = new GLCanvasCtrl_cls
	(mpCSplitterChildB, mpCParentFrame,
	 wxID_ANY, attribList, wxDefaultPosition, wxDefaultSize,
	 wxWANTS_CHARS,    
	 wxT("MainGLCanvas 2"), mpCGLCtrl[0]->mpCGLCanvas->mpCGLContext, 2,
	 _GL_CANVAS_DISPLAY_X_PLUS);
    mpCGLCtrl[3] = new GLCanvasCtrl_cls
	(mpCSplitterChildB, mpCParentFrame,
	 wxID_ANY, attribList, wxDefaultPosition, wxDefaultSize, 
	 wxWANTS_CHARS | wxCLIP_CHILDREN | wxBORDER_NONE, 
	 wxT("MainGLCanvas 3"), mpCGLCtrl[0]->mpCGLCanvas->mpCGLContext, 3, 
	 _GL_CANVAS_DISPLAY_Y_PLUS);

    for (int i = 0; i < 4; i++)
	for (int j = 0; j < 4; j++){
	    if (i == j) continue;
	    mpCGLCtrl[i]->mpCGLCanvas->
		mVPOtherCanvas.push_back(mpCGLCtrl[j]->mpCGLCanvas);
	}

    mpCSplitterMain->SplitHorizontally(mpCSplitterChildA, mpCSplitterChildB, 0);
    mpCSplitterChildA->SplitVertically(mpCGLCtrl[0],
				       mpCGLCtrl[1]);
    mpCSplitterChildB->SplitVertically(mpCGLCtrl[2],
				       mpCGLCtrl[3]);
    mpCSplitterChildA->Unsplit();
    mpCSplitterChildB->Unsplit();
    mpCSplitterMain->Unsplit();

    pBoxSizerLFT->Add( mpCSplitterMain, 1, wxEXPAND);
    
    // ẼTCU[
    mpCBoxSizerRGT = new wxBoxSizer(wxVERTICAL);

    PDataSequence_cls* pCFileSeqLink = 
	mpCParentFrame->GetPCActiveFileSequence();

    // NoteBookA
    mpCNotebookGLAttrib = new wxNotebook(this, ID_BOOK_GLATTRIB);
    pCFileSeqLink->InstantiateGLAttribGUI(mpCNotebookGLAttrib);
    
    for (int i = 0; i < 4; i++){
	wxString strNotebookTag = wxT("Attrib ");
	strNotebookTag << i;
	pCFileSeqLink->mpCGLAttribute[i]->mpCGUI->SetPanel();
	mpCNotebookGLAttrib->AddPage
	    (pCFileSeqLink->mpCGLAttribute[i]->mpCGUI->mpCMInputPanel,
	     strNotebookTag);
    }
    
    mpCBoxSizerRGT->Add(mpCNotebookGLAttrib, 0, wxEXPAND);

    // NoteBookB
    Main_cls *pCMain = mpCParentFrame->mpCParent;
    mpCNotebookSetting = new wxNotebook(this, ID_BOOK_SETTING);
    
    pCMain->mpCDrawOption->InstantiateGUI(mpCNotebookSetting);
    pCMain->mpCDrawOption->mpCGUI->SetPanel(NULL);
    mpCNotebookSetting->AddPage
	(pCMain->mpCDrawOption->mpCGUI->mpCMInputPanel, _("Draw Option"));
    
    pCMain->mpCOverlay->InstantiateGUI(mpCNotebookSetting);
    pCMain->mpCOverlay->mpCGUI->SetPanel(NULL);
    mpCNotebookSetting->AddPage
	(pCMain->mpCOverlay->mpCGUI->mpCMInputPanel, _("Over Lay"));

    pCMain->mpCExposure->InstantiateGUI(mpCNotebookSetting);
    pCMain->mpCExposure->mpCGUI->SetPanel(NULL);
    mpCNotebookSetting->AddPage
	(pCMain->mpCExposure->mpCGUI->mpCMInputPanel, _("Exposure"));
    
    mpCBoxSizerRGT->Add(mpCNotebookSetting, 0, wxEXPAND);
    
    mpCBoxSizerRGT->Add(220 + 8, 0, 0); // _
    
    //pCFrame->mpCFilterPain = new FilterPanelPain_cls(this, pCFrame);

    //pCBoxSizerRGT->Add(pCFrame->mpCFilterPain, 1, wxEXPAND);

    mpBoxSizerTop->Add( pBoxSizerLFT, 1, wxEXPAND);
    mpBoxSizerTop->Add( mpCBoxSizerRGT, 0, wxEXPAND);
    this->SetSizer(mpBoxSizerTop);
}


TopHalfPanel_cls::
~TopHalfPanel_cls(){
    delete mpCSplitterChildA;
    delete mpCSplitterChildB;
    delete mpCSplitterMain;
}

void TopHalfPanel_cls::
SplitPanel(unsigned int type){
    mCPreviewPanelType.mBody = type;

    switch (type){
    case 0:
	mpCSplitterMain->Unsplit();
	mpCSplitterChildA->Unsplit(mpCGLCtrl[1]);
	break;
    case 1:
	mpCSplitterChildA->Unsplit();
	mpCSplitterMain->Unsplit(mpCSplitterChildB);
	mpCSplitterChildA->SplitHorizontally(mpCGLCtrl[0],
					     mpCGLCtrl[1]);
	break;
    case 2:
	mpCSplitterChildA->Unsplit();
	mpCSplitterMain->Unsplit();
	mpCSplitterChildA->SplitVertically(mpCGLCtrl[0],
					   mpCGLCtrl[1]);
	break;
    case 3:
	mpCSplitterChildA->Unsplit();
	mpCSplitterChildB->Unsplit();
	mpCSplitterMain->Unsplit();
	mpCSplitterMain->SplitHorizontally(mpCSplitterChildA, mpCSplitterChildB, 0);
	mpCSplitterChildA->SplitVertically(mpCGLCtrl[0],
					   mpCGLCtrl[1]);
	mpCSplitterChildB->SplitVertically(mpCGLCtrl[2],
					   mpCGLCtrl[3]);
	break;
    case 4:
	mpCSplitterChildA->Unsplit();
	mpCSplitterChildB->Unsplit();
	mpCSplitterMain->Unsplit();
	mpCSplitterMain->SplitVertically(mpCSplitterChildA, mpCSplitterChildB, 0);
	mpCSplitterChildA->SplitHorizontally(mpCGLCtrl[0],
					     mpCGLCtrl[1]);
	mpCSplitterChildB->SplitHorizontally(mpCGLCtrl[2],
					     mpCGLCtrl[3]);
	break;
    }
}

GLAttributeGUI_cls* TopHalfPanel_cls::
GetPCGLAttribGUI(int index){
    return 
	mpCParentFrame->GetPCActiveFileSequence()->mpCGLAttribute[index]->mpCGUI;
}

void TopHalfPanel_cls::
CheckGLRefresh(int frame, int interpStep){
    for (int i = 0; i <4 ;i++)
	mpCGLCtrl[i]->mpCGLCanvas->CheckGLRefresh(frame, interpStep);
}

void TopHalfPanel_cls::
ClearStatusGLPanels(){
    for (int i = 0; i <4 ;i++){
	mpCGLCtrl[i]->mpCGLCanvas->mPrevFrame = -1;
	mpCGLCtrl[i]->mpCGLCanvas->mPrevStep = -1;
    }
}

void TopHalfPanel_cls::
RefreshGLPanels(){
    for (int i = 0; i <4 ;i++){
	mpCGLCtrl[i]->UpdateToggleButtonsAndParams();
	mpCGLCtrl[i]->mpCGLCanvas->Refresh(FALSE);
    }
}

void TopHalfPanel_cls::
RefreshAttrib(){
    for (int i = 0; i <4 ;i++){
	GetPCGLAttribGUI(i)->HideAndShow();
	GetPCGLAttribGUI(i)->mpCMInputPanel->UpdateValues();
    }
    mpCParentFrame->mpCParent->mpCDrawOption->mpCGUI->mpCMInputPanel->UpdateValues();
}

void TopHalfPanel_cls::
FuncHookAttribHideAndShow(void *pPanel, void *pArg){
    for (int i = 0; i <4 ;i++){
	mspCThis->GetPCGLAttribGUI(i)->HideAndShow();
	mspCThis->mpCNotebookGLAttrib->GetPage(i)->Layout();
    }

    mspCThis->mpCBoxSizerRGT->Layout();
}

// ----------------------

void TopHalfPanel_cls::
OnMouse(wxMouseEvent& event){
    if (event.RightDown() == TRUE){
	/*
	for (std::list<FilterBase_cls*>::iterator itr = mpCParentFrame->mpCFilterCtrl->mVpCFilter.begin(); 
	     itr != mpCParentFrame->mpCFilterCtrl->mVpCFilter.end(); itr++)
	    if (event.GetId() == (*itr)->mpCGUIPanel->mpBTNShow->GetId()){
		PopupMenu(FilterGUI_cls::mspoPpupMenu, wxDefaultPosition);
		return;
	    }
	*/
    
	/*
	if (event.GetId() == GetId()){
	    mpCParentFrame->PopupMenu(mpCParentFrame->mpCMenuFilter, wxDefaultPosition);
	}
	*/
    }
}

/*
void TopHalfPanel_cls::
OnKeyDown(wxKeyEvent& event){
    if (event.GetKeyCode() == WXK_DELETE)
	mpCParentFrame->mpCFilterCtrl->DeleteSelectedItem();
}
*/

void     TopHalfPanel_cls::
ReDefineConfList(){
    mCConfList.Clear();
    mCConfList.Add(&mCPreviewPanelType, wxT("PreviewPanelType="), wxT("0"));
}

void     TopHalfPanel_cls::
ReadStrLine(wxString strLine){
    mCConfList.ReadStrLineAll(strLine);
    for (int i = 0; i < 4; i++)
	mpCGLCtrl[i]->ReadStrLine(strLine);
}

wxString TopHalfPanel_cls::
Serialize(){
    wxString sOut;
    sOut << mCConfList.SerializeAll(); 
    for (int i = 0; i < 4; i++)
	sOut << mpCGLCtrl[i]->Serialize();
    return sOut;
}

TopHalfPanel_cls* TopHalfPanel_cls::mspCThis = NULL;
