
#ifndef _TOP_HALF_PANEL_H_
#define _TOP_HALF_PANEL_H_

#include "../CONFITEM/clsConfItem.h"

#include <wx/wx.h>
#include <wx/splitter.h>
#include <list>

class GLCanvasCtrl_cls;
class FrameMain_cls;
class Preference_cls;
class wxNotebook;


#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class TopHalfPanel_cls;
class GLAttributeGUI_cls;

class TopHalfPanel_cls : public wxPanel {
 public:
    TopHalfPanel_cls(wxWindow *pC, FrameMain_cls *pCFrame);
    ~TopHalfPanel_cls();
    
    static TopHalfPanel_cls *mspCThis;
    FrameMain_cls *mpCParentFrame;
    //FilterPanels_cls* mpCFilterPanels[_DF3_MAX_SLOT];
    
    wxSplitterWindow* mpCSplitterMain;
    wxSplitterWindow* mpCSplitterChildA;
    wxSplitterWindow* mpCSplitterChildB;

    GLCanvasCtrl_cls* mpCGLCtrl[4];

    wxNotebook *mpCNotebookGLAttrib;
    wxBoxSizer *mpCBoxSizerRGT;

    wxNotebook *mpCNotebookSetting;
    wxBoxSizer *mpBoxSizerSetting[2];

    void SplitPanel(unsigned int type);

    //std::list < ItemIntAndPointer_cls > mPanelListItem;

    GLAttributeGUI_cls* GetPCGLAttribGUI(int index);
    void CheckGLRefresh(int frame, int interpStep);
    void ClearStatusGLPanels();
    void RefreshGLPanels();
    void RefreshAttrib();
    static void FuncHookAttribHideAndShow(void *pPanel, void *pArg);

    void OnMouse(wxMouseEvent& event);
    
    //void OnKeyDown(wxKeyEvent &event);

    //----

    ConfItemList_cls     mCConfList;
    ConfItemUINT_cls     mCPreviewPanelType;
    void     ReDefineConfList();
    void     ReadStrLine(wxString strLine);
    wxString Serialize();

 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

#endif
