// "clsFBO.h"
// (setq c-basic-offset 4)

#ifndef _FBO_DRAW_H_
#define _FBO_DRAW_H_

#define _FBO_USE_RGBA true

#include "clsGLPerspective.h"

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class FBO_cls {
 public:
    FBO_cls(int width, int height);
    ~FBO_cls();

    static void Initialize();
    static bool msbInitialized;
    static bool msbSupported;
    static bool msbComplete;
    bool mbUsed;

    void SetGeometryBuffer(int width, int height);
    void SetGeometryPanel(int width, int height);
    void SetDepth(int depth);
    int mWidthBuffer, mHeightBuffer;
    int mWidthPanel, mHeightPanel;
    int mDepth;
    
    void MakeFBO(bool bUseRGBA = FALSE);
    void Begin(bool bClear = TRUE);
    void End();
    static void MakeCirclePatternOnStencil();
    static void DrawDomeTexSegment(double coordu, double coordv0, double coordv1,
				   double x0, double x1, double y0, double y1, 
				   double z0, double z1, double deg);
    // GLOBJSTRINGƈꏏ
    static void Push2DMatrix(int width, int height);
    static void Pop2DMatrix();
    static void DrawOnScreen2D(FBO_cls *pCFBO,
			       int clientWidth, int clientHeight,
			       int clipWidth, int clipHeight,
			       int offsetX, int offsetY);
    static void DrawOnScreen(FBO_cls *pCFBO[4], int num, 
			     GLPerspective_cls CGLPerspective,
			     int clipWidth, int clipHeight,
			     bool bAdd = FALSE);
    GLuint mTexRGBId;
    GLuint mRBId;
    GLuint mFBOId;

    float  GetLineWidthFactor();
    
};

#endif
