// -*- c -*- 
// (setq c-basic-offset 4)
// "clsGLInfo.h"

#include "clsGLInfo.h"
#include <stdlib.h>
#include <stdio.h>

#ifdef WIN32
#include <windows.h>
#include <GL/glu.h>
#include <GL/glext.h>
#elif defined __WXMAC__
#define GL_GLEXT_PROTOTYPES 
#include <OpenGL/glu.h>
#else
#define GL_GLEXT_PROTOTYPES 
#include <GL/glu.h>
#endif
//#include <GL/gl.h>

void GLInfo_cls::
Initialize(){
    mstrGLVersion    = (char*)glGetString(GL_VERSION);
    mstrGLExtentions = (char*)glGetString(GL_EXTENSIONS);

    sscanf(mstrGLVersion.c_str(), "%d.%d", &mMajorVersion, &mMinorVersion);

    if (mMajorVersion >= 2)
	mstrGLSLVersion  = (char*)glGetString(GL_SHADING_LANGUAGE_VERSION);
    else
	mstrGLSLVersion = "0.0";
    sscanf(mstrGLSLVersion.c_str(), "%d.%d", &mGLSLMajorVersion, &mGLSLMinorVersion);
}

wxString GLInfo_cls::
GetGLVersionStr(){
    return wxString::Format(_T("OpenGL %d.%d"), mMajorVersion, mMinorVersion);
}

wxString GLInfo_cls::
GetGLSLVersionStr(){
    if (mGLSLMajorVersion == 0)
	return wxT("GLSL Not Implemented");
    else
	return wxString::Format(_T("GLSL %d.%d"), mGLSLMajorVersion, mGLSLMinorVersion);
}
