// -*- c -*-
// "clsGLPerspective.cpp"
// (setq c-basic-offset 4)

#ifndef _GL_PERSPECTIVE_H_
#define _GL_PERSPECTIVE_H_

#include "clsPositionAndDirection.h"

#ifdef WIN32
#include <windows.h> // WIN32GLɂ͕Kv
#include <GL/glu.h>
#elif defined __WXMAC__
#include <OpenGL/glu.h>
#else
#include <GL/glu.h>
#endif

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class GLPerspective_cls{ 
 public:
    GLPerspective_cls(int width = 640, int height = 480, double deg = 35, 
		      double depthMIN = 0.03, double depthMAX = 5000);
    
    double GetAspectRatio();
    double GetClipAspectRatio();

    void SetViewportOnGL();
    void SetPerspectiveOnGL(PositionAndDirection_cls* pCConfigure);
    static void SetModelOrProjectionViewOnGL
	(PositionAndDirection_cls* pCConfigure, GLenum mode = GL_MODELVIEW);
    void SetWindowSize (int width, int height);
    void SetClipSize (int width, int height);

    static void Push2DMatrix(int width, int height);
    static void Pop2DMatrix();

    bool   mbPerspective;
    double mDeg;
    double mDepthMIN;
    double mDepthMAX;
    // o̓obt@[摜Ŝ̃TCY
    int    mWidth, mHeight;
    // ̂Ŏg̈̃TCY
    int    mClipWidth, mClipHeight;
};

#endif //_GL_PERSPECTIVE_H_
