// (setq c-basic-offset 4)
// "clsDataExporter.cpp"

#ifndef _DATA_EXPORTER_H_
#define _DATA_EXPORTER_H_

#include <wx/wx.h>
#include <wx/glcanvas.h>

class DataExporter_cls;
class Main_cls;
class PDataBlock_cls;

#define _DATA_SIMPLEBINARY 0
#define _DATA_SIMPLEASCII  1

#include "clsGrammerBase.h"

#include "../COMMON/clsFilename.h"
#include "../CONFITEM/clsConfItem.h"
#include "../WIDGETCTRL/clsMultiInputPanel.h"
#include "../WIDGETCTRL/clsDialogEXKey.h"
#include "../WIDGETCTRL/clsDialogController.h"
#include "../WIDGETCTRL/EX/clsButtonEX.h"

class DataExporterGUI_cls : public wxDialogEXKey, GrammerBaseGUI_cls {
 public:
    DataExporterGUI_cls(DataExporter_cls* pCCtrl,
			wxWindow *pC, wxPoint pos, wxSize size);

    DataExporter_cls* mpCCtrl;

    int mActiveList;

    void OnButtonReference(wxCommandEvent &event);
    void OnButtonExport(wxCommandEvent &event);
    void OnButtonClose(wxCommandEvent &event);
    void OnButtonAbort(wxCommandEvent &event);
    void AbortExport();
    void ExportFinish();

    MultiInputPanel_cls* mpCMNumExportParam;
    void SetMNumExportParam(wxBoxSizer *pBoxSizer);

    wxButtonEX     *mpCButtonExport;

    void OnBtnUpHead(wxCommandEvent &event);
    void OnBtnDownHead(wxCommandEvent &event);
    void OnBtnUpBody(wxCommandEvent &event);
    void OnBtnDownBody(wxCommandEvent &event);
    void OnBtnDefault(wxCommandEvent &event);
    void OnInsertDummy1(wxCommandEvent &event);
    void OnInsertDummy3(wxCommandEvent &event);
    void OnInsertDummy10(wxCommandEvent &event);
    void OnInsertXYZ(wxCommandEvent &event);
    void OnInsertVXVYVZ(wxCommandEvent &event);
    void OnInsertRadius(wxCommandEvent &event);
    void OnInsertType(wxCommandEvent &event);
    void OnInsertId(wxCommandEvent &event);
    void OnInsertValue1(wxCommandEvent &event);
    void OnInsertTime(wxCommandEvent &event);
    void OnInsertNumber(wxCommandEvent &event);
    void OnDelete(wxCommandEvent &event);
    void OnClick(wxListEvent& event);
    void OnListKeyDown(wxListEvent& event);
    void OnKeyDown(wxKeyEvent& event);
    void OnMouseRGT(wxMouseEvent& event);

    static void FuncHookCombobox(void *pEvent, void *pArg);

 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

class DataExporter_cls :
public GrammerBase_cls, public DialogControl_cls{
 public:
    DataExporter_cls(Main_cls *pCMain);
    
    Main_cls            *mpCMainLink;
    DataExporterGUI_cls *mpCGUI;
    FileSequence_cls    mCFileSequence;

    ConfItemSTR_cls   mCLastSavedFile;
    ConfItemINT_cls   mCInitNum;
    int             mCurrentOffset;
    bool            mbInExporting;

    void InitGUI(wxWindow *pC);
    void OpenWindow(wxWindow *pCParent);
    void UpdateItems(bool bForce = FALSE);

    void ExportFinish();

    bool ExportBinary(wxString strFilename, PDataBlock_cls *pCDataBlock);
    bool ExportAscii(wxString strFilename, PDataBlock_cls *pCDataBlock);
    wxString GetWXStrModifiedFilename();
    void ExportData(PDataBlock_cls *pCDataBlock);

    void ReadStrLine(wxString strLine);
    wxString Serialize();
};

#endif
