// -*- c++ -*- 
// "clsDataLoader.h"
// (setq c-basic-offset 4)

#include "clsDataLoader.h"
#include "clsDataLoaderGUI.h"

#include "../../clsMain.h"

DataLoader_cls::
DataLoader_cls(Main_cls *pCMain) :
    GrammerBase_cls(wxT("DataLoad"))
{
    mpCGUI = NULL;
    mpCMainLink = pCMain;    
    
    mCConfList.Add(&mCLastOpenedFile, wxT("LastOpenedFile="), wxT("NONE"));
    mCConfList.Add(&mCInterpType, wxT("InterpolateType="), wxT("1"));
    mCConfList.Add(&mCVariablePNum, wxT("VariableNumber="), wxT("0"));
    mCConfList.Add(&mCAdjustTranslate, wxT("LoaderTranslaye="), wxT("0 0 0"));
    mCConfList.Add(&mCAdjustScale, wxT("LoaderScale="), wxT("1"));
}

DataLoader_cls::
~DataLoader_cls(){
}

void DataLoader_cls::
InitGUI(wxWindow *pCParent){
    mpCGUI = new DataLoaderGUI_cls(pCParent, this);
}

void DataLoader_cls::
OpenWindow(wxWindow *pCParent){
    if (mpCGUI == NULL) InitGUI(pCParent);
    if (mpCGUI->IsShownOnScreen() == FALSE){
	mpCGUI->Show(TRUE);
	mpCGUI->SetFocus();
    }
    else
	mpCGUI->SetFocus();

    mpCGUI->Raise();
}

void DataLoader_cls::
OpenDataFile(wxString strFilePath){
    mpCMainLink->OpenDataFileCommand(strFilePath);
    mCLastOpenedFile.mstrBody = strFilePath;
}

// ---------

void DataLoader_cls::
ReadStrLine(wxString strLine){
    mCConfList.ReadStrLineAll(strLine);
}

wxString DataLoader_cls::
Serialize(){
    return mCConfList.SerializeAll();
}
