// (setq c-basic-offset 4)
// "clsDataLoaderGUI.h"
// "wxWidgetEnum.h"

#include "clsDataLoaderGUI.h"
#include "clsDataLoader.h"

#include "../WIDGETCTRL/clsMultiInputPanel.h"
#include "../WIDGETCTRL/clsHookCtrl.h"
#include "../WIDGETCTRL/EX/clsFileDialogEX.h"
#include "../WIDGETCTRL/EX/clsButtonEX.h"
extern wxFileDialogEX *GpCFileDialog;

#include "../../wxWidgetEnum.h"
#include "../../wxWidgetEnumMenu.h"

extern wxFrame  *GpCMainFrameCLS;

#include <wx/wx.h>

BEGIN_EVENT_TABLE(DataLoaderGUI_cls, wxDialog)
EVT_LIST_ITEM_RIGHT_CLICK(wxID_ANY, DataLoaderGUI_cls::OnClick) 
EVT_LIST_KEY_DOWN        (wxID_ANY, DataLoaderGUI_cls::OnListKeyDown)
EVT_KEY_DOWN                     (DataLoaderGUI_cls::OnKeyDown)
EVT_RIGHT_UP                     (DataLoaderGUI_cls::OnMouseRGT)
EVT_BUTTON(btnDataLoaderOpenFile, DataLoaderGUI_cls::OnBtnOpenFile)
EVT_BUTTON(btnDataLoaderUpHead,   DataLoaderGUI_cls::OnBtnUpHead)
EVT_BUTTON(btnDataLoaderDownHead, DataLoaderGUI_cls::OnBtnDownHead)
EVT_BUTTON(btnDataLoaderUpBody,   DataLoaderGUI_cls::OnBtnUpBody)
EVT_BUTTON(btnDataLoaderDownBody,  DataLoaderGUI_cls::OnBtnDownBody)
EVT_BUTTON(btnDataLoaderDefault,   DataLoaderGUI_cls::OnBtnDefault)
EVT_MENU(menuGrammerSwapUpHead,    DataLoaderGUI_cls::OnBtnUpHead)
EVT_MENU(menuGrammerSwapDownHead,  DataLoaderGUI_cls::OnBtnDownHead)
EVT_MENU(menuGrammerSwapUpBody,    DataLoaderGUI_cls::OnBtnUpBody)
EVT_MENU(menuGrammerSwapDownBody,  DataLoaderGUI_cls::OnBtnDownBody)
EVT_MENU(menuGrammerInsertDummy1,  DataLoaderGUI_cls::OnInsertDummy1)
EVT_MENU(menuGrammerInsertDummy3,  DataLoaderGUI_cls::OnInsertDummy3)
EVT_MENU(menuGrammerInsertDummy10, DataLoaderGUI_cls::OnInsertDummy10)
EVT_MENU(menuGrammerInsertXYZ,     DataLoaderGUI_cls::OnInsertXYZ)
EVT_MENU(menuGrammerInsertVxVyVz,  DataLoaderGUI_cls::OnInsertVXVYVZ)
EVT_MENU(menuGrammerInsertRadius,  DataLoaderGUI_cls::OnInsertRadius)
EVT_MENU(menuGrammerInsertType,    DataLoaderGUI_cls::OnInsertType)
EVT_MENU(menuGrammerInsertId,      DataLoaderGUI_cls::OnInsertId)
EVT_MENU(menuGrammerInsertValue1,  DataLoaderGUI_cls::OnInsertValue1)
EVT_MENU(menuGrammerInsertTime,    DataLoaderGUI_cls::OnInsertTime)
EVT_MENU(menuGrammerInsertNumber,  DataLoaderGUI_cls::OnInsertNumber)
EVT_MENU(menuGrammerDelete,        DataLoaderGUI_cls::OnDelete)
END_EVENT_TABLE()

DataLoaderGUI_cls::
DataLoaderGUI_cls(wxWindow *pCParent, DataLoader_cls *pCCtrl) :
wxDialogEXKey(pCParent, wxID_ANY, wxT("Data Loader"), wxDefaultPosition),
    GrammerBaseGUI_cls(pCCtrl)
{
    mpCParent = pCParent;
    mpCCtrl   = pCCtrl;

    wxBoxSizer  *pBoxSizerSRC = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer  *pBoxSizerTOP = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer  *pBoxSizerBTM = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer  *pBoxSizerBL  = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer  *pBoxSizerBLT = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer  *pBoxSizerBLB = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer  *pBoxSizerBR  = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer  *pBoxSizerBRT = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer  *pBoxSizerBRB = new wxBoxSizer(wxHORIZONTAL);
    
    wxBoxSizer  *pBoxSizerTL = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer  *pBoxSizerTR = new wxBoxSizer(wxVERTICAL);

    SetMInput(pBoxSizerTL);

    wxButton *pCButtton = new wxButton (this, btnDataLoaderOpenFile, _("Open File Sequence"), wxDefaultPosition, wxDefaultSize);
    
    pBoxSizerTR->Add(pCButtton, 1, wxEXPAND);
    pBoxSizerTOP->Add(pBoxSizerTL, 1, wxEXPAND);
    pBoxSizerTOP->Add(pBoxSizerTR, 1, wxEXPAND);

    wxStaticText *pStaticTextHead = new wxStaticText
	(this, wxID_ANY, _("Header Format"));
    wxStaticText *pStaticTextBody = new wxStaticText
	(this, wxID_ANY, _("Body Format"));
    
    pBoxSizerBLT->Add(4, -1);
    pBoxSizerBLT->Add(pStaticTextHead, 0, wxEXPAND | wxALIGN_CENTER_HORIZONTAL);
    pBoxSizerBRT->Add(4, -1);
    pBoxSizerBRT->Add(pStaticTextBody, 0, wxEXPAND | wxALIGN_CENTER_HORIZONTAL);

    pBoxSizerBL->Add(pBoxSizerBLT, 0, wxEXPAND);
    pBoxSizerBR->Add(pBoxSizerBRT, 0, wxEXPAND);

#ifdef WIN32
    int listCtrlWidth = 260;
#else
    int listCtrlWidth = 280;
#endif
    mpCListCtrlHead = new wxListCtrlEX
	(this, wxID_ANY, wxDefaultPosition, wxSize(listCtrlWidth, 180),
	 wxLC_REPORT | wxSUNKEN_BORDER);
    SetColumn(mpCListCtrlHead);
    UpdateList(mpCListCtrlHead, mpCCtrl->mCGrammerHead);
    
    mpCListCtrlBody = new wxListCtrlEX
	(this, wxID_ANY, wxDefaultPosition, wxSize(listCtrlWidth, 180),
	 wxLC_REPORT | wxSUNKEN_BORDER);
    SetColumn(mpCListCtrlBody);
    UpdateList(mpCListCtrlBody, mpCCtrl->mCGrammerBody);
    
    pBoxSizerBL->Add(mpCListCtrlHead, 1, wxEXPAND);
    pBoxSizerBR->Add(mpCListCtrlBody, 1, wxEXPAND);

    mpCBtnUpHead = new wxButtonEX(this, btnDataLoaderUpHead, wxT("Up"));
    mpCBtnDownHead = new wxButtonEX(this, btnDataLoaderDownHead, wxT("Down"));

    pBoxSizerBLB->Add(mpCBtnUpHead, 0, wxEXPAND);
    pBoxSizerBLB->Add(mpCBtnDownHead, 0, wxEXPAND);

    mpCBtnUpBody = new wxButtonEX(this, btnDataLoaderUpBody, wxT("Up"));
    mpCBtnDownBody = new wxButtonEX(this, btnDataLoaderDownBody, wxT("Down"));
    mpCBtnDefault = new wxButtonEX(this, btnDataLoaderDefault, wxT("Default"));
    
    pBoxSizerBRB->Add(mpCBtnUpBody, 0, wxEXPAND);
    pBoxSizerBRB->Add(mpCBtnDownBody, 0, wxEXPAND);
    pBoxSizerBRB->Add(-1, 0, wxEXPAND);
    pBoxSizerBRB->Add(mpCBtnDefault, 0, wxEXPAND);

    pBoxSizerBL->Add(pBoxSizerBLB, 0, wxEXPAND);
    pBoxSizerBR->Add(pBoxSizerBRB, 0, wxEXPAND);

    pBoxSizerBTM->Add(pBoxSizerBL, 1, wxEXPAND);
    pBoxSizerBTM->Add(pBoxSizerBR, 1, wxEXPAND);
    pBoxSizerSRC->Add(pBoxSizerTOP, 0, wxEXPAND);
    pBoxSizerSRC->Add(pBoxSizerBTM, 0, wxEXPAND);
    
    SetSizerAndFit(pBoxSizerSRC);

    SetMenu();
}

void DataLoaderGUI_cls::
SetMInput(wxBoxSizer *pBoxSizer){
    MultiInputPanel_cls* pCurr = 
	InitializeMNumPanel(&mpCMInput, this);

    pCurr->mTextWidth = 90;
    pCurr->mItemWidth = -1;
    
    wxString strListType[2] = {
	wxT("Simple Binary"),wxT("Simple Ascii") };
    pCurr->CombinePointerList(_ITEM_UINT_LIST, &mpCCtrl->mCDataType.mBody,
			      2, strListType, _("Data Type"));
    wxString strInterpType[3] = {
	_("Linear"), _("Hermite"), _("No Interpolate") };
    pCurr->CombinePointerList(_ITEM_UINT_LIST, &mpCCtrl->mCInterpType.mBody,
			      3, strInterpType, _("Interpolation"));
    
    wxString strVariablePNum[2] = {
	_("Constant"), _("Variable") };
    pCurr->CombinePointerList(_ITEM_UINT_LIST, &mpCCtrl->mCVariablePNum.mBody,
			      2, strVariablePNum, _("Particle Number"));

    int boxWidth = 3;
    pCurr->mItemWidth = 50;
    pCurr->CombinePointer
	(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Translate"));
    pCurr->CombinePointer
	(_ITEM_FLOAT, &mpCCtrl->mCAdjustTranslate.mpBody[0]);
    pCurr->CombinePointer
	(_ITEM_FLOAT, &mpCCtrl->mCAdjustTranslate.mpBody[1]);
    pCurr->CombinePointer
	(_ITEM_FLOAT, &mpCCtrl->mCAdjustTranslate.mpBody[2]);
    pCurr->mItemWidth = -1;
    pCurr->CombinePointer
	(_ITEM_FLOAT, &mpCCtrl->mCAdjustScale.mBody,_("Scaling"));
    
    pCurr->FinishSetting(pBoxSizer);

    pCurr->mpCHookCtrl->SetFuncHook(FuncHookCombobox, _HOOK_COMBOBOX,
				    wxID_ANY, FALSE, this);
}

void DataLoaderGUI_cls::
OnBtnOpenFile(wxCommandEvent &event){
    mpCCtrlBase->SetHeaderGrammer(GetVGrammer(mpCListCtrlHead));
    mpCCtrlBase->SetBodyGrammer(GetVGrammer(mpCListCtrlBody));

    wxString strLastOpened = mpCCtrl->mCLastOpenedFile.mstrBody;
    if (strLastOpened == wxT("NONE"))
	GpCFileDialog->SetInitPath(wxT("./"), wxT(""));
    else
	GpCFileDialog->SetInitPathFull(strLastOpened);

    GpCFileDialog->SetMessage(wxT("Coose first file"));
    GpCFileDialog->SetWildcard(wxT("*"));
    GpCFileDialog->SetStyle(wxFD_FILE_MUST_EXIST);

    if (GpCFileDialog->ShowModal() == wxID_OK){
	
	mpCCtrl->SetHeaderGrammer(GetVGrammer(mpCListCtrlHead));
	mpCCtrl->SetBodyGrammer(GetVGrammer(mpCListCtrlBody));

	wxString strTmp = GpCFileDialog->GetPath();
	mpCCtrl->OpenDataFile(strTmp);
    }
    else
	return;

    Hide();
}

void DataLoaderGUI_cls::
OnBtnUpHead(wxCommandEvent& event){
    SwapList(mpCListCtrlHead, 0, -1);
}

void DataLoaderGUI_cls::
OnBtnDownHead(wxCommandEvent& event){
    SwapList(mpCListCtrlHead, 0, +1);
}

void DataLoaderGUI_cls::
OnBtnUpBody(wxCommandEvent& event){
    SwapList(mpCListCtrlBody, 1, -1);
}

void DataLoaderGUI_cls::
OnBtnDownBody(wxCommandEvent& event){
    SwapList(mpCListCtrlBody, 1, +1);
}

void DataLoaderGUI_cls::
OnBtnDefault(wxCommandEvent& event){
    SetToDefault(this, mpCCtrl->mCGrammerHead, mpCCtrl->mCGrammerBody);
}

void DataLoaderGUI_cls::
OnInsertDummy1(wxCommandEvent &event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_DUMMY1, mActiveList);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataLoaderGUI_cls::
OnInsertDummy3(wxCommandEvent &event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_DUMMY3, mActiveList);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataLoaderGUI_cls::
OnInsertDummy10(wxCommandEvent &event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_DUMMY10, mActiveList);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataLoaderGUI_cls::
OnInsertXYZ(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_XYZ, mActiveList);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataLoaderGUI_cls::
OnInsertVXVYVZ(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_VXVYVZ, mActiveList);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataLoaderGUI_cls::
OnInsertRadius(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_RADIUS, mActiveList);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataLoaderGUI_cls::
OnInsertType(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_TYPE, mActiveList);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataLoaderGUI_cls::
OnInsertId(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_ID, mActiveList);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataLoaderGUI_cls::
OnInsertValue1(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_VALUE1, mActiveList);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataLoaderGUI_cls::
OnInsertTime(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_TIME, mActiveList);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataLoaderGUI_cls::
OnInsertNumber(wxCommandEvent& event){
    AddListItem(GetPActiveListCtrl(), -1, _GRAMMER_NUMBER, mActiveList);
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataLoaderGUI_cls::
OnDelete(wxCommandEvent &event){
    DeleteSelectedItem(GetPActiveListCtrl());
    UpdateIndexAndColor(GetPActiveListCtrl());
}

void DataLoaderGUI_cls::
OnClick(wxListEvent& event){
    if (event.GetId() == mpCListCtrlHead->GetId()){
	mActiveList = 0;
	UpdateMenuHead();
	PopupMenu(mpPopupMenuHeader);
    }
    else{
	mActiveList = 1;
	UpdateMenuBody();
	PopupMenu(mpPopupMenuBody);
    }
}

void DataLoaderGUI_cls::
OnListKeyDown(wxListEvent& event){
    if (event.GetKeyCode() == WXK_DELETE){
	DeleteSelectedItem(GetPActiveListCtrl());
	UpdateIndexAndColor(GetPActiveListCtrl());
    }
    event.Skip();
}

void DataLoaderGUI_cls::
OnKeyDown(wxKeyEvent& event){
    if (event.GetModifiers() == wxMOD_CONTROL)
	switch(event.GetKeyCode()){
	case 'O': {
	    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuFileOpenProject);
	    GpCMainFrameCLS->AddPendingEvent(com);
	    break; }
	}
}

void DataLoaderGUI_cls::
OnMouseRGT(wxMouseEvent& event){
    if (event.GetId() == mpCListCtrlHead->GetId()){
	mActiveList = 0;
	UpdateMenuHead();
#ifdef __WXMAC__
	PopupMenu(mpPopupMenuHeader);
#else
	PopupMenu(mpMenuInsertHead);
#endif
    }
    else if (event.GetId() == mpCListCtrlBody->GetId()){
	mActiveList = 1;
	UpdateMenuBody();
#ifdef __WXMAC__
	PopupMenu(mpPopupMenuBody);
#else
	PopupMenu(mpMenuInsertBody);
#endif 
    }
}

void DataLoaderGUI_cls::
FuncHookCombobox(void *pEvent, void *pArg){
    DataLoaderGUI_cls *pThis = (DataLoaderGUI_cls*)pEvent;
    pThis->OnHookCombobox();
}
