// -*- c++ -*-
// "clsGrammerBase.h"
// (setq c-basic-offset 4)

#include "clsGrammerBase.h"
#include "clsDataLoader.h"

#include "../MYAPI/MsgBox.h"

#include "../../wxWidgetEnum.h"
#include "../../wxWidgetEnumMenu.h"

BEGIN_EVENT_TABLE(wxListCtrlEX, wxWindow)
EVT_RIGHT_UP(wxListCtrlEX::OnMouse)
END_EVENT_TABLE()

wxListCtrlEX::
wxListCtrlEX(wxWindow* parent, wxWindowID id, 
	     const wxPoint& pos, const wxSize& size, long style):
wxListCtrl(parent, id, pos, size, style)
{
}

void wxListCtrlEX::
OnMouse(wxMouseEvent& event){
    GetParent()->AddPendingEvent(event);
}

// ---

GrammerBaseGUI_cls::
GrammerBaseGUI_cls(GrammerBase_cls *pCCtrlBase){
    mpCCtrlBase = pCCtrlBase;

    mstrItemName[0].push_back(wxT("Time"));
    mstrItemName[0].push_back(wxT("Number"));
    mstrItemName[0].push_back(wxT("Dummy"));
    mstrItemName[0].push_back(wxT("Dummy*3"));
    mstrItemName[0].push_back(wxT("Dummy*10"));
    mstrItemDescript[0].push_back(wxT("float"));
    mstrItemDescript[0].push_back(wxT("integer"));
    mstrItemDescript[0].push_back(wxT("float"));
    mstrItemDescript[0].push_back(wxT("float*3"));
    mstrItemDescript[0].push_back(wxT("float*10"));
    mstrItemByte[0].push_back(wxT("4"));
    mstrItemByte[0].push_back(wxT("4"));
    mstrItemByte[0].push_back(wxT("4"));
    mstrItemByte[0].push_back(wxT("12"));
    mstrItemByte[0].push_back(wxT("40"));

    mstrItemName[1].push_back(wxT("x y z"));
    mstrItemName[1].push_back(wxT("Vx Vy Vz"));
    mstrItemName[1].push_back(wxT("Dummy"));
    mstrItemName[1].push_back(wxT("Dummy*3"));
    mstrItemName[1].push_back(wxT("Dummy*10"));
    mstrItemName[1].push_back(wxT("Radius"));
    mstrItemName[1].push_back(wxT("ID"));
    mstrItemName[1].push_back(wxT("Type"));
    mstrItemName[1].push_back(wxT("Value1"));
    mstrItemDescript[1].push_back(wxT("float*3"));
    mstrItemDescript[1].push_back(wxT("float*3"));
    mstrItemDescript[1].push_back(wxT("float"));
    mstrItemDescript[1].push_back(wxT("float*3"));
    mstrItemDescript[1].push_back(wxT("float*10"));
    mstrItemDescript[1].push_back(wxT("float"));
    mstrItemDescript[1].push_back(wxT("integer"));
    mstrItemDescript[1].push_back(wxT("integer[0-3]"));
    mstrItemDescript[1].push_back(wxT("float"));
    mstrItemByte[1].push_back(wxT("12"));
    mstrItemByte[1].push_back(wxT("12"));
    mstrItemByte[1].push_back(wxT("4"));
    mstrItemByte[1].push_back(wxT("12"));
    mstrItemByte[1].push_back(wxT("40"));
    mstrItemByte[1].push_back(wxT("4"));
    mstrItemByte[1].push_back(wxT("4"));
    mstrItemByte[1].push_back(wxT("4"));
    mstrItemByte[1].push_back(wxT("4"));
}

GrammerBaseGUI_cls::
~GrammerBaseGUI_cls(){
    delete mpPopupMenuHeader;
    delete mpPopupMenuBody;
}

wxListCtrl* GrammerBaseGUI_cls::
GetPActiveListCtrl(){
    if (mActiveList == 0)
	return mpCListCtrlHead;
    return mpCListCtrlBody;
}

std::vector < int > GrammerBaseGUI_cls::
GetVGrammer(wxListCtrl* pCList){
    std::vector < int > VGrammer;
    wxInt32 nItem = -1;
    while (TRUE){
	nItem = pCList->GetNextItem(nItem, wxLIST_NEXT_ALL);
	if (nItem == -1) break;
	VGrammer.push_back(pCList->GetItemData(nItem));
    }
    return VGrammer;
}

void GrammerBaseGUI_cls::
SetMenu(){
    mpPopupMenuHeader = new wxMenu; // ENbNj[
    mpPopupMenuHeader->Append(menuGrammerSwapUpHead, wxT("Swap up"));
    mpPopupMenuHeader->Append(menuGrammerSwapDownHead, wxT("Swap down"));
    mpPopupMenuHeader->AppendSeparator();
    mpPopupMenuHeader->Append(menuGrammerDelete, _("Delete item"));
    mpMenuInsertHead = new wxMenu;
    mpPopupMenuHeader->Append(menuGrammerInsert,
			    _("InsertItem"), mpMenuInsertHead);

    mpPopupMenuBody = new wxMenu; // ENbNj[
    mpPopupMenuBody->Append(menuGrammerSwapUpBody, wxT("Swap up"));
    mpPopupMenuBody->Append(menuGrammerSwapDownBody, wxT("Swap down"));
    mpPopupMenuBody->AppendSeparator();
    mpPopupMenuBody->Append(menuGrammerDelete, _("Delete item"));
    mpMenuInsertBody = new wxMenu;
    mpPopupMenuBody->Append(menuGrammerInsert,
			    _("InsertItem"), mpMenuInsertBody);
}

void GrammerBaseGUI_cls::
SetColumn(wxListCtrl* pCList){
    pCList->InsertColumn(0,wxT(""), wxLIST_FORMAT_CENTER, 20);
    pCList->InsertColumn(1,_("Data"), wxLIST_FORMAT_LEFT, 90);
    pCList->InsertColumn(2,_("Type"), wxLIST_FORMAT_LEFT, 80);
    pCList->InsertColumn(3,_("Byte"), wxLIST_FORMAT_LEFT, 60);
}

void GrammerBaseGUI_cls::
SetToDefault(wxWindow *pCParent, 
	     ConfItemINTARRAY_cls &CGrammerHead, 
	     ConfItemINTARRAY_cls &CGrammerBody){
    if (MsgBoxYesno(pCParent, _("Inquery"), _("Set to default ?")) == TRUE){
	CGrammerHead.SetItem(wxT("GrammerHead="), wxT("0 1"));
	CGrammerBody.SetItem(wxT("GrammerBody="), wxT("0 1 5 6 7 8"));
	UpdateList(mpCListCtrlHead, CGrammerHead);
	UpdateList(mpCListCtrlBody, CGrammerBody);
    }
}

void GrammerBaseGUI_cls::
UpdateList(wxListCtrl *pCList, ConfItemINTARRAY_cls &Grammer){
    if (pCList == mpCListCtrlHead){
	mpCListCtrlHead->DeleteAllItems();
	for (int i = 0; i < Grammer.mDimension; i++)
	    AddListItem(mpCListCtrlHead, -1, Grammer.mpBody[i], 0);
	UpdateIndexAndColor(pCList);
    }
    if (pCList == mpCListCtrlBody){
	mpCListCtrlBody->DeleteAllItems();
	for (int i = 0; i < Grammer.mDimension; i++)
	    AddListItem(mpCListCtrlBody, -1, Grammer.mpBody[i], 1);
	UpdateIndexAndColor(pCList);
    }
}

void GrammerBaseGUI_cls::
DeleteSelectedItem(wxListCtrl *pCList){
    wxInt32 nItem = -1;
    while (TRUE){
	nItem = pCList->GetNextItem(nItem, wxLIST_NEXT_ALL, 
				  wxLIST_STATE_SELECTED);
	if (nItem == -1) break;
	pCList->DeleteItem(nItem);
	nItem = -1;
    }
}

void GrammerBaseGUI_cls::
AddListItem(wxListCtrl *pCList, wxInt32 nID, int typeItem, int typeFormat){
    wxListItem listItem;
    
    if (nID == -1)
	nID = pCList->GetNextItem(-1, wxLIST_NEXT_ALL, 
				  wxLIST_STATE_SELECTED);
    
    if (nID == -1)// ǉ
	nID = pCList->GetItemCount();
    else
	;//nID++; //Î̎
    
    listItem.SetId(nID);
    listItem.SetMask(wxLIST_MASK_DATA | wxLIST_MASK_STATE);
    listItem.SetData(typeItem);
    
    wxString strNum; strNum << pCList->GetItemCount();
    listItem.SetText(strNum);
    pCList->InsertItem(listItem);
    
    pCList->SetItem(nID, 1, mstrItemName[typeFormat][typeItem]);

    if (mpCCtrlBase->mCDataType.mBody == _DATA_SIMPLEBINARY){
	pCList->SetItem(nID, 2, mstrItemDescript[typeFormat][typeItem]);
	pCList->SetItem(nID, 3, mstrItemByte[typeFormat][typeItem]);
    }
    else{
	pCList->SetItem(nID, 2, wxT("-"));
	pCList->SetItem(nID, 3, wxT("-"));
    }
}

void GrammerBaseGUI_cls::
UpdateIndexAndColor(wxListCtrl *pCList){
    wxInt32 nItem = -1;
    int index = 0;
    while (TRUE){
	nItem = pCList->GetNextItem(nItem, wxLIST_NEXT_ALL);
	if (nItem == -1) break;
	wxString strIndex; strIndex << index;
	pCList->SetItem(nItem, 0, strIndex);
	int typeItem = pCList->GetItemData(nItem);
	wxListItem listItem;
	listItem.SetId(nItem);
	if (typeItem == _GRAMMER_DUMMY1 ||
	    typeItem == _GRAMMER_DUMMY3 ||
	    typeItem == _GRAMMER_DUMMY10){
	    pCList->GetItem(listItem);
	    listItem.SetTextColour(*wxLIGHT_GREY);
	    pCList->SetItem(listItem);
	}
	else{
	    pCList->GetItem(listItem);
	    listItem.SetTextColour(*wxBLACK);
	    pCList->SetItem(listItem);
	}
	index++;
    }
}

void GrammerBaseGUI_cls::
SwapList(wxListCtrl *pCList, int typeFormat, int direction){

    if (pCList->GetItemCount() < 2) return;

    std::vector < wxInt32 > VItemList;

    wxInt32 nItem = -1, nItemPrev;
    while (TRUE){
	nItem = pCList->GetNextItem(nItem, wxLIST_NEXT_ALL);
	if (nItem == -1) break;
	VItemList.push_back(nItem);
    }

    int index = 0;
    if (direction == +1)
	index = VItemList.size() - 1; //SwapDown͉T
    
    while (TRUE){
	if (index < 0 || index >= VItemList.size()) break;
	nItem = VItemList[index];

	// ݂̃ACeIACeȂ珈
	int stateCurr = 
	    pCList->GetItemState(nItem, wxLIST_STATE_SELECTED);

	if (stateCurr != 0){
	    int prevIndex = index + direction;
	    if (prevIndex < 0 || prevIndex >= VItemList.size()){
		index -= direction;
		continue;
	    }
	    nItemPrev = VItemList[prevIndex];

	    int statePrev = 
		pCList->GetItemState(nItemPrev, wxLIST_STATE_SELECTED);

	    // Xbvf[^
	    wxUIntPtr ptrPrev = pCList->GetItemData(nItemPrev);
	    wxUIntPtr ptrCurr = pCList->GetItemData(nItem);

	    // Xbvs
	    pCList->SetItemData
		(nItemPrev, pCList->GetItemData(nItem));
	    pCList->SetItemState
		(nItemPrev, stateCurr, wxLIST_STATE_SELECTED);
	    pCList->SetItemData
		(nItem, ptrPrev);
	    pCList->SetItemState
		(nItem, statePrev, wxLIST_STATE_SELECTED);

	    int typeCurr = pCList->GetItemData(nItem);
	    int typePrev = pCList->GetItemData(nItemPrev);

	    pCList->SetItem(nItem,1,mstrItemName[typeFormat][typeCurr]);
	    pCList->SetItem(nItemPrev,1,mstrItemName[typeFormat][typePrev]);

	    if (mpCCtrlBase->mCDataType.mBody == _DATA_SIMPLEBINARY){
		pCList->SetItem(nItem,2,mstrItemDescript[typeFormat][typeCurr]);
		pCList->SetItem(nItem,3,mstrItemByte[typeFormat][typeCurr]);
		pCList->SetItem(nItemPrev,2,mstrItemDescript[typeFormat][typePrev]);
		pCList->SetItem(nItemPrev,3,mstrItemByte[typeFormat][typePrev]);
	    }
	    else{
		pCList->SetItem(nItem,2,wxT("-"));
		pCList->SetItem(nItem,3,wxT("-"));
		pCList->SetItem(nItemPrev,2,wxT("-"));
		pCList->SetItem(nItemPrev,3,wxT("-"));
	    }
	}
	index -= direction;
    }

    UpdateIndexAndColor(pCList);
}

void GrammerBaseGUI_cls::
ClearMenu(wxMenu* pMenu){
    wxMenuItemList list = pMenu->GetMenuItems();
    
    for (wxMenuItemList::iterator iter = list.begin(); iter != list.end(); 
	 ++iter)
	pMenu->Delete(*iter);
}

void GrammerBaseGUI_cls::
UpdateMenuHead(){
    ClearMenu(mpMenuInsertHead);

    bool bTime   = FALSE;
    bool bNumber = FALSE;
    
    wxListCtrl *pCList = mpCListCtrlHead;
    wxInt32 nItem = -1;
    while (TRUE){
	nItem = pCList->GetNextItem(nItem, wxLIST_NEXT_ALL);
	if (nItem == -1) break;
	if (pCList->GetItemData(nItem) == _GRAMMER_TIME)   bTime   = TRUE;
	if (pCList->GetItemData(nItem) == _GRAMMER_NUMBER) bNumber = TRUE;
    }

    if (bTime == FALSE) 
	mpMenuInsertHead->Append(menuGrammerInsertTime, wxT("Time"));
    if (bNumber == FALSE) 
	mpMenuInsertHead->Append(menuGrammerInsertNumber, wxT("Number"));

    mpMenuInsertHead->Append(menuGrammerInsertDummy1, _("Dummy"));
    mpMenuInsertHead->Append(menuGrammerInsertDummy3, _("Dummy*3"));
    mpMenuInsertHead->Append(menuGrammerInsertDummy10, _("Dummy*10"));
}

void GrammerBaseGUI_cls::
UpdateMenuBody(){
    ClearMenu(mpMenuInsertBody);

    bool bXYZ    = FALSE;
    bool bVxVyVz = FALSE;
    bool bRadius = FALSE;
    bool bId     = FALSE;
    bool bType   = FALSE;
    bool bValue1 = FALSE;
    
    wxListCtrl *pCList = mpCListCtrlBody;
    wxInt32 nItem = -1;
    while (TRUE){
	nItem = pCList->GetNextItem(nItem, wxLIST_NEXT_ALL);
	if (nItem == -1) break;
	if (pCList->GetItemData(nItem) == _GRAMMER_XYZ)    bXYZ = TRUE;
	if (pCList->GetItemData(nItem) == _GRAMMER_VXVYVZ) bVxVyVz = TRUE;
	if (pCList->GetItemData(nItem) == _GRAMMER_RADIUS) bRadius = TRUE;
	if (pCList->GetItemData(nItem) == _GRAMMER_ID)     bId   = TRUE;
	if (pCList->GetItemData(nItem) == _GRAMMER_TYPE)   bType = TRUE;
	if (pCList->GetItemData(nItem) == _GRAMMER_VALUE1) bValue1 = TRUE;
    }

    if (bXYZ == FALSE) 
	mpMenuInsertBody->Append(menuGrammerInsertXYZ, wxT("XYZ"));
    if (bVxVyVz == FALSE) 
	mpMenuInsertBody->Append(menuGrammerInsertVxVyVz, wxT("VxVyVz"));
    if (bRadius == FALSE) 
	mpMenuInsertBody->Append(menuGrammerInsertRadius, wxT("Raius"));
    if (bId == FALSE)
	mpMenuInsertBody->Append(menuGrammerInsertId, wxT("ID"));
    if (bType == FALSE)
	mpMenuInsertBody->Append(menuGrammerInsertType, wxT("Type"));
    if (bValue1 == FALSE)
	mpMenuInsertBody->Append(menuGrammerInsertValue1, wxT("Value1"));
    
    mpMenuInsertBody->Append(menuGrammerInsertDummy1, _("Dummy"));
    mpMenuInsertBody->Append(menuGrammerInsertDummy3, _("Dummy*3"));
    mpMenuInsertBody->Append(menuGrammerInsertDummy10, _("Dummy*10"));
}

void GrammerBaseGUI_cls::
OnHookCombobox(){
    mpCCtrlBase->SetHeaderGrammer(GetVGrammer(mpCListCtrlHead));
    mpCCtrlBase->SetBodyGrammer(GetVGrammer(mpCListCtrlBody));
    UpdateList(mpCListCtrlHead, mpCCtrlBase->mCGrammerHead);
    UpdateList(mpCListCtrlBody, mpCCtrlBase->mCGrammerBody);
}

// ----

GrammerBase_cls::
GrammerBase_cls(wxString strTag){
    mCConfList.Add(&mCDataType, strTag + wxT("DataType="), wxT("0"));
    mCConfList.Add(&mCGrammerHead, strTag + wxT("GrammerHead="), wxT("0 1"));
    mCConfList.Add(&mCGrammerBody, strTag + wxT("GrammerBody="), wxT("0 1 5 6 7 8"));
}

void GrammerBase_cls::
SetHeaderGrammer(std::vector < int > VHeader){
    mCGrammerHead.mDimension = VHeader.size();
    for (int i = 0; i < mCGrammerHead.mDimension; i++)
	mCGrammerHead.mpBody[i] = VHeader[i];
}

void GrammerBase_cls::
SetBodyGrammer(std::vector < int > VBody){
    mCGrammerBody.mDimension = VBody.size();
    for (int i = 0; i < mCGrammerBody.mDimension; i++)
	mCGrammerBody.mpBody[i] = VBody[i];
}

int GrammerBase_cls::
GetHeaderByte(){
    int byte = 0;
    for (int i = 0; i < mCGrammerHead.mDimension; i++)
	switch(mCGrammerHead.mpBody[i]){
	case _GRAMMER_TIME:
	case _GRAMMER_NUMBER:
	case _GRAMMER_DUMMY1:
	    byte += 4; break;
	case _GRAMMER_DUMMY3:
	    byte += 12; break;
	case _GRAMMER_DUMMY10:
	    byte += 40; break;
	}
    return byte;
}

int GrammerBase_cls::
GetHeaderLine(){
    int line = 0;
    for (int i = 0; i < mCGrammerHead.mDimension; i++)
	switch(mCGrammerHead.mpBody[i]){
	case _GRAMMER_TIME:
	case _GRAMMER_NUMBER:
	case _GRAMMER_DUMMY1:
	    line += 1; break;
	case _GRAMMER_DUMMY3:
	    line += 3; break;
	case _GRAMMER_DUMMY10:
	    line += 10; break;
	}
    return line;
}
