// -*- c -*-
// "clsPreference.h"

#include "clsPreference.h"
#include "clsPreferenceGUI.h"

#include "../../clsFrameMain.h"

#define _MOUSE_BTN_LEFT   0
#define _MOUSE_BTN_MIDDLE 1
#define _MOUSE_BTN_RIGHT  2

int GThreadNumberReadAscii = 4;

Preference_cls::
Preference_cls(FrameMain_cls *pCParentFrame){
    mpCParentFrame = pCParentFrame;
    mpBitmapLink = mpCParentFrame->mpBitmapPreference;
    SetToDefaultMouse(0);
    InitGUI(pCParentFrame);//mpCGUI = NULL;
};

Preference_cls::
~Preference_cls(){
    if (mpCGUI != NULL) delete mpCGUI;
}

void Preference_cls::
InitGUI(wxWindow *pC){
    mpCGUI = new PreferenceGUI_cls(this, pC, wxDefaultPosition, wxDefaultSize);
    SetPDialog(mpCGUI);
}

void Preference_cls::
UpdateItems(bool bForce){
    mpCGUI->mpCMNumMouseParam->UpdateValues();
    //mpCGUI->mpCMNumPerformanceParam->UpdateValuesAll(bForce);
    //mpCGUI->mpCMNumTLParam->UpdateValuesAll(bForce);
    mpCGUI->mpCMNumMemParam->UpdateValues();
}

void Preference_cls::
OpenWindow(wxWindow *pC){
    DialogControl_cls::OpenWindow(pC);
    UpdateItems(TRUE);
    //mpCGUI->GrayOutItems();
}

// {^sꍇ
void Preference_cls::
ModulateBTN(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[0] == TRUE)
	if (bAModifier[mCMButtonEmulate.mBody] == TRUE){
	    bAMouseBTN[_MOUSE_BTN_LEFT] = FALSE;
	    bAMouseBTN[_MOUSE_BTN_MIDDLE] = TRUE;
	}
    bAModifier[mCMButtonEmulate.mBody] = FALSE;
}

bool Preference_cls::
IsMouse4Gyration(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCGyrationMouse.mBody] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++){
	bool condition = mCbGyrationMod.mpbBody[i];
	if (i == mCMButtonEmulate.mBody) condition = FALSE;
	if (bAModifier[i] != condition) return FALSE;
    }
    return TRUE;
}

bool Preference_cls::
IsMouse4Zoom(bool bAModifier[4], bool bAMouseBTN[4]){
        if (bAMouseBTN[mCZoomMouse.mBody] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++)
	if (bAModifier[i] != mCbZoomMod.mpbBody[i]) return FALSE;
    return TRUE;
}

bool Preference_cls::
IsMouse4MoveCenter(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCCenterMouse.mBody] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++){
	bool condition = mCbCenterMod.mpbBody[i];
	if (i == mCMButtonEmulate.mBody) condition = FALSE;
	if (bAModifier[i] != condition) return FALSE;
    }
    return TRUE;
}

bool Preference_cls::
IsMouse4MoveItem(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCItemMouse.mBody] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++){
	bool condition = mCbItemMod.mpbBody[i];
	if (i == mCMButtonEmulate.mBody) condition = FALSE;
	if (bAModifier[i] != condition) return FALSE;
    }
    return TRUE;
}

bool Preference_cls::
IsMouse4Menu(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCMenuMouse.mBody] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++)
	if (bAModifier[i] != mCbMenuMod.mpbBody[i])
	    return FALSE;
    return TRUE;
}

bool Preference_cls::
IsMouse4HitTest(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCHitTestMouse.mBody] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++){
	bool condition = mCbHitTestMod.mpbBody[i];
	if (i == mCMButtonEmulate.mBody) condition = FALSE;
	if (bAModifier[i] != condition) return FALSE;
    }
    return TRUE;
}

void Preference_cls::
SetToDefaultMouse(int type){
    ConfItemList_cls *pCList = &mCConfListMouse;
    pCList->Clear();
    switch(type){
    case 0:
	pCList->Add(&mCGyrationMouse, wxT("GUI_GYRATION="), L"0");
	pCList->Add(&mCbGyrationMod,  wxT("GUI_GYRATION_MOD="), wxT("0 0 0"));
	pCList->Add(&mCbGyrationInvert, wxT("GUI_GYRATION_INVERT="), L"0");
	pCList->Add(&mCZoomMouse, wxT("GUI_ZOOM="), L"1");
	pCList->Add(&mCbZoomMod, wxT("GUI_ZOOM_MOD="), L"0 0 0");
	pCList->Add(&mCbZoomInvert, wxT("GUI_ZOOM_INVERT="), L"0");
	pCList->Add(&mCCenterMouse, wxT("GUI_CENTER="), L"0");
	pCList->Add(&mCbCenterMod, wxT("GUI_CENTER_MOD="), L"1 1 0");
	pCList->Add(&mCItemMouse, wxT("GUI_ITEM="), L"0");
	pCList->Add(&mCbItemMod, wxT("GUI_ITEM_MOD="), L"1 0 0");
	pCList->Add(&mCMenuMouse, wxT("GUI_MENU="), L"2");
	pCList->Add(&mCbMenuMod, wxT("GUI_MENU_MOD="), L"0 0 0");
	pCList->Add(&mCHitTestMouse, wxT("GUI_HITTEST="), L"2");
	pCList->Add(&mCbHitTestMod, wxT("GUI_HITTEST_MOD="), L"1 0 0");
	pCList->Add(&mCMButtonEmulate, wxT("GUI_MBUTTON_EMULATE="), L"2");
	break;
    }
}
