// -*- c -*-
// "clsPreference.cpp"

#ifndef _PREFERENCE_H_
#define _PREFERENCE_H_

#include "../CONFITEM/clsConfItem.h"
#include "../WIDGETCTRL/clsDialogController.h"

class FrameMain_cls;
class PreferenceGUI_cls;

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class Preference_cls 
: public DialogControl_cls
{ 
 public:
    Preference_cls(FrameMain_cls *pCParentFrame);
    ~Preference_cls();
    
    void InitGUI(wxWindow *pC);
    void UpdateItems(bool bForce = FALSE);
    void OpenWindow(wxWindow *pC);

    FrameMain_cls*     mpCParentFrame;
    PreferenceGUI_cls* mpCGUI;
    wxBitmap*          mpBitmapLink;

    void ModulateBTN     (bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4Gyration(bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4Zoom    (bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4MoveCenter(bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4MoveItem(bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4Menu    (bool bAModifier[4], bool bAMouseBTN[4]);
    bool IsMouse4HitTest (bool bAModifier[4], bool bAMouseBTN[4]);
    void SetToDefaultMouse(int type);

    // -- Mouse --
    ConfItemList_cls       mCConfListMouse;

    ConfItemUINT_cls       mCGyrationMouse;
    ConfItemBOOLARRAY_cls  mCbGyrationMod;
    ConfItemUINT_cls       mCZoomMouse;
    ConfItemBOOLARRAY_cls  mCbZoomMod;
    ConfItemUINT_cls       mCCenterMouse;
    ConfItemBOOLARRAY_cls  mCbCenterMod;
    ConfItemUINT_cls       mCItemMouse;
    ConfItemBOOLARRAY_cls  mCbItemMod;
    ConfItemUINT_cls       mCMenuMouse;
    ConfItemBOOLARRAY_cls  mCbMenuMod;
    ConfItemUINT_cls       mCHitTestMouse;
    ConfItemBOOLARRAY_cls  mCbHitTestMod;
    ConfItemBOOL_cls       mCbZoomInvert, mCbGyrationInvert;    
    ConfItemUINT_cls       mCMButtonEmulate;

    void ReadStrLine(std::wstring strLine);
    wxString Serialize();
};

#endif
