// -*- c -*-
// "clsPreferenceGUI.h"
// (setq c-basic-offset 4)

#include "clsPreferenceGUI.h"
#include "clsPreference.h"

#include "../GRAPHIC/clsImageIO.h"
#include "../PARTICLEDATA/clsParticleDataSeqCtrl.h"
#include "../WIDGETCTRL/EX/clsButtonEX.h"

#include "../../clsFrameMain.h"
#include "../../wxWidgetEnum.h"

#include <wx/notebook.h>

extern int GThreadNumberReadAscii;

// ÓIɃCxgт
BEGIN_EVENT_TABLE(PreferenceGUI_cls, wxDialog)
     EVT_BUTTON(wxID_CANCEL   ,  PreferenceGUI_cls::OnButtonClose)
END_EVENT_TABLE()

PreferenceGUI_cls::
PreferenceGUI_cls(Preference_cls* pCParent, wxWindow *pC,
		  wxPoint pos, wxSize size) :
    wxDialogEXKey(pC, wxID_ANY, _("Preference"), 
		  pos, size, pCParent->mpBitmapLink) {
	
    mpCParent = pCParent;
    //SetScreenRectPos(&pCParent->mCScreenRect);
    mTemplateSetting = 0;
    
    // TCU[
    wxBoxSizer    *pBoxSizerSrc  = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer    *pBoxSizerBTM  = new wxBoxSizer(wxHORIZONTAL);

    mpCBook = new wxNotebook(this, ID_BOOK_PREFERENCE);

    mpBoxSizerBookMouse = new wxBoxSizer(wxVERTICAL);
    SetMNumMouseParam(mpBoxSizerBookMouse);
    mpCBook->AddPage(mpCMNumMouseParam, _("Mouse"));
    mpCBook->SetSizer(mpBoxSizerBookMouse);
    
    /*
    mpBoxSizerBookTL    = new wxBoxSizer(wxVERTICAL);
    SetMNumTLParam(mpBoxSizerBookTL);
    mpCBook->AddPage(mpCMNumTLParam, _("Time Line"));
    mpCBook->SetSizer(mpBoxSizerBookTL);
    */

    mpBoxSizerBookMem    = new wxBoxSizer(wxVERTICAL);
    SetMNumMemParam(mpBoxSizerBookMem);
    mpCBook->AddPage(mpCMNumMemParam, _("Performance"));
    mpCBook->SetSizer(mpBoxSizerBookMem);

    /*
    mpBoxSizerBookPerformance = new wxBoxSizer(wxVERTICAL);
    SetMNumPerformanceParam(mpBoxSizerBookPerformance);
    mpCBook->AddPage(mpCMNumPerformanceParam, _("Performance"));
    mpCBook->SetSizer(mpBoxSizerBookPerformance);
    */

    pBoxSizerSrc->Add( mpCBook, 0, wxEXPAND);

    wxButtonEX *pCButtonClose = new wxButtonEX (this, wxID_CANCEL,
						wxT("Close"));

    pBoxSizerBTM->Add( -1, -1, 1, wxEXPAND);

    pBoxSizerBTM->Add( pCButtonClose,  0, wxEXPAND);

    pBoxSizerSrc->Add( pBoxSizerBTM, 0, wxEXPAND);

    SetSizerAndFit(pBoxSizerSrc);
}

PreferenceGUI_cls::
~PreferenceGUI_cls(){
    MakeModal(FALSE);
}

void PreferenceGUI_cls::
SetMNumMouseParam(wxBoxSizer *pBoxSizer){
    MultiInputPanel_cls* pCurr = 
	InitializeMNumPanel(&mpCMNumMouseParam, mpCBook);
    int boxWidth = 4;
    
    pCurr->mTextWidth = 100;
    pCurr->mItemWidth = -1;
    pCurr->mComboWidth = 130;
    pCurr->mCheckBoxWidth = 55;

    wxString strList[4] = {
	_("Left Mouse BTN"), _("Middle Mouse BTN"), _("Right Mouse BTN"), _("Not Assigned")};
    wxString strListB[4] = { _("Left BTN + Shift"), _("Left BTN + Ctrl"), _("Left BTN + Alt"), _("Not Assigned")};
    wxString strListC[2] = { _("Defalut"), _("Blender Like")};
    
    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Gyration"));
    pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &mpCParent->mCGyrationMouse.mBody, 4, strList);
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbGyrationMod.mpbBody[0],
			  wxT("Shift"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbGyrationMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbGyrationMod.mpbBody[2],
			  wxT("Alt"));

    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Zoom"));
    pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &mpCParent->mCZoomMouse.mBody, 4, strList);
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbZoomMod.mpbBody[0], 
			  wxT("Shift"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbZoomMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbZoomMod.mpbBody[2],
			  wxT("Alt"));

    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Move Center"));
    pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &mpCParent->mCCenterMouse.mBody, 4, strList);
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbCenterMod.mpbBody[0], 
			  wxT("Shift"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbCenterMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbCenterMod.mpbBody[2],
			  wxT("Alt"));

    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Move Item"));
    pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &mpCParent->mCItemMouse.mBody, 4, strList);
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbItemMod.mpbBody[0], 
			  wxT("Shift"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbItemMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbItemMod.mpbBody[2],
			  wxT("Alt"));

    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Menu"));
    pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &mpCParent->mCMenuMouse.mBody, 4, strList);
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbMenuMod.mpbBody[0], 
			  wxT("Shift"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbMenuMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbMenuMod.mpbBody[2],
			  wxT("Alt"));
    
    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Item Selection"));
    pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &mpCParent->mCHitTestMouse.mBody, 4, strList);
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbHitTestMod.mpbBody[0], 
			  wxT("Shift"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbHitTestMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbHitTestMod.mpbBody[2],
			  wxT("Alt"));
    
    int comboIndexMButton = pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &mpCParent->mCMButtonEmulate.mBody, 4, strListB, _("MButton Emulate"));

    boxWidth = 2;
    //pCurr->mCheckBoxWidth = 70;
    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Invert"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbZoomInvert.mbBody,
			  _("Zoom"));
    pCurr->CombinePointer(_ITEM_BOOL, &mpCParent->mCbGyrationInvert.mbBody,
			  _("Gyration"));

    int comboIndex = pCurr->CombinePointerList
	(_ITEM_UINT_LIST, &mTemplateSetting, 2, strListC,  _("Template"));
    
    pCurr->FinishSetting(pBoxSizer, TRUE);

    /*
    Connect(pCurr->mVCItemList[comboIndex].mId, wxEVT_COMMAND_COMBOBOX_SELECTED,
	    wxCommandEventHandler(PreferenceGUI_cls::OnCommandEventTemplate));
    Connect(pCurr->mVCItemList[comboIndexMButton].mId,
	    wxEVT_COMMAND_COMBOBOX_SELECTED,
	    wxCommandEventHandler(PreferenceGUI_cls::OnCommandEventGrayOut));
    */
}

void PreferenceGUI_cls::
SetMNumMemParam(wxBoxSizer *pBoxSizer){
    MultiInputPanel_cls* pCurr = 
	InitializeMNumPanel(&mpCMNumMemParam, mpCBook);
    pCurr->mTextWidth = 140;
    pCurr->mItemWidth = -1;

    int boxWidth = 2;
    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Memory Limit(MB)"));
    pCurr->CombinePointer(_ITEM_INTEGER, 
			  &mpCParent->mpCParentFrame->GetPCDataSeqCtrl()->mMemoryLimitationMB,
			  wxT("Critical"));
    pCurr->CombinePointer(_ITEM_INTEGER, 
			  &mpCParent->mpCParentFrame->GetPCDataSeqCtrl()->mTotalUsedMemoryMB,
			  wxT("NowUsed"), FALSE);

    pCurr->CombinePointer(_ITEM_INTEGER_SPIN,
			  &GThreadNumberReadAscii, _("Thread (I/O)"));

    pCurr->CombinePointer(_ITEM_INTEGER_SPIN,
			  &ImageIO_cls::msJPEGQuality, _("JPEG Quality"));
    
    pCurr->FinishSetting(pBoxSizer, TRUE);
}

void PreferenceGUI_cls::
OnButtonClose(wxCommandEvent &event){
    CloseEXKey();
}
