// (setq c-basic-offset 4)
// "clsScene.h"

#include "clsScene.h"
#include "../TIMELINE/clsTimeCtrl.h"
#include "../UNDO/clsUndoManager.h"
extern UndoManager_cls GCUndoList;
#include "../WIDGETCTRL/EX/clsButtonEX.h"

// ÓIɃCxgт
BEGIN_EVENT_TABLE(SceneGUI_cls, wxDialog)
     EVT_BUTTON(wxID_OK     , SceneGUI_cls::OnButtonOK)
     EVT_BUTTON(wxID_CANCEL , SceneGUI_cls::OnButtonClose)
END_EVENT_TABLE()

SceneGUI_cls::
SceneGUI_cls(Scene_cls* pCParent, wxWindow *pC,
	     wxPoint pos, wxSize size) :
    wxDialogEXKey(pC, wxID_ANY, _("Scene Config"), 
		  pos, size, pCParent->mpBitmapLink) {

    mpCParent = pCParent;
    //SetScreenRectPos(&pCParent->mCScreenRect);

    // TCU[
    wxBoxSizer    *pBoxSizerSrc = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer    *pBoxSizerBTM = new wxBoxSizer(wxHORIZONTAL);

    SetMNumMain(pBoxSizerSrc);

    wxButtonEX *pCButtonOK  = new wxButtonEX(this, wxID_OK,
					       wxT("OK"));
    wxButtonEX *pCButtonCancel = new wxButtonEX(this, wxID_CANCEL,
					       wxT("Cancel"));

    pBoxSizerBTM->Add(-1, -1, 1, wxEXPAND);
    pBoxSizerBTM->Add(pCButtonOK , 0, wxEXPAND);
    pBoxSizerBTM->Add(pCButtonCancel, 0, wxEXPAND);
    pBoxSizerSrc->Add(pBoxSizerBTM, 0, wxEXPAND);

    SetSizerAndFit(pBoxSizerSrc);
}

SceneGUI_cls::
~SceneGUI_cls(){
    MakeModal(FALSE);
}

void SceneGUI_cls::
SetMNumMain(wxBoxSizer *pBoxSizer){
    MultiInputPanel_cls* pCurr = 
	InitializeMNumPanel(&mpCMNumMain, this);
    pCurr->mbUndoCommand = FALSE;
    int boxWidth = 2;
    pCurr->mTextWidth = 80;
    pCurr->mItemWidth = -1;
    
    pCurr->CombinePointer(_ITEM_UINT_SPIN, &mpCParent->mTmpMaxFrame, _("Scene Length"));
    pCurr->SetRange(_ITEM_LASTITEM, 0, 65535);

    pCurr->CombinePointer(_ITEM_BOXSIZERHORIZONTAL, &boxWidth, _("Work Area"));
    pCurr->CombinePointer(_ITEM_UINT_SPIN, &mpCParent->mTmpWAMin);
    pCurr->SetRange(_ITEM_LASTITEM, 0, 65535);
    pCurr->CombinePointer(_ITEM_UINT_SPIN, &mpCParent->mTmpWAMax);
    pCurr->SetRange(_ITEM_LASTITEM,0, 65535);
    
    wxString strType[2] = {_("do remap"), _("do not remap")};
    pCurr->CombinePointerList(_ITEM_UINT_LIST, &mpCParent->mTmpType,
			      2, strType, _("key remap"));

    pCurr->FinishSetting(pBoxSizer, TRUE);
    //pCurr->SetScreenRectPos(&mCRectMNumScene);
}

void SceneGUI_cls::
OnButtonClose(wxCommandEvent &event){
    mpCMNumMain->UpdateValues();
    CloseEXKey();
}

void SceneGUI_cls::
OnButtonOK(wxCommandEvent& event){
    mpCMNumMain->UpdateValues();
    CloseEXKey(wxID_OK);
}

// --------------------

Scene_cls::
Scene_cls(wxWindow* pCWindow, TimeCtrl_cls *pCTimeCtrlLink,
	  wxBitmap* pBitmapLink){
    mTmpType = 0;
    mpCTimeCtrlLink = pCTimeCtrlLink;
    mpBitmapLink = pBitmapLink;
    mpCGUI = NULL;
    InitGUI(pCWindow);


}

void Scene_cls::
InitGUI(wxWindow* pCWindow){
    mpCGUI = new SceneGUI_cls(this, pCWindow, 
			      mCScreenRect.GetPosition(),
			      mCScreenRect.GetSize());
    SetPDialog(mpCGUI);
}

void Scene_cls::
UpdateItems(bool bForce){
    mpCGUI->mpCMNumMain->UpdateValues(_MN_ALLITEM);
}

void Scene_cls::
InitializeTmpValues(){
    mTmpMaxFrame = mpCTimeCtrlLink->mCMaxFrame.mBody;
    mTmpWAMin = mpCTimeCtrlLink->mCWAMin.mBody;
    mTmpWAMax = mpCTimeCtrlLink->mCWAMax.mBody;
    mTmpType = mpCTimeCtrlLink->mCSceneLengthType.mBody;
}

void Scene_cls::
AssignTmpValues(){
    unsigned int initMaxFrame = mpCTimeCtrlLink->mCMaxFrame.mBody;
    GCUndoList.OpenBlock();
    mpCTimeCtrlLink->SetWAMaxCommand(mTmpWAMin);
    mpCTimeCtrlLink->mCWAMax.mBody = mTmpWAMax;
    mpCTimeCtrlLink->SetMaxFrameCommand(mTmpMaxFrame);
    mpCTimeCtrlLink->mCSceneLengthType.mBody = mTmpType;
    if (mTmpType == 1 &&
	mTmpMaxFrame != initMaxFrame && mTmpMaxFrame != 0){
	mpCTimeCtrlLink->RemapParameterKeys
	    (((double)initMaxFrame) / (mTmpMaxFrame));
    }
    GCUndoList.CloseBlock();
}
