// "clsShortcut.h"

#include "clsShortcut.h"
#include "../MAINCANVAS/clsTopHalfPanel.h"
#include "../GLCANVAS/clsMainGLCanvas.h"
#include "../GLCANVAS/clsGLCanvasCtrl.h"
#include "../TIMELINE/clsTimeCtrl.h"
#include "../../clsMain.h"

Shortcut_cls::
Shortcut_cls(FrameMain_cls *pCParentFrame){
    mpCParentFrame = pCParentFrame;
}

void Shortcut_cls::
ProcShortcutKey(int modifier, int code){
    bool bRefreshGLPanel = FALSE;

    if (modifier == wxMOD_CONTROL)
	bRefreshGLPanel |= ProcCtrl(code);
    else if (modifier == wxMOD_ALT)
	bRefreshGLPanel |= ProcAlt(code);
    else 
	bRefreshGLPanel |= ProcNoModifier(code);

    if (bRefreshGLPanel == TRUE) 
	mpCParentFrame->mpCTopHalfPanel->RefreshGLPanels();
}

bool Shortcut_cls::
ProcNoModifier(int code){
    FrameMain_cls *pC = mpCParentFrame;
    switch(code){
    case '0':
    case WXK_NUMPAD0:
	pC->mpCActiveGLCanvasLink->SetDisplayMode(_GL_CANVAS_DISPLAY_FREE);
	pC->mpCActiveGLCanvasLink->mpCGLCtrl->UpdateWindow();
	pC->mpCActiveGLCanvasLink->Refresh(FALSE);
	break;
    case '1':
    case WXK_NUMPAD1:
	pC->mpCActiveGLCanvasLink->SetDisplayMode(_GL_CANVAS_DISPLAY_X_PLUS);
	pC->mpCActiveGLCanvasLink->mpCGLCtrl->UpdateWindow();
	pC->mpCActiveGLCanvasLink->Refresh(FALSE);
	break;
    case '3':
    case WXK_NUMPAD3:
	pC->mpCActiveGLCanvasLink->SetDisplayMode(_GL_CANVAS_DISPLAY_Y_PLUS);
	pC->mpCActiveGLCanvasLink->mpCGLCtrl->UpdateWindow();
	pC->mpCActiveGLCanvasLink->Refresh(FALSE);
	break;
    case '5':
    case WXK_NUMPAD5:
	pC->mpCActiveGLCanvasLink->TogglePerspective();
	break;
    case '7':
    case WXK_NUMPAD7:
	pC->mpCActiveGLCanvasLink->SetDisplayMode(_GL_CANVAS_DISPLAY_Z_MINUS);
	pC->mpCActiveGLCanvasLink->mpCGLCtrl->UpdateWindow();
	pC->mpCActiveGLCanvasLink->Refresh(FALSE);
	break;

    case 'B':
	pC->GetPCTimeCtrl()->SetWAMinCommand(pC->GetPCTimeCtrl()->mFrame, _TIME_CTRL_CURRENT);
	break;
    case 'N':
	pC->GetPCTimeCtrl()->SetWAMaxCommand(pC->GetPCTimeCtrl()->mFrame, _TIME_CTRL_CURRENT);
	break;
    case 'K':
	pC->GetPCTimeCtrl()->MoveFrameCommandSnip(+1); 
	break;
    case 'J':
	pC->GetPCTimeCtrl()->MoveFrameCommandSnip(-1); 
	break;
    case 'Z':
	pC->mpCParent->Undo();
	break;
    case 'Y':
	pC->mpCParent->Redo();
	break;
    case WXK_RIGHT:
	pC->mpCParent->mpCTime->MoveFrameCommand(+1); 
	break;
    case WXK_LEFT:
	pC->mpCParent->mpCTime->MoveFrameCommand(-1); 
	break;
    }
    
    return FALSE;
}

bool Shortcut_cls::
ProcAlt(int code){
    return FALSE;
}

bool Shortcut_cls::
ProcCtrl(int code){
    FrameMain_cls *pC = mpCParentFrame;

    switch(code){
    case '1':
    case WXK_NUMPAD1:
	pC->mpCActiveGLCanvasLink->SetDisplayMode(_GL_CANVAS_DISPLAY_X_MINUS);
	pC->mpCActiveGLCanvasLink->mpCGLCtrl->UpdateWindow();
	pC->mpCActiveGLCanvasLink->Refresh(FALSE);
	break;
    case '3':
    case WXK_NUMPAD3:
	pC->mpCActiveGLCanvasLink->SetDisplayMode(_GL_CANVAS_DISPLAY_Y_MINUS);
	pC->mpCActiveGLCanvasLink->mpCGLCtrl->UpdateWindow();
	pC->mpCActiveGLCanvasLink->Refresh(FALSE);
	break;
    case '7':
    case WXK_NUMPAD7:
	pC->mpCActiveGLCanvasLink->SetDisplayMode(_GL_CANVAS_DISPLAY_Z_PLUS);
	pC->mpCActiveGLCanvasLink->mpCGLCtrl->UpdateWindow();
	pC->mpCActiveGLCanvasLink->Refresh(FALSE);
	break;
    case 'Z':
	pC->mpCParent->Undo();
	break;
    case 'Y':
	pC->mpCParent->Redo();
	break;
    }

    return FALSE;
}
