// -*- c -*-
// "clsParamGroup.cpp"

#ifndef _PARAM_GROUP_H
#define _PARAM_GROUP_H

#include "../CONFITEM/clsConfItem.h"
#include "clsParameters.h"

#include <wx/wx.h>
#include <vector>
#include <fstream>

class ParametersPanel_cls;
class ParamGroup_cls;
class ParamGroupGUI_cls;
class ParamGUICtrl_cls;
class SceneObj_cls;
class TimeCtrl_cls;

#define _PARAM_ALL -1
#define _PARAM_MAGICNUM -9999

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class ParamGroup_cls{
 public:
    ParamGroup_cls(wxString strGroutpLabel, 
		   int dimension, wxString *pstrSubLabel,
		   int updateBit, bool bTimeDependent = FALSE);
    
    std::vector < Parameters_cls > mVCParam;
    std::vector < ParametersPanel_cls* > mVpCParamGUI;
    std::vector < ParamGroup_cls* > mVpCParamGroup;
    wxString mstrGroupLabel;
    ParamGroupGUI_cls *mpCGUI;
    SceneObj_cls *mpCSceneObjLink;
    int mControlMode;
    bool mbGroupingGroup; // O[v̏W
    bool mbShownOnTL;
    bool mbLinking;
    //bool mbVisible;

    double       *mpDValue2Cache;
    unsigned int mTypeCache, mTypeCacheOrg;
    int mIndexHermiteParam;

    void MakeParamGUI(ParamGUICtrl_cls *pCParent, wxBoxSizer *pCBoxSizer,
		      int depth = 0);
    void HideItems();
    void ShowItems();
    void RefreshPanels();
    bool SelectObject(SceneObj_cls* pCSceneObj);
    SceneObj_cls* GetPCObject(int objectIndex);
    bool SelectObject(int objectIndex, int guideIndex);
    void CheckSnippingTag(std::vector < bool > *pVbSnipTag);
    bool IsKeyFrameAll(double doubleFrame);
    void CreateKeyDLG(wxPoint posPanel, int xpos, int ypos, 
		      int frame, double doubleFrame);
    static void  ShowAndHideParameters(void* pArg, void *pEvent);

    std::vector < double > GetInterpolatedValue(double valueX, double resolution);
    void GetInterpolatedValue4Fast(float *pValue, 
				   double valueX, double resolution);
    void SetKeyFrame(double *pValue, bool bForce = FALSE,
		     double doubleIndex = _PARAM_CURRENT);
    void SetKeyFrameIfChanged(double doubleIndex = _PARAM_CURRENT);

    // ----

    void DeselectAll();
    void InsertKey(int index, double valueX, double valueY = _PARAM_MAGICNUM);
    void DeleteSelectedKey();
    bool DeleteKey(double doubleIndex);
    bool SelectKeyFrameRegion(double doubleIndexA, double doubleIndexB,
			      bool bSelected);
    void SelectKeyFrame(double doubleIndex,  double resolutionByPixel,
			bool   bMultiSelect, bool bDeselect);
    bool SelectKeyByXY(double valueX, double resolutionX,
		       double valueY, double resolutionY, 
		       bool bSingleSelect = TRUE);
    bool MoveSelectedKeyByXY(double dX, double dY, double resolution,
			     double minX = 0, double maxX = 0,
			     double minY = 0, double maxY = 0);
    void CopyFromP(ParamGroup_cls *pCParamGroup);

    void ProcStartDragging(double origin, bool bCtrl, bool bAlt);
    void ProcDragging(wxMouseEvent& event);
    void SetRegionOrigin(double origin);
    void TurnOffDragging();
    
    // ----
    
    ConfItemList_cls mCConfList;
    ConfItemINT_cls mCDimension;

    wxString Serialize();
    void ReadStrLine(std::wistream &istream, wxString strLineTag);
};

#endif
