// -*- c -*-
// "clsParametersPanel.h"
// (setq c-basic-offset 4)

#include "clsParametersPanel.h"
#include "clsParameters.h"
#include "clsParamTL.h"
#include "../WIDGETCTRL/clsBitmapPanel.h"
#include "../TIMELINE/clsTimeCtrl.h"
#include "../../wxWidgetEnum.h"
#include "../../wxWidgetEnumMenu.h"

#ifdef WIN32
#define _MEM_PANEL_OFFSET 14
#else
#define _MEM_PANEL_OFFSET 10
#endif

BEGIN_EVENT_TABLE(ParametersPanel_cls, wxPanel)
     EVT_PAINT       (ParametersPanel_cls::OnPaint)
     EVT_KEY_DOWN    (ParametersPanel_cls::OnKeyDown)
END_EVENT_TABLE()

ParametersPanel_cls::
     ParametersPanel_cls(Parameters_cls *pCParam, wxWindow *parent, 
			 bool bShow, wxPoint pos, wxSize size, wxWindowID id) :
    wxPanel(parent, id, pos, size),
    mpCParam(pCParam)
{
    mOffset = _MEM_PANEL_OFFSET;
    if (msbInitialized == FALSE){
	LoadBitmap();
	msbInitialized = TRUE;
    }
    
    // TCU[
    wxBoxSizer  *pBoxSizerSrc = new wxBoxSizer(wxHORIZONTAL);

    mpCBPanelTime = new BitmapPanel_cls(this, wxID_ANY, wxDefaultPosition, wxSize(14,16));
    mpCBPanelTime->AddBitmapP(&msCBitmapConstant);
    mpCBPanelTime->AddBitmapP(&msCBitmapTimeDependent);
    mpCBPanelTime->SetBitmapPDisable(&msCBitmapTimeDisable);
    Connect(mpCBPanelTime->GetId(), wxEVT_LEFT_UP,
	    wxMouseEventHandler(ParametersPanel_cls::OnMouseL));
    Connect(mpCBPanelTime->GetId(), wxEVT_RIGHT_UP,
	    wxMouseEventHandler(ParametersPanel_cls::OnMouseR));
    
    mpButtonLFT   = new wxButton  (this, wxID_ANY, wxT("<"),
				   wxDefaultPosition, wxSize(16,16));
    mpButtonLFT->Connect(wxEVT_KEY_DOWN,
			 wxKeyEventHandler(ParametersPanel_cls::OnKeyDown));
    mpCheckBoxKey = new wxCheckBox(this, wxID_ANY, wxT(""),
				   wxDefaultPosition, wxSize(13,14));
    mpCheckBoxKey->Connect(wxEVT_KEY_DOWN,
			   wxKeyEventHandler(ParametersPanel_cls::OnKeyDown));

    mpButtonRGT   = new wxButton  (this, wxID_ANY, wxT(">"),
				   wxDefaultPosition, wxSize(16,16));
    mpButtonRGT->Connect(wxEVT_KEY_DOWN,
			 wxKeyEventHandler(ParametersPanel_cls::OnKeyDown));

    Connect(mpButtonLFT->GetId(), wxEVT_COMMAND_BUTTON_CLICKED,
	    wxCommandEventHandler(ParametersPanel_cls::OnButtonKeyLFT));
    Connect(mpCheckBoxKey->GetId(), wxEVT_COMMAND_CHECKBOX_CLICKED,
	    wxCommandEventHandler(ParametersPanel_cls::OnCheckBoxKey));
    Connect(mpButtonRGT->GetId(), wxEVT_COMMAND_BUTTON_CLICKED,
	    wxCommandEventHandler(ParametersPanel_cls::OnButtonKeyRGT));

    /*
    mpCBPanelVisible = new BitmapPanel_cls(this, wxID_ANY, wxDefaultPosition, wxSize(14,16));
    mpCBPanelVisible->AddBitmapP(&msCBitmapInvisible);
    mpCBPanelVisible->AddBitmapP(&msCBitmapVisible);
    Connect(mpCBPanelVisible->GetId(), wxEVT_LEFT_UP,
	    wxMouseEventHandler(ParametersPanel_cls::OnMouseL));
    */
		  
    mpCParamTL = new ParamTL_cls(mpCParam, this, //pCTimeCtrl, 
				 wxDefaultPosition, wxSize(-1, 16));
    
    Connect(mpCParamTL->GetId(), wxEVT_LEFT_DOWN,
	    wxMouseEventHandler(ParametersPanel_cls::OnMouseL));
    Connect(mpCParamTL->GetId(), wxEVT_RIGHT_DOWN,
	    wxMouseEventHandler(ParametersPanel_cls::OnMouseR));

    //pBoxSizerSrc->Add(mpButtonHide, 0, 0);
    pBoxSizerSrc->Add(12, -1, 0, wxEXPAND);
    pBoxSizerSrc->Add(mpCBPanelTime, 0, 0);
    pBoxSizerSrc->Add(mpButtonLFT  , 0, 0);
    pBoxSizerSrc->Add(mpCheckBoxKey, 0, wxALIGN_CENTER_VERTICAL);
    pBoxSizerSrc->Add(mpButtonRGT  , 0, 0);
    pBoxSizerSrc->Add(2, -1, 0, wxEXPAND);
    //pBoxSizerSrc->Add(mpCBPanelVisible, 0, 0);
    pBoxSizerSrc->Add(mpCParamTL  , 1, wxEXPAND);
    
    SetSizer(pBoxSizerSrc);
    
    UpdatePanelBitmapState();
    Show(bShow);
}

void ParametersPanel_cls::
LoadBitmap(){
    msCBitmapTimeDependent = wxBitmap(wxT("ICONS/timeP.png"),wxBITMAP_TYPE_PNG);
    msCBitmapConstant      = wxBitmap(wxT("ICONS/timeN.png"),wxBITMAP_TYPE_PNG);
    msCBitmapTimeDisable   = wxBitmap(wxT("ICONS/timeD.png"),wxBITMAP_TYPE_PNG);
    msCBitmapVisible   = wxBitmap(wxT("ICONS/eyeP.png"),wxBITMAP_TYPE_PNG);
    msCBitmapInvisible = wxBitmap(wxT("ICONS/eyeN.png"),wxBITMAP_TYPE_PNG);
}

void ParametersPanel_cls::
LinkParameter(Parameters_cls *pCParam){
    mpCParam = pCParam;
    mpCParamTL->LinkParameter(pCParam);
    UpdatePanelBitmapState();
    Refresh(TRUE);
}

void ParametersPanel_cls::
UpdatePanelBitmapState(){
    if (mpCParam != NULL) {
	mpCBPanelTime->mState = 
	    (unsigned int)mpCParam->mCbTimeDependent.mbBody;
	/*
	mpCBPanelVisible->mState = 
	    (unsigned int)mpCParam->mCbVisible.mbBody;
	*/
    }
    else {
	mpCBPanelTime->mState = 0;
	//mpCBPanelVisible->mState = 0;
    }
}

void ParametersPanel_cls::
SetDoubleIndex(){
    ParamTL_cls::SetDoubleIndex();
    msMaxFrame = ParamTL_cls::msMaxFrame;
    msAAMin = ParamTL_cls::msAAMin;
    msAAMax = ParamTL_cls::msAAMax;
    msCurrentDoubleIndex = ParamTL_cls::msCurrentDoubleIndex;
    msDoubleIndexAAMin = ParamTL_cls::msDoubleIndexAAMin;
    msDoubleIndexAAMax = ParamTL_cls::msDoubleIndexAAMax;
    msDoubleIndexWAMin = ParamTL_cls::msDoubleIndexWAMin;
    msDoubleIndexWAMax = ParamTL_cls::msDoubleIndexWAMax;
}

void ParametersPanel_cls::
OnButtonKeyLFT(wxCommandEvent& event){
    if (mpCParam == NULL) return;
    ParamTL_cls::mspCTimeCtrlLink->SetFrameFromDoubleCommand
	(mpCParam->GetPrevKeyPosDoubleIndex(msCurrentDoubleIndex));
    event.Skip();
}

void ParametersPanel_cls::
OnButtonKeyRGT(wxCommandEvent& event){
    if (mpCParam == NULL) return;
    ParamTL_cls::mspCTimeCtrlLink->SetFrameFromDoubleCommand
	(mpCParam->GetNextKeyPosDoubleIndex(msCurrentDoubleIndex));
    event.Skip();
}

void ParametersPanel_cls::
OnCheckBoxKey(wxCommandEvent& event){
    
    if (mpCParam == NULL) return;

    if (mpCheckBoxKey->GetValue() == FALSE)
	mpCParam->DeleteKeyQueue(msCurrentDoubleIndex);
    else
	mpCParam->InsertKeyQueue(-1);
    
    wxMouseEvent com(wxEVT_LEFT_DOWN);
    com.SetId(mpCParamTL->GetId());
    com.m_shiftDown = TRUE;
    GetParent()->ProcessEvent(com);
    
    mpCParamTL->Refresh(TRUE);
    event.Skip();
}

void ParametersPanel_cls::
EmuCheckBox(){
    if (mpCParam == NULL) return;
    mpCheckBoxKey->SetValue(!mpCheckBoxKey->GetValue());
    wxCommandEvent 
	event(wxEVT_COMMAND_CHECKBOX_CLICKED, mpCheckBoxKey->GetId());
#ifdef WIN32
    AddPendingEvent(event);
#else
    OnCheckBoxKey(event);
#endif
}

void ParametersPanel_cls::
UpdateDisplay(){
    if (mpCParamTL != NULL){
	mpCParamTL->Refresh(FALSE);
    }
    if (mpCBPanelTime != NULL)
	mpCBPanelTime->Refresh(FALSE);
    /*
    if (mpCBPanelVisible != NULL)
	mpCBPanelVisible->Refresh(FALSE);
    */
    if (mpCParam == NULL) {
	mpCheckBoxKey->Disable();
	mpButtonLFT->Disable();
	mpButtonRGT->Disable();
	mpCBPanelTime->Disable();
	//mpCBPanelVisible->Disable();
	return;
    } 
    else{
	if (mpCParam->mCbTimeDependent.mbBody == TRUE){
	    mpCheckBoxKey->Enable();
	    mpButtonLFT->Enable();
	    mpButtonRGT->Enable();
	    mpCBPanelTime->Enable();
	    //mpCBPanelVisible->Enable();
	}
	else{
	    mpCheckBoxKey->Disable();
	    mpButtonLFT->Disable();
	    mpButtonRGT->Disable();
	    mpCBPanelTime->Enable();
	    //mpCBPanelVisible->Enable();
	}
    }
    mpCheckBoxKey->SetValue(IsKeyFrame(msCurrentDoubleIndex));
}

bool ParametersPanel_cls::
IsKeyFrame(double doubleIndex){
    return mpCParam->IsKeyFrame(doubleIndex);
}

void ParametersPanel_cls::
SetMemberSize(wxSize size){
    mWidth = size.GetWidth();
    mHeight = size.GetHeight();
}

int ParametersPanel_cls::
GetDeviceX(float x){
    return (int)(x * (mWidth - 2 * mOffset) + mOffset);
}

void ParametersPanel_cls::
OnPaint(wxPaintEvent& event){
    // must always be here
    wxPaintDC dc(this);
    SetMemberSize(dc.GetSize());
    UpdateDisplay();
    event.Skip();
}

void ParametersPanel_cls::
OnKeyDown(wxKeyEvent& event){
    int code = event.GetKeyCode();
    GetParent()->AddPendingEvent(event);
}

void ParametersPanel_cls::
OnMouseL(wxMouseEvent& event){
    /*
    if (event.GetId() == mpCBPanelTime->GetId()){
	if (mpCParamTL->mbSelected == FALSE){
	    if (mpCParam == NULL) return;
	    mpCParam->SetTimeDependent(mpCBPanelTime->mState == 1);
	}
	else
	    mspCDF3SeqGUILink->SetTimeDependent(mpCBPanelTime->mState == 1);
	wxCommandEvent dummy(wxEVT_COMMAND_MENU_SELECTED, menuItemRefresh);
	GetGrandParent()->AddPendingEvent(dummy);
    }
    */

    /*
    if (event.GetId() == mpCBPanelVisible->GetId()){
	if (mpCParamTL->mbSelected == FALSE){
	    if (mpCParam == NULL) return;
	    mpCParam->mCbVisible.mbBody = (mpCBPanelVisible->mState == 1);
	}
	else
	    mspCDF3SeqGUILink->SetVisibility(mpCBPanelVisible->mState == 1);
	wxCommandEvent dummy(wxEVT_COMMAND_MENU_SELECTED, menuItemRefresh);
	GetGrandParent()->AddPendingEvent(dummy);
    }
    */

    //GetParent()->AddPendingEvent(event);
    event.Skip();
}

void ParametersPanel_cls::
OnMouseR(wxMouseEvent& event){
    GetParent()->AddPendingEvent(event);
    event.Skip();
}

double ParametersPanel_cls::msCurrentDoubleIndex;
double ParametersPanel_cls::msDoubleIndexAAMin;
double ParametersPanel_cls::msDoubleIndexAAMax;
double ParametersPanel_cls::msDoubleIndexWAMin;
double ParametersPanel_cls::msDoubleIndexWAMax;
int    ParametersPanel_cls::msMaxFrame;
int    ParametersPanel_cls::msAAMin;
int    ParametersPanel_cls::msAAMax;

wxBitmap ParametersPanel_cls::msCBitmapTimeDependent;
wxBitmap ParametersPanel_cls::msCBitmapConstant;
wxBitmap ParametersPanel_cls::msCBitmapTimeDisable;
wxBitmap ParametersPanel_cls::msCBitmapVisible;
wxBitmap ParametersPanel_cls::msCBitmapInvisible;
bool     ParametersPanel_cls::msbInitialized = FALSE;
