// -*- c -*- 
// "clsParticleDataBlock.cpp"

#ifndef _PARTICLE_DATA_BLOCK_H_
#define _PARTICLE_DATA_BLOCK_H_

#define _PNUM_UNDEFINED -1

#include <wx/wx.h>

class PDataSnap_cls;
class DataLoader_cls;

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class PDataBlock_cls{
 public:
    PDataBlock_cls(PDataSnap_cls *pCParentSnap);
    ~PDataBlock_cls();

    PDataSnap_cls* mpCParentSnap;
    static DataLoader_cls *mspCDataLoaderLink;

    float (*mpX)[3];
    float (*mpV)[3];
    float (*mpA)[3];
    float (*mpJ)[3];
    float *mpRadius;
    float *mpDRadius;
    float *mpValue1;
    float *mpDValue1;
    unsigned char *mpType; 
    int   *mpID;
    
    void Allocate(int pNum);
    void ReleaseData();
    int  GetUsedMemoryKB();
    
    int  mPNumBlock;
    bool mbAllocated;
    int  mInterpolateType;
    int  mVariablePNum;
    bool mbUseID;

    void LoadData(wxString strFilename);
    void LoadHeaderBinary(wxString strFilename);
    void LoadHeaderAscii(wxString strFilename);
    void StartLoadingData(wxString strFilename);

    void InterpolateData(PDataBlock_cls *pCNext);
    //void InterpolateDataLinear(PDataBlock_cls *pCNext);

};

#endif
