
#include "clsParticleDataSeqCtrl.h"
#include "clsParticleDataSequence.h"

PDataSeqCtrl_cls::
PDataSeqCtrl_cls(DrawOption_cls *pCDrawOptionLink){
    mActiveChannel = 0;
    mTotalUsedMemoryMB = 0;
#ifdef AMD64
    mMemoryLimitationMB = 4096; // FIX_ME!! Ƃ̌ˍ
#else
    mMemoryLimitationMB = 768;
#endif
    for (int i = 0; i < _MAX_PDATA_CHANNEL; i++)
	mpCPDataSequence[i] = new PDataSequence_cls(i, pCDrawOptionLink);
}

PDataSeqCtrl_cls::
~PDataSeqCtrl_cls(){
    for (int i = 0; i < _MAX_PDATA_CHANNEL; i++)
	delete mpCPDataSequence[i];
}

PDataSequence_cls* PDataSeqCtrl_cls::
GetPCActiveFileSequence(){
    return mpCPDataSequence[mActiveChannel];
}

/*
void PDataSeqCtrl_cls::
ClearSequence(int channel, bool bClearFileInfo){
    if (channel == _ALL_SEQUENCE){
	for (int i = 0; i < _MAX_PDATA_CHANNEL; i++)
	    mpCPDataSequence[i]->Clear(_SEQUENCE_ALL_INDEX, bClearFileInfo);
	return;
    }
    if (channel == _ACTIVE_SEQUENCE){
	mpCPDataSequence[mActiveChannel]->Clear(_SEQUENCE_ALL_INDEX, bClearFileInfo);
	return;
    }
    mpCPDataSequence[channel]->Clear(_SEQUENCE_ALL_INDEX, bClearFileInfo);
}
*/

void PDataSeqCtrl_cls::
ClearData(int channel, int index, bool bClearFileInfo){
    if (channel == _ALL_SEQUENCE){
	for (int i = 0; i < _MAX_PDATA_CHANNEL; i++)
	    mpCPDataSequence[i]->Clear(index, bClearFileInfo);
	return;
    }
    if (channel == _ACTIVE_SEQUENCE){
	mpCPDataSequence[mActiveChannel]->Clear(index, bClearFileInfo);
	return;
    }
    mpCPDataSequence[channel]->Clear(_SEQUENCE_ALL_INDEX, bClearFileInfo);
}

void PDataSeqCtrl_cls::
OpenDataFile(wxString strFilePathInit){
    mpCPDataSequence[mActiveChannel]->OpenDataFile(strFilePathInit);
}

wxString PDataSeqCtrl_cls::
GetStrActiveFileSequencePath(){
    return GetPCActiveFileSequence()->mCFileSequence.mstrPath;
}

int PDataSeqCtrl_cls::
GetActiveFileSequenceLength(){
    return GetPCActiveFileSequence()->mCFileSequence.mSeqLength;
}

void PDataSeqCtrl_cls::
CleanUpMemory(int currentIndex, int animStep){
    mTotalUsedMemoryMB = CalcAndGetUsedTotalMemoryMB();

    GetPCActiveFileSequence()->ReleaseMemoryOutofStep(animStep);
    while (mTotalUsedMemoryMB > mMemoryLimitationMB){
	if (GetPCActiveFileSequence()->
	    ReleaseMemoryAStep(currentIndex, animStep) == FALSE)
	    break;
	mTotalUsedMemoryMB = CalcAndGetUsedTotalMemoryMB();
    }
}

void PDataSeqCtrl_cls::
PrepareIndex(int index, double indexmod, bool bWaitFinish){
    //
    GetPCActiveFileSequence()->PrepareIndex(index, indexmod, bWaitFinish);
}

bool PDataSeqCtrl_cls::
IsPreparing(int index, double indexmod){
    //
    return GetPCActiveFileSequence()->IsPreparing(index, indexmod);
}

int  PDataSeqCtrl_cls::
CalcAndGetUsedTotalMemoryMB(){
    // FIX_ME!! FileSequenceƂ͈Ⴄ
    return GetPCActiveFileSequence()->GetUsedTotalMemoryMB();
}

int  PDataSeqCtrl_cls::
GetLoadedFrameNumber(){
    // FIX_ME!! FileSequenceƂ͈Ⴄ
    return GetPCActiveFileSequence()->GetLoadedFrameNumber();
}

bool PDataSeqCtrl_cls::
IsTheIndexReady(int index, double indexmod){
    return GetPCActiveFileSequence()->IsTheIndexReady(index, indexmod);
}

bool PDataSeqCtrl_cls::
IsTheIndexLoaded(int index){
    return GetPCActiveFileSequence()->IsTheIndexLoaded(index);
}

void PDataSeqCtrl_cls::
ClearSnipping(){
    for (int i = 0; i < _MAX_PDATA_CHANNEL; i++)
	mpCPDataSequence[i]->ClearSnipping();
}

void PDataSeqCtrl_cls::
SetSnipping(int index){
    for (int i = 0; i < _MAX_PDATA_CHANNEL; i++)
	mpCPDataSequence[i]->SetSnipping(index);
}

// ----

wxString PDataSeqCtrl_cls::
Serialize(){
    wxString strOut;
    for (int i = 0; i < _MAX_PDATA_CHANNEL; i++){
	strOut << mpCPDataSequence[i]->Serialize();
    }
    return strOut;
}

void PDataSeqCtrl_cls::
ReadStrLine(std::wistream &istream, wxString strLine){
    for (int i = 0; i < _MAX_PDATA_CHANNEL; i++){
	mpCPDataSequence[i]->ReadStrLine(istream, strLine);
    }
}
