// -*- c -*- 
// "clsParticleDataSeqCtrl.cpp"

#ifndef _PARTICLE_DATA_SEQ_CTRL_H_
#define _PARTICLE_DATA_SEQ_CTRL_H_

#define _MAX_PDATA_CHANNEL 4
#define _ALL_SEQUENCE    -2
#define _ACTIVE_SEQUENCE -1

#include <wx/wx.h>

#include <fstream>

class PDataSequence_cls;
class DrawOption_cls;

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class PDataSeqCtrl_cls{
 public:
    PDataSeqCtrl_cls(DrawOption_cls *pCDrawOptionLink);
    ~PDataSeqCtrl_cls();

    PDataSequence_cls *mpCPDataSequence[_MAX_PDATA_CHANNEL];

    PDataSequence_cls *GetPCActiveFileSequence();

    int mActiveChannel;
    int mTotalUsedMemoryMB;
    int mMemoryLimitationMB;

    //void ClearSequence(int channel, bool bClearFileInfo);
    void ClearData(int channel, int index, bool bClearFileInfo);
    void OpenDataFile(wxString strFilePathInit);
    wxString GetStrActiveFileSequencePath();
    int  GetActiveFileSequenceLength();

    void CleanUpMemory(int frame, int animStep);
    void PrepareIndex(int index, double indexmod, bool bWaitFinish);
    bool IsPreparing(int index, double indexmod);
    int  CalcAndGetUsedTotalMemoryMB();
    int  GetLoadedFrameNumber();
    bool IsTheIndexReady(int index, double indexmod);
    bool IsTheIndexLoaded(int index);
    
    void ClearSnipping();
    void SetSnipping(int index);

    wxString Serialize();
    void ReadStrLine(std::wistream &istream, wxString strLine);
};

#endif
