// -*- c -*- 
// "clsParticleDataSequence.cpp"

#ifndef _PARTICLE_DATA_SEQUENCE_H_
#define _PARTICLE_DATA_SEQUENCE_H_

#define _MAX_PDATA_INDEX 8000
#define _MAX_PARTICLE_TYPE 4
#define _SEQUENCE_CURRENT_INDEX -1
#define _SEQUENCE_ALL_INDEX     -2

#include "clsGLDrawData.h"
#include "../GLATTRIB/clsGLAttribute.h"
#include "../MYGL/clsPositionAndDirection.h"

#include "../COMMON/clsFilename.h"

#include <fstream>

#include <wx/wx.h>

class DataExporter_cls;
class DrawOption_cls;
class PDataSnap_cls;

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class PDataSequence_cls{
 public:
    PDataSequence_cls(int index, DrawOption_cls *pCDrawOptionLink);
    ~PDataSequence_cls();

    void InstantiateGLAttribGUI(wxWindow *pCParent);
    void RefreshGLAttribTex();

    PDataSnap_cls *mpCPDataSnap[_MAX_PDATA_INDEX];
    int mSelfIndex;
    GLDrawData_cls   *mpCGLDrawData;
    GLAttribute_cls  *mpCGLAttribute[_MAX_PARTICLE_TYPE];
    FileSequence_cls mCFileSequence;

    ConfItemSTR_cls mCConfSelfIndex;

    void Clear(int index, bool bClearFileInfo);
    void ReleaseMemoryOutofStep(int animStep);
    int  SearchLowNeedStepLarge(int currentIndex, bool bSnipped);
    int  SearchLowNeedStepSmall(int currentIndex, bool bSnipped);
    bool ReleaseMemoryAStep(int currentIndex, int animStep);

    void SetIndividualFilenames();
    void OpenDataFile(wxString strFilePathInit);

    int  ClampIndexWithinRange(int index);
    wxString GetFilename(int index);
    int      GetFilenameStatus(int index);
    int      GetParticleNumber(int index);
    double   GetTime(int index);
    double   GetDT(int index, double interpStepDouble);

    void ClearSnipping();
    void SetSnipping(int index);

    void PrepareIndex(int index, double indexmod, bool bWaitFinish);
    int  GetUsedTotalMemoryMB();
    int  GetLoadedFrameNumber();
    bool IsPreparing(int index, double indexmod);
    bool IsTheIndexReady(int index, double indexmod);
    bool IsTheIndexLoaded(int index);

    // ----
    void SetCameraInfo(PositionAndDirection_cls CCameraPos);
    void GLDrawData(int fboIndex, int index, double dT, 
		    int lightNumber, float *pLightPos, 
		    double lightPhi, double lightTheta,
		    bool bShadowVolume = FALSE, bool bShadowMode = FALSE);
    void ExportData(DataExporter_cls *pCDataExporter, int index);

    wxString SerializeFile();
    wxString Serialize();
    void ReadStrLine(std::wistream &istream, wxString strLine);
    
};

#endif
