// -*- c -*- 
// "clsShadowVolume.cpp"

#ifndef _GL_SHADOW_VOLUME_H_
#define _GL_SHADOW_VOLUME_H_

#include "clsGLDrawData.h"

#include "../CONFITEM/clsConfItem.h"
#include "../MYGL/clsPositionAndDirection.h"

class ShadowVolume_cls{
 public:
    ShadowVolume_cls(ArrayAndIndex_cls **sppIndexAndZ,
		     PositionAndDirection_cls *pCParticlePos);

    static ArrayAndIndex_cls **msppIndexAndZLink;

    static ConfItemList_cls msCConfListStatic;
    static ConfItemUINT_cls msCShadowQuality;
    static ConfItemFLOAT_cls msCShadowLength;

    static void InitializeStaticMembers();
    
    int mCylinderDList[2];
    bool *mpbInShadowList;
    
    PositionAndDirection_cls *mpCParticlePosLink;

    void UpdateDisplayList(double phi, double theta);
    void CheckShadow
	(int downsized, float (*pPos)[3], float *pRadius,
	 float radiusFactor, 
	 float cameraPos[3], float lightDir[3],
	 double lightPhi, double lightTheta);
    void CheckShadowSequential
	(int downsized, int drawTypeList[4],
	 int radiusTypeList[4], float radiusFactorList[4],
	 unsigned char *pType, float (*pPos)[3], float *pRadius,
	 float cameraPos[3], float lightDir[3],
	 double lightPhi, double lightTheta);
    
    void GLDrawCylinderConstantRadius
	(int downsized, float (*pPos)[3], float *pRadius,
	 float radiusFactor, float quality);
    void GLDrawCylinderVariableRadius
	(int downsized, float (*pPos)[3], float *pRadius,
	 float radiusFactor, float quality);
    //void DrawCylinderConstantRadius();
    void DrawCylinder(float pos[3], float scale, int i, int i_);
};

#endif
