
#ifndef _THREAD_FILE_READER_H_
#define _THREAD_FILE_READER_H_

#include <string>
#include <vector>

#include <wx/wx.h>
#include <wx/thread.h>

#include <fstream>
#include <sstream>

class DataLoader_cls;

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class ThreadFileReader_cls : public wxThread {
 public:
    ThreadFileReader_cls(wxThreadKind kind);

    void SetParameters(bool *pbFinishedFlag, 
		       DataLoader_cls *pCDataLoder,
		       wxString strFilePath, int pNum,
		       float (*pX)[3], float (*pV)[3],
		       float (*pA)[3], float (*pJ)[3], 
		       float *pRadius, unsigned char  *pType, int *pId,
		       float *pValue1,
		       bool bUseID);
    
    bool *mpbFinishedFlagLink;
    wxString mstrFilePath;
    
    float (*mpX)[3];
    float (*mpV)[3];
    float (*mpA)[3];
    float (*mpJ)[3];
    float *mpRadius;
    unsigned char *mpType;
    int   *mpID;
    float *mpValue1;

    bool  mbUseID;
    bool  mbUseDefaultFormat;

    int   mPNum;
    DataLoader_cls *mpCDataLoaderLink;
    int   mDataType;
    std::vector < int > mVGrammerBody;
    bool  mbTranslate, mbScaling;
    float mTranslate[3];
    float mScaling;
    int   mHeaderByte;
    int   mHeaderLine;
    
    void  DoAdjusting();
    void  ReadBinaryBodyDefaultFormat
	(std::fstream& ifstream, int progressInterval);
    void  ReadBinaryBody();
    void  ReadAsciiBody();
    virtual ExitCode Entry();
};

#endif
