
#ifndef _THREAD_FILE_READER_ASCII_H_
#define _THREAD_FILE_READER_ASCII_H_

#include <string>
#include <vector>

#include <wx/wx.h>
#include <wx/thread.h>

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class ThreadAsciiReader_cls : public wxThread {
 public:
    ThreadAsciiReader_cls(wxThreadKind kind);

    void SetParameters(bool *pbFinishedFlag,
		       std::string *pstrBuf, int pNum, int headerLine,
		       int threadnum, int modnumber,
		       std::vector < int > VGrammerBody, bool bUseDefaultFormat,
		       float (*pX)[3], float (*pV)[3],
		       float (*pA)[3], float (*pJ)[3], 
		       float *pRadius, unsigned char  *pType, int *pId,
		       float *pValue1);

    bool *mpbFinishedFlagLink;
    std::string *mpStrBuf;

    float (*mpX)[3];
    float (*mpV)[3];
    float (*mpA)[3];
    float (*mpJ)[3];
    float *mpRadius;
    unsigned char *mpType;
    int   mTypeCache;
    int   *mpID;
    float *mpValue1;
    bool  mbUseDefaultFormat;

    int   mPNum;
    int   mHeaderLine;
    int   mThreadNum;
    int   mModNumber;
    std::vector < int > mVGrammerBody;
    
    void ReadDeafultFormat(std::istringstream &ssteream, int progressInterval);
    void Read3Format(std::istringstream &ssteream, int progressInterval,
		     std::string strFormat, std::vector < char* > VPointer,
		     std::vector < int > VInc);
    void Read6Format(std::istringstream &ssteream, int progressInterval,
		     std::string strFormat, std::vector < char* > VPointer,
		     std::vector < int > VInc);
    void Read12Format(std::istringstream &ssteream, int progressInterval,
		      std::string strFormat, std::vector < char* > VPointer,
		      std::vector < int > VInc);
    void Read18Format(std::istringstream &ssteream, int progressInterval,
		      std::string strFormat, std::vector < char* > VPointer,
		      std::vector < int > VInc);
    void FillByDummy(std::string &strFormat, std::vector < char* > &VPointer,
		     std::vector < int > &VInc, int itemNum, char *pDummy);
    virtual ExitCode Entry();
};

#endif
