
#ifndef _THREAD_INTERPOLATER_H_
#define _THREAD_INTERPOLATER_H_

#define _INTERPOLATE_LINEAR  0
#define _INTERPOLATE_HERMITE 1
#define _INTERPOLATE_NO      2

#define _INTERPOLATE_PNUM_CONSTANT 0
#define _INTERPOLATE_PNUM_VARIABLE 1

#include <wx/wx.h>
#include <wx/thread.h>

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class ThreadInterpolator_cls : public wxThread {
 public:		 
    ThreadInterpolator_cls(wxThreadKind kind);

    void SetParameters(bool *pbFinishedFlag,
		       int PNum, int PNumNext, float dtime,
		       int interpolateType, int variablePNum,
		       int threadnum, int modnumber,
		       float (*pX)[3], float (*pV)[3],
		       float (*pA)[3], float (*pJ)[3], 
		       float *pRadius, float *pDRadius,
		       float *pValue1, float *pDValue1,
		       unsigned char  *pType, int *pID,
		       float (*pXNext)[3], float (*pVNext)[3],
		       float (*pANext)[3], float (*pJNext)[3], 
		       float *pRadiusNext, 
		       float *pValue1Next,
		       unsigned char  *pTypeNext, int *pIDNext);

    bool *mpbFinishedFlagLink;
    int   mInterpolateType;
    int   mValiablePNum;
    
    float (*mpX)[3];
    float (*mpV)[3];
    float (*mpA)[3];
    float (*mpJ)[3];
    unsigned char *mpType;
    float *mpRadius, *mpDRadius;
    float *mpValue1, *mpDValue1;
    int   *mpID;

    float (*mpXNext)[3];
    float (*mpVNext)[3];
    float (*mpANext)[3];
    float (*mpJNext)[3];
    unsigned char *mpTypeNext;
    float *mpRadiusNext;
    float *mpValue1Next;
    int   *mpIDNext;

    int    mPNum, mPNumNext;
    float  mDTime;
    int   mThreadNum, mModNumber;
    
    int SearchIDNear(int index, int ID, int range);
    int SearchIDFull(int ID);

    void InterpolateDataLinear();
    void InterpolateDataLinearSearchingID();
    
    
    virtual ExitCode Entry();
};

#endif
