// -*- c -*-
// "clsCameraPath.h"

#include "clsCameraPath.h"

#include "../GLOBJECTS/clsCamera.h"
#include "../UNDO/clsUndoManager.h"

#ifdef WIN32
#define ENDLWX wxT("\r\n")
#else
#define ENDLWX wxT("\n")
#endif

#define LOOP_XYZ for (int xyz = 0; xyz < 3; xyz++)
#define X 0
#define Y 1
#define Z 2

CameraPath_cls::
CameraPath_cls() : SceneObj_cls(wxT("Camera")) {

    mObjType  = _SCENEOBJ_CAMERA;
    mObjIndex = _SCENEOBJ_IDBASE_CAMERA;

    SetInitValueTrans(-1.5, 0, 1.5);
    SetInitValueRot  (0, 45, 0);
    
    mCConfList.Clear();
    mCConfList.Add(&mCCamGeometry, wxT("CameraGeometry="), wxT("0"));
    mCConfList.Add(&mCVAngle, wxT("CameraVAngle="), wxT("35"));
    mCConfList.Add(&mCbLookAnchor, wxT("CareraLookAnchor="), wxT("0"));
    mCConfList.Add(&mCbVisible, wxT("CameraVisible="), wxT("1"));
}

// ----

wxString CameraPath_cls::
Serialize(){
    wxString strOut;
    strOut << wxT("---CameraPath") << ENDLWX;
    strOut << mCConfList.SerializeAll();
    strOut << mpCTranslate->Serialize();
    strOut << mpCRotation->Serialize();
    return strOut;
}

void CameraPath_cls::
ReadStrLine(std::wistream &istream, wxString strLineTag){
    if (strLineTag == wxT("---CameraPath")){
	std::wstring wstrLine;
	wxString strLine;
	while ( std::getline (istream, wstrLine)){
	    strLine = wstrLine.c_str();
	    if (strLine.Find(wxT("ParamGroup=")) != wxNOT_FOUND) break;
	    mCConfList.ReadStrLineAll(strLine);
	}
	mpCTranslate->ReadStrLine(istream, strLine);
	std::getline (istream, wstrLine);
	strLine = wstrLine.c_str();
	mpCRotation->ReadStrLine(istream, strLine);
    }
}

// ----

AnchorPath_cls::
AnchorPath_cls() : SceneObj_cls(wxT("Anchor")) {
    SetInitValueTrans(0, 0, 0);
    SetInitValueRot  (0, 0, 0);
    mObjIndex = _SCENEOBJ_IDBASE_CAMERA + 1;
}

wxString AnchorPath_cls::
Serialize(){
    wxString strOut;
    strOut << wxT("---AnchorPath") << ENDLWX; 
    //strOut << mCConfList.SerializeAll();
    //strOut << wxT("--ParamGroup") << ENDLWX;
    strOut << mpCTranslate->Serialize();
    return strOut;
}

void AnchorPath_cls::
ReadStrLine(std::wistream &istream, wxString strLineTag){
    if (strLineTag == wxT("---AnchorPath")){
	std::wstring wstrLine;
	wxString strLine;
	while ( std::getline (istream, wstrLine)){
	    strLine = wstrLine.c_str();
	    if (strLine.Find(wxT("ParamGroup=")) != wxNOT_FOUND) break;
	    //mCConfList.ReadStrLineAll(strLine);
	}
	mpCTranslate->ReadStrLine(istream, strLine);
    }
}
