// "clsCameraPathGUI.cpp"

#ifndef _CAMERA_PATH_GUI_H
#define _CAMERA_PATH_GUI_H

#include "../WIDGETCTRL/clsDialogEXKey.h"
#include "../WIDGETCTRL/clsDialogController.h"
#include "../WIDGETCTRL/clsMinimizeButton.h"

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

#include <wx/notebook.h>

class AnchorPath_cls;
class CameraPath_cls;
class CameraPathCtrl_cls;
class FrameMain_cls;
class MainGLCanvas_cls;
class StereoGram_cls;

class CameraPathGUI_cls : public wxDialogEXKey, public MinimizeButton_cls {
 public:
    CameraPathGUI_cls(CameraPathCtrl_cls* pCCtrl, 
		      wxWindow *pC, wxPoint pos, wxSize size);

    static CameraPathGUI_cls *mspCThis;
    CameraPathCtrl_cls *mpCCtrl;

    wxButtonEX /**mpCBTNView,*/ *mpCBTNAdv, *mpCBTNPath;
    wxNotebook *mpCBook1;

    MultiInputPanel_cls* mpCMNumView[4];
    MultiInputPanel_cls* mpCMNumAdv;
    MultiInputPanel_cls* mpCMNumPath;

    int mIndexPitchAngle;
    int mIndexAnglePath;
    int mIndexGrid;
    int mIndexBG0, mIndexBG1;
    int mIndexFBOSize;

    MainGLCanvas_cls* GetPCActiveGLCanvas();
    void HideAndShowView(int i);
    void HideAndShowPath();
    void HideAndShowAll();

    void SetMNumView(int i, wxBoxSizer *pBoxSizer, wxWindow *pCWindow);
    void SetMNumAdv (wxBoxSizer *pBoxSizer);
    void SetMNumPath(wxBoxSizer *pBoxSizer);
    void ReconnectView();
    void ReconnectViewAdv();

    void OnNotebookChanged(wxNotebookEvent &event);
    void OnButtonShowItemAdv (wxCommandEvent &event);
    void OnButtonShowItemPath(wxCommandEvent &event);
    void OnButtonViewDefault(wxCommandEvent &event);

    static void FuncHookShow(void *pPanel, void *pArg);
    static void FuncHookAssign(void *pPanel, void *pArg);

    void UpdateValuesAll();

private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

class CameraPathCtrl_cls : public DialogControl_cls {
 public:
    CameraPathCtrl_cls(FrameMain_cls *pCParentFrame, 
		       StereoGram_cls *pCStereoGram,
		       CameraPath_cls *pCCameraPath,
		       AnchorPath_cls *pCAnchorPath);

    FrameMain_cls *mpCParentFrame;
    wxBitmap *mpBitmapLink;

    CameraPathGUI_cls *mpCGUI;

    //CameraPath_cls* GetActivePath();
    AnchorPath_cls *mpCAnchorPathLinked;
    CameraPath_cls *mpCCameraPathLinked;
    
    int mActiveView;

    void InitGUI(wxWindow *pC);
    void UpdateItems(bool bForce = FALSE);
};

#endif
