// -*- c -*-
// "clsLightSource.cpp"

#ifndef _LIGHT_SOURCE_H_
#define _LIGHT_SOURCE_H_

#include "clsSceneObj.h"
#include "../CONFITEM/clsConfItem.h"
#include "../MYGL/clsPositionAndDirection.h"

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

#define _LIGHT_NUM_MAX 7
#define _LIGHT_POINT 0
#define _LIGHT_SPOT  1
#define _LIGHT_CYLINDER 2
#define _LIGHT_PARALLEL 3

class LightSRC_cls;

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class LightSRC_cls : public SceneObj_cls {
 public:
    LightSRC_cls(int selfIndex, wxString strTag);
    ~LightSRC_cls();

    int mSelfIndex;
    int mUpdateBit;

    //ParamGroup_cls *mpCLightColor;
    ParamGroup_cls *mpCLightStrength;

    //ConfItemList_cls  mCConfList;
    ConfItemINT_cls   mCLightType;
    ConfItemINT_cls   mCFadeType;
    ConfItemINT_cls   mCSpotAngle;
    ConfItemBOOL_cls  mCbCastShadow;
    
    void CopyFromP(LightSRC_cls *pCFrom);
    void GetLightInfo(double doubleIndex, float pLightPos[4], 
		      float pLightPhiTheta[2], bool bSV);
    void GetLightColor(double doubleIndex, float pLightColor[4]);
    void GetLightDir(double doubleIndex, float pLightDir[4], bool bSV);
    void GLSetLightSourceComp
	(int GLLightIndex, double doubleIndex, bool bAmbient, bool bDiffuse);
    void GLSetLightSource(double doubleIndex, bool bEnable,
			  int shadowMode);

    wxString Serialize();
    void ReadStrLine(std::wistream &istream, wxString strLineTag);
};

#endif
