// -*- c -*-
// "clsSceneObj.cpp"

#ifndef _SCENE_OBJ_H
#define _SCENE_OBJ_H

#include "../MYGL/clsPositionAndDirection.h"
#include "../PARAMETER/clsParamGroup.h"

#ifdef WIN32
#include <windows.h>
#include <GL/glu.h>
#include <GL/glext.h>
#elif defined __WXMAC__
#define GL_GLEXT_PROTOTYPES 
#include <OpenGL/glu.h>
#else
#define GL_GLEXT_PROTOTYPES 
#include <GL/glu.h>
#endif

#define _SCENEOBJ_CAMERA 0
#define _SCENEOBJ_LIGHT  1

#define _SCENEOBJ_IDBASE_CAMERA 0
#define _SCENEOBJ_IDBASE_LIGHT  10

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class GLGuides_cls;

class SceneObj_cls{
 public:
    SceneObj_cls(wxString strObjName);
    ~SceneObj_cls();

    void SetInitValueTrans(double x, double y, double z);
    void SetInitValueRot(double x, double y, double z);
    void CopyFromP_SceneObj(SceneObj_cls *pCFrom);

    bool mbSelected, mbDragging;
    int  mObjType, mObjIndex;
    int  mDragMode;
    ParamGroup_cls *mpCTranslate;
    ParamGroup_cls *mpCRotation;
    static GLGuides_cls* mspCGLGuideLink;
    static GLGuides_cls* mspCGLGuideYPRLink;

    ConfItemList_cls  mCConfList;
    ConfItemUINT_cls  mCTarget;
    ConfItemBOOL_cls  mCbVisible;
    
    void UpdateCurrentObj(double dobuleIndex);
    PositionAndDirection_cls mCCurrentObj;
    PositionAndDirection_cls mCCurrentObjLookingAtCamera;

    void Targetting();
    void SetDragMode(int mode);

    void GLDrawGuide(double scale);
    void GLDrawPath(double scale);
    void GLDrawCurrent(double doubleIndex, double scale, int displayList,
		       bool bDirection = FALSE);


    //wxString Serialize();
};

#endif
