// -*- c++ -*-/
// "clsPlayCtrlGUI.h"

#include "clsPlayCtrlGUI.h"
#include "clsTimeCtrl.h"

#include "../../wxWidgetEnum.h"
#include "../../wxWidgetEnumMenu.h"

#include "../WIDGETCTRL/EX/clsButtonEX.h"
#include "../WIDGETCTRL/EX/clsCheckBoxEX.h"
#include "../WIDGETCTRL/EX/clsStaticTextEX.h"
//#include "../WIDGETCTRL/EX/clsSliderEX.h"
#include <wx/tglbtn.h>

extern bool GbAbort;

BEGIN_EVENT_TABLE(PlayCtrlGUI_cls, wxPanel)
EVT_BUTTON(btnCtrlSetKeyPos, PlayCtrlGUI_cls::OnButtonSetKeyPos)
EVT_BUTTON(btnCtrlSetKeyAnc, PlayCtrlGUI_cls::OnButtonSetKeyAnc)
EVT_BUTTON(btnCtrlStepBCK2,  PlayCtrlGUI_cls::OnButtonStepBCK2)
EVT_BUTTON(btnCtrlPlayBCK1,  PlayCtrlGUI_cls::OnButtonPlayBCK1)
EVT_BUTTON(btnCtrlStepBCK1,  PlayCtrlGUI_cls::OnButtonStepBCK1)
EVT_BUTTON(btnCtrlStepFWD1,  PlayCtrlGUI_cls::OnButtonStepFWD1)
EVT_BUTTON(btnCtrlPlayFWD1,  PlayCtrlGUI_cls::OnButtonPlayFWD1)
EVT_BUTTON(btnCtrlStepFWD2,  PlayCtrlGUI_cls::OnButtonStepFWD2)
EVT_BUTTON(btnCtrlAbort,     PlayCtrlGUI_cls::OnButtonAbort)
EVT_TOGGLEBUTTON(btnCtrlRepeat,    PlayCtrlGUI_cls::OnToggleRepeat)
EVT_SPINCTRL(spnCtrlAnimStep,   PlayCtrlGUI_cls::OnSpinAnimStep)
EVT_SPINCTRL(spnCtrlAnimInterp, PlayCtrlGUI_cls::OnSpinAnimInterp)
EVT_SPINCTRL(spnCtrlPrefetch,   PlayCtrlGUI_cls::OnSpinPrefetch)
END_EVENT_TABLE()

PlayCtrlGUI_cls::
PlayCtrlGUI_cls(wxWindow *pCParent, TimeCtrl_cls *pCCtrl,
		wxWindowID id, wxPoint pos, wxSize size):
wxPanel(pCParent, id, pos, size)
{
    mpCTimeLink = pCCtrl;
    SetBackgroundColour(wxColour(216, 216, 216));

    //i
    wxBoxSizer *pBoxSizerButtons2 = new wxBoxSizer(wxHORIZONTAL);

    mpCButtonSetKeyPos  = 
	new wxButtonEX(this, btnCtrlSetKeyPos,
		       wxString::Format(_T("%s [POS]"),	_("Set Key")),
		       wxDefaultPosition, wxSize(120, -1));
    mpCButtonSetKeyAnc  =
	new wxButtonEX(this, btnCtrlSetKeyAnc,
		       wxString::Format(_T("%s [ANC]"), _("Set Key")),
		       wxDefaultPosition, wxSize(120, -1));

    mpCButtonStepBCK2 =
	new wxButtonEX(this, btnCtrlStepBCK2, wxT("|<|"), 
		       wxDefaultPosition, wxSize(40, -1));
    mpCButtonPlayBCK1 =
	new wxButtonEX(this, btnCtrlPlayBCK1, wxT("<-|"),
		       wxDefaultPosition, wxSize(40, -1));
    mpCButtonStepBCK1 =
	new wxButtonEX(this, btnCtrlStepBCK1, wxT("<||"),
		       wxDefaultPosition, wxSize(40, -1));
    mpCButtonStepFWD1 =
	new wxButtonEX(this, btnCtrlStepFWD1, wxT("||>"),
		       wxDefaultPosition, wxSize(40, -1));
    mpCButtonPlayFWD1 =
	new wxButtonEX(this, btnCtrlPlayFWD1, wxT("|->"),
		       wxDefaultPosition, wxSize(40, -1));
    mpCButtonStepFWD2 =
	new wxButtonEX(this, btnCtrlStepFWD2, wxT("|>|"),
		       wxDefaultPosition, wxSize(40, -1));

    mpCButtonAbort = 
	new wxButtonEX(this, btnCtrlAbort, wxT("[X]"),
		       wxDefaultPosition, wxSize(30, -1));
    mpCButtonAbort->SetBackgroundColour(wxColour(255, 128, 128));

    mpCButtonSetKeyPos->mKeyEventTarget = _WIDGETEX_TOPPARENT;
    mpCButtonSetKeyAnc->mKeyEventTarget = _WIDGETEX_TOPPARENT;
    mpCButtonStepBCK2->mKeyEventTarget = _WIDGETEX_TOPPARENT;
    mpCButtonPlayBCK1->mKeyEventTarget = _WIDGETEX_TOPPARENT;
    mpCButtonStepBCK1->mKeyEventTarget = _WIDGETEX_TOPPARENT;
    mpCButtonStepFWD1->mKeyEventTarget = _WIDGETEX_TOPPARENT;
    mpCButtonPlayFWD1->mKeyEventTarget = _WIDGETEX_TOPPARENT;
    mpCButtonStepFWD2->mKeyEventTarget = _WIDGETEX_TOPPARENT;
    mpCButtonAbort->mKeyEventTarget = _WIDGETEX_TOPPARENT;
    
    mpCSpinAnimStep = 
	new wxSpinCtrl(this, spnCtrlAnimStep, wxT(""),
		       wxDefaultPosition, wxSize(50, -1));
    mpCSpinAnimStep->SetRange(1, 99);

    mpCSpinAnimInterp = 
	new wxSpinCtrl(this, spnCtrlAnimInterp, wxT(""),
		       wxDefaultPosition, wxSize(50, -1));
    mpCSpinAnimInterp->SetRange(1, 99);

    mpCSpinPrefetch = 
	new wxSpinCtrl(this, spnCtrlPrefetch, wxT(""),
		       wxDefaultPosition, wxSize(50, -1));
    mpCSpinPrefetch->SetValue(3);
    mpCSpinPrefetch->SetRange(1, 99);
    
    mpCToggleRepeat    =
	new wxToggleButton(this, btnCtrlRepeat, wxT("Repeat"),
			   wxDefaultPosition, wxSize(70, -1));

    int flags = wxEXPAND | wxALIGN_CENTER_VERTICAL;

    pBoxSizerButtons2->Add(mpCButtonSetKeyAnc,  0, flags);
    pBoxSizerButtons2->Add(mpCButtonSetKeyPos,  0, flags);
    pBoxSizerButtons2->Add(10, -1);
    pBoxSizerButtons2->Add(mpCButtonStepBCK2,   0, flags);
    pBoxSizerButtons2->Add(mpCButtonPlayBCK1,   0, flags);
    pBoxSizerButtons2->Add(mpCButtonStepBCK1,   0, flags);
    pBoxSizerButtons2->Add(mpCButtonStepFWD1,   0, flags);
    pBoxSizerButtons2->Add(mpCButtonPlayFWD1,   0, flags);
    pBoxSizerButtons2->Add(mpCButtonStepFWD2,   0, flags);
    pBoxSizerButtons2->Add(10, -1);
    pBoxSizerButtons2->Add(mpCToggleRepeat,     0, flags);
    pBoxSizerButtons2->Add(10, -1);
    wxStaticTextEX *pCTagStep =
	new wxStaticTextEX(this, wxID_ANY, _("Stepping"));
    pBoxSizerButtons2->Add(pCTagStep,           0, flags);
    pBoxSizerButtons2->Add(mpCSpinAnimStep,     0, flags);
    wxStaticTextEX *pCTagInterval =
	new wxStaticTextEX(this, wxID_ANY, _("Interval"));
    pBoxSizerButtons2->Add(pCTagInterval,       0, flags);
    pBoxSizerButtons2->Add(mpCSpinAnimInterp,   0, flags);
    pBoxSizerButtons2->Add(10, -1);
    wxStaticTextEX *pCTagPrefetch =
	new wxStaticTextEX(this, wxID_ANY, _("Prefetch"));
    pBoxSizerButtons2->Add(pCTagPrefetch,       0, flags);
    pBoxSizerButtons2->Add(mpCSpinPrefetch  ,   0, flags);
    
    pBoxSizerButtons2->Add(-1, 0, flags);
    pBoxSizerButtons2->Add(mpCButtonAbort, 0, flags);
    
    
    //pBoxSizerButtons2->Add(10, -1);

    //pBoxSizerSrc->Add(pBoxSizerButtons2, 0, flags);

    this->SetSizer(pBoxSizerButtons2);
}

void PlayCtrlGUI_cls::
OnButtonSetKeyPos(wxCommandEvent &event){
    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuItemSetKeyPos);
    wxGetTopLevelParent(this)->AddPendingEvent(com);
}

void PlayCtrlGUI_cls::
OnButtonSetKeyAnc(wxCommandEvent &event){
    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuItemSetKeyAnc);
    wxGetTopLevelParent(this)->AddPendingEvent(com);
}

void PlayCtrlGUI_cls::
OnButtonStepBCK2(wxCommandEvent& event){
    mpCTimeLink->MoveFrameCommandLarge(-1);
    RefreshGLPanels();
}

void PlayCtrlGUI_cls::
OnButtonPlayBCK1(wxCommandEvent& event){
    mpCTimeLink->StartPlayCommand(-1);
    UpdateButtonColor();
}

void PlayCtrlGUI_cls::
OnButtonStepBCK1(wxCommandEvent& event){
    //mpCTimeLink->MoveFrameCommand(-1);
    mpCTimeLink->MoveInterpStepCommand(-1);
    RefreshGLPanels();
}

void PlayCtrlGUI_cls::
OnButtonStepFWD1(wxCommandEvent& event){
    //mpCTimeLink->MoveFrameCommand(+1);
    mpCTimeLink->MoveInterpStepCommand(+1);
    RefreshGLPanels();
}

void PlayCtrlGUI_cls::
OnButtonPlayFWD1(wxCommandEvent& event){
    mpCTimeLink->StartPlayCommand(+1);
    UpdateButtonColor();
}

void PlayCtrlGUI_cls::
OnButtonStepFWD2(wxCommandEvent& event){
    mpCTimeLink->MoveFrameCommandLarge(+1);
    RefreshGLPanels();
}

void PlayCtrlGUI_cls::
OnButtonAbort(wxCommandEvent& event){
    GbAbort = TRUE;
}

void PlayCtrlGUI_cls::
OnToggleRepeat(wxCommandEvent& event){
    bool newValue = mpCToggleRepeat->GetValue();
    bool oldValue = mpCTimeLink->mCbRepeat.mbBody;
    if (newValue != oldValue) 
	mpCTimeLink->SetRepeatCommand((int)newValue, (int)oldValue);
}

void PlayCtrlGUI_cls::
OnSpinAnimStep(wxSpinEvent& event){
    int newValue = mpCSpinAnimStep->GetValue();
    int oldValue = mpCTimeLink->mCAnimStep.mBody;
    if (newValue != oldValue) 
	mpCTimeLink->SetAnimStepCommand(newValue, oldValue);
}

void PlayCtrlGUI_cls::
OnSpinAnimInterp(wxSpinEvent& event){
    int newValue = mpCSpinAnimInterp->GetValue();
    int oldValue = mpCTimeLink->mCAnimInterp.mBody;
    if (newValue != oldValue) 
	mpCTimeLink->SetAnimInterpCommand(newValue, oldValue);
}

void PlayCtrlGUI_cls::
OnSpinPrefetch(wxSpinEvent& event){
    int expectedMax = mpCTimeLink->GetExpectedPrefetchMax();
    int newValue = mpCSpinPrefetch->GetValue();

    if (newValue > expectedMax * 0.6 && newValue > 3){
	newValue = expectedMax * 0.6;
	mpCSpinPrefetch->SetValue(newValue);
    }

    int oldValue = mpCTimeLink->mPrefetchRange;
    if (newValue != oldValue) 
	mpCTimeLink->SetPrefetchCommand(newValue, oldValue);
}

void PlayCtrlGUI_cls::
UpdateDisplayedValues(){
    mpCSpinAnimStep->SetValue(mpCTimeLink->mCAnimStep.mBody);
    mpCSpinAnimInterp->SetValue(mpCTimeLink->mCAnimInterp.mBody);
    mpCToggleRepeat->SetValue(mpCTimeLink->mCbRepeat.mbBody);
}

void PlayCtrlGUI_cls::
UpdateButtonColor(){
    if (mpCTimeLink->mbPlayTex == TRUE){
	if (mpCTimeLink->mPlayDirection == +1){
	    mpCButtonPlayFWD1->SetBackgroundColour(wxT("LIGHT BLUE"));
	    mpCButtonPlayBCK1->SetBackgroundColour(wxNullColour); 
	}
	else if (mpCTimeLink->mPlayDirection == -1){
	    mpCButtonPlayBCK1->SetBackgroundColour(wxT("LIGHT BLUE"));
	    mpCButtonPlayFWD1->SetBackgroundColour(wxNullColour); 
	}
    }
    else{
	mpCButtonPlayFWD1->SetBackgroundColour(wxNullColour);
	mpCButtonPlayBCK1->SetBackgroundColour(wxNullColour);
    }
}

void PlayCtrlGUI_cls::
RefreshGLPanels(){
    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuEditRefreshGL);
    wxGetTopLevelParent(this)->AddPendingEvent(com);
}
