// -*- c++ -*-
// "clsPlayCtrlGUI.cpp"

#ifndef _PLAY_CTRL_GUI_H
#define _PLAY_CTRL_GUI_H

#include <wx/wx.h>
#include <wx/spinctrl.h>

class TimeCtrl_cls;
class wxCheckBoxEX;
class wxButtonEX;
class wxToggleButton; 

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class PlayCtrlGUI_cls : public wxPanel {
 public:
    PlayCtrlGUI_cls(wxWindow *pCParent, TimeCtrl_cls *pCCtrl,
		    wxWindowID id, wxPoint pos, wxSize size);
    //~PlayCtrlGUI_cls();

    TimeCtrl_cls *mpCTimeLink;

    wxCheckBoxEX *mpCCheckBoxPrefetch;
    wxCheckBoxEX *mpCCheckBoxQuickShow;

    wxButtonEX   *mpCButtonSetKeyAnc;
    wxButtonEX   *mpCButtonSetKeyPos;
    
    wxButtonEX   *mpCButtonStepBCK2;
    wxButtonEX   *mpCButtonPlayBCK1;
    wxButtonEX   *mpCButtonStepBCK1;
    wxButtonEX   *mpCButtonStepFWD1;
    wxButtonEX   *mpCButtonPlayFWD1;
    wxButtonEX   *mpCButtonStepFWD2;
    wxButtonEX   *mpCButtonAbort;

    wxToggleButton   *mpCToggleRepeat;

    wxSpinCtrl   *mpCSpinAnimStep;
    wxSpinCtrl   *mpCSpinAnimInterp;
    wxSpinCtrl   *mpCSpinPrefetch;

    void OnButtonSetKeyPos(wxCommandEvent &event);
    void OnButtonSetKeyAnc(wxCommandEvent &event);
    void OnButtonStepBCK2(wxCommandEvent &event);
    void OnButtonPlayBCK1(wxCommandEvent &event);
    void OnButtonStepBCK1(wxCommandEvent &event);
    void OnButtonStepFWD1(wxCommandEvent &event);
    void OnButtonPlayFWD1(wxCommandEvent &event);
    void OnButtonStepFWD2(wxCommandEvent &event);
    void OnButtonAbort   (wxCommandEvent &event);
    void OnToggleRepeat  (wxCommandEvent &event);
    void OnSpinAnimStep  (wxSpinEvent &event);
    void OnSpinAnimInterp(wxSpinEvent &event);
    void OnSpinPrefetch  (wxSpinEvent &event);

    void UpdateDisplayedValues();
    void UpdateButtonColor();
    void RefreshGLPanels();
    

 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

#endif
