// "clsTLPanelBase.h"

#include "clsTLPanelBase.h"
//#include "../clsDF3Sequence.h"
#include "clsTimeCtrl.h"

#include "../../wxWidgetEnumMenu.h"

#ifndef TRUE
#define TRUE true
#define FALSE false
#endif

TLPanelGeom_cls::
TLPanelGeom_cls(){
    mOffset = _TL_BORDER_OFFSET;
}

void TLPanelGeom_cls::
SetMemberSize(wxSize size){
    mWidth = size.GetWidth();
    mHeight = size.GetHeight();
}

int  TLPanelGeom_cls::
GetDeviceX(float x){
    return (int)(x * (mWidth - 2. * mOffset) + mOffset);
}

//----

// ÓIɃCxgт
BEGIN_EVENT_TABLE(TLPanelBase_cls, wxPanel)
EVT_KEY_DOWN                    (TLPanelBase_cls::OnKeyDown)
END_EVENT_TABLE()

TLPanelBase_cls::
TLPanelBase_cls(wxWindow *parent, TimeCtrl_cls *pCCtrl,
		wxWindowID id, wxPoint pos, wxSize size, bool bCustomBG):
wxPanel(parent, id, pos, size, 0)
{
    mpCCtrlLink = pCCtrl;
    SetBackgroundColour(wxColour(216, 216, 216));
    if (bCustomBG == TRUE)
	SetBackgroundStyle(wxBG_STYLE_CUSTOM);
    mSelected = 0;
    mMin_Dragged = 0;
    mMax_Dragged = 99;
}

void TLPanelBase_cls::
UpdateTLFrame(){
    mCurrentFrame = mpCCtrlLink->mFrame;
    mCurrentStep  = mpCCtrlLink->mInterpStep;
    mAnimInterp   = mpCCtrlLink->mCAnimInterp.mBody;
    mFrameMax     = mpCCtrlLink->mCMaxFrame.mBody;
    mMinFrameWA   = mpCCtrlLink->mCWAMin.mBody;
    mMaxFrameWA   = mpCCtrlLink->mCWAMax.mBody;
    mAAMin        = mpCCtrlLink->mCAAMin.mBody;
    mAAMax        = mpCCtrlLink->mCAAMax.mBody;
    mAnimStep     = mpCCtrlLink->mCAnimStep.mBody;
}

int TLPanelBase_cls::
GetFrameFromPosition(int pos, unsigned int minFrame, unsigned int maxFrame){
    if (maxFrame == minFrame) return 0;
    
    double dIndex = (double)(pos - mOffset) / (mWidth - 2.0 * mOffset);
    int frame = (int)(dIndex * (maxFrame - minFrame) + minFrame + 0.5);
    if (frame < 0) frame = 0;
    if (frame > (int)maxFrame) frame = maxFrame;
    return frame;
}

int  TLPanelBase_cls::
GetCoordinate(unsigned int frame, 
	      unsigned int minFrame, unsigned int maxFrame){

    float x0 = 0;
    if (maxFrame != minFrame){
	float width = (float)((int)maxFrame - (int)minFrame);
	x0 = (float)frame / width;
    }
    
    return GetDeviceX(x0); 
}

void TLPanelBase_cls::
CalcDeviceCoordinate(int *pX0, int *pX1, 
		     float frame0, float frame1,
		     int minFrame, int maxFrame){
    if (maxFrame == minFrame){
	*pX0 = 0; *pX1 = 1;
	return;
    }
    
    float diff0 = frame0 - minFrame;
    float diff1 = frame1 - minFrame;
    float width = maxFrame - minFrame;
    float x0 = diff0 / width;
    float x1 = diff1 / width;
    *pX0 = GetDeviceX(x0); *pX1 = GetDeviceX(x1);
}

void TLPanelBase_cls::
DrawWorkingArea(wxAutoBufferedPaintDC &dc,
		float minWA, float maxWA, int minAA, int maxAA){
    dc.SetBrush(*wxWHITE_BRUSH);
    CalcDeviceCoordinate(&mX0, &mX1, minWA, maxWA, minAA, maxAA);
    dc.DrawRectangle(mX0, 0, mX1-mX0, mHeight - 0);
}

void TLPanelBase_cls::
DrawWorkingAreaSlider(wxAutoBufferedPaintDC &dc,
		      float minWA, float maxWA, int minAA, int maxAA){
    CalcDeviceCoordinate(&mX0, &mX1, minWA, maxWA, minAA, maxAA);
    DrawRegionSliderX0X1(dc);
}

void TLPanelBase_cls::
DrawCurrentTime(wxAutoBufferedPaintDC &dc, int minAA, int maxAA){
    CalcDeviceCoordinate(&mXCurrentFrame, &mXDraggingFrame,
			 mCurrentFrame, mFrame_Dragged, minAA, maxAA);
    dc.SetBrush(*wxTRANSPARENT_BRUSH);
    dc.SetPen(*wxGREY_PEN);
    dc.DrawRectangle(mXCurrentFrame, 0, 1, mHeight);

    dc.SetPen(*wxRED_PEN);
    CalcDeviceCoordinate(&mX0, &mX1,
			 (float)mCurrentFrame + (float)mCurrentStep / mAnimInterp, 0, minAA, maxAA);
    dc.DrawRectangle(mX0, 0, 1, mHeight);
}


/*
void TLPanelBase_cls::
CalcCoordinateX0X1(unsigned int frame, unsigned int step,
		   unsigned int minFrame, unsigned int maxFrame){
    float x0, x1, xcurrent, xdragging;

    if (maxFrame == minFrame){
	x0 = 0; x1 = 1; xcurrent = 0; xdragging = 0;
    }
    else{
	float diff  = (float)((int)frame    - (int)minFrame);
	float width = (float)((int)maxFrame - (int)minFrame);
	x0 = diff / width;
	x1 = (diff + step) / width;
	float diffcurrent = (float)((int)mCurrentFrame - (int)minFrame);
	xcurrent = diffcurrent / width;
	float diffdragging = (float)((int)mFrame_Dragged - (int)minFrame);
	xdragging = diffdragging / width;
    }
    
    mX0 = GetDeviceX(x0); mX1 = GetDeviceX(x1);
    mXCurrentFrame  = GetDeviceX(xcurrent);
    mXDraggingFrame = GetDeviceX(xdragging);
    
    if (mX0 == mX1) mX1 = mX0+1;
}
*/


// --

void TLPanelBase_cls::
SetRegion(unsigned int regionMin, unsigned int regionMax){
    mRegionMin = regionMin;
    mRegionMax = regionMax;
}

void TLPanelBase_cls::
SetInitValue(wxMouseEvent& event, 
	     unsigned int initMin, unsigned int initMax){
    mInitMin = initMin;
    mInitMax = initMax;
    
    mMouseFrame = GetFrameFromPosition(event.GetX(),
				       mRegionMin, mRegionMax);
    CalcDeviceCoordinate(&mX0, &mX1,
			 mInitMin, mInitMax, mRegionMin, mRegionMax);
    /*
    CalcCoordinateX0X1(mInitMin, mInitMax - mInitMin,
		       mRegionMin, mRegionMax);
    */
}

bool TLPanelBase_cls::SetNewIndexDragging(){return FALSE;}
bool TLPanelBase_cls::SetNewMinDragging(){return FALSE;}
bool TLPanelBase_cls::SetNewMaxDragging(){return FALSE;}
void TLPanelBase_cls::SetNewMinFix(int max_DragIni){}
void TLPanelBase_cls::SetNewMaxFix(int max_DragIni){}

bool TLPanelBase_cls::
SetNewIndexFix(int frameAtClick){
    if (mFrame_Dragged == frameAtClick) return FALSE;
    mpCCtrlLink->SetFrameCommand(mFrame_Dragged, frameAtClick);
    return TRUE;
}


void TLPanelBase_cls::
DrawRegionSliderX0X1(wxAutoBufferedPaintDC &dc){
    dc.SetBrush(wxBrush(wxT("AQUAMARINE"), wxSOLID));
    dc.SetPen(*wxBLACK_PEN);
    wxPoint *listPointA = new wxPoint[4];
    wxPoint *listPointB = new wxPoint[4];
    listPointA[0] = wxPoint(-1, 0);
    listPointA[1] = wxPoint(-1, mHeight-1);
    listPointA[2] = wxPoint(-7, mHeight-1);
    listPointA[3] = wxPoint(-7, 3);
    listPointB[0] = wxPoint(0, 0);
    listPointB[1] = wxPoint(0, mHeight-1);
    listPointB[2] = wxPoint(6, mHeight-1);
    listPointB[3] = wxPoint(6, 3);
    dc.DrawPolygon(4, listPointA, mX0);
    dc.DrawPolygon(4, listPointB, mX1);
    delete listPointA;
    delete listPointB;
}

bool TLPanelBase_cls::
SelectItem(){
    mSelected = 0; 
    mbIndexChanged = FALSE;
    mFrame_Dragged = mCurrentFrame;
    //mFrame_Dragged_Prev = mFrame_Dragged;

    int posX = mMousePosCurrent;
    
    if (posX > mXCurrentFrame - 5 && posX < mXCurrentFrame + 5) 
	mSelected = _TL_SEL_SLIDER; 
    else{
	if (posX < mX0 && posX > mX0 - 7) mSelected = _TL_SEL_MIN;
	if (posX < mX1 + 7 && posX > mX1) mSelected = _TL_SEL_MAX;
	int posHandle = GetCoordinate((mInitMin + mInitMax) / 2, 
				      mRegionMin, mRegionMax);
	if (posX < posHandle + 7 && posX > posHandle - 7 && mSelected == 0) 
	    mSelected = _TL_SEL_REGION;
    }

    if (mSelected == 0) return FALSE;
    if (mSelected == _TL_SEL_SLIDER) SetCursor(wxCURSOR_SIZEWE);
    if (mSelected != _TL_SEL_SLIDER) SetCursor(wxCURSOR_HAND);
    
    mFrameAtClick = mMouseFrame;
    mMinAtClick = mInitMin;
    mMaxAtClick = mInitMax;
    mMin_Dragged = mMinAtClick;
    mMax_Dragged = mMaxAtClick;
    
    return TRUE;
    
}

void TLPanelBase_cls::
ProcDragging(bool bControlDown){
    switch (mSelected){
    case _TL_SEL_MIN:
	mMin_Dragged = mMouseFrame; 
	if (mMin_Dragged >= mMax_Dragged) mMin_Dragged = mMax_Dragged;
	break;
    case _TL_SEL_MAX:
	mMax_Dragged = mMouseFrame; 
	if (mMax_Dragged <= mMin_Dragged) mMax_Dragged = mMin_Dragged;
	break;
    case _TL_SEL_REGION: {
	int min = mMinAtClick + (mMouseFrame - mFrameAtClick);
	int max = mMaxAtClick + (mMouseFrame - mFrameAtClick);
	if (min < (int)mRegionMin) min = mRegionMin;
	if (max > (int)mRegionMax) max = mRegionMax;
	mMin_Dragged = min;
	mMax_Dragged = max;
	break; }
    case _TL_SEL_SLIDER:
	//mFrame_Dragged = mMouseFrame; 	
	mFrame_Dragged = mpCCtrlLink->RoundFrame(mMouseFrame);
	if (bControlDown == TRUE)
	    if (SetNewIndexFix(mFrameAtClick) == TRUE){
		mbIndexChanged = TRUE;
	    }
	break;
    }
}

void TLPanelBase_cls::
ProcReleaseMouse(){
    if (mbCaptureMouse == TRUE){
	ReleaseMouse();
	mbCaptureMouse = FALSE;
	SetCursor(wxNullCursor);
    }
    if (mSelected == _TL_SEL_SLIDER) 
	if (SetNewIndexFix(mFrameAtClick) == TRUE)
	    mbIndexChanged = TRUE;
    
    if (mSelected == _TL_SEL_MIN)    SetNewMinFix(mMinAtClick);
    if (mSelected == _TL_SEL_MAX)    SetNewMaxFix(mMaxAtClick);
    mSelected = 0;
}

void TLPanelBase_cls::
ProcMouseEventBase(wxMouseEvent& event){
    if (event.ButtonDown(wxMOUSE_BTN_LEFT)){
	if (SelectItem() == TRUE){
	    CaptureMouse();
	    mbCaptureMouse = TRUE;
	}
	else{
	    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuSelectDeselect);
	    wxGetTopLevelParent(this)->AddPendingEvent(com);
	}
    }

    if (event.ButtonUp(wxMOUSE_BTN_LEFT))
	ProcReleaseMouse();

    if (event.Dragging() == TRUE)
	ProcDragging(event.m_controlDown);
    
    mMousePosCurrent = event.GetX();

    if (mSelected != 0){
	bool bRefresh = FALSE;
	if (mFrame_Dragged != mFrame_Dragged_Prev) 
	    bRefresh |= SetNewIndexDragging();
	if (mMin_Dragged   != mMin_Dragged_Prev)
	    bRefresh |= SetNewMinDragging();
	if (mMax_Dragged   != mMax_Dragged_Prev)
	    bRefresh |= SetNewMaxDragging();
	
	if (bRefresh == TRUE){
	    mFrame_Dragged_Prev = mFrame_Dragged;
	    mMin_Dragged_Prev = mMin_Dragged;
	    mMax_Dragged_Prev = mMax_Dragged;
	}
    }

    /*
    if (mbIndexChanged == TRUE){
	wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuEditRefreshGL);
	wxGetTopLevelParent(this)->AddPendingEvent(com);
	mbIndexChanged = FALSE;
    }
    */
}

void TLPanelBase_cls::
OnKeyDown(wxKeyEvent& event){
    event.SetId(wxGetTopLevelParent(this)->GetId());
    wxGetTopLevelParent(this)->AddPendingEvent(event);
    //event.Skip();
}

//TimeCtrl_cls *TLPanelBase_cls::mspCTimeLink = NULL;

// ---------------------------

