// -*- c -*- 
// "clsTLPanelBase.cpp"

#ifndef _TLPANEL_BASE_H_
#define _TLPANEL_BASE_H_

#include <wx/wx.h>
#include <wx/dcbuffer.h>

class TLPanel_cls; 
class DF3Sequence_cls;
class TimeCtrl_cls;

#define _TL_SEL_MIN 1
#define _TL_SEL_MAX 2
#define _TL_SEL_REGION 3
#define _TL_SEL_SLIDER 4

#define _TL_BORDER_OFFSET 8

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif
class TLPanelGeom_cls {
 public:
    TLPanelGeom_cls();
    
    int mWidth, mHeight;
    int mOffset;
    int mX0, mX1;
    void SetMemberSize(wxSize size);
    int  GetDeviceX(float x);
};

class TLPanelBase_cls : public wxPanel, public TLPanelGeom_cls {
 public:
    TLPanelBase_cls(wxWindow *parent, TimeCtrl_cls *pCCtrl,
		    wxWindowID id, wxPoint pos, wxSize size, 
		    bool bCustomBG = TRUE);

    TimeCtrl_cls *mpCCtrlLink;
    //int  mWidth, mHeight;
    //int  mOffset;
    
    //static TimeCtrl_cls *mspCTimeLink;

    unsigned int mFrameAtClick, mFrame_Dragged, mFrame_Dragged_Prev;
    int          mMinAtClick,   mMin_Dragged,   mMin_Dragged_Prev;
    int          mMaxAtClick,   mMax_Dragged,   mMax_Dragged_Prev;

    unsigned int mCurrentFrame; // ݂̃t[
    unsigned int mCurrentStep;
    unsigned int mAnimInterp;
    unsigned int mFrameMax;
    unsigned int mMinFrameWA;
    unsigned int mMaxFrameWA;
    unsigned int mAAMin;
    unsigned int mAAMax;
    unsigned int mAnimStep;

    void UpdateTLFrame();
    int  GetFrameFromPosition(int pos, unsigned int minFrame, unsigned int maxFrame);
    int  GetCoordinate(unsigned int frame, 
		       unsigned int minFrame, unsigned int maxFrame);
    int   mXCurrentFrame, mXDraggingFrame;
    void  CalcDeviceCoordinate(int *pX0, int *pX1, 
			       float frame0, float frame1,
			       int minFrame, int maxFrame);

    void  DrawWorkingArea
	(wxAutoBufferedPaintDC &dc,
	 float minWA, float maxWA, int minAA, int maxAA);
    void  DrawWorkingAreaSlider
	(wxAutoBufferedPaintDC &dc,
	 float minWA, float maxWA, int minAA, int maxAA);
    void  DrawCurrentTime
	(wxAutoBufferedPaintDC &dc, int minAA, int maxAA);

    /*
    void  CalcCoordinateX0X1(unsigned int frame, unsigned int step,
			     unsigned int minIndex, unsigned int maxIndex);
    */

    
    int          mMousePosCurrent;     // ݂̃}EXʒu
    //unsigned int mFrameInDragging;   // hbOFrame (!!?!!)
    
    unsigned int mRegionMin, mRegionMax; // ̈
    unsigned int mInitMin, mInitMax, mInitFrame; // NbNMinMax
    bool  mbCaptureMouse;
    int   mMouseFrame;            // }EXʒuł̃t[
    int   mSelected;              // ZNgACe
    bool  mbIndexChanged;         // Indexς(Refresh̃gK)

    
    void SetRegion(unsigned int regionMin, unsigned int regionMax);
    void SetInitValue(wxMouseEvent& event, 
		      unsigned int initMin, unsigned int initMax);

    // ----
    
    virtual void ForceUpdateDisplay() = 0;
    // }EX̃hbOɂ鑀
    virtual bool SetNewIndexDragging();
    virtual bool SetNewMinDragging();
    virtual bool SetNewMaxDragging();
    virtual void SetNewMinFix(int min_DragIni);
    virtual void SetNewMaxFix(int max_DragIni);
    bool SetNewIndexFix(int frame_DragIni);

    void  DrawRegionSliderX0X1(wxAutoBufferedPaintDC &dc);

    // ----
    bool  SelectItem();
    void  ProcDragging(bool bControlDown);
    void  ProcReleaseMouse();
    void  ProcMouseEventBase(wxMouseEvent& event);

    void  OnKeyDown(wxKeyEvent& event);

 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

#endif
