// -*- c -*- 
// "clsTLPanel.cpp"

#ifndef _TLPANEL_H_
#define _TLPANEL_H_

#include <wx/wx.h>
#include <wx/dcbuffer.h>

class TLPanel_cls; 
class DF3Sequence_cls;
class TimeCtrl_cls;

#define _TL_SEL_MIN 1
#define _TL_SEL_MAX 2
#define _TL_SEL_REGION 3
#define _TL_SEL_SLIDER 4

class TLPanel_cls : public TLPanelBase_cls, public wxPanel {
 public:
    TLPanel_cls(wxWindow *parent, wxWindowID id, wxPoint pos, wxSize size);
    ~TLPanel_cls();

    static TimeCtrl_cls *mspCTimeLink;

    virtual void UpdateDisplay() = 0;
    void OnPaint(wxPaintEvent& event);
    void OnChar(wxKeyEvent& event);

    void UpdateTLFrame();

    unsigned int mFrameInDisplay;
    
    unsigned int mFrameMax;
    unsigned int mMinFrameWA;
    unsigned int mMaxFrameWA;
    unsigned int mAAMin;
    unsigned int mAAMax;
    unsigned int mStep;

    int CalcFrameFromPosition(int pos, unsigned int minFrame, unsigned int maxFrame);

    // Region Selector
    unsigned int *mpCRegionTgtMin, *mpCRegionTgtMax;
    unsigned int mRegionMin, mRegionMax;
    unsigned int mInitMin, mInitMax;
    int   mFrameAtClick, mMinAtClick, mMaxAtClick;
    bool  mbCaptureMouse;
    int   mMouseFrame;
    int   mSelected;
    
    void SetRange(unsigned int regionMin, unsigned int regionMax);
    void SetInitRegion(wxMouseEvent& event, 
		       unsigned int initMin, unsigned int initMax);
    void DrawRegionSliderX0X1(wxAutoBufferedPaintDC &dc);
    void CalcSelected(wxMouseEvent& event);
    bool ProcSelect();
    void ProcMouseEventBase(wxMouseEvent& event);
    void ProcDragging(unsigned int *pMin, unsigned int *pMax);
    //unsigned int *pFrame);

    int   mPosCurrent, mFrameInSlider;    

    /*
 protected:
    DF3Sequence_cls *mpCParent;
    */
    
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

#endif
