// -*- c++ -*-
// "clsTimeCtrlGUI.h"

#include "clsTimeCtrlGUIAtoi.h"
#include "clsTimeCtrl.h"

#include "../WIDGETCTRL/clsAtoiTextCtrl.h"
#include "../../wxWidgetEnum.h"

BEGIN_EVENT_TABLE(TimeCtrlGUIAtoi_cls, wxPanel)
EVT_CHAR        (TimeCtrlGUIAtoi_cls::OnChar)
EVT_PAINT       (TimeCtrlGUIAtoi_cls::OnPaint)
END_EVENT_TABLE()

TimeCtrlGUIAtoi_cls::
TimeCtrlGUIAtoi_cls(wxWindow *pCParent, TimeCtrl_cls *pCCtrl,
		    wxWindowID id, wxPoint pos, wxSize size): 
TLPanelBase_cls(pCParent, pCCtrl, id, pos, size, FALSE)
{
    // ?? sizer܂Ȃ̂ňʒu𒼐ړ

    mpCAtoiFrame = 
	new AtoiTextCtrl_cls(this, spnCtrlFrame, 0,
			     wxDefaultPosition, wxSize(43, -1));
    mpCAtoiFrame->SetRange(0, 99);
    mpCAtoiStep = 
	new AtoiTextCtrl_cls(this, spnCtrlStep, 0,
			     wxPoint(43, 0), wxSize(30, -1));
    mpCAtoiStep->SetRange(0, 0);
}

TimeCtrlGUIAtoi_cls::
~TimeCtrlGUIAtoi_cls(){
}

void TimeCtrlGUIAtoi_cls::
UpdateDisplay(wxAutoBufferedPaintDC &dc){
    ;
}

void TimeCtrlGUIAtoi_cls::
UpdateDisplay(){
    mpCAtoiFrame->SetValueInt(mpCCtrlLink->mFrame);
    mpCAtoiFrame->SetRange(0, mpCCtrlLink->mCMaxFrame.mBody);
    mpCAtoiStep->SetValueInt(mpCCtrlLink->mInterpStep);
    mpCAtoiStep->SetRange(0, mpCCtrlLink->mCAnimInterp.mBody - 1);
}

void TimeCtrlGUIAtoi_cls::
ForceUpdateDisplay(){
    wxPaintEvent com;
    OnPaint(com);
}

bool TimeCtrlGUIAtoi_cls::SetNewIndexDragging(){
    mpCCtrlLink->SetFrameNative(mFrame_Dragged, _COMMAND_UPDATE_DISPLAY_TL);
    return TRUE;
}

bool TimeCtrlGUIAtoi_cls::SetNewMinDragging(){
    mpCCtrlLink->SetWAMinNative(mMin_Dragged); return TRUE;
}

bool TimeCtrlGUIAtoi_cls::SetNewMaxDragging(){
    mpCCtrlLink->SetWAMaxNative(mMax_Dragged); return TRUE;
}


void TimeCtrlGUIAtoi_cls::SetNewMinFix(int minAtClick){
    mpCCtrlLink->SetWAMinCommand(mMin_Dragged, minAtClick);
}

void TimeCtrlGUIAtoi_cls::SetNewMaxFix(int maxAtClick){
    mpCCtrlLink->SetWAMaxCommand(mMax_Dragged, maxAtClick);
}

void TimeCtrlGUIAtoi_cls::
OnChar(wxKeyEvent& event){
    if (event.GetKeyCode() == WXK_RETURN || event.GetKeyCode() == WXK_SPACE){
	int newframe = mpCAtoiFrame->GetValue();
	int oldframe = mpCCtrlLink->mFrame;
	if (newframe != oldframe)
	    mpCCtrlLink->SetFrameCommand(newframe);
	int newstep = mpCAtoiStep->GetValue();
	int oldstep = mpCCtrlLink->mInterpStep;
	if (newstep != oldstep)
	    mpCCtrlLink->SetInterpStepCommand(newstep);
    }
}

void TimeCtrlGUIAtoi_cls::
OnPaint(wxPaintEvent& event){
    UpdateDisplay();
    event.Skip();
}

