
#include "clsUndoItemConstParam.h"
#include "../CONFITEM/clsConfItem.h"

#include "wx/wx.h"

#include "../../wxWidgetEnumMenu.h"

CommandSetValue_cls::
CommandSetValue_cls(void *pTarget, float value, int updateBit){
    mpTarget = pTarget;
    mType = _COMMAND_BASIC_FLOAT;
    mValueFloat = value;
    mUpdateBit = updateBit;
}

CommandSetValue_cls::
CommandSetValue_cls(void *pTarget, double value, int updateBit){
    mpTarget = pTarget;
    mType = _COMMAND_BASIC_DOUBLE;
    mValueDouble = value;
    mUpdateBit = updateBit;
}

CommandSetValue_cls::
CommandSetValue_cls(void *pTarget, unsigned int value, int updateBit){
    mpTarget = pTarget;
    mType = _COMMAND_BASIC_UNSIGNED_INT;
    mValueUnsignedInt = value;
    mUpdateBit = updateBit;
}

CommandSetValue_cls::
CommandSetValue_cls(void *pTarget, int value, int updateBit){
    mpTarget = pTarget;
    mType = _COMMAND_BASIC_INT;
    mValueInt = value;
    mUpdateBit = updateBit;
}

CommandSetValue_cls::
CommandSetValue_cls(void *pTarget, wxString value, int updateBit){
    mpTarget = pTarget;
    mType = _COMMAND_BASIC_STRING;
    mValueString = value;
    mUpdateBit = updateBit;
}

void CommandSetValue_cls::
Execute(bool bFlag){
    switch(mType){
    case _COMMAND_BASIC_FLOAT:
	*(float*)mpTarget = mValueFloat;
	break;
    case _COMMAND_BASIC_DOUBLE:
	*(double*)mpTarget = mValueDouble;
	break;
    case _COMMAND_BASIC_INT:
	*(int*)mpTarget = mValueInt;
	break;
    case _COMMAND_BASIC_UNSIGNED_INT:
	*(unsigned int*)mpTarget = mValueUnsignedInt;
	break;
    case _COMMAND_BASIC_STRING:
	*(wxString*)mpTarget = mValueString;
	break;
    }

    UpdateBit();
}

//----

CommandSetColor_cls::
CommandSetColor_cls(ConfItemFLOATARRAY_cls *pCTarget, 
		    float *pColorFloat, int updateBit){
    mpCTarget = pCTarget;
    for (int rgba = 0; rgba < 4; rgba++)
	mColorFloat[rgba] = pColorFloat[rgba];
    mUpdateBit = updateBit;
}

void CommandSetColor_cls::
Execute(bool bFlag){
    for (int rgba = 0; rgba < 4; rgba++)
	mpCTarget->mpBody[rgba] = mColorFloat[rgba];

    printf("ColorExecute Updatebit=%d\n", mUpdateBit);
    UpdateBit();
}
