// -*- c++ -*-
// (setq c-basic-offset 4)

#include "clsUndoItemTimeCtrl.h"
#include "../TIMELINE/clsTimeCtrl.h"

CommandSetTimeCtrlValue_cls::
CommandSetTimeCtrlValue_cls(TimeCtrl_cls *pCTarget, int target, int value){
    mpCTarget = pCTarget;
    mTarget   = target;
    mValue    = value;
}

void CommandSetTimeCtrlValue_cls::
Execute(bool bFlag){
    if (mTarget== _COMMAND_TARGET_FRAME) mpCTarget->SetFrameNative(mValue);
    if (mTarget== _COMMAND_TARGET_INTERPSTEP) mpCTarget->SetInterpStepNative(mValue);
    if (mTarget== _COMMAND_TARGET_WAMIN) mpCTarget->SetWAMinNative(mValue);
    if (mTarget== _COMMAND_TARGET_WAMAX) mpCTarget->SetWAMaxNative(mValue);
    if (mTarget== _COMMAND_TARGET_AAMIN) mpCTarget->SetAAMinNative(mValue);
    if (mTarget== _COMMAND_TARGET_AAMAX) mpCTarget->SetAAMaxNative(mValue);
    if (mTarget== _COMMAND_TARGET_REPEAT) mpCTarget->SetRepeatNative(mValue);
    if (mTarget== _COMMAND_TARGET_ANIMSTEP) 
	mpCTarget->SetAnimStepNative(mValue);
    if (mTarget== _COMMAND_TARGET_ANIMINTERP) 
	mpCTarget->SetAnimInterpNative(mValue);
    if (mTarget== _COMMAND_TARGET_PREFETCH) 
	mpCTarget->SetPrefetchNative(mValue);
    if (mTarget== _COMMAND_TARGET_MAXFRAME) mpCTarget->SetMaxFrameNative(mValue);
}

//---

CommandStartAnim_cls::
CommandStartAnim_cls(TimeCtrl_cls *pCTarget, int direction){
    mpCTarget = pCTarget;
    mDirection = direction;
}

void CommandStartAnim_cls::
Execute(bool bFlag){
    mpCTarget->StartPlay(mDirection);
}

//---

CommandStopAnim_cls::
CommandStopAnim_cls(TimeCtrl_cls *pCTarget, int frame){
    mpCTarget = pCTarget;
    mFrame = frame;
}

void CommandStopAnim_cls::
Execute(bool bFlag){
    mpCTarget->StopAnimationAt(mFrame);
}
