// -*- c -*-
// "clsUndoManager.h"
// (setq c-basic-offset 4)

#ifndef _UNDO_MANAGER_H_
#define _UNDO_MANEGER_H_

#include "clsUndoManager.h"

#include "../PARTICLEDATA/clsSnapData.h"
extern bool GbSnapDataRefresh;

#include <wx/wx.h>
extern wxFrame *GpCMainFrameCLS;
#include "../../wxWidgetEnumMenu.h"

#ifndef TRUE
#define TRUE true
#define FALSE false
#endif

UndoManager_cls GCUndoList;

CommandItem_cls::
CommandItem_cls(){
    mCommandType = _COMMAND_TYPE_NORMAL;
    mUpdateBit = 0;
}

CommandItem_cls::
~CommandItem_cls(){
}

void CommandItem_cls::
UpdateBit(){
    UpdateBit(mUpdateBit);
}

void CommandItem_cls::
UpdateBit(int updateBit){
    
    GCUndoList.mUpdateAccumulateBit |= updateBit;
    
    // $B;~4VJQ2=$N$_$O$^$H$a$F=hM}$5$l$k$H:$$k(B
    if (GpCMainFrameCLS == 0) return; //$B=i4|@_Dj;~$K$^$@L5$$(B
    if ((updateBit & _COMMAND_UPDATE_DISPLAY_TL) != 0){
	wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, 
			   menuEditRefreshTL);
	GpCMainFrameCLS->AddPendingEvent(com);
    }
    
    /*
    if ((updateBit & _COMMAND_UPDATE_DISPLAY_ATTRIB) != 0){
	wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, 
			   menuEditRefreshAttrib);
	GpCMainFrameCLS->AddPendingEvent(com);
    }

    if ((updateBit & _COMMAND_UPDATE_DISPLAY_GL) != 0){
	GbSnapDataRefresh = TRUE;
	wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, 
			   menuEditRefreshGL);
	GpCMainFrameCLS->AddPendingEvent(com);
    }

    if ((updateBit & _COMMAND_UPDATE_DISPLAY_IMGSEQ) != 0){
	wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, 
			   menuEditRefreshIMGSEQ);
	GpCMainFrameCLS->AddPendingEvent(com);
    }
    
    if ((updateBit & _COMMAND_UPDATE_DISPLAY_CAMCONF) != 0){
	wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, 
			   menuEditRefreshCamConf);
	GpCMainFrameCLS->AddPendingEvent(com);
    }
    
    if ((updateBit & _COMMAND_UPDATE_DISPLAY_COLOR) != 0){
	wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, 
			   menuEditRefreshColor);
	GpCMainFrameCLS->AddPendingEvent(com);
    }

    if ((updateBit & _COMMAND_UPDATE_DISPLAY_EXPORTER) != 0){
	wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, 
			   menuEditRefreshExporter);
	GpCMainFrameCLS->AddPendingEvent(com);
    }

    if ((updateBit & _COMMAND_UPDATE_DISPLAY_DRAWOPTIONS) != 0){
	wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED,
			   menuEditRefreshDrawOptions);
	GpCMainFrameCLS->AddPendingEvent(com);
    }

    if ((updateBit & _COMMAND_UPDATE_DISPLAY_LIGHT) != 0){
	wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED,
			   menuEditRefreshLight);
	GpCMainFrameCLS->AddPendingEvent(com);
    }

    if ((updateBit & _COMMAND_UPDATE_DISPLAY_EXPOSURE) != 0){
	wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED,
			   menuEditRefreshExposure);
	GpCMainFrameCLS->AddPendingEvent(com);
    }
    */
}

// --------------------------

ComBlockOpen::
ComBlockOpen(){
    mCommandType = _COMMAND_TYPE_BLOCK_OPEN;
}

void ComBlockOpen::
Execute(bool bFlag){
    GCUndoList.mBlockDepth++;
    //return FALSE;
}

ComBlockClose::
ComBlockClose(){
    mCommandType = _COMMAND_TYPE_BLOCK_CLOSE;
}

void ComBlockClose::
Execute(bool bFlag){
    GCUndoList.mBlockDepth--;
    //return FALSE;
}

// --------------------------

UndoManager_cls::
UndoManager_cls(){
    mCurrentIndex = 0;
    mBlockDepth = 0;
    mUpdateAccumulateBit = 0;
}

UndoManager_cls::
~UndoManager_cls(){
    for (unsigned int i = 0; i < mVPCRedoList.size(); i++){
	delete mVPCRedoList[i];
	delete mVPCUndoList[i];
    }
}

void UndoManager_cls::
Clear(){
    for (unsigned int i = 0; i < mVPCRedoList.size(); i++) RemoveItem(i);
    mVPCRedoList.clear();
    mVPCUndoList.clear();
    mCurrentIndex = 0;
}

void UndoManager_cls::
RemoveItem(unsigned int i){
    delete mVPCRedoList[i];
    delete mVPCUndoList[i];
}

void UndoManager_cls::
OpenBlock(){
    SetNewCommand
	(new ComBlockOpen, new ComBlockClose);
    ExecCurrent();
}

void UndoManager_cls::
CloseBlock(){
    int type = GetRedoCommandType();

    SetNewCommand
	(new ComBlockClose, new ComBlockOpen);
    ExecCurrent();

    // $B6u$C$]$N%V%m%C%/$J$i0UL#$,L5$$$N$G0l$DLa$k(B
    //UndoCurrent$B$GLa$k$K$O(BmBlockDepth$B$,(B0$B$G$J$$$H:$$k$N$GF~$l;RMQ$K2>$K(B0$B$K!#(B
    int blockDepthOrg = mBlockDepth;
    mBlockDepth = 0;
    if (type == _COMMAND_TYPE_BLOCK_OPEN)
	UndoCurrent(); 
    mBlockDepth = blockDepthOrg;
}

void UndoManager_cls::
SendEventToFrame(int comID){
    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, comID);
    GpCMainFrameCLS->AddPendingEvent(com);
}

void UndoManager_cls::
ExecUpdate(){
    if (GpCMainFrameCLS == NULL) return; //$B=i4|@_Dj;~$K$^$@L5$$(B
    
    if ((mUpdateAccumulateBit & _COMMAND_UPDATE_DISPLAY_TL) != 0)
	SendEventToFrame(menuEditRefreshTL);
    if ((mUpdateAccumulateBit & _COMMAND_UPDATE_DISPLAY_ATTRIB) != 0)
	SendEventToFrame(menuEditRefreshAttrib);
    if ((mUpdateAccumulateBit & _COMMAND_UPDATE_DISPLAY_GL) != 0){
	GbSnapDataRefresh = TRUE;
	SendEventToFrame(menuEditRefreshGL);
    }
    if ((mUpdateAccumulateBit & _COMMAND_UPDATE_DISPLAY_IMGSEQ) != 0)
	SendEventToFrame(menuEditRefreshIMGSEQ);
    if ((mUpdateAccumulateBit & _COMMAND_UPDATE_DISPLAY_CAMCONF) != 0)
	SendEventToFrame(menuEditRefreshCamConf);
    if ((mUpdateAccumulateBit & _COMMAND_UPDATE_DISPLAY_COLOR) != 0)
	SendEventToFrame(menuEditRefreshColor);
    if ((mUpdateAccumulateBit & _COMMAND_UPDATE_DISPLAY_EXPORTER) != 0)
	SendEventToFrame(menuEditRefreshExporter);
    if ((mUpdateAccumulateBit & _COMMAND_UPDATE_DISPLAY_DRAWOPTIONS) != 0)
	SendEventToFrame(menuEditRefreshDrawOptions);
    if ((mUpdateAccumulateBit & _COMMAND_UPDATE_DISPLAY_LIGHT) != 0)
	SendEventToFrame(menuEditRefreshLight);
    if ((mUpdateAccumulateBit & _COMMAND_UPDATE_DISPLAY_EXPOSURE) != 0)
	SendEventToFrame(menuEditRefreshExposure);

    mUpdateAccumulateBit = 0;
}

void UndoManager_cls::
SetNewCommand(CommandItem_cls* pComRedo, CommandItem_cls* pComUndo){
    for (unsigned int i = mCurrentIndex; i < mVPCRedoList.size(); i++)
	RemoveItem(i);
    
    mVPCRedoList.resize(mCurrentIndex);
    mVPCUndoList.resize(mCurrentIndex);
    mVPCRedoList.push_back(pComRedo);
    mVPCUndoList.push_back(pComUndo);
}

void UndoManager_cls::
PushNewCommand(CommandItem_cls* pComRedo, CommandItem_cls* pComUndo){
    mVPCRedoList.push_back(pComRedo);
    mVPCUndoList.push_back(pComUndo);
}

#include "../MYAPI/MsgBox.h"

int UndoManager_cls::
GetRedoCommandType(int level){
    if (mCurrentIndex <= level) return _COMMAND_TYPE_NORMAL;
    return mVPCRedoList[mCurrentIndex - level]->mCommandType;
}

int UndoManager_cls::
GetUndoCommandType(int level){
    if (mCurrentIndex <= level) return _COMMAND_TYPE_NORMAL;
    return mVPCUndoList[mCurrentIndex - level]->mCommandType;
}

void UndoManager_cls::
SkipCurrent(){
    if (mCurrentIndex < mVPCRedoList.size()){
	mCurrentIndex++;
	if (mBlockDepth > 0) SkipCurrent();
    }
}

void UndoManager_cls::
ExecCurrent(){
    if (mCurrentIndex < mVPCRedoList.size() ){
	mVPCRedoList[mCurrentIndex]->Execute(_COMMAND_REDO);
	mCurrentIndex++;
	if (mBlockDepth > 0) ExecCurrent();
    }
    if (mBlockDepth == 0) ExecUpdate();
}

void UndoManager_cls::
UndoCurrent(){
    mCurrentIndex--;
    //MsgBoxf(NULL, "UndoCurrent", "%d size:%d", mCurrentIndex, mVPCRedoList.size());
    if (mCurrentIndex < 65535){ 
	//bool bRecursiveMasterSlave = 
	mVPCUndoList[mCurrentIndex]->Execute(_COMMAND_UNDO);
	//MsgBoxf(NULL, "Call In Undo", "MasterSlave:%d, depth:%d", (int)bRecursiveMasterSlave, mBlockDepth);
	//if (bRecursiveMasterSlave) UndoCurrent();
	if (mBlockDepth > 0) UndoCurrent();
	//return TRUE; 
    }
    else 
	mCurrentIndex = 0;
    if (mBlockDepth == 0) ExecUpdate();
    //return FALSE;
}

#endif
