// -*- c -*- 
// "clsColourDialogEX.h"

#include "clsColourDialogEX.h"

#define ENDLWX wxT("\n");

#define LOOP_RGB for (int rgb=0; rgb < 3; rgb++)
#define R 0
#define G 1
#define B 2

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

wxColourDialogEX::
wxColourDialogEX(wxWindow* parent, wxColour CColor, bool bFullChoose){
    mCColour = CColor;
    mCColourData.SetColour(mCColour);
    mCColourData.SetChooseFull(bFullChoose);
    mpCDialog = new wxColourDialog(parent, &mCColourData);
};

wxColourDialogEX::
~wxColourDialogEX(){
    delete mpCDialog;
}

void wxColourDialogEX::
SetColourFloat(float *pFloatColor){
    LOOP_RGB mpFloatColor[rgb] = pFloatColor[rgb];
    mCColour.Set(mpFloatColor[R] * 255,
		 mpFloatColor[G] * 255,
		 mpFloatColor[B] * 255);
    //mCColourData.SetColour(mCColour);
}

void wxColourDialogEX::
SetColour(wxColour CColor){
    mCColour = CColor;
    //mCColourData.SetColour(mCColour);
}

int wxColourDialogEX::
ShowModal(){
    // does not work on MACOS. Why?
    mpCDialog->GetColourData().SetColour(mCColour);
    return mpCDialog->ShowModal();
}

unsigned char wxColourDialogEX::
GetR(){
    return mpCDialog->GetColourData().GetColour().Red();
}

unsigned char wxColourDialogEX::
GetG(){
    return mpCDialog->GetColourData().GetColour().Green();
}

unsigned char wxColourDialogEX::
GetB(){
    return mpCDialog->GetColourData().GetColour().Blue();
}

float* wxColourDialogEX::
GetPColorFloat(){
    mpFloatColor[0] = (float)GetR() / 255;
    mpFloatColor[1] = (float)GetG() / 255;
    mpFloatColor[2] = (float)GetB() / 255;
    return mpFloatColor;
}

// ----

wxString wxColourDialogEX::
SerializeCustomColors(){
    wxString strColors;
    
    mCColourData = mpCDialog->GetColourData();
    strColors << wxT("---CustomColors") << ENDLWX;
    for (int i = 0; i < 16; i++){
	wxColour CClr = mCColourData.GetCustomColour(i);
	strColors << CClr.Red() << wxT(" ");
	strColors << CClr.Green() << wxT(" ");
	strColors << CClr.Blue() << ENDLWX;
    }
    strColors << wxT("---END") << ENDLWX;
    
    return strColors;
}

void wxColourDialogEX::
ReadStrLine(std::wistream &istream, std::wstring strLine){
    std::wstring::size_type loc = strLine.find(L"---CustomColors");
    if (loc != std::wstring::npos){
	wxWindow *parent = mpCDialog->GetParent();
	mCColourData = mpCDialog->GetColourData();
	
	for (int i = 0; i < 16; i++){
	    std::wstring strLine;
	    std::getline(istream, strLine);
	    std::wstringstream strTmp(strLine);
	    wxColour CClr;
	    int r,g,b;
	    strTmp >> r >> g >> b;
	    CClr.Set(r, g, b);
	    mCColourData.SetCustomColour(i, CClr);
	}
	delete mpCDialog;
	mpCDialog = new wxColourDialog(parent, &mCColourData);
	std::getline(istream, strLine);
    }
}

wxColourDialogEX *GpCClrDialog;
