// -*- c -*- 
// "clsGraphPanel.cpp"

#ifndef _GRAPH_PANEL_H_
#define _GRAPH_PANEL_H_

#include <wx/wx.h>
#include <wx/dcbuffer.h>
#include <vector>

#define _GRAPH_MONOCHROME 0
#define _GRAPH_RGBA       1

class ParamGroup_cls;

class GraphPanel_cls : public wxPanel {
 public:
    GraphPanel_cls(wxWindow *parent, wxWindowID id, 
		   wxPoint pos = wxDefaultPosition,
		   wxSize size = wxDefaultSize,
		   bool bColor = TRUE);
    ~GraphPanel_cls();

    ParamGroup_cls* mpCParamGroupLinked;
    int mWidth, mHeight;
    wxMenu *mpCPopupMenu;

    void SetParamGroup(ParamGroup_cls *pCParamGroup);

    void ShowMenu();

    int  GetCoordX(double valueX);
    int  GetCoordY(double valueY);
    double GetDoubleX(int coordx);
    double GetDoubleY(int coordy);
    void SetPenColor(wxBufferedPaintDC &dc, int i);
    void SetBrushColor(wxBufferedPaintDC &dc, int i);
    void DrawGraphOfParamGroup(wxBufferedPaintDC &dc);
    void SetValueX(double valueX);
    void OnPaint(wxPaintEvent &event);
    void OnMouse(wxMouseEvent &event);

    int    mColorType;
    double mViewMinY, mViewMaxY;
    double mValueMinY, mValueMaxY;

    int    mCoordX, mCoordY;
    int    mCoordXAtClick, mCoordYAtClick;
    double mValueX, mValueY;
    double mValueXAtClick, mValueYAtClick;

    static wxColour msColorRGBA[4];

    void OnInsertKey(wxCommandEvent& event);
    void OnDeleteKey(wxCommandEvent& event);
    void OnColor(wxCommandEvent& event);
    void SetMode(int mode);
    void OnKeyDown(wxKeyEvent& event);
        
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

#endif
