// -*- c -*- 
// "clsInputItem.cpp"

#ifndef _INPUT_ITEM_H_
#define _INPUT_ITEM_H_

#define _ITEM_NOT_DEFINED    0
#define _ITEM_INTEGER        1
#define _ITEM_INTEGER_SPIN   2
#define _ITEM_INTEGER_SLIDER 3
#define _ITEM_FLOAT          4
#define _ITEM_FLOAT_SLIDER   5
#define _ITEM_DOUBLE         6
#define _ITEM_DOUBLE_SLIDER  7
#define _ITEM_BOOL           8
#define _ITEM_UINT           9
#define _ITEM_UINT_LIST     10
#define _ITEM_UINT_SPIN     11
#define _ITEM_STRING        12
#define _ITEM_DUALSLIDER    13
#define _ITEM_UINT_ICON     14

#define _ITEM_WXPANEL       15
#define _ITEM_BUTTON        40

#define _GP_ALIGN_LEFT  0
#define _GP_ALIGN_RIGHT 1
//#define _GP_NO_EXPAND   0
//#define _GP_EXPAND      1


#define _ITEM_BUTTON_HIDE_PANEL 50

#define _ITEM_BOXSIZERHORIZONTAL 60

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

#ifndef TRUE
#define TRUE true
#define FALSE false
#endif

#include <wx/wx.h>
#include <vector>

class wxStaticTextEX;

class InputItem_cls{
 public:
    InputItem_cls();

    wxString mstrLabel;
    wxStaticTextEX* mpCTextLabel;

    int  mType, mId, mUpdateBit;
    int  mTextWidth, mItemWidth;
    void *mpValue, *mpCCtrl;
    float*   mpColorFloat;
    bool     mbEnable;
    bool     mbUndoCommand;
    double   mMin, mMax;
    int      mScale;

    unsigned int  mListMax;
    std::vector < wxString > mVstrChoiceList;
    std::vector < wxIcon >   *mpVIcon; // 
    
    bool mbConnectSizer;
    int  mSizerIndex;

    wxSizerFlags GetSizerFlagLabel();
    wxSizerFlags GetSizerFlagH(int borderWidth = 2);
    int      mAlign;
    
    wxSizerFlags GetSizerFlagV();

    bool   IsButton();
    void   Show(bool bShow = TRUE);
    void   Hide();
    void   Enable(bool bEnable = TRUE);

    void SetParameter
	(int sizerCounter, 
	 int textWidth, int checkboxWidth, int comboWidth, int itemWidth);
    void CombinePointerButton
	(int id, wxString strLabel, int type,  bool bEnable);
    void CombinePointer
	(int type, void *pValue, 
	 wxString strLabel = wxT(""), bool bEnable = TRUE);
    void CombineList
	(unsigned int listMax, wxString *pChoiceList);
    
    void   SetRange(double min, double max, int scale);
    void   ApplyRange();
    bool   GetValueBool();
    float  GetValueFloat();
    double GetValueDouble(int index = 0);
    int    GetValueInt();
    wxString GetValueStr();
    
    bool   Assign();

    void   UpdateDisplay();
    
    int  ConnectBoxSizer(wxBoxSizer* pBoxSizer, wxWindow* pWindow);

    wxBoxSizer* GetPNewSizer(wxWindow* pWindow);
    wxWindow*   GetPCwxWindow();
    
    void ItemConnect(wxBoxSizer* pBoxSizer);
    void ItemConnect_Int(wxBoxSizer* pBoxSizer, wxWindow* pWindow);
    void ItemConnect_IntSpin(wxBoxSizer* pBoxSizer, wxWindow* pWindow);
    void ItemConnect_IntSlider(wxBoxSizer* pBoxSizer, wxWindow* pWindow);
    void ItemConnect_Float(wxBoxSizer* pBoxSizer, wxWindow* pWindow);
    void ItemConnect_FloatSlider(wxBoxSizer* pBoxSizer, wxWindow* pWindow);
    void ItemConnect_Double(wxBoxSizer* pBoxSizer, wxWindow* pWindow);
    void ItemConnect_DoubleSlider(wxBoxSizer* pBoxSizer, wxWindow* pWindow);
    void ItemConnect_Bool(wxBoxSizer* pBoxSizer, wxWindow* pWindow);
    void ItemConnect_List(wxBoxSizer* pBoxSizer, wxWindow* pWindow);
    void ItemConnect_Icon(wxBoxSizer* pBoxSizer, wxWindow* pWindow);
    void ItemConnect_String(wxBoxSizer* pBoxSizer, wxWindow* pWindow);
    void ItemConnect_DualSlider(wxBoxSizer* pBoxSizer, wxWindow *pWindow);
    void ItemConnect_WXPanel(wxBoxSizer* pBoxSizer);
    void ItemConnect_Button(wxBoxSizer* pBoxSizer, wxWindow* pWindow, bool bExpand = FALSE);
};

#endif
