// -*- c -*- 
// "clsMultiInputsPanel.cpp"

#ifndef _MULTI_INPUT_PANEL_H_
#define _MULTI_INPUT_PANEL_H_

/*
#include "EX/clsButtonEX.h"
*/
#include "clsDialogEXKey.h"
#include "clsInputItem.h"

#include <vector>

#define _MN_FORWARD 1
#define _MN_BACKWARD -1

#define _ITEM_LASTITEM -1
#define _MN_ALLITEM  -2
#define _MN_NOITEM   -3
#define _MN_ASSIGN_ALL -2

#define _MN_NO_BUTTONS 0
#define _MN_ASSIGN_UPDATE_HIDE 1
#define _MN_CANCEL_OK 2
#define _MN_OK_CANCEL 3
#define _MN_HELP      4
#define _MN_ADVANCED  8

#define _MN_PANEL  0
#define _MN_DIALOG 1

#define _MN_NOFORCE FALSE

#define _MN_DLG_MAKEGEOM TRUE
#define _MN_DLG_NOMAKEGEOM FALSE
#define _MN_DLG_MODAL TRUE

#ifdef WIN32
#define _MN_OK_CANCEL_DEFAULT _MN_OK_CANCEL
#else
#define _MN_OK_CANCEL_DEFAULT _MN_CANCEL_OK
#endif

class wxButtonEX;
class wxCheckBoxEX;
class MultiInputPanel_cls;

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

#include <wx/wx.h>

class HookCtrl_cls;

class MultiInputBase_cls {
 public:
    MultiInputBase_cls(void **ppToThis, wxWindow *pCMInputPanel);
    ~MultiInputBase_cls();

    int         mType;
    void        **mppToThis;
    wxWindow    *mpCParent;
    wxBoxSizer  *mpBoxSizerSrc;
    wxSizerItem *mpPadding;

    HookCtrl_cls *mpCHookCtrl;
    
    int    mTextWidth, mCheckBoxWidth, mComboWidth, mItemWidth;
    int    mMinimumWidth;
    //double mMin, mMax;
    int    mUpdateBit;
    bool   mbUndoCommand;
    
    std::vector < InputItem_cls > mVCItemList;
    InputItem_cls& GetLastItem();

    void SetColorForXYZ(unsigned int index);

    int  mSizerIndex, mSizerCounter;
    void ProcHorizontalBoxSizer(int currIndex, int type, void *pValue);

    int  CombinePointerButton(int id, wxString strLabel, 
			      int type = _ITEM_BUTTON, bool enabled = TRUE);
    int  CombinePointer(int type, void *pValue, 
			wxString strLabel=wxT(""), bool enable = TRUE);
    int  CombinePointerList(int type, void *pValue, 
			    unsigned int listMax, wxString *pChoiceList, 
			    wxString strLabel=wxT(""), bool enable = TRUE);
    
    void SetRange(int index, double min, double max, int scale = 1);
    
    void UpdateOtherItems(int index);
    void AssignBase(int index = _MN_ASSIGN_ALL, 
		    bool bUseHookChange = TRUE,
		    bool bForceHookChange = FALSE);
    void AssignBaseById(int id);
    void ShowItem(unsigned int index, bool bShow = TRUE);
    void HideItem(unsigned int index);
    void EnableItem(int index, bool bEnable);

    void OnScrollBase(wxScrollEvent& event);
    void OnScrollBaseChanged(wxScrollEvent& event);
    void OnCheckBoxBase(wxCommandEvent& event);
    void OnComboBoxBase(wxCommandEvent& event);
    
    virtual void ConnectButton  (wxWindow *pWindow, int id) = 0;
    virtual void ConnectClick   (wxWindow *pWindow, int id) = 0;
    virtual void ConnectBool    (wxWindow *pWindow, int id) = 0;
    virtual void ConnectComboBox(wxWindow *pWindow, int id) = 0;
    virtual void ConnectScroll  (wxWindow *pWindow, int id) = 0;
    //virtual void ConnnectSpin   (wxWindow *pWindow, int id) = 0;

    void MakeNewSizer(int index, wxBoxSizer *pBoxSizerSrc, wxWindow *pCPanel);
    void MakeGeometryBase(wxBoxSizer *pBoxSizerSrc, wxWindow *pCPanel);

    void UpdateValues(int index = _MN_ALLITEM);
};

class MultiInputDialog_cls :
public wxDialogEXKey{
 public:
    MultiInputDialog_cls
	(MultiInputDialog_cls **ppToThis,
	 wxWindow *pCParent, wxWindowID id, wxString strLabel,
	 wxPoint pos  = wxDefaultPosition, wxSize size = wxDefaultSize);
    
    MultiInputDialog_cls **mppToThis;
    MultiInputPanel_cls   *mpCPanel;
    void       *mpCUserDefinedClue;
    
    HookCtrl_cls *mpCHookCtrlLink;
    wxButtonEX *mpBTNOK;
    wxButtonEX *mpBTNCancel;

    int  CombinePointer(int type, void *pValue, 
			wxString strLabel=wxT(""), bool enable = TRUE);
    int  CombinePointerList(int type, void *pValue, 
			    unsigned int listMax, wxString *pChoiceList, 
			    wxString strLabel=wxT(""), bool enable = TRUE);
    void SetRange(int index, double min, double max, int scale = -1);
    void ShowItem(int index);
    void HideItem(int index);
	
    void OnOK(wxCommandEvent &event);
    void MakeGeometry();

    void UpdateValues(int index = _MN_ALLITEM);
    
    DECLARE_EVENT_TABLE()
};

class MultiInputPanel_cls : 
public wxPanel, public MultiInputBase_cls {
 public:
    MultiInputPanel_cls
	(MultiInputPanel_cls **ppToThis,
	 wxWindow *pCParent, wxWindowID id, 
	 wxPoint pos  = wxDefaultPosition, wxSize size = wxDefaultSize);
  
    MultiInputDialog_cls *mpCParentDLG;

    void SetPaddingWidth(int paddingWidth);
    int  GetPaddingWidth(int minimumWidth);
    
    void MakeGeometry();

    void ConnectButton  (wxWindow *pWindow, int id);
    void ConnectClick   (wxWindow *pWindow, int id);
    void ConnectBool    (wxWindow *pWindow, int id);
    void ConnectComboBox(wxWindow *pWindow, int id);
    void ConnectScroll  (wxWindow *pWindow, int id);
    

    void OnButton(wxCommandEvent& event);
    void OnChar(wxKeyEvent& event);
    void OnKeyDown(wxKeyEvent& event);
    void OnCheckBox(wxCommandEvent &event);
    void OnComboBox(wxCommandEvent &event);
    void OnHide(wxCommandEvent& event);
    void OnMouse(wxMouseEvent &event);
    void OnMouseOnItem(wxMouseEvent &event);
    void OnMouseOnHide(wxMouseEvent &event);
    void OnScroll(wxScrollEvent& event);
    void OnScrollChanged(wxScrollEvent& event);

    //--ŜB̏
    int  mIndexMinimize;
    wxButtonEX*   mpBTNMinimize;
    wxCheckBoxEX* mpCheckBoxValid;
    void AssignMinimizeButtonBoth(wxButtonEX* pBTNMinimize);
    void ShowPanel(bool mode);
    
    //--
    void AddThisAndHideButtonToSizer(wxBoxSizer *pBoxSizer);
    int  FinishSetting(wxBoxSizer *pBoxSizer, bool vis = TRUE);
    
    DECLARE_EVENT_TABLE()
};

#endif
