// (setq c-basic-offset 4)
// "clsFrameMain.h"
// "wxWidgetEnum.h"

#include "clsFrameMain.h"
#include "clsMain.h"

#include "SRC/MYAPI/MsgBox.h"

#include "SRC/COMMON/clsFilename.h"
#include "SRC/GLATTRIB/clsColorCurveGUI.h"
#include "SRC/GLCANVAS/clsGLCanvasCtrl.h"
#include "SRC/GLCANVAS/clsMainGLCanvas.h"
extern MainGLCanvas_cls* GpCurrentGLPanel;
#include "SRC/GRAPHIC/clsImgSequence.h"
#include "SRC/MAINCANVAS/clsDrawOption.h"
#include "SRC/MAINCANVAS/clsDrawOptionGUI.h"
#include "SRC/MAINCANVAS/clsExposure.h"
#include "SRC/MAINCANVAS/clsExposureGUI.h"
#include "SRC/MAINCANVAS/clsOverlay.h"
#include "SRC/MAINCANVAS/clsOverlayGUI.h"
#include "SRC/MAINCANVAS/clsTopHalfPanel.h"
#include "SRC/MAINCANVAS/clsBtmHalfPanel.h"
#include "SRC/MAINCANVAS/clsParamGUICtrl.h"
#include "SRC/MYGL/clsGLInfo.h"
#include "SRC/PANELS/clsDataLoader.h"
#include "SRC/PANELS/clsDataExporter.h"
#include "SRC/PANELS/clsPreference.h"
#include "SRC/PANELS/clsScene.h"
#include "SRC/PANELS/clsShortcut.h"
#include "SRC/PARTICLEDATA/clsParticleDataSeqCtrl.h"
#include "SRC/PARTICLEDATA/clsParticleDataSequence.h"
#include "SRC/PARTICLEDATA/clsShadowVolume.h"
#include "SRC/PARTICLEDATA/clsThreadFileReader.h"
extern ThreadFileReader_cls *GpCThreadReader;
extern bool                  GbThreadReaderFinished;
extern int                   GThreadReaderPercentage;
extern int                   GThreadReaderIndex;

#include "SRC/SCENEOBJ/clsCameraPathGUI.h"
#include "SRC/SCENEOBJ/clsLightSourceGUI.h"
#include "SRC/TIMELINE/clsTimeCtrl.h"
#include "SRC/TIMELINE/clsPlayCtrlGUI.h"
#include "SRC/UNDO/clsUndoManager.h"
extern UndoManager_cls GCUndoList;
#include "SRC/WIDGETCTRL/EX/clsFileDialogEX.h"
extern wxFileDialogEX *GpCFileDialog;
#include "SRC/WIDGETCTRL/EX/clsColourDialogEX.h"
extern wxColourDialogEX *GpCClrDialog;

extern bool                  GbGLLockForLoadingData;
extern bool                  GbGLLockPlayWait;
extern int                   GDrawingPercentage;
extern int                   GDrawingStage;

#include <fstream>
#include <sstream>
#include <wx/cursor.h>
#include <wx/choicdlg.h>
#include <wx/file.h>
#include <wx/datetime.h>
#include <wx/numdlg.h>
#include <wx/stopwatch.h>
#include <wx/tglbtn.h>
#include <wx/thread.h>
#include <wx/tooltip.h>
#include <wx/vscroll.h>

#include "wxWidgetEnum.h"
#include "wxWidgetEnumMenu.h"
#include "wxWidgetString.h"

wxFrame  *GpCMainFrameCLS;
int       GShortcutKeycode;
int       GShortcutModifier;
bool      GbAbort = FALSE;
wxBitmap *GpCBitmapGraphP;
wxBitmap *GpCBitmapGraphN;

#define ENDLWX wxT("\n")
#define X 0
#define Y 1
#define Z 2
#define LOOP_XYZ for(int xyz = 0; xyz < 3; xyz++)

#ifdef WIN32
#define WCHARCONV(x) (wxString)wxConvLibc.cMB2WC(x)
#else
#define WCHARCONV(x) (wxString)wxConvUTF8.cMB2WC(x)
#endif

#ifdef WIN32
#define _WSIZE_OFFSET_X 0
#define _WSIZE_OFFSET_Y 0
#else
#define _WSIZE_OFFSET_X 10
#define _WSIZE_OFFSET_Y 24
#endif

#define TIMER_ID 0

// ÓIɃCxgт
BEGIN_EVENT_TABLE(FrameMain_cls, wxFrame)
//EVT_PAINT(FrameMain_cls::OnPaint)
EVT_MENU(Minimal_Quit,           FrameMain_cls::OnQuit)
EVT_MENU(Minimal_About,          FrameMain_cls::OnAbout)
EVT_MENU(menuEditUndo,           FrameMain_cls::OnMenuUndo)
EVT_MENU(menuEditRedo,           FrameMain_cls::OnMenuRedo)
EVT_MENU(menuEditScene,          FrameMain_cls::OnMenuScene)
EVT_MENU(menuEditPreference,     FrameMain_cls::OnMenuPreference)
EVT_MENU(menuEditShortcut,       FrameMain_cls::OnMenuShortcut)
EVT_MENU(menuEditGo,             FrameMain_cls::OnMenuGo)
EVT_MENU(menuEditRemoveCacheSnap,FrameMain_cls::OnMenuRemoveCacheSnap)
EVT_MENU(menuEditRemoveCacheAll, FrameMain_cls::OnMenuRemoveCacheAll)
EVT_MENU(menuEditRefreshGL,      FrameMain_cls::OnMenuRefreshGL)
EVT_MENU(menuEditRefreshTL,      FrameMain_cls::OnMenuRefreshTL)
EVT_MENU(menuEditRefreshSB,      FrameMain_cls::OnMenuRefreshSB)
EVT_MENU(menuEditRefreshAttrib,  FrameMain_cls::OnMenuRefreshAttrib)
EVT_MENU(menuEditRefreshIMGSEQ,  FrameMain_cls::OnMenuRefreshIMGSEQ)
EVT_MENU(menuEditRefreshCamConf, FrameMain_cls::OnMenuRefreshCamConf)
EVT_MENU(menuEditRefreshColor,   FrameMain_cls::OnMenuRefreshColor)
EVT_MENU(menuEditRefreshExporter,FrameMain_cls::OnMenuRefreshExporter)
EVT_MENU(menuEditRefreshDrawOptions,FrameMain_cls::OnMenuRefreshDrawOptions)
EVT_MENU(menuEditRefreshLight,   FrameMain_cls::OnMenuRefreshLight)
EVT_MENU(menuEditRefreshExposure,FrameMain_cls::OnMenuRefreshExposure)
EVT_MENU(menuEditResizedTL,      FrameMain_cls::OnMenuResizedTL)
EVT_MENU(menuSelectDeselect,     FrameMain_cls::OnMenuDeselect)
EVT_MENU(menuFileOpenProject,    FrameMain_cls::OnMenuOpenProject)
EVT_MENU(menuFileSaveProject,    FrameMain_cls::OnMenuSaveProject)
EVT_MENU(menuFileSaveProjectAs,  FrameMain_cls::OnMenuSaveProjectAs)
EVT_MENU(menuFileOpenData,       FrameMain_cls::OnMenuLoadData)
EVT_MENU(menuFileExportData,     FrameMain_cls::OnMenuExportData)
EVT_MENU(menuFileSaveImageSnap,  FrameMain_cls::OnMenuSaveImageSnap)
EVT_MENU(menuFileSaveImageSeq,   FrameMain_cls::OnMenuSaveImageSeq)
EVT_MENU(menuItemSaveImgSeqBegin,FrameMain_cls::OnMenuSaveImgSeqBegin)
EVT_MENU(menuItemExportDataBegin,FrameMain_cls::OnMenuExportDataBegin)
EVT_MENU(menuFileCloseData,      FrameMain_cls::OnMenuCloseData)
EVT_MENU(menuViewMainPanelType0, FrameMain_cls::OnMenuViewPanelType)
EVT_MENU(menuViewMainPanelType1, FrameMain_cls::OnMenuViewPanelType)
EVT_MENU(menuViewMainPanelType2, FrameMain_cls::OnMenuViewPanelType)
EVT_MENU(menuViewMainPanelType3, FrameMain_cls::OnMenuViewPanelType)
EVT_MENU(menuViewMainPanelType4, FrameMain_cls::OnMenuViewPanelType)
EVT_MENU(menuDialogCameraPath,   FrameMain_cls::OnMenuCameraPath)
EVT_MENU(menuDialogLightSRC,     FrameMain_cls::OnMenuLighgtSRC)
EVT_MENU(menuDialogColorCurve,   FrameMain_cls::OnMenuColorCurve)
EVT_MENU(menuItemSetKeyPos,      FrameMain_cls::OnMenuSetKeyPos)
EVT_MENU(menuItemSetKeyAnc,      FrameMain_cls::OnMenuSetKeyAnc)
EVT_MENU(menuItemPlayStop,       FrameMain_cls::OnMenuPlayStop)
//EVT_SIZE      (FrameMain_cls::OnSize)
EVT_KEY_DOWN  (FrameMain_cls::OnKeyDown)
EVT_IDLE      (FrameMain_cls::OnIdle)
EVT_TIMER     (TIMER_ID, FrameMain_cls::OnTimer)
END_EVENT_TABLE()

FrameMain_cls::
FrameMain_cls(const wxString& title, Main_cls *pMain, int posx, int posy,
	      int width, int height) :
wxFrame(NULL, wxID_ANY, title, wxPoint(posx, posy), wxSize(width, height)),
mCTimer(this, TIMER_ID)
{
    mspCThis = this;
    mpCParent = pMain;
    GpCMainFrameCLS = this;
    mbHasOpenedProject = FALSE;
    mbRepeatPlay = FALSE;

    mpBitmapScene = 
	new wxBitmap(wxT("ICONS/Scene.png"), wxBITMAP_TYPE_PNG);
    mpBitmapCamera = 
	new wxBitmap(wxT("ICONS/Camera.png"), wxBITMAP_TYPE_PNG);
    mpBitmapLight0 = 
	new wxBitmap(wxT("ICONS/LightSource.png"), wxBITMAP_TYPE_PNG);
    mpBitmapLight1 = 
	new wxBitmap(wxT("ICONS/SpotLight.png"), wxBITMAP_TYPE_PNG);
    mpBitmapColor = 
	new wxBitmap(wxT("ICONS/Color.png"), wxBITMAP_TYPE_PNG);
    mpBitmapPreference = 
	new wxBitmap(wxT("ICONS/Preference.png"), wxBITMAP_TYPE_PNG);
    GpCBitmapGraphP = 
	new wxBitmap(wxT("ICONS/GraphP.png"), wxBITMAP_TYPE_PNG);
    GpCBitmapGraphN = 
	new wxBitmap(wxT("ICONS/GraphN.png"), wxBITMAP_TYPE_PNG);

    mpCShortcut   = new Shortcut_cls(this);
    mpCPreference = new Preference_cls(this); // ߂ɕKv
    mpCGLInfo     = new GLInfo_cls();
    
    SetExtraStyle(wxWS_EX_PROCESS_IDLE);
    mCTimer.Start(500);
    
    mCConfList.Add(&mCLastOpenedFileZJP, wxT("LastOpenedFileZJP="), wxT("None"));
    mCConfList.Add(&mCLastOpenedFileIMG, wxT("LastOpenedFileIMG="), wxT("None"));

    /*
    wxIcon icon(wxT("ICONS/Zindaiji3.png"), wxBITMAP_TYPE_PNG);
    SetIcon(icon); // set the frame icon
    */
    
    //Drag'nDrop
    //SetDropTarget(new DnDFile_cls(this));

    mpCSplitterMain = new
	wxSplitterWindow(this, wxID_ANY, 
			 wxDefaultPosition, wxDefaultSize, wxSP_NOBORDER | wxSP_3DSASH);
    mpCSplitterMain->SetSashGravity(1);
    Connect(mpCSplitterMain->GetId(),
	    wxEVT_COMMAND_SPLITTER_SASH_POS_CHANGED,
	    wxSplitterEventHandler(FrameMain_cls::OnSash));
    
    // TCU[
    wxBoxSizer  *pBoxSizerSrc = new wxBoxSizer(wxVERTICAL);
    
    mpCTopHalfPanel = new TopHalfPanel_cls
	(mpCSplitterMain, this);
    mpCBtmHalfPanel = new BtmHalfPanel_cls
	(mpCSplitterMain, this);
    mpCTopHalfPanel->SetBackgroundColour(wxT("WHITE"));
    mpCBtmHalfPanel->SetBackgroundColour(wxT("BLACK"));

    mpCActiveGLCanvasLink = mpCTopHalfPanel->mpCGLCtrl[0]->mpCGLCanvas;
    
    //EBhE
    mpCSplitterMain->SplitHorizontally(mpCTopHalfPanel, mpCBtmHalfPanel, -30);

    GetPCTimeCtrl()->InstantiateGUIB(this);
    pBoxSizerSrc->Add(mpCSplitterMain, 1, wxEXPAND);
    pBoxSizerSrc->Add(GetPCTimeCtrl()->mpCGUIPlay, 0, wxEXPAND);
    
    // ---

    InitMenu();
    CreateStatusBar(4);
    int statusBarWidth[4] = {-1, -1, 180, 180};
    GetStatusBar()->SetFieldsCount(4, statusBarWidth);
    GetStatusBar()->PushStatusText(wxT("field_0"), 0);
    GetStatusBar()->PushStatusText(wxT("field_1"), 1);
    GetStatusBar()->PushStatusText(wxT("field_2"), 2);
    GetStatusBar()->PushStatusText(wxT("field_3"), 3);

    this->SetSizer(pBoxSizerSrc);

    SetFocus();
    Refresh(false);

    MainGLCanvas_cls::InitializeStaticMembers(mpCParent->mpCOverlay);
    ShadowVolume_cls::InitializeStaticMembers();

    GpCFileDialog = new wxFileDialogEX(this);
    GpCClrDialog = new wxColourDialogEX(this, wxColour(wxT("BLACK")), TRUE);
    GpCurrentGLPanel = mpCTopHalfPanel->mpCGLCtrl[0]->mpCGLCanvas;
}

FrameMain_cls::
~FrameMain_cls(){
    delete mpCGLInfo;
    delete mpCPreference;
    delete mpCShortcut;
    delete GpCFileDialog;
    delete GpCClrDialog;

    delete mpBitmapScene;
    delete mpBitmapCamera;
    delete mpBitmapLight0;
    delete mpBitmapLight1;
    delete mpBitmapColor;
    delete mpBitmapPreference;
    delete GpCBitmapGraphP;
    delete GpCBitmapGraphN;

    MainGLCanvas_cls::DestructStaticMembers();
}

void FrameMain_cls::
FitSplitterWindow(bool bForce){
    int btmHalfPanelHeight = mpCBtmHalfPanel->GetSizer()->GetMinSize().GetHeight();
    if (btmHalfPanelHeight > 120) btmHalfPanelHeight = 120;

    int sashPos    = mpCSplitterMain->GetSashPosition();
    int windowSize = mpCSplitterMain->GetClientSize().GetHeight();
    int sashCandid = windowSize - btmHalfPanelHeight;
    mpCSplitterMain->SetMinimumPaneSize(80);

    if (bForce || (sashPos > sashCandid)){
	mpCSplitterMain->SetSashPosition(windowSize - 150, TRUE);
	Refresh(TRUE);
    }
}

// ----------------------

PDataSequence_cls* FrameMain_cls::
GetPCActiveFileSequence(){
    return GetPCDataSeqCtrl()->GetPCActiveFileSequence();
}

MainGLCanvas_cls* FrameMain_cls::
GetPCGLCanvas(int index){
    return mpCTopHalfPanel->mpCGLCtrl[index]->mpCGLCanvas;
}

void FrameMain_cls::
ReconnectCameraPathGUI(){
    mpCParent->mpCCameraPathCtrl->mpCGUI->ReconnectView();
}

void FrameMain_cls::
PrepareTheFrame(int frame){
    bool bWaitFinish = FALSE;
    if (frame == _FM_FRAME_CURRENT){
	frame = GetPCTimeCtrl()->mFrame;
	bWaitFinish = TRUE;
    }
    double indexDoube = GetPCTimeCtrl()->GetRemappedIndexDouble(frame);
    int index = (int)indexDoube;
    double indexmod = indexDoube-index;
    GetPCDataSeqCtrl()->PrepareIndex(index, indexmod, bWaitFinish);
}

bool FrameMain_cls::
IsTheFrameReady(int frame){
    if (frame == _FM_FRAME_CURRENT) frame = GetPCTimeCtrl()->mFrame;
    int step = GetPCTimeCtrl()->mInterpStep;
    double remappedDoubleIndex = GetPCTimeCtrl()->
	GetRemappedIndexDouble(frame, step);
    int index = (int)remappedDoubleIndex;
    double indexmod = remappedDoubleIndex - index;
    return GetPCDataSeqCtrl()->IsTheIndexReady(index, indexmod);
}

bool FrameMain_cls::
IsTheFrameLoaded(int frame){
    if (frame == _FM_FRAME_CURRENT) frame = GetPCTimeCtrl()->mFrame;
    int index = GetPCTimeCtrl()->GetRemappedIndex(frame);
    return GetPCDataSeqCtrl()->IsTheIndexLoaded(index);
}


// ----------------------

void FrameMain_cls::
OnQuit(wxCommandEvent& event){
    static bool sbLock = FALSE;
    if (sbLock == TRUE) return;
    sbLock = TRUE;
    if (MsgBoxYesno(this, _("Query"), _("Really Quit ?")) == TRUE){
	mpCParent->WaitThreadFinish();
	mpCParent->QuitProcess();
	Close(true);
    }
    sbLock = FALSE;
}

void FrameMain_cls::
OnAbout(wxCommandEvent& event){
    static bool sbLock = FALSE;
    if (sbLock == TRUE) return;
    sbLock = TRUE;
    wxMemorySize mem_size_msz = wxGetFreeMemory(); 
    wxString strMem = mem_size_msz.ToString();
    if (strMem == wxT("-1")) strMem = wxT("Unknown");
    else {
	mem_size_msz /= 1024 * 1024;
	strMem = mem_size_msz.ToString();
    }
    
    static wxString wstrYesNo[3] = {wxT("no"), wxT("yes")};
    wxString strAboutGLVer(mpCGLInfo->mstrGLVersion.c_str(), wxConvFile);
    wxMessageBox(wxString::Format
		 (_FRAME_MAIN_APPNAME _T("\n")
		  _T("%s %s\n%s %s\n%s %s MB\n%s %d\n%s\n%s\nProgrammed by Takaaki Takeda\n"),
		  _("Powered by"), wxVERSION_STRING,
		  _("running under"), wxGetOsDescription().c_str(),
		  _("free memory"), strMem.c_str(),
		  wxT("CoreNumber:"), wxThread::GetCPUCount(),
		  mpCGLInfo->GetGLVersionStr().c_str(),
		  mpCGLInfo->GetGLSLVersionStr().c_str()
		  ), _("About Zindaiji3"),
		 wxOK | wxICON_INFORMATION, this); // ʒuw͌ȂH
    sbLock = FALSE;
}

void FrameMain_cls::
OnSash(wxSplitterEvent& event){
    mpCBtmHalfPanel->RecheckSize();
}

void FrameMain_cls::
OnKeyDown(wxKeyEvent& event){
    int modifier = event.GetModifiers();
    int code = event.GetKeyCode();
    mpCShortcut->ProcShortcutKey(modifier, code);
}

void FrameMain_cls::
PrepareFramesAhead(int range){
    range *= GetPCTimeCtrl()->mPrefetchRange;
    if (range > 0)
	for (int dframe = 1; dframe <= range; dframe++){
	    int targetFrame = GetPCTimeCtrl()->
		CalcNextFrame(_TIME_CTRL_CURRENT, dframe, FALSE);
	    if (targetFrame > (int)GetPCTimeCtrl()->mCMaxFrame.mBody) continue;
	    if (IsTheFrameReady(targetFrame) == FALSE){
		PrepareTheFrame(targetFrame);
		dframe = range; continue;
	    }
	}
    else
	for (int dframe = -1; dframe >= range; dframe--){
	    int targetFrame = GetPCTimeCtrl()->
		CalcNextFrame(_TIME_CTRL_CURRENT, dframe, FALSE);
	    if (targetFrame < 0) continue;
	    if (IsTheFrameReady(targetFrame) == FALSE){
		PrepareTheFrame(targetFrame);
		dframe = range; continue;
	    }
	}
}

void FrameMain_cls::
OnIdle(wxIdleEvent& event){
    GetPCDataSeqCtrl()->CleanUpMemory(GetPCTimeCtrl()->mFrame,
				      GetPCTimeCtrl()->mCAnimStep.mBody);

#ifdef __WXMAC__
    static int sInit = 0;
    if (sInit == 0){
	wxMilliSleep(500);
	wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuEditRefreshGL);
	AddPendingEvent(com);
	sInit = 1;
    }
#endif
    
    if (GpCThreadReader == NULL)
	PrepareFramesAhead(GetPCTimeCtrl()->mPlayDirection);
    else{
	wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuEditRefreshSB);
	AddPendingEvent(com);
    }

    if (GbGLLockPlayWait == TRUE){
	return;
    }
    
    if (mpCParent->mpCTime->mbPlayTex == TRUE){
	if (GetPCTimeCtrl()->ProcPlaying() == TRUE)
	    GbGLLockPlayWait = TRUE;
    }
    else
	// ԂmPrevFrameƈPaint;
	mpCTopHalfPanel->CheckGLRefresh(GetPCTimeCtrl()->mFrame,
					GetPCTimeCtrl()->mInterpStep);
}

void FrameMain_cls::
OnTimer(wxTimerEvent& event){
    if (GpCThreadReader != NULL){
	if (GbThreadReaderFinished == TRUE)
	    GpCThreadReader = NULL;
    }
    //wxWakeUpIdle();
}

void FrameMain_cls::
OnMenuOpenProject(wxCommandEvent& event){
    static bool sbLock = FALSE;
    if (sbLock == TRUE) return;
    sbLock = TRUE;

    GpCFileDialog->SetMessage(wxT("Select a project file"));
    GpCFileDialog->SetWildcard(wxT("Project file (*.zjp)|*.zjp"));
    if (mCLastOpenedFileZJP.mstrBody != wxT("")){
	SplitPath_cls CPath(mCLastOpenedFileZJP.mstrBody);
	GpCFileDialog->SetInitPath
	    (CPath.GetPathStr(_FN_DRIVE_DIR),
	     CPath.GetPathStr(_FN_FNAME_EXT));
    }

    if (GpCFileDialog->ShowModal() == wxID_OK){
	GbGLLockForLoadingData = TRUE;
	GetPCDataSeqCtrl()->ClearData
	    (_ACTIVE_SEQUENCE, _SEQUENCE_ALL_INDEX, TRUE);
	mpCParent->ReadConfigure(GpCFileDialog->GetPath());
	mpCTopHalfPanel->ClearStatusGLPanels();
	GbGLLockForLoadingData = FALSE;
	
	mpCTopHalfPanel->RefreshGLPanels();
	mpCBtmHalfPanel->RefreshTLPanels();
	mpCTopHalfPanel->RefreshAttrib();
	mpCParent->mpCColorCurveCtrl->UpdateItems();
    }
    sbLock = FALSE;
}

void FrameMain_cls::
OnMenuSaveProject(wxCommandEvent& event){
    if (mbHasOpenedProject == FALSE){
	OnMenuSaveProjectAs(event);
	return;
    }

    static bool sbLock = FALSE;
    if (sbLock == TRUE) return;
    sbLock = TRUE;

    wxBeginBusyCursor();
    //GetStatusBar()->PushStatusText(wxT("Saving..."));
    mpCParent->SaveConfigure(mCLastOpenedFileZJP.mstrBody, _FM_PROJECT_CONF);
    wxMilliSleep(500);
    //GetStatusBar()->PopStatusText();
    wxEndBusyCursor();

    sbLock = FALSE;
}

void FrameMain_cls::
OnMenuSaveProjectAs(wxCommandEvent& event){
    static bool sbLock = FALSE;
    if (sbLock == TRUE) return;
    sbLock = TRUE;
    
    GpCFileDialog->SetMessage(wxT("Select a file"));
    GpCFileDialog->SetWildcard(wxT("Project file (*.zjp)|*.zjp"));
    GpCFileDialog->SetStyle(wxFD_SAVE | wxFD_OVERWRITE_PROMPT);
    if (mCLastOpenedFileZJP.mstrBody != wxT("")){
	SplitPath_cls CPath(mCLastOpenedFileZJP.mstrBody);
	if (mbHasOpenedProject == TRUE)
	    GpCFileDialog->SetInitPath
		(CPath.GetPathStr(_FN_DRIVE_DIR),
		 CPath.GetPathStr(_FN_FNAME_EXT));
	else
	    GpCFileDialog->SetInitPath
		(CPath.GetPathStr(_FN_DRIVE_DIR), wxT(".zjp"));
    }
    
    if (GpCFileDialog->ShowModal() == wxID_OK){
	mpCParent->SaveConfigure(GpCFileDialog->GetPath(), _FM_PROJECT_CONF);
	wxString strInfo = GpCFileDialog->GetPath();
	mbHasOpenedProject = TRUE;
	mCLastOpenedFileZJP.mstrBody = strInfo;
	/*
	if (mpCDF3SeqCtrl->GetPDF3Seq(_DF3_SLOT_0)->mVCFileSequence.size() > 0)
	    strInfo << wxT(" @ ") << mpCDF3SeqCtrl->GetPDF3Seq(_DF3_SLOT_0)->mVCFileSequence[0].GetInfoStr() << wxT(" - ") << _APPNAME_SHORT;
	SetTitle(strInfo);
	*/
    }
    sbLock = FALSE;
}

void FrameMain_cls::
OnMenuLoadData(wxCommandEvent& event){
    mpCParent->mpCDataLoader->OpenWindow(this);
}

void FrameMain_cls::
OnMenuExportData(wxCommandEvent& event){
    mpCParent->mpCDataExporter->OpenWindow(this);
}

void FrameMain_cls::
OnMenuSaveImageSnap(wxCommandEvent& event){
    mpCActiveGLCanvasLink->mbSaveImageQueue = TRUE;
    mpCActiveGLCanvasLink->Refresh(FALSE);
}

void FrameMain_cls::
OnMenuSaveImageSeq(wxCommandEvent& event){
    int width, height;
    mpCActiveGLCanvasLink->GetClientSize(&width, &height);
    mpCParent->mpCImgSeq->SetGeom(width, height, mpCActiveGLCanvasLink->mCGLPerspective.mDeg);
    mpCParent->mpCImgSeq->mCInitNum.mBody = mpCParent->mpCTime->mCWAMin.mBody;
    mpCActiveGLCanvasLink->mpCImgSeqLinked = mpCParent->mpCImgSeq;
    mpCParent->mpCImgSeq->SetDefaultPath(mCLastOpenedFileIMG.mstrBody);
    mpCParent->mpCImgSeq->OpenWindow(this);
}

void FrameMain_cls::
OnMenuSaveImgSeqBegin(wxCommandEvent& event){
    if (mpCActiveGLCanvasLink->mCDisplayMode.mBody < _GL_CANVAS_LINKED_CAM0)
	if (MsgBoxYesno
	    (mpCActiveGLCanvasLink->mpCImgSeqLinked->mpCGUI,
	     _("Save Image Sequence"), _("Panel 0 is not linked to camera")) == TRUE){
	    mpCActiveGLCanvasLink->LinkageConnect();
	}
    
    if (GetPCTimeCtrl()->mCAnimStep.mBody != 1){
	wxString strMes;
	strMes << _("Playing mode is Skipping: ") << GetPCTimeCtrl()->mCAnimStep.mBody << ENDLWX << _("Change Skipping to 1 ?");
	if (MsgBoxYesno
	    (mpCActiveGLCanvasLink->mpCImgSeqLinked->mpCGUI,
	     _("Save Image Sequence"), strMes) == TRUE){
	    GetPCTimeCtrl()->mCAnimStep.mBody = 1;
	    mpCBtmHalfPanel->RefreshTLPanels();
	}
    }

    mpCActiveGLCanvasLink->StartSaveImgSeqProcess(mpCParent->mpCImgSeq);
    mpCActiveGLCanvasLink->mCDrawInfo.ForceNewDraw();

    if (mpCActiveGLCanvasLink->mpCImgSeqLinked->mbSnapMode == TRUE)
	GetPCTimeCtrl()->StartPlayCommand(+1);
    else{
	GCUndoList.OpenBlock();
	GetPCTimeCtrl()->MoveFrameCommandLarge(-1);
	GetPCTimeCtrl()->StartPlayCommand(+1);
	GCUndoList.CloseBlock();
    }
}

void FrameMain_cls::
OnMenuExportDataBegin(wxCommandEvent& event){
    mpCActiveGLCanvasLink->StartExportDataProcess(mpCParent->mpCDataExporter);
    mpCActiveGLCanvasLink->mCDrawInfo.ForceNewDraw();

    GCUndoList.OpenBlock();
    GetPCTimeCtrl()->SetAnimInterpCommand(1, GetPCTimeCtrl()->mCAnimInterp.mBody);
    GetPCTimeCtrl()->MoveFrameCommandLarge(-1);
    GetPCTimeCtrl()->StartPlayCommand(+1);
    GCUndoList.CloseBlock();
}

void FrameMain_cls::
OnMenuCloseData(wxCommandEvent& event){
    mpCParent->CloseDataCommand();
    mpCTopHalfPanel->RefreshGLPanels();
    mpCBtmHalfPanel->RefreshTLPanels();
}

void FrameMain_cls::
OnMenuCameraPath(wxCommandEvent& event){
    mpCParent->mpCCameraPathCtrl->DialogControl_cls::OpenWindow(this);
}

void FrameMain_cls::
OnMenuLighgtSRC(wxCommandEvent& event){
    mpCParent->mpCLightSRCCtrl->DialogControl_cls::OpenWindow(this);
}

void FrameMain_cls::
OnMenuColorCurve(wxCommandEvent& event){
    mpCParent->mpCColorCurveCtrl->DialogControl_cls::OpenWindow(this);
    mpCParent->mpCColorCurveCtrl->mpCGUI->Refresh(TRUE);
}

void FrameMain_cls::
OnMenuViewPanelType(wxCommandEvent& event){
    int panelType = event.GetId() - menuViewMainPanelType0;
    mpCTopHalfPanel->SplitPanel(panelType);
}

void FrameMain_cls::
OnMenuUndo(wxCommandEvent& event){
    mpCParent->Undo();
}

void FrameMain_cls::
OnMenuRedo(wxCommandEvent& event){
    mpCParent->Redo();
}

void FrameMain_cls::
OnMenuScene(wxCommandEvent& event){
    mpCParent->mpCScene->InitializeTmpValues();
    if (mpCParent->mpCScene->OpenWindowModal(this) == TRUE)
	mpCParent->mpCScene->AssignTmpValues();
}

void FrameMain_cls::
OnMenuPreference(wxCommandEvent& event){
    mpCPreference->OpenWindow(this);
}

void FrameMain_cls::
OnMenuShortcut(wxCommandEvent& event){
    mpCShortcut->ProcShortcutKey(GShortcutModifier, GShortcutKeycode);
}

void FrameMain_cls::
OnMenuGo(wxCommandEvent& event){
    long frame = wxGetNumberFromUser(wxT("Frame"), wxT(""), _("Move Frame"),
				     mpCParent->mpCTime->mFrame,
				     0, mpCParent->mpCTime->mCMaxFrame.mBody);
    if (frame == -1) return;
    mpCParent->mpCTime->SetFrameCommand(frame);
    /*
    mpCParent->mpCTime->mFrame = frame;
    mpCParent->mpCTime->UpdateDF3SeqGUI(TRUE);
    mpCDF3SeqCtrl->mpCGUI->mpCSlider->SetValue(frame);
    */
}

void FrameMain_cls::
OnMenuRemoveCacheSnap(wxCommandEvent& event){
    int index = GetPCTimeCtrl()->GetRemappedIndex(_TIME_CTRL_CURRENT);
    GetPCDataSeqCtrl()->ClearData
	(_ACTIVE_SEQUENCE, index, FALSE);
}

void FrameMain_cls::
OnMenuRemoveCacheAll(wxCommandEvent& event){
    GetPCDataSeqCtrl()->ClearData
	(_ACTIVE_SEQUENCE, _SEQUENCE_ALL_INDEX, FALSE);
}

void FrameMain_cls::
OnMenuRefreshGL(wxCommandEvent& event){
    mpCTopHalfPanel->RefreshGLPanels();
}

void FrameMain_cls::
OnMenuRefreshTL(wxCommandEvent& event){
    GetPCTimeCtrl()->RefreshGUI();
    /*
    static int count = 0;
    printf("RefreshTL %d\n", count);
    count++;
    */
    mpCBtmHalfPanel->RefreshTLPanels();
}

void FrameMain_cls::
OnMenuRefreshSB(wxCommandEvent& event){
    wxString strDrawPercentage, strReadPercentage;

    switch(GDrawingStage){
    case 0: 
	strDrawPercentage << wxT("Drawing "); break;
    case 1:
	strDrawPercentage << wxT("Shadow "); break;
    case 2:
	strDrawPercentage << wxT("Drawing LH"); break;
    }
    
    if (GDrawingPercentage != 100)
	strDrawPercentage << GDrawingPercentage << wxT("%");
    else
	strDrawPercentage = wxT("");
    
    if (GThreadReaderPercentage != 100) 
	strReadPercentage << 
	    wxT("index:") << GThreadReaderIndex << wxT("- Loading") <<
	    GThreadReaderPercentage << wxT("%") ;

    GetStatusBar()->SetStatusText(strDrawPercentage, 2);
    GetStatusBar()->SetStatusText(strReadPercentage, 3);
}

void FrameMain_cls::
OnMenuRefreshAttrib(wxCommandEvent& event){
    mpCTopHalfPanel->RefreshAttrib();
}

void FrameMain_cls::
OnMenuRefreshIMGSEQ(wxCommandEvent& event){
    // FIX_ME!!@ȂƂԂ܂
    if (mpCParent->mpCImgSeq->mpCGUI != NULL)
	mpCParent->mpCImgSeq->mpCGUI->mpCMNumImgSeqParam->UpdateValues();
}

void FrameMain_cls::
OnMenuRefreshCamConf(wxCommandEvent& event){
    if (mpCParent->mpCCameraPathCtrl->mpCGUI != NULL)
	mpCParent->mpCCameraPathCtrl->mpCGUI->UpdateValuesAll();
}

void FrameMain_cls::
OnMenuRefreshColor(wxCommandEvent& event){
    mpCParent->mpCColorCurveCtrl->UpdateItems();
}

void FrameMain_cls::
OnMenuRefreshExporter(wxCommandEvent& event){
    if (mpCParent->mpCDataExporter->mpCGUI != NULL)
	mpCParent->mpCDataExporter->mpCGUI->mpCMNumExportParam->UpdateValues();
}

void FrameMain_cls::
OnMenuRefreshDrawOptions(wxCommandEvent& event){
    if (mpCParent->mpCDrawOption->mpCGUI != NULL)
	mpCParent->mpCDrawOption->mpCGUI->mpCMInputPanel->UpdateValues();
    if (mpCParent->mpCOverlay->mpCGUI != NULL)
	mpCParent->mpCOverlay->mpCGUI->mpCMInputPanel->UpdateValues();
    if (mpCParent->mpCExposure->mpCGUI != NULL)
	mpCParent->mpCExposure->mpCGUI->mpCMInputPanel->UpdateValues();
}

void FrameMain_cls::
OnMenuRefreshLight(wxCommandEvent& event){
    if (mpCParent->mpCLightSRCCtrl->mpCGUI != NULL){
	mpCParent->mpCLightSRCCtrl->mpCGUI->ReconnectParam();
	mpCParent->mpCLightSRCCtrl->mpCGUI->RemakeIconList(-2);
	mpCParent->mpCLightSRCCtrl->mpCGUI->mpCMInputLight->UpdateValues();
    }
}

void FrameMain_cls::
OnMenuRefreshExposure(wxCommandEvent& event){
    mpCParent->mpCExposure->mpCGUI->mpCMInputPanel->UpdateValues();
}

void FrameMain_cls::
OnMenuDeselect(wxCommandEvent& event){
    MainGLCanvas_cls::mspCSelectedObject = 
	mpCParent->mpCParamGUICtrlLink->SelectObject(NULL);
}

void FrameMain_cls::
OnMenuResizedTL(wxCommandEvent& event){
    mpCBtmHalfPanel->RecheckSize();
}

void FrameMain_cls::
OnMenuSetKeyPos(wxCommandEvent& event){
    mpCTopHalfPanel->mpCGLCtrl[0]->mpCGLCanvas->SetKeyPos(); //!! CHECK_ME !!
    mpCTopHalfPanel->RefreshGLPanels();
    mpCBtmHalfPanel->RefreshTLPanels();
}

void FrameMain_cls::
OnMenuSetKeyAnc(wxCommandEvent& event){
    mpCTopHalfPanel->mpCGLCtrl[0]->mpCGLCanvas->SetKeyAnc(); //!! CHECK_ME !!
    mpCTopHalfPanel->RefreshGLPanels();
}

void FrameMain_cls::
OnMenuPlayStop(wxCommandEvent& event){
    mpCActiveGLCanvasLink->StopSaveImgSeqProcess();
    mpCActiveGLCanvasLink->StopExportDataProcess();
    if (GetPCTimeCtrl()->mbPlayTex == TRUE && mbRepeatPlay != TRUE)
	GetPCTimeCtrl()->ProcStopPlaying();
    mbRepeatPlay = FALSE;
}

// ----------------------

TimeCtrl_cls* FrameMain_cls::
GetPCTimeCtrl(){
    return mpCParent->mpCTime;
}

PDataSeqCtrl_cls* FrameMain_cls::
GetPCDataSeqCtrl(){
    return mpCParent->mpCPDataSeqCtrl;
}

CameraPathCtrl_cls* FrameMain_cls::
GetPCPathCtrl(){
    return mpCParent->mpCCameraPathCtrl;
}

// ----------------------

wxString FrameMain_cls::
Serialize(){
    wxString strOut;
    strOut << mpCTopHalfPanel->Serialize();
    return strOut;
}

wxString FrameMain_cls::
SerializeForConfigure(){
    wxString strOut;
    strOut << mCConfList.SerializeAll();
    return strOut;
}

void FrameMain_cls::
ReadStrLine(wxString strLine){
    mCConfList.ReadStrLineAll(strLine);
    mpCTopHalfPanel->ReadStrLine(strLine);
}

FrameMain_cls* FrameMain_cls::mspCThis;
