// -*- c++ -*- 
// "clsFrameMain.cpp"
// (setq c-basic-offset 4)

#ifndef _FRAME_MAIN_H_
#define _FRAME_MAIN_H_

#include "SRC/CONFITEM/clsConfItem.h"

#include <wx/wx.h>
#include <wx/splitter.h>
#include <wx/stopwatch.h>

class CameraPathCtrl_cls;
class CameraPathGLGUI_cls;
class ControlPanel_cls;
class FrameMain_cls; 
class GLInfo_cls;
class Main_cls;
class MainGLCanvas_cls;
class PDataSeqCtrl_cls;
class PDataSequence_cls;
class Preference_cls;
class Scene_cls;
class Shortcut_cls;
class TopHalfPanel_cls;
class TimeCtrl_cls;

class wxButtonEX;
class wxCheckBoxEX; 
class TopHalfPanel_cls;
class BtmHalfPanel_cls;

#define _FM_DEFAULT_CONF false
#define _FM_PROJECT_CONF true

#define _FM_FRAME_CURRENT -1

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class FrameMain_cls : public wxFrame {
 public:
    FrameMain_cls(const wxString& title, Main_cls *pMain, int posx, int posy,
		  int width, int height);
    ~FrameMain_cls();

    // --- clsFrameMainInitMenu.cpp
    void AddBitmapMenu(wxMenu *pMenu, int ID, wxString strMain, 
		       wxString strSub, wxBitmap *pBitmap);
    void InitMenu();
    
    // --- MAIN ---
    
    static FrameMain_cls *mspCThis;
    Main_cls *mpCParent;

    wxSplitterWindow  *mpCSplitterMain;
    TopHalfPanel_cls  *mpCTopHalfPanel;
    BtmHalfPanel_cls  *mpCBtmHalfPanel;
    void FitSplitterWindow(bool bForce = FALSE);

    wxMenuBar         *mpCMenuBar;
    wxMenu            *mpCMenuFile, *mpCMenuEdit, *mpCMenuView;
    wxMenu            *mpCMenuDialog, *mpCMenuHelp;

    wxBitmap *mpBitmapScene;
    wxBitmap *mpBitmapCamera;
    wxBitmap *mpBitmapLight0;
    wxBitmap *mpBitmapLight1;
    wxBitmap *mpBitmapColor;
    wxBitmap *mpBitmapPreference;

    wxTimer           mCTimer;

    Preference_cls    *mpCPreference;
    Shortcut_cls      *mpCShortcut;
    MainGLCanvas_cls  *mpCActiveGLCanvasLink;
    GLInfo_cls        *mpCGLInfo;
    
    // -----
    PDataSequence_cls *GetPCActiveFileSequence();
    MainGLCanvas_cls  *GetPCGLCanvas(int index);
    
    void ReconnectCameraPathGUI();
    void PrepareTheFrame(int frame);
    bool IsTheFrameReady(int frame);
    bool IsTheFrameLoaded(int frame);
    
    // -----
    void OnQuit (wxCommandEvent& event);
    void OnAbout(wxCommandEvent& event);
    void OnKeyDown(wxKeyEvent& event);
    void OnSash(wxSplitterEvent& event);
    void PrepareFramesAhead(int range);
    void OnIdle(wxIdleEvent& event);
    void OnTimer(wxTimerEvent& event);

    // -----
    void OnMenuOpenProject(wxCommandEvent& event);
    void OnMenuSaveProject(wxCommandEvent& event);
    void OnMenuSaveProjectAs(wxCommandEvent& event);
    void OnMenuLoadData(wxCommandEvent& event);
    void OnMenuExportData(wxCommandEvent& event);
    void OnMenuSaveImageSnap(wxCommandEvent& event);
    void OnMenuSaveImageSeq(wxCommandEvent& event);
    void OnMenuSaveImgSeqBegin(wxCommandEvent& event);
    void OnMenuExportDataBegin(wxCommandEvent& event);
    void OnMenuCloseData(wxCommandEvent& event);
    void OnMenuCameraPath(wxCommandEvent& event);
    void OnMenuLighgtSRC(wxCommandEvent& event);
    void OnMenuColorCurve(wxCommandEvent& event);
    void OnMenuViewPanelType(wxCommandEvent& event);
    void OnMenuUndo(wxCommandEvent& event);
    void OnMenuRedo(wxCommandEvent& event);
    void OnMenuGo(wxCommandEvent& event);
    void OnMenuRemoveCacheSnap(wxCommandEvent& event);
    void OnMenuRemoveCacheAll(wxCommandEvent& event);
    void OnMenuScene(wxCommandEvent& event);
    void OnMenuPreference(wxCommandEvent& event);
    void OnMenuShortcut(wxCommandEvent& event);

    void OnMenuRefreshGL(wxCommandEvent& event);
    void OnMenuRefreshTL(wxCommandEvent& event);
    void OnMenuRefreshAttrib(wxCommandEvent& event);
    void OnMenuRefreshIMGSEQ(wxCommandEvent& event);
    void OnMenuRefreshCamConf(wxCommandEvent& event);
    void OnMenuRefreshColor(wxCommandEvent& event);
    void OnMenuRefreshExporter(wxCommandEvent& event);
    void OnMenuRefreshDrawOptions(wxCommandEvent& event);
    void OnMenuRefreshLight(wxCommandEvent& event);
    void OnMenuRefreshExposure(wxCommandEvent& event);
    
    void OnMenuDeselect(wxCommandEvent& event);

    void OnMenuResizedTL(wxCommandEvent& event);
    void OnMenuRefreshSB(wxCommandEvent& event);
    void OnMenuSetKeyPos(wxCommandEvent& event);
    void OnMenuSetKeyAnc(wxCommandEvent& event);
    bool mbRepeatPlay;
    void OnMenuPlayStop(wxCommandEvent& event);
    
    TimeCtrl_cls* GetPCTimeCtrl();
    PDataSeqCtrl_cls* GetPCDataSeqCtrl();
    CameraPathCtrl_cls* GetPCPathCtrl();
    
    bool mbHasOpenedProject;
    ConfItemList_cls mCConfList;
    ConfItemSTR_cls  mCLastOpenedFileZJP;
    ConfItemSTR_cls  mCLastOpenedFileIMG;

    wxString Serialize();
    wxString SerializeForConfigure();
    void ReadStrLine(wxString strLine);

 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

#endif
