// -*- c++ -*- 
// (setq c-basic-offset 4)
// "clsMain.cpp"

#ifndef _MAIN_H_
#define _MAIN_H_

#include <fstream>

#include "SRC/CONFITEM/clsConfItem.h"

class AnchorPath_cls;
class CameraPath_cls;
class CameraPathCtrl_cls;
class ColorCurveCtrl_cls;
class CustomColor_cls;
class DrawOption_cls;
class DrawingBlock_cls;
class Exposure_cls;
class FilterCtrl_cls;
class FrameMain_cls;
class ImgSequence_cls;
class ImportList_cls;
class LightSRCCtrl_cls;
class Main_cls;
class TexPropertyCtrl_cls;
class TimeCtrl_cls;
class TreeBoxRule_cls;
class Scene_cls;
class Overlay_cls;
class Parameters_cls;
class ParamGroup_cls;
class ParamGUICtrl_cls;

class PDataSeqCtrl_cls;
//class SceneObj_cls;
class DataLoader_cls;
class DataExporter_cls;

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class Main_cls{
 public:
    Main_cls();
    ~Main_cls();

    int mPID;

    DrawOption_cls   *mpCDrawOption;
    Overlay_cls      *mpCOverlay;
    PDataSeqCtrl_cls *mpCPDataSeqCtrl;
    DataLoader_cls   *mpCDataLoader;
    DataExporter_cls *mpCDataExporter;
    Exposure_cls     *mpCExposure;
    CameraPath_cls   *mpCCameraPath;
    AnchorPath_cls   *mpCAnchorPath;
    CameraPathCtrl_cls *mpCCameraPathCtrl;
    LightSRCCtrl_cls   *mpCLightSRCCtrl;
    ColorCurveCtrl_cls *mpCColorCurveCtrl;
    TimeCtrl_cls    *mpCTime;
    Scene_cls       *mpCScene; 
    FrameMain_cls   *mpCFrame;
    ImgSequence_cls *mpCImgSeq;

    ParamGUICtrl_cls *mpCParamGUICtrlLink;
    ParamGroup_cls   *mpCParamGroupCameraPath;

    wxString         mstrExecuteDir;
    // Global ̑
    //std::vector < Parameters_cls* > mVPParamInstancePrim;
    //void UpdateParamInstancePrim();
    //Parameters_cls* mpCBoxSize; // e̕TCY
    //Parameters_cls* mpCBoxRotate; // ẻ]

    wxWindow* GetPTopLevelWindow();
    int  GetUsedTotalMemoryMB();
    int  GetAverageMemoryMB();
    int  GetMemoryLimitMB();
    void SelectObject(int objectIndex, int guideIndex = 0);
    void ThisObjectIsSelected(int objectIndex);
    bool IsTheIndexReady(int index, double indexmod);
    bool IsTheIndexLoaded(int index);
    void WaitThreadFinish();
    void OpenDataFileCommand(wxString strFilePath);
    void OpenDataFile(wxString strFilePath);
    void CloseDataCommand();
    void CloseData();

    ConfItemBOOL_cls mCbToolTip;

    wxBitmap *mpBitmapColor, *mpBitmapLight;

    //----

    //DrawingBlock_cls* mpCDBoxMain;
    //TreeBoxRule_cls*  mpCTreeBoxRule;
    
    ImportList_cls*  mpCImportList;
    CustomColor_cls* mpCCustomColor;

    TexPropertyCtrl_cls* mpCTexPropertyCtrl;

    //----

    bool bOneTimeWarningShowed_SceneLength;

    //----

    void RefreshDialogs();
    
    //----
    
    void ImportParamInitialize();
    void ImportParamMain(std::wistream &istream, std::wstring strLine);
    void ImportParam(unsigned int type);

    //----
    
    void Undo();
    void Redo();

    void ReadConfigure(wxString strFileIn);
    bool SaveConfigure(wxString strFileOut, bool flag);
    void QuitProcess();

    //----
    
    bool IsPovrayCondistionSatisfiled();
    bool ProcOutputPovRay(int stereo);
    /*
    void OutputPovStrObjDensity(std::wfstream &ofstream,
				std::vector < DrawingBlock_cls > &VCDrawingCls, 
				PositionAndDirection_cls CCamGlobalCoord, int frame);
    */
    void OutputPovRayMain(std::wfstream &ofstream, int frame);
    bool OutputPovRayIO(std::wstring strFile, int frame);
    bool OutputPovRayIOAnim(unsigned int *pInit, unsigned int *pFin, 
			    bool bQuery = FALSE);
    
    void ExportDF3Seq();
    void ExportImgSeq();

   // ----
    void ReadStrLine(std::wstring strLine);
    wxString Serialize();

};

#endif
